
#ifndef __ALGEBRA_FUNCTION_NAME_ATTRIBUTE_HH__
#define __ALGEBRA_FUNCTION_NAME_ATTRIBUTE_HH__


#include "attribute.hh"


namespace Util {
	
	
	// This attribute is used to annotate algebra function names
	// of those algebra functions which will be generated by the
	// specializing grammar generator, to the CFG nodes which need
	// to be applied to an algebra function.
	class AlgebraFunctionNameAttribute : public Attribute {
		
		private:
			
			// The name of the algebra function.
			std::string* algebraFunctionName;
			
			
		public:
			
			AlgebraFunctionNameAttribute (std::string* algebraFunctionName);
			AlgebraFunctionNameAttribute (AlgebraFunctionNameAttribute& a);
			virtual ~AlgebraFunctionNameAttribute();
			
			// Returns the name of the algebra function.
			std::string* getAlgebraFunctionName();
			
			virtual Attribute* clone();
			
			
	};
	
	
}


#endif	// ifndef __ALGEBRA_FUNCTION_NAME_ATTRIBUTE_HH__

