> module RNAshapesMfe.Intloop22 where

> import RNAshapesMfe.RnaI
> import RNAshapesMfe.Intloop
> import Data.Array.Unboxed

Data arrangement: internal loop formed by b,c,e,f framed by pairs (a,h) and (d,e)

     5'.... a b c d ......
            |     |      . 
     3'.... h g f e ......

      _____________
     |      _      |
     |     | |     |
     a b c e f g h  

 the table is arranged as follows: (a,h) (e,d) b c f g 
	   (f and g are in fact nested in a tuple since ghc allows only up to five-tuples for indexing) 
	    pairlist = [(C,G),(G,C),(G,U),(U,G),(A,U),(U,A)]

> il22_energy seq lb rb = int22_energy seq lb (lb+1) (lb+2) (lb+3) (rb-3) (rb-2) (rb-1) rb 

> int22_energy:: RNAInput-> Int ->Int ->Int ->Int ->Int ->Int -> Int -> Int -> Int
> int22_energy seq a b c d e f g h 
>	      | seq!b == N = 250
>	      | seq!c == N = 250
>	      | seq!f == N = 250
>	      | seq!g == N = 250
>	      | otherwise =  intloop22!(pairs (seq!a, seq!h), pairs (seq!e, seq!d),
>					       basemap (seq!b), basemap (seq!c), (basemap (seq!f),basemap (seq!g)))

> intloop22:: UArray (Int,Int,Int,Int,(Int,Int)) Int
> intloop22 = array ((0,0,0,0,(0,0)),(5,5,3,3,(3,3)))
>                     [((0,0,0,0,(0,0)),130),((0,0,0,0,(0,1)),160),((0,0,0,0,(0,2)),30),((0,0,0,0,(0,3)),200),
>                       ((0,0,0,0,(1,0)),120),((0,0,0,0,(1,1)),150),((0,0,0,0,(1,2)),20),((0,0,0,0,(1,3)),200),
>                       ((0,0,0,0,(2,0)),30),((0,0,0,0,(2,1)),60),((0,0,0,0,(2,2)),-70),((0,0,0,0,(2,3)),200),
>                       ((0,0,0,0,(3,0)),200),((0,0,0,0,(3,1)),200),((0,0,0,0,(3,2)),200),((0,0,0,0,(3,3)),200),
>                       
>                       ((0,0,0,1,(0,0)),160),((0,0,0,1,(0,1)),200),((0,0,0,1,(0,2)),60),((0,0,0,1,(0,3)),200),
>                       ((0,0,0,1,(1,0)),210),((0,0,0,1,(1,1)),180),((0,0,0,1,(1,2)),150),((0,0,0,1,(1,3)),200),
>                       ((0,0,0,1,(2,0)),200),((0,0,0,1,(2,1)),200),((0,0,0,1,(2,2)),200),((0,0,0,1,(2,3)),200),
>                       ((0,0,0,1,(3,0)),190),((0,0,0,1,(3,1)),170),((0,0,0,1,(3,2)),130),((0,0,0,1,(3,3)),200),
>                       
>                       ((0,0,0,2,(0,0)),30),((0,0,0,2,(0,1)),60),((0,0,0,2,(0,2)),-70),((0,0,0,2,(0,3)),200),
>                       ((0,0,0,2,(1,0)),200),((0,0,0,2,(1,1)),200),((0,0,0,2,(1,2)),200),((0,0,0,2,(1,3)),200),
>                       ((0,0,0,2,(2,0)),100),((0,0,0,2,(2,1)),140),((0,0,0,2,(2,2)),0),((0,0,0,2,(2,3)),200),
>                       ((0,0,0,2,(3,0)),-40),((0,0,0,2,(3,1)),-110),((0,0,0,2,(3,2)),-60),((0,0,0,2,(3,3)),200),
>                       
>                       ((0,0,0,3,(0,0)),200),((0,0,0,3,(0,1)),200),((0,0,0,3,(0,2)),200),((0,0,0,3,(0,3)),200),
>                       ((0,0,0,3,(1,0)),190),((0,0,0,3,(1,1)),170),((0,0,0,3,(1,2)),130),((0,0,0,3,(1,3)),200),
>                       ((0,0,0,3,(2,0)),110),((0,0,0,3,(2,1)),40),((0,0,0,3,(2,2)),90),((0,0,0,3,(2,3)),200),
>                       ((0,0,0,3,(3,0)),140),((0,0,0,3,(3,1)),80),((0,0,0,3,(3,2)),130),((0,0,0,3,(3,3)),200),
>                       
>                       
>                       ((0,0,1,0,(0,0)),120),((0,0,1,0,(0,1)),210),((0,0,1,0,(0,2)),200),((0,0,1,0,(0,3)),190),
>                       ((0,0,1,0,(1,0)),110),((0,0,1,0,(1,1)),140),((0,0,1,0,(1,2)),200),((0,0,1,0,(1,3)),120),
>                       ((0,0,1,0,(2,0)),20),((0,0,1,0,(2,1)),150),((0,0,1,0,(2,2)),200),((0,0,1,0,(2,3)),130),
>                       ((0,0,1,0,(3,0)),200),((0,0,1,0,(3,1)),200),((0,0,1,0,(3,2)),200),((0,0,1,0,(3,3)),200),
>                       
>                       ((0,0,1,1,(0,0)),150),((0,0,1,1,(0,1)),180),((0,0,1,1,(0,2)),200),((0,0,1,1,(0,3)),170),
>                       ((0,0,1,1,(1,0)),140),((0,0,1,1,(1,1)),170),((0,0,1,1,(1,2)),200),((0,0,1,1,(1,3)),150),
>                       ((0,0,1,1,(2,0)),200),((0,0,1,1,(2,1)),200),((0,0,1,1,(2,2)),200),((0,0,1,1,(2,3)),200),
>                       ((0,0,1,1,(3,0)),120),((0,0,1,1,(3,1)),150),((0,0,1,1,(3,2)),200),((0,0,1,1,(3,3)),140),
>                       
>                       ((0,0,1,2,(0,0)),20),((0,0,1,2,(0,1)),150),((0,0,1,2,(0,2)),200),((0,0,1,2,(0,3)),130),
>                       ((0,0,1,2,(1,0)),200),((0,0,1,2,(1,1)),200),((0,0,1,2,(1,2)),200),((0,0,1,2,(1,3)),200),
>                       ((0,0,1,2,(2,0)),90),((0,0,1,2,(2,1)),180),((0,0,1,2,(2,2)),200),((0,0,1,2,(2,3)),170),
>                       ((0,0,1,2,(3,0)),-150),((0,0,1,2,(3,1)),-20),((0,0,1,2,(3,2)),200),((0,0,1,2,(3,3)),-40),
>                       
>                       ((0,0,1,3,(0,0)),200),((0,0,1,3,(0,1)),200),((0,0,1,3,(0,2)),200),((0,0,1,3,(0,3)),200),
>                       ((0,0,1,3,(1,0)),120),((0,0,1,3,(1,1)),150),((0,0,1,3,(1,2)),200),((0,0,1,3,(1,3)),140),
>                       ((0,0,1,3,(2,0)),0),((0,0,1,3,(2,1)),130),((0,0,1,3,(2,2)),200),((0,0,1,3,(2,3)),110),
>                       ((0,0,1,3,(3,0)),30),((0,0,1,3,(3,1)),60),((0,0,1,3,(3,2)),200),((0,0,1,3,(3,3)),50),
>                       
>                       
>                       ((0,0,2,0,(0,0)),30),((0,0,2,0,(0,1)),200),((0,0,2,0,(0,2)),100),((0,0,2,0,(0,3)),110),
>                       ((0,0,2,0,(1,0)),20),((0,0,2,0,(1,1)),200),((0,0,2,0,(1,2)),90),((0,0,2,0,(1,3)),0),
>                       ((0,0,2,0,(2,0)),-70),((0,0,2,0,(2,1)),200),((0,0,2,0,(2,2)),0),((0,0,2,0,(2,3)),90),
>                       ((0,0,2,0,(3,0)),200),((0,0,2,0,(3,1)),200),((0,0,2,0,(3,2)),200),((0,0,2,0,(3,3)),200),
>                       
>                       ((0,0,2,1,(0,0)),60),((0,0,2,1,(0,1)),200),((0,0,2,1,(0,2)),140),((0,0,2,1,(0,3)),40),
>                       ((0,0,2,1,(1,0)),150),((0,0,2,1,(1,1)),200),((0,0,2,1,(1,2)),180),((0,0,2,1,(1,3)),130),
>                       ((0,0,2,1,(2,0)),200),((0,0,2,1,(2,1)),200),((0,0,2,1,(2,2)),200),((0,0,2,1,(2,3)),200),
>                       ((0,0,2,1,(3,0)),130),((0,0,2,1,(3,1)),200),((0,0,2,1,(3,2)),170),((0,0,2,1,(3,3)),110),
>                       
>                       ((0,0,2,2,(0,0)),-70),((0,0,2,2,(0,1)),200),((0,0,2,2,(0,2)),0),((0,0,2,2,(0,3)),90),
>                       ((0,0,2,2,(1,0)),200),((0,0,2,2,(1,1)),200),((0,0,2,2,(1,2)),200),((0,0,2,2,(1,3)),200),
>                       ((0,0,2,2,(2,0)),0),((0,0,2,2,(2,1)),200),((0,0,2,2,(2,2)),80),((0,0,2,2,(2,3)),90),
>                       ((0,0,2,2,(3,0)),-60),((0,0,2,2,(3,1)),200),((0,0,2,2,(3,2)),-70),((0,0,2,2,(3,3)),-260),
>                       
>                       ((0,0,2,3,(0,0)),200),((0,0,2,3,(0,1)),200),((0,0,2,3,(0,2)),200),((0,0,2,3,(0,3)),200),
>                       ((0,0,2,3,(1,0)),130),((0,0,2,3,(1,1)),200),((0,0,2,3,(1,2)),170),((0,0,2,3,(1,3)),110),
>                       ((0,0,2,3,(2,0)),90),((0,0,2,3,(2,1)),200),((0,0,2,3,(2,2)),90),((0,0,2,3,(2,3)),-110),
>                       ((0,0,2,3,(3,0)),130),((0,0,2,3,(3,1)),200),((0,0,2,3,(3,2)),120),((0,0,2,3,(3,3)),110),
>                       
>                       
>                       ((0,0,3,0,(0,0)),200),((0,0,3,0,(0,1)),190),((0,0,3,0,(0,2)),-40),((0,0,3,0,(0,3)),140),
>                       ((0,0,3,0,(1,0)),200),((0,0,3,0,(1,1)),120),((0,0,3,0,(1,2)),-150),((0,0,3,0,(1,3)),30),
>                       ((0,0,3,0,(2,0)),200),((0,0,3,0,(2,1)),130),((0,0,3,0,(2,2)),-60),((0,0,3,0,(2,3)),130),
>                       ((0,0,3,0,(3,0)),200),((0,0,3,0,(3,1)),200),((0,0,3,0,(3,2)),200),((0,0,3,0,(3,3)),200),
>                       
>                       ((0,0,3,1,(0,0)),200),((0,0,3,1,(0,1)),170),((0,0,3,1,(0,2)),-110),((0,0,3,1,(0,3)),80),
>                       ((0,0,3,1,(1,0)),200),((0,0,3,1,(1,1)),150),((0,0,3,1,(1,2)),-20),((0,0,3,1,(1,3)),60),
>                       ((0,0,3,1,(2,0)),200),((0,0,3,1,(2,1)),200),((0,0,3,1,(2,2)),200),((0,0,3,1,(2,3)),200),
>                       ((0,0,3,1,(3,0)),200),((0,0,3,1,(3,1)),140),((0,0,3,1,(3,2)),-40),((0,0,3,1,(3,3)),50),
>                       
>                       ((0,0,3,2,(0,0)),200),((0,0,3,2,(0,1)),130),((0,0,3,2,(0,2)),-60),((0,0,3,2,(0,3)),130),
>                       ((0,0,3,2,(1,0)),200),((0,0,3,2,(1,1)),200),((0,0,3,2,(1,2)),200),((0,0,3,2,(1,3)),200),
>                       ((0,0,3,2,(2,0)),200),((0,0,3,2,(2,1)),170),((0,0,3,2,(2,2)),-70),((0,0,3,2,(2,3)),120),
>                       ((0,0,3,2,(3,0)),200),((0,0,3,2,(3,1)),-40),((0,0,3,2,(3,2)),-420),((0,0,3,2,(3,3)),-50),
>                       
>                       ((0,0,3,3,(0,0)),200),((0,0,3,3,(0,1)),200),((0,0,3,3,(0,2)),200),((0,0,3,3,(0,3)),200),
>                       ((0,0,3,3,(1,0)),200),((0,0,3,3,(1,1)),140),((0,0,3,3,(1,2)),-40),((0,0,3,3,(1,3)),50),
>                       ((0,0,3,3,(2,0)),200),((0,0,3,3,(2,1)),110),((0,0,3,3,(2,2)),-260),((0,0,3,3,(2,3)),110),
>                       ((0,0,3,3,(3,0)),200),((0,0,3,3,(3,1)),50),((0,0,3,3,(3,2)),-50),((0,0,3,3,(3,3)),-40),
>                       
>                       
>                       
>                       ((0,1,0,0,(0,0)),50),((0,1,0,0,(0,1)),60),((0,1,0,0,(0,2)),0),((0,1,0,0,(0,3)),200),
>                       ((0,1,0,0,(1,0)),110),((0,1,0,0,(1,1)),150),((0,1,0,0,(1,2)),-70),((0,1,0,0,(1,3)),200),
>                       ((0,1,0,0,(2,0)),-30),((0,1,0,0,(2,1)),10),((0,1,0,0,(2,2)),-160),((0,1,0,0,(2,3)),200),
>                       ((0,1,0,0,(3,0)),200),((0,1,0,0,(3,1)),200),((0,1,0,0,(3,2)),200),((0,1,0,0,(3,3)),200),
>                       
>                       ((0,1,0,1,(0,0)),110),((0,1,0,1,(0,1)),110),((0,1,0,1,(0,2)),-100),((0,1,0,1,(0,3)),200),
>                       ((0,1,0,1,(1,0)),170),((0,1,0,1,(1,1)),150),((0,1,0,1,(1,2)),-60),((0,1,0,1,(1,3)),200),
>                       ((0,1,0,1,(2,0)),200),((0,1,0,1,(2,1)),200),((0,1,0,1,(2,2)),200),((0,1,0,1,(2,3)),200),
>                       ((0,1,0,1,(3,0)),70),((0,1,0,1,(3,1)),50),((0,1,0,1,(3,2)),20),((0,1,0,1,(3,3)),200),
>                       
>                       ((0,1,0,2,(0,0)),40),((0,1,0,2,(0,1)),50),((0,1,0,2,(0,2)),-70),((0,1,0,2,(0,3)),200),
>                       ((0,1,0,2,(1,0)),200),((0,1,0,2,(1,1)),200),((0,1,0,2,(1,2)),200),((0,1,0,2,(1,3)),200),
>                       ((0,1,0,2,(2,0)),100),((0,1,0,2,(2,1)),140),((0,1,0,2,(2,2)),0),((0,1,0,2,(2,3)),200),
>                       ((0,1,0,2,(3,0)),10),((0,1,0,2,(3,1)),-70),((0,1,0,2,(3,2)),-80),((0,1,0,2,(3,3)),200),
>                       
>                       ((0,1,0,3,(0,0)),200),((0,1,0,3,(0,1)),200),((0,1,0,3,(0,2)),200),((0,1,0,3,(0,3)),200),
>                       ((0,1,0,3,(1,0)),180),((0,1,0,3,(1,1)),150),((0,1,0,3,(1,2)),120),((0,1,0,3,(1,3)),200),
>                       ((0,1,0,3,(2,0)),-50),((0,1,0,3,(2,1)),-60),((0,1,0,3,(2,2)),-60),((0,1,0,3,(2,3)),200),
>                       ((0,1,0,3,(3,0)),150),((0,1,0,3,(3,1)),0),((0,1,0,3,(3,2)),90),((0,1,0,3,(3,3)),200),
>                       
>                       
>                       ((0,1,1,0,(0,0)),130),((0,1,1,0,(0,1)),220),((0,1,1,0,(0,2)),200),((0,1,1,0,(0,3)),200),
>                       ((0,1,1,0,(1,0)),100),((0,1,1,0,(1,1)),130),((0,1,1,0,(1,2)),200),((0,1,1,0,(1,3)),120),
>                       ((0,1,1,0,(2,0)),-70),((0,1,1,0,(2,1)),70),((0,1,1,0,(2,2)),200),((0,1,1,0,(2,3)),40),
>                       ((0,1,1,0,(3,0)),200),((0,1,1,0,(3,1)),200),((0,1,1,0,(3,2)),200),((0,1,1,0,(3,3)),200),
>                       
>                       ((0,1,1,1,(0,0)),100),((0,1,1,1,(0,1)),190),((0,1,1,1,(0,2)),200),((0,1,1,1,(0,3)),110),
>                       ((0,1,1,1,(1,0)),100),((0,1,1,1,(1,1)),130),((0,1,1,1,(1,2)),200),((0,1,1,1,(1,3)),120),
>                       ((0,1,1,1,(2,0)),200),((0,1,1,1,(2,1)),200),((0,1,1,1,(2,2)),200),((0,1,1,1,(2,3)),200),
>                       ((0,1,1,1,(3,0)),0),((0,1,1,1,(3,1)),30),((0,1,1,1,(3,2)),200),((0,1,1,1,(3,3)),170),
>                       
>                       ((0,1,1,2,(0,0)),70),((0,1,1,2,(0,1)),70),((0,1,1,2,(0,2)),200),((0,1,1,2,(0,3)),100),
>                       ((0,1,1,2,(1,0)),200),((0,1,1,2,(1,1)),200),((0,1,1,2,(1,2)),200),((0,1,1,2,(1,3)),200),
>                       ((0,1,1,2,(2,0)),90),((0,1,1,2,(2,1)),180),((0,1,1,2,(2,2)),200),((0,1,1,2,(2,3)),170),
>                       ((0,1,1,2,(3,0)),-190),((0,1,1,2,(3,1)),-30),((0,1,1,2,(3,2)),200),((0,1,1,2,(3,3)),-70),
>                       
>                       ((0,1,1,3,(0,0)),200),((0,1,1,3,(0,1)),200),((0,1,1,3,(0,2)),200),((0,1,1,3,(0,3)),200),
>                       ((0,1,1,3,(1,0)),110),((0,1,1,3,(1,1)),140),((0,1,1,3,(1,2)),200),((0,1,1,3,(1,3)),120),
>                       ((0,1,1,3,(2,0)),-150),((0,1,1,3,(2,1)),-20),((0,1,1,3,(2,2)),200),((0,1,1,3,(2,3)),-30),
>                       ((0,1,1,3,(3,0)),-20),((0,1,1,3,(3,1)),-10),((0,1,1,3,(3,2)),200),((0,1,1,3,(3,3)),20),
>                       
>                       
>                       ((0,1,2,0,(0,0)),-20),((0,1,2,0,(0,1)),200),((0,1,2,0,(0,2)),110),((0,1,2,0,(0,3)),90),
>                       ((0,1,2,0,(1,0)),-40),((0,1,2,0,(1,1)),200),((0,1,2,0,(1,2)),90),((0,1,2,0,(1,3)),0),
>                       ((0,1,2,0,(2,0)),-170),((0,1,2,0,(2,1)),200),((0,1,2,0,(2,2)),-90),((0,1,2,0,(2,3)),30),
>                       ((0,1,2,0,(3,0)),200),((0,1,2,0,(3,1)),200),((0,1,2,0,(3,2)),200),((0,1,2,0,(3,3)),200),
>                       
>                       ((0,1,2,1,(0,0)),70),((0,1,2,1,(0,1)),200),((0,1,2,1,(0,2)),80),((0,1,2,1,(0,3)),-10),
>                       ((0,1,2,1,(1,0)),110),((0,1,2,1,(1,1)),200),((0,1,2,1,(1,2)),150),((0,1,2,1,(1,3)),100),
>                       ((0,1,2,1,(2,0)),200),((0,1,2,1,(2,1)),200),((0,1,2,1,(2,2)),200),((0,1,2,1,(2,3)),200),
>                       ((0,1,2,1,(3,0)),20),((0,1,2,1,(3,1)),200),((0,1,2,1,(3,2)),50),((0,1,2,1,(3,3)),0),
>                       
>                       ((0,1,2,2,(0,0)),-50),((0,1,2,2,(0,1)),200),((0,1,2,2,(0,2)),-20),((0,1,2,2,(0,3)),60),
>                       ((0,1,2,2,(1,0)),200),((0,1,2,2,(1,1)),200),((0,1,2,2,(1,2)),200),((0,1,2,2,(1,3)),200),
>                       ((0,1,2,2,(2,0)),0),((0,1,2,2,(2,1)),200),((0,1,2,2,(2,2)),80),((0,1,2,2,(2,3)),90),
>                       ((0,1,2,2,(3,0)),-90),((0,1,2,2,(3,1)),200),((0,1,2,2,(3,2)),-100),((0,1,2,2,(3,3)),-300),
>                       
>                       ((0,1,2,3,(0,0)),200),((0,1,2,3,(0,1)),200),((0,1,2,3,(0,2)),200),((0,1,2,3,(0,3)),200),
>                       ((0,1,2,3,(1,0)),120),((0,1,2,3,(1,1)),200),((0,1,2,3,(1,2)),150),((0,1,2,3,(1,3)),100),
>                       ((0,1,2,3,(2,0)),-130),((0,1,2,3,(2,1)),200),((0,1,2,3,(2,2)),-60),((0,1,2,3,(2,3)),-240),
>                       ((0,1,2,3,(3,0)),90),((0,1,2,3,(3,1)),200),((0,1,2,3,(3,2)),110),((0,1,2,3,(3,3)),60),
>                       
>                       
>                       ((0,1,3,0,(0,0)),200),((0,1,3,0,(0,1)),200),((0,1,3,0,(0,2)),-10),((0,1,3,0,(0,3)),140),
>                       ((0,1,3,0,(1,0)),200),((0,1,3,0,(1,1)),120),((0,1,3,0,(1,2)),-160),((0,1,3,0,(1,3)),30),
>                       ((0,1,3,0,(2,0)),200),((0,1,3,0,(2,1)),40),((0,1,3,0,(2,2)),-160),((0,1,3,0,(2,3)),50),
>                       ((0,1,3,0,(3,0)),200),((0,1,3,0,(3,1)),200),((0,1,3,0,(3,2)),200),((0,1,3,0,(3,3)),200),
>                       
>                       ((0,1,3,1,(0,0)),200),((0,1,3,1,(0,1)),110),((0,1,3,1,(0,2)),-160),((0,1,3,1,(0,3)),30),
>                       ((0,1,3,1,(1,0)),200),((0,1,3,1,(1,1)),120),((0,1,3,1,(1,2)),-60),((0,1,3,1,(1,3)),30),
>                       ((0,1,3,1,(2,0)),200),((0,1,3,1,(2,1)),200),((0,1,3,1,(2,2)),200),((0,1,3,1,(2,3)),200),
>                       ((0,1,3,1,(3,0)),200),((0,1,3,1,(3,1)),20),((0,1,3,1,(3,2)),-160),((0,1,3,1,(3,3)),10),
>                       
>                       ((0,1,3,2,(0,0)),200),((0,1,3,2,(0,1)),50),((0,1,3,2,(0,2)),-60),((0,1,3,2,(0,3)),140),
>                       ((0,1,3,2,(1,0)),200),((0,1,3,2,(1,1)),200),((0,1,3,2,(1,2)),200),((0,1,3,2,(1,3)),200),
>                       ((0,1,3,2,(2,0)),200),((0,1,3,2,(2,1)),170),((0,1,3,2,(2,2)),-70),((0,1,3,2,(2,3)),120),
>                       ((0,1,3,2,(3,0)),200),((0,1,3,2,(3,1)),-70),((0,1,3,2,(3,2)),-440),((0,1,3,2,(3,3)),-100),
>                       
>                       ((0,1,3,3,(0,0)),200),((0,1,3,3,(0,1)),200),((0,1,3,3,(0,2)),200),((0,1,3,3,(0,3)),200),
>                       ((0,1,3,3,(1,0)),200),((0,1,3,3,(1,1)),120),((0,1,3,3,(1,2)),-50),((0,1,3,3,(1,3)),30),
>                       ((0,1,3,3,(2,0)),200),((0,1,3,3,(2,1)),-10),((0,1,3,3,(2,2)),-410),((0,1,3,3,(2,3)),10),
>                       ((0,1,3,3,(3,0)),200),((0,1,3,3,(3,1)),40),((0,1,3,3,(3,2)),-100),((0,1,3,3,(3,3)),60),
>                       
>                       
>                       
>                       ((0,2,0,0,(0,0)),200),((0,2,0,0,(0,1)),240),((0,2,0,0,(0,2)),100),((0,2,0,0,(0,3)),200),
>                       ((0,2,0,0,(1,0)),180),((0,2,0,0,(1,1)),210),((0,2,0,0,(1,2)),80),((0,2,0,0,(1,3)),200),
>                       ((0,2,0,0,(2,0)),80),((0,2,0,0,(2,1)),110),((0,2,0,0,(2,2)),-20),((0,2,0,0,(2,3)),200),
>                       ((0,2,0,0,(3,0)),200),((0,2,0,0,(3,1)),200),((0,2,0,0,(3,2)),200),((0,2,0,0,(3,3)),200),
>                       
>                       ((0,2,0,1,(0,0)),190),((0,2,0,1,(0,1)),220),((0,2,0,1,(0,2)),90),((0,2,0,1,(0,3)),200),
>                       ((0,2,0,1,(1,0)),230),((0,2,0,1,(1,1)),210),((0,2,0,1,(1,2)),170),((0,2,0,1,(1,3)),200),
>                       ((0,2,0,1,(2,0)),200),((0,2,0,1,(2,1)),200),((0,2,0,1,(2,2)),200),((0,2,0,1,(2,3)),200),
>                       ((0,2,0,1,(3,0)),230),((0,2,0,1,(3,1)),210),((0,2,0,1,(3,2)),170),((0,2,0,1,(3,3)),200),
>                       
>                       ((0,2,0,2,(0,0)),80),((0,2,0,2,(0,1)),110),((0,2,0,2,(0,2)),-20),((0,2,0,2,(0,3)),200),
>                       ((0,2,0,2,(1,0)),200),((0,2,0,2,(1,1)),200),((0,2,0,2,(1,2)),200),((0,2,0,2,(1,3)),200),
>                       ((0,2,0,2,(2,0)),130),((0,2,0,2,(2,1)),170),((0,2,0,2,(2,2)),30),((0,2,0,2,(2,3)),200),
>                       ((0,2,0,2,(3,0)),60),((0,2,0,2,(3,1)),0),((0,2,0,2,(3,2)),40),((0,2,0,2,(3,3)),200),
>                       
>                       ((0,2,0,3,(0,0)),200),((0,2,0,3,(0,1)),200),((0,2,0,3,(0,2)),200),((0,2,0,3,(0,3)),200),
>                       ((0,2,0,3,(1,0)),230),((0,2,0,3,(1,1)),210),((0,2,0,3,(1,2)),170),((0,2,0,3,(1,3)),200),
>                       ((0,2,0,3,(2,0)),160),((0,2,0,3,(2,1)),90),((0,2,0,3,(2,2)),140),((0,2,0,3,(2,3)),200),
>                       ((0,2,0,3,(3,0)),190),((0,2,0,3,(3,1)),130),((0,2,0,3,(3,2)),180),((0,2,0,3,(3,3)),200),
>                       
>                       
>                       ((0,2,1,0,(0,0)),190),((0,2,1,0,(0,1)),280),((0,2,1,0,(0,2)),200),((0,2,1,0,(0,3)),270),
>                       ((0,2,1,0,(1,0)),170),((0,2,1,0,(1,1)),200),((0,2,1,0,(1,2)),200),((0,2,1,0,(1,3)),180),
>                       ((0,2,1,0,(2,0)),70),((0,2,1,0,(2,1)),200),((0,2,1,0,(2,2)),200),((0,2,1,0,(2,3)),180),
>                       ((0,2,1,0,(3,0)),200),((0,2,1,0,(3,1)),200),((0,2,1,0,(3,2)),200),((0,2,1,0,(3,3)),200),
>                       
>                       ((0,2,1,1,(0,0)),180),((0,2,1,1,(0,1)),210),((0,2,1,1,(0,2)),200),((0,2,1,1,(0,3)),190),
>                       ((0,2,1,1,(1,0)),160),((0,2,1,1,(1,1)),190),((0,2,1,1,(1,2)),200),((0,2,1,1,(1,3)),180),
>                       ((0,2,1,1,(2,0)),200),((0,2,1,1,(2,1)),200),((0,2,1,1,(2,2)),200),((0,2,1,1,(2,3)),200),
>                       ((0,2,1,1,(3,0)),160),((0,2,1,1,(3,1)),190),((0,2,1,1,(3,2)),200),((0,2,1,1,(3,3)),180),
>                       
>                       ((0,2,1,2,(0,0)),70),((0,2,1,2,(0,1)),200),((0,2,1,2,(0,2)),200),((0,2,1,2,(0,3)),180),
>                       ((0,2,1,2,(1,0)),200),((0,2,1,2,(1,1)),200),((0,2,1,2,(1,2)),200),((0,2,1,2,(1,3)),200),
>                       ((0,2,1,2,(2,0)),120),((0,2,1,2,(2,1)),210),((0,2,1,2,(2,2)),200),((0,2,1,2,(2,3)),200),
>                       ((0,2,1,2,(3,0)),-50),((0,2,1,2,(3,1)),80),((0,2,1,2,(3,2)),200),((0,2,1,2,(3,3)),70),
>                       
>                       ((0,2,1,3,(0,0)),200),((0,2,1,3,(0,1)),200),((0,2,1,3,(0,2)),200),((0,2,1,3,(0,3)),200),
>                       ((0,2,1,3,(1,0)),160),((0,2,1,3,(1,1)),190),((0,2,1,3,(1,2)),200),((0,2,1,3,(1,3)),180),
>                       ((0,2,1,3,(2,0)),50),((0,2,1,3,(2,1)),180),((0,2,1,3,(2,2)),200),((0,2,1,3,(2,3)),160),
>                       ((0,2,1,3,(3,0)),80),((0,2,1,3,(3,1)),110),((0,2,1,3,(3,2)),200),((0,2,1,3,(3,3)),100),
>                       
>                       
>                       ((0,2,2,0,(0,0)),100),((0,2,2,0,(0,1)),200),((0,2,2,0,(0,2)),180),((0,2,2,0,(0,3)),180),
>                       ((0,2,2,0,(1,0)),80),((0,2,2,0,(1,1)),200),((0,2,2,0,(1,2)),150),((0,2,2,0,(1,3)),60),
>                       ((0,2,2,0,(2,0)),-20),((0,2,2,0,(2,1)),200),((0,2,2,0,(2,2)),50),((0,2,2,0,(2,3)),140),
>                       ((0,2,2,0,(3,0)),200),((0,2,2,0,(3,1)),200),((0,2,2,0,(3,2)),200),((0,2,2,0,(3,3)),200),
>                       
>                       ((0,2,2,1,(0,0)),90),((0,2,2,1,(0,1)),200),((0,2,2,1,(0,2)),160),((0,2,2,1,(0,3)),70),
>                       ((0,2,2,1,(1,0)),170),((0,2,2,1,(1,1)),200),((0,2,2,1,(1,2)),210),((0,2,2,1,(1,3)),150),
>                       ((0,2,2,1,(2,0)),200),((0,2,2,1,(2,1)),200),((0,2,2,1,(2,2)),200),((0,2,2,1,(2,3)),200),
>                       ((0,2,2,1,(3,0)),170),((0,2,2,1,(3,1)),200),((0,2,2,1,(3,2)),210),((0,2,2,1,(3,3)),150),
>                       
>                       ((0,2,2,2,(0,0)),-20),((0,2,2,2,(0,1)),200),((0,2,2,2,(0,2)),50),((0,2,2,2,(0,3)),140),
>                       ((0,2,2,2,(1,0)),200),((0,2,2,2,(1,1)),200),((0,2,2,2,(1,2)),200),((0,2,2,2,(1,3)),200),
>                       ((0,2,2,2,(2,0)),30),((0,2,2,2,(2,1)),200),((0,2,2,2,(2,2)),110),((0,2,2,2,(2,3)),110),
>                       ((0,2,2,2,(3,0)),40),((0,2,2,2,(3,1)),200),((0,2,2,2,(3,2)),40),((0,2,2,2,(3,3)),-160),
>                       
>                       ((0,2,2,3,(0,0)),200),((0,2,2,3,(0,1)),200),((0,2,2,3,(0,2)),200),((0,2,2,3,(0,3)),200),
>                       ((0,2,2,3,(1,0)),170),((0,2,2,3,(1,1)),200),((0,2,2,3,(1,2)),210),((0,2,2,3,(1,3)),150),
>                       ((0,2,2,3,(2,0)),140),((0,2,2,3,(2,1)),200),((0,2,2,3,(2,2)),130),((0,2,2,3,(2,3)),-60),
>                       ((0,2,2,3,(3,0)),180),((0,2,2,3,(3,1)),200),((0,2,2,3,(3,2)),170),((0,2,2,3,(3,3)),160),
>                       
>                       
>                       ((0,2,3,0,(0,0)),200),((0,2,3,0,(0,1)),270),((0,2,3,0,(0,2)),30),((0,2,3,0,(0,3)),220),
>                       ((0,2,3,0,(1,0)),200),((0,2,3,0,(1,1)),180),((0,2,3,0,(1,2)),-90),((0,2,3,0,(1,3)),90),
>                       ((0,2,3,0,(2,0)),200),((0,2,3,0,(2,1)),180),((0,2,3,0,(2,2)),-10),((0,2,3,0,(2,3)),180),
>                       ((0,2,3,0,(3,0)),200),((0,2,3,0,(3,1)),200),((0,2,3,0,(3,2)),200),((0,2,3,0,(3,3)),200),
>                       
>                       ((0,2,3,1,(0,0)),200),((0,2,3,1,(0,1)),190),((0,2,3,1,(0,2)),-80),((0,2,3,1,(0,3)),100),
>                       ((0,2,3,1,(1,0)),200),((0,2,3,1,(1,1)),180),((0,2,3,1,(1,2)),0),((0,2,3,1,(1,3)),90),
>                       ((0,2,3,1,(2,0)),200),((0,2,3,1,(2,1)),200),((0,2,3,1,(2,2)),200),((0,2,3,1,(2,3)),200),
>                       ((0,2,3,1,(3,0)),200),((0,2,3,1,(3,1)),180),((0,2,3,1,(3,2)),0),((0,2,3,1,(3,3)),90),
>                       
>                       ((0,2,3,2,(0,0)),200),((0,2,3,2,(0,1)),180),((0,2,3,2,(0,2)),-10),((0,2,3,2,(0,3)),180),
>                       ((0,2,3,2,(1,0)),200),((0,2,3,2,(1,1)),200),((0,2,3,2,(1,2)),200),((0,2,3,2,(1,3)),200),
>                       ((0,2,3,2,(2,0)),200),((0,2,3,2,(2,1)),200),((0,2,3,2,(2,2)),-40),((0,2,3,2,(2,3)),150),
>                       ((0,2,3,2,(3,0)),200),((0,2,3,2,(3,1)),70),((0,2,3,2,(3,2)),-310),((0,2,3,2,(3,3)),60),
>                       
>                       ((0,2,3,3,(0,0)),200),((0,2,3,3,(0,1)),200),((0,2,3,3,(0,2)),200),((0,2,3,3,(0,3)),200),
>                       ((0,2,3,3,(1,0)),200),((0,2,3,3,(1,1)),180),((0,2,3,3,(1,2)),0),((0,2,3,3,(1,3)),90),
>                       ((0,2,3,3,(2,0)),200),((0,2,3,3,(2,1)),160),((0,2,3,3,(2,2)),-210),((0,2,3,3,(2,3)),160),
>                       ((0,2,3,3,(3,0)),200),((0,2,3,3,(3,1)),100),((0,2,3,3,(3,2)),0),((0,2,3,3,(3,3)),10),
>                       
>                       
>                       
>                       ((0,3,0,0,(0,0)),200),((0,3,0,0,(0,1)),240),((0,3,0,0,(0,2)),100),((0,3,0,0,(0,3)),200),
>                       ((0,3,0,0,(1,0)),160),((0,3,0,0,(1,1)),190),((0,3,0,0,(1,2)),60),((0,3,0,0,(1,3)),200),
>                       ((0,3,0,0,(2,0)),100),((0,3,0,0,(2,1)),130),((0,3,0,0,(2,2)),0),((0,3,0,0,(2,3)),200),
>                       ((0,3,0,0,(3,0)),200),((0,3,0,0,(3,1)),200),((0,3,0,0,(3,2)),200),((0,3,0,0,(3,3)),200),
>                       
>                       ((0,3,0,1,(0,0)),200),((0,3,0,1,(0,1)),240),((0,3,0,1,(0,2)),100),((0,3,0,1,(0,3)),200),
>                       ((0,3,0,1,(1,0)),260),((0,3,0,1,(1,1)),240),((0,3,0,1,(1,2)),200),((0,3,0,1,(1,3)),200),
>                       ((0,3,0,1,(2,0)),200),((0,3,0,1,(2,1)),200),((0,3,0,1,(2,2)),200),((0,3,0,1,(2,3)),200),
>                       ((0,3,0,1,(3,0)),260),((0,3,0,1,(3,1)),240),((0,3,0,1,(3,2)),200),((0,3,0,1,(3,3)),200),
>                       
>                       ((0,3,0,2,(0,0)),100),((0,3,0,2,(0,1)),130),((0,3,0,2,(0,2)),0),((0,3,0,2,(0,3)),200),
>                       ((0,3,0,2,(1,0)),200),((0,3,0,2,(1,1)),200),((0,3,0,2,(1,2)),200),((0,3,0,2,(1,3)),200),
>                       ((0,3,0,2,(2,0)),140),((0,3,0,2,(2,1)),170),((0,3,0,2,(2,2)),40),((0,3,0,2,(2,3)),200),
>                       ((0,3,0,2,(3,0)),20),((0,3,0,2,(3,1)),-40),((0,3,0,2,(3,2)),0),((0,3,0,2,(3,3)),200),
>                       
>                       ((0,3,0,3,(0,0)),200),((0,3,0,3,(0,1)),200),((0,3,0,3,(0,2)),200),((0,3,0,3,(0,3)),200),
>                       ((0,3,0,3,(1,0)),230),((0,3,0,3,(1,1)),210),((0,3,0,3,(1,2)),170),((0,3,0,3,(1,3)),200),
>                       ((0,3,0,3,(2,0)),150),((0,3,0,3,(2,1)),80),((0,3,0,3,(2,2)),130),((0,3,0,3,(2,3)),200),
>                       ((0,3,0,3,(3,0)),220),((0,3,0,3,(3,1)),150),((0,3,0,3,(3,2)),200),((0,3,0,3,(3,3)),200),
>                       
>                       
>                       ((0,3,1,0,(0,0)),190),((0,3,1,0,(0,1)),280),((0,3,1,0,(0,2)),200),((0,3,1,0,(0,3)),270),
>                       ((0,3,1,0,(1,0)),150),((0,3,1,0,(1,1)),180),((0,3,1,0,(1,2)),200),((0,3,1,0,(1,3)),160),
>                       ((0,3,1,0,(2,0)),90),((0,3,1,0,(2,1)),220),((0,3,1,0,(2,2)),200),((0,3,1,0,(2,3)),200),
>                       ((0,3,1,0,(3,0)),200),((0,3,1,0,(3,1)),200),((0,3,1,0,(3,2)),200),((0,3,1,0,(3,3)),200),
>                       
>                       ((0,3,1,1,(0,0)),190),((0,3,1,1,(0,1)),220),((0,3,1,1,(0,2)),200),((0,3,1,1,(0,3)),210),
>                       ((0,3,1,1,(1,0)),190),((0,3,1,1,(1,1)),220),((0,3,1,1,(1,2)),200),((0,3,1,1,(1,3)),210),
>                       ((0,3,1,1,(2,0)),200),((0,3,1,1,(2,1)),200),((0,3,1,1,(2,2)),200),((0,3,1,1,(2,3)),200),
>                       ((0,3,1,1,(3,0)),190),((0,3,1,1,(3,1)),220),((0,3,1,1,(3,2)),200),((0,3,1,1,(3,3)),210),
>                       
>                       ((0,3,1,2,(0,0)),90),((0,3,1,2,(0,1)),220),((0,3,1,2,(0,2)),200),((0,3,1,2,(0,3)),200),
>                       ((0,3,1,2,(1,0)),200),((0,3,1,2,(1,1)),200),((0,3,1,2,(1,2)),200),((0,3,1,2,(1,3)),200),
>                       ((0,3,1,2,(2,0)),130),((0,3,1,2,(2,1)),220),((0,3,1,2,(2,2)),200),((0,3,1,2,(2,3)),200),
>                       ((0,3,1,2,(3,0)),-90),((0,3,1,2,(3,1)),40),((0,3,1,2,(3,2)),200),((0,3,1,2,(3,3)),30),
>                       
>                       ((0,3,1,3,(0,0)),200),((0,3,1,3,(0,1)),200),((0,3,1,3,(0,2)),200),((0,3,1,3,(0,3)),200),
>                       ((0,3,1,3,(1,0)),160),((0,3,1,3,(1,1)),190),((0,3,1,3,(1,2)),200),((0,3,1,3,(1,3)),180),
>                       ((0,3,1,3,(2,0)),40),((0,3,1,3,(2,1)),170),((0,3,1,3,(2,2)),200),((0,3,1,3,(2,3)),150),
>                       ((0,3,1,3,(3,0)),110),((0,3,1,3,(3,1)),140),((0,3,1,3,(3,2)),200),((0,3,1,3,(3,3)),120),
>                       
>                       
>                       ((0,3,2,0,(0,0)),100),((0,3,2,0,(0,1)),200),((0,3,2,0,(0,2)),180),((0,3,2,0,(0,3)),180),
>                       ((0,3,2,0,(1,0)),60),((0,3,2,0,(1,1)),200),((0,3,2,0,(1,2)),130),((0,3,2,0,(1,3)),40),
>                       ((0,3,2,0,(2,0)),0),((0,3,2,0,(2,1)),200),((0,3,2,0,(2,2)),70),((0,3,2,0,(2,3)),160),
>                       ((0,3,2,0,(3,0)),200),((0,3,2,0,(3,1)),200),((0,3,2,0,(3,2)),200),((0,3,2,0,(3,3)),200),
>                       
>                       ((0,3,2,1,(0,0)),100),((0,3,2,1,(0,1)),200),((0,3,2,1,(0,2)),180),((0,3,2,1,(0,3)),80),
>                       ((0,3,2,1,(1,0)),200),((0,3,2,1,(1,1)),200),((0,3,2,1,(1,2)),240),((0,3,2,1,(1,3)),180),
>                       ((0,3,2,1,(2,0)),200),((0,3,2,1,(2,1)),200),((0,3,2,1,(2,2)),200),((0,3,2,1,(2,3)),200),
>                       ((0,3,2,1,(3,0)),200),((0,3,2,1,(3,1)),200),((0,3,2,1,(3,2)),240),((0,3,2,1,(3,3)),180),
>                       
>                       ((0,3,2,2,(0,0)),0),((0,3,2,2,(0,1)),200),((0,3,2,2,(0,2)),70),((0,3,2,2,(0,3)),160),
>                       ((0,3,2,2,(1,0)),200),((0,3,2,2,(1,1)),200),((0,3,2,2,(1,2)),200),((0,3,2,2,(1,3)),200),
>                       ((0,3,2,2,(2,0)),40),((0,3,2,2,(2,1)),200),((0,3,2,2,(2,2)),110),((0,3,2,2,(2,3)),120),
>                       ((0,3,2,2,(3,0)),0),((0,3,2,2,(3,1)),200),((0,3,2,2,(3,2)),0),((0,3,2,2,(3,3)),-200),
>                       
>                       ((0,3,2,3,(0,0)),200),((0,3,2,3,(0,1)),200),((0,3,2,3,(0,2)),200),((0,3,2,3,(0,3)),200),
>                       ((0,3,2,3,(1,0)),170),((0,3,2,3,(1,1)),200),((0,3,2,3,(1,2)),210),((0,3,2,3,(1,3)),150),
>                       ((0,3,2,3,(2,0)),130),((0,3,2,3,(2,1)),200),((0,3,2,3,(2,2)),120),((0,3,2,3,(2,3)),-70),
>                       ((0,3,2,3,(3,0)),200),((0,3,2,3,(3,1)),200),((0,3,2,3,(3,2)),190),((0,3,2,3,(3,3)),180),
>                       
>                       
>                       ((0,3,3,0,(0,0)),200),((0,3,3,0,(0,1)),270),((0,3,3,0,(0,2)),30),((0,3,3,0,(0,3)),220),
>                       ((0,3,3,0,(1,0)),200),((0,3,3,0,(1,1)),160),((0,3,3,0,(1,2)),-110),((0,3,3,0,(1,3)),70),
>                       ((0,3,3,0,(2,0)),200),((0,3,3,0,(2,1)),200),((0,3,3,0,(2,2)),10),((0,3,3,0,(2,3)),190),
>                       ((0,3,3,0,(3,0)),200),((0,3,3,0,(3,1)),200),((0,3,3,0,(3,2)),200),((0,3,3,0,(3,3)),200),
>                       
>                       ((0,3,3,1,(0,0)),200),((0,3,3,1,(0,1)),210),((0,3,3,1,(0,2)),-70),((0,3,3,1,(0,3)),120),
>                       ((0,3,3,1,(1,0)),200),((0,3,3,1,(1,1)),210),((0,3,3,1,(1,2)),30),((0,3,3,1,(1,3)),120),
>                       ((0,3,3,1,(2,0)),200),((0,3,3,1,(2,1)),200),((0,3,3,1,(2,2)),200),((0,3,3,1,(2,3)),200),
>                       ((0,3,3,1,(3,0)),200),((0,3,3,1,(3,1)),210),((0,3,3,1,(3,2)),30),((0,3,3,1,(3,3)),120),
>                       
>                       ((0,3,3,2,(0,0)),200),((0,3,3,2,(0,1)),200),((0,3,3,2,(0,2)),10),((0,3,3,2,(0,3)),190),
>                       ((0,3,3,2,(1,0)),200),((0,3,3,2,(1,1)),200),((0,3,3,2,(1,2)),200),((0,3,3,2,(1,3)),200),
>                       ((0,3,3,2,(2,0)),200),((0,3,3,2,(2,1)),200),((0,3,3,2,(2,2)),-30),((0,3,3,2,(2,3)),150),
>                       ((0,3,3,2,(3,0)),200),((0,3,3,2,(3,1)),30),((0,3,3,2,(3,2)),-350),((0,3,3,2,(3,3)),20),
>                       
>                       ((0,3,3,3,(0,0)),200),((0,3,3,3,(0,1)),200),((0,3,3,3,(0,2)),200),((0,3,3,3,(0,3)),200),
>                       ((0,3,3,3,(1,0)),200),((0,3,3,3,(1,1)),180),((0,3,3,3,(1,2)),0),((0,3,3,3,(1,3)),90),
>                       ((0,3,3,3,(2,0)),200),((0,3,3,3,(2,1)),150),((0,3,3,3,(2,2)),-220),((0,3,3,3,(2,3)),150),
>                       ((0,3,3,3,(3,0)),200),((0,3,3,3,(3,1)),120),((0,3,3,3,(3,2)),30),((0,3,3,3,(3,3)),30),
>                       
>                       
>                       
>                       ((0,4,0,0,(0,0)),200),((0,4,0,0,(0,1)),240),((0,4,0,0,(0,2)),100),((0,4,0,0,(0,3)),200),
>                       ((0,4,0,0,(1,0)),180),((0,4,0,0,(1,1)),210),((0,4,0,0,(1,2)),80),((0,4,0,0,(1,3)),200),
>                       ((0,4,0,0,(2,0)),80),((0,4,0,0,(2,1)),110),((0,4,0,0,(2,2)),-20),((0,4,0,0,(2,3)),200),
>                       ((0,4,0,0,(3,0)),200),((0,4,0,0,(3,1)),200),((0,4,0,0,(3,2)),200),((0,4,0,0,(3,3)),200),
>                       
>                       ((0,4,0,1,(0,0)),190),((0,4,0,1,(0,1)),220),((0,4,0,1,(0,2)),90),((0,4,0,1,(0,3)),200),
>                       ((0,4,0,1,(1,0)),230),((0,4,0,1,(1,1)),210),((0,4,0,1,(1,2)),170),((0,4,0,1,(1,3)),200),
>                       ((0,4,0,1,(2,0)),200),((0,4,0,1,(2,1)),200),((0,4,0,1,(2,2)),200),((0,4,0,1,(2,3)),200),
>                       ((0,4,0,1,(3,0)),230),((0,4,0,1,(3,1)),210),((0,4,0,1,(3,2)),170),((0,4,0,1,(3,3)),200),
>                       
>                       ((0,4,0,2,(0,0)),80),((0,4,0,2,(0,1)),110),((0,4,0,2,(0,2)),-20),((0,4,0,2,(0,3)),200),
>                       ((0,4,0,2,(1,0)),200),((0,4,0,2,(1,1)),200),((0,4,0,2,(1,2)),200),((0,4,0,2,(1,3)),200),
>                       ((0,4,0,2,(2,0)),130),((0,4,0,2,(2,1)),170),((0,4,0,2,(2,2)),30),((0,4,0,2,(2,3)),200),
>                       ((0,4,0,2,(3,0)),60),((0,4,0,2,(3,1)),0),((0,4,0,2,(3,2)),40),((0,4,0,2,(3,3)),200),
>                       
>                       ((0,4,0,3,(0,0)),200),((0,4,0,3,(0,1)),200),((0,4,0,3,(0,2)),200),((0,4,0,3,(0,3)),200),
>                       ((0,4,0,3,(1,0)),230),((0,4,0,3,(1,1)),210),((0,4,0,3,(1,2)),170),((0,4,0,3,(1,3)),200),
>                       ((0,4,0,3,(2,0)),160),((0,4,0,3,(2,1)),90),((0,4,0,3,(2,2)),140),((0,4,0,3,(2,3)),200),
>                       ((0,4,0,3,(3,0)),190),((0,4,0,3,(3,1)),130),((0,4,0,3,(3,2)),180),((0,4,0,3,(3,3)),200),
>                       
>                       
>                       ((0,4,1,0,(0,0)),190),((0,4,1,0,(0,1)),280),((0,4,1,0,(0,2)),200),((0,4,1,0,(0,3)),270),
>                       ((0,4,1,0,(1,0)),170),((0,4,1,0,(1,1)),200),((0,4,1,0,(1,2)),200),((0,4,1,0,(1,3)),180),
>                       ((0,4,1,0,(2,0)),70),((0,4,1,0,(2,1)),200),((0,4,1,0,(2,2)),200),((0,4,1,0,(2,3)),180),
>                       ((0,4,1,0,(3,0)),200),((0,4,1,0,(3,1)),200),((0,4,1,0,(3,2)),200),((0,4,1,0,(3,3)),200),
>                       
>                       ((0,4,1,1,(0,0)),180),((0,4,1,1,(0,1)),210),((0,4,1,1,(0,2)),200),((0,4,1,1,(0,3)),190),
>                       ((0,4,1,1,(1,0)),160),((0,4,1,1,(1,1)),190),((0,4,1,1,(1,2)),200),((0,4,1,1,(1,3)),180),
>                       ((0,4,1,1,(2,0)),200),((0,4,1,1,(2,1)),200),((0,4,1,1,(2,2)),200),((0,4,1,1,(2,3)),200),
>                       ((0,4,1,1,(3,0)),160),((0,4,1,1,(3,1)),190),((0,4,1,1,(3,2)),200),((0,4,1,1,(3,3)),180),
>                       
>                       ((0,4,1,2,(0,0)),70),((0,4,1,2,(0,1)),200),((0,4,1,2,(0,2)),200),((0,4,1,2,(0,3)),180),
>                       ((0,4,1,2,(1,0)),200),((0,4,1,2,(1,1)),200),((0,4,1,2,(1,2)),200),((0,4,1,2,(1,3)),200),
>                       ((0,4,1,2,(2,0)),120),((0,4,1,2,(2,1)),210),((0,4,1,2,(2,2)),200),((0,4,1,2,(2,3)),200),
>                       ((0,4,1,2,(3,0)),-50),((0,4,1,2,(3,1)),80),((0,4,1,2,(3,2)),200),((0,4,1,2,(3,3)),70),
>                       
>                       ((0,4,1,3,(0,0)),200),((0,4,1,3,(0,1)),200),((0,4,1,3,(0,2)),200),((0,4,1,3,(0,3)),200),
>                       ((0,4,1,3,(1,0)),160),((0,4,1,3,(1,1)),190),((0,4,1,3,(1,2)),200),((0,4,1,3,(1,3)),180),
>                       ((0,4,1,3,(2,0)),50),((0,4,1,3,(2,1)),180),((0,4,1,3,(2,2)),200),((0,4,1,3,(2,3)),160),
>                       ((0,4,1,3,(3,0)),80),((0,4,1,3,(3,1)),110),((0,4,1,3,(3,2)),200),((0,4,1,3,(3,3)),100),
>                       
>                       
>                       ((0,4,2,0,(0,0)),100),((0,4,2,0,(0,1)),200),((0,4,2,0,(0,2)),180),((0,4,2,0,(0,3)),180),
>                       ((0,4,2,0,(1,0)),80),((0,4,2,0,(1,1)),200),((0,4,2,0,(1,2)),150),((0,4,2,0,(1,3)),60),
>                       ((0,4,2,0,(2,0)),-20),((0,4,2,0,(2,1)),200),((0,4,2,0,(2,2)),50),((0,4,2,0,(2,3)),140),
>                       ((0,4,2,0,(3,0)),200),((0,4,2,0,(3,1)),200),((0,4,2,0,(3,2)),200),((0,4,2,0,(3,3)),200),
>                       
>                       ((0,4,2,1,(0,0)),90),((0,4,2,1,(0,1)),200),((0,4,2,1,(0,2)),160),((0,4,2,1,(0,3)),70),
>                       ((0,4,2,1,(1,0)),170),((0,4,2,1,(1,1)),200),((0,4,2,1,(1,2)),210),((0,4,2,1,(1,3)),150),
>                       ((0,4,2,1,(2,0)),200),((0,4,2,1,(2,1)),200),((0,4,2,1,(2,2)),200),((0,4,2,1,(2,3)),200),
>                       ((0,4,2,1,(3,0)),170),((0,4,2,1,(3,1)),200),((0,4,2,1,(3,2)),210),((0,4,2,1,(3,3)),150),
>                       
>                       ((0,4,2,2,(0,0)),-20),((0,4,2,2,(0,1)),200),((0,4,2,2,(0,2)),50),((0,4,2,2,(0,3)),140),
>                       ((0,4,2,2,(1,0)),200),((0,4,2,2,(1,1)),200),((0,4,2,2,(1,2)),200),((0,4,2,2,(1,3)),200),
>                       ((0,4,2,2,(2,0)),30),((0,4,2,2,(2,1)),200),((0,4,2,2,(2,2)),110),((0,4,2,2,(2,3)),110),
>                       ((0,4,2,2,(3,0)),40),((0,4,2,2,(3,1)),200),((0,4,2,2,(3,2)),40),((0,4,2,2,(3,3)),-160),
>                       
>                       ((0,4,2,3,(0,0)),200),((0,4,2,3,(0,1)),200),((0,4,2,3,(0,2)),200),((0,4,2,3,(0,3)),200),
>                       ((0,4,2,3,(1,0)),170),((0,4,2,3,(1,1)),200),((0,4,2,3,(1,2)),210),((0,4,2,3,(1,3)),150),
>                       ((0,4,2,3,(2,0)),140),((0,4,2,3,(2,1)),200),((0,4,2,3,(2,2)),130),((0,4,2,3,(2,3)),-60),
>                       ((0,4,2,3,(3,0)),180),((0,4,2,3,(3,1)),200),((0,4,2,3,(3,2)),170),((0,4,2,3,(3,3)),160),
>                       
>                       
>                       ((0,4,3,0,(0,0)),200),((0,4,3,0,(0,1)),270),((0,4,3,0,(0,2)),30),((0,4,3,0,(0,3)),220),
>                       ((0,4,3,0,(1,0)),200),((0,4,3,0,(1,1)),180),((0,4,3,0,(1,2)),-90),((0,4,3,0,(1,3)),90),
>                       ((0,4,3,0,(2,0)),200),((0,4,3,0,(2,1)),180),((0,4,3,0,(2,2)),-10),((0,4,3,0,(2,3)),180),
>                       ((0,4,3,0,(3,0)),200),((0,4,3,0,(3,1)),200),((0,4,3,0,(3,2)),200),((0,4,3,0,(3,3)),200),
>                       
>                       ((0,4,3,1,(0,0)),200),((0,4,3,1,(0,1)),190),((0,4,3,1,(0,2)),-80),((0,4,3,1,(0,3)),100),
>                       ((0,4,3,1,(1,0)),200),((0,4,3,1,(1,1)),180),((0,4,3,1,(1,2)),0),((0,4,3,1,(1,3)),90),
>                       ((0,4,3,1,(2,0)),200),((0,4,3,1,(2,1)),200),((0,4,3,1,(2,2)),200),((0,4,3,1,(2,3)),200),
>                       ((0,4,3,1,(3,0)),200),((0,4,3,1,(3,1)),180),((0,4,3,1,(3,2)),0),((0,4,3,1,(3,3)),90),
>                       
>                       ((0,4,3,2,(0,0)),200),((0,4,3,2,(0,1)),180),((0,4,3,2,(0,2)),-10),((0,4,3,2,(0,3)),180),
>                       ((0,4,3,2,(1,0)),200),((0,4,3,2,(1,1)),200),((0,4,3,2,(1,2)),200),((0,4,3,2,(1,3)),200),
>                       ((0,4,3,2,(2,0)),200),((0,4,3,2,(2,1)),200),((0,4,3,2,(2,2)),-40),((0,4,3,2,(2,3)),150),
>                       ((0,4,3,2,(3,0)),200),((0,4,3,2,(3,1)),70),((0,4,3,2,(3,2)),-310),((0,4,3,2,(3,3)),60),
>                       
>                       ((0,4,3,3,(0,0)),200),((0,4,3,3,(0,1)),200),((0,4,3,3,(0,2)),200),((0,4,3,3,(0,3)),200),
>                       ((0,4,3,3,(1,0)),200),((0,4,3,3,(1,1)),180),((0,4,3,3,(1,2)),0),((0,4,3,3,(1,3)),90),
>                       ((0,4,3,3,(2,0)),200),((0,4,3,3,(2,1)),160),((0,4,3,3,(2,2)),-210),((0,4,3,3,(2,3)),160),
>                       ((0,4,3,3,(3,0)),200),((0,4,3,3,(3,1)),100),((0,4,3,3,(3,2)),0),((0,4,3,3,(3,3)),10),
>                       
>                       
>                       
>                       ((0,5,0,0,(0,0)),200),((0,5,0,0,(0,1)),240),((0,5,0,0,(0,2)),100),((0,5,0,0,(0,3)),200),
>                       ((0,5,0,0,(1,0)),160),((0,5,0,0,(1,1)),190),((0,5,0,0,(1,2)),60),((0,5,0,0,(1,3)),200),
>                       ((0,5,0,0,(2,0)),100),((0,5,0,0,(2,1)),130),((0,5,0,0,(2,2)),0),((0,5,0,0,(2,3)),200),
>                       ((0,5,0,0,(3,0)),200),((0,5,0,0,(3,1)),200),((0,5,0,0,(3,2)),200),((0,5,0,0,(3,3)),200),
>                       
>                       ((0,5,0,1,(0,0)),200),((0,5,0,1,(0,1)),240),((0,5,0,1,(0,2)),100),((0,5,0,1,(0,3)),200),
>                       ((0,5,0,1,(1,0)),260),((0,5,0,1,(1,1)),240),((0,5,0,1,(1,2)),200),((0,5,0,1,(1,3)),200),
>                       ((0,5,0,1,(2,0)),200),((0,5,0,1,(2,1)),200),((0,5,0,1,(2,2)),200),((0,5,0,1,(2,3)),200),
>                       ((0,5,0,1,(3,0)),260),((0,5,0,1,(3,1)),240),((0,5,0,1,(3,2)),200),((0,5,0,1,(3,3)),200),
>                       
>                       ((0,5,0,2,(0,0)),100),((0,5,0,2,(0,1)),130),((0,5,0,2,(0,2)),0),((0,5,0,2,(0,3)),200),
>                       ((0,5,0,2,(1,0)),200),((0,5,0,2,(1,1)),200),((0,5,0,2,(1,2)),200),((0,5,0,2,(1,3)),200),
>                       ((0,5,0,2,(2,0)),140),((0,5,0,2,(2,1)),170),((0,5,0,2,(2,2)),40),((0,5,0,2,(2,3)),200),
>                       ((0,5,0,2,(3,0)),20),((0,5,0,2,(3,1)),-40),((0,5,0,2,(3,2)),0),((0,5,0,2,(3,3)),200),
>                       
>                       ((0,5,0,3,(0,0)),200),((0,5,0,3,(0,1)),200),((0,5,0,3,(0,2)),200),((0,5,0,3,(0,3)),200),
>                       ((0,5,0,3,(1,0)),230),((0,5,0,3,(1,1)),210),((0,5,0,3,(1,2)),170),((0,5,0,3,(1,3)),200),
>                       ((0,5,0,3,(2,0)),150),((0,5,0,3,(2,1)),80),((0,5,0,3,(2,2)),130),((0,5,0,3,(2,3)),200),
>                       ((0,5,0,3,(3,0)),220),((0,5,0,3,(3,1)),150),((0,5,0,3,(3,2)),200),((0,5,0,3,(3,3)),200),
>                       
>                       
>                       ((0,5,1,0,(0,0)),190),((0,5,1,0,(0,1)),280),((0,5,1,0,(0,2)),200),((0,5,1,0,(0,3)),270),
>                       ((0,5,1,0,(1,0)),150),((0,5,1,0,(1,1)),180),((0,5,1,0,(1,2)),200),((0,5,1,0,(1,3)),160),
>                       ((0,5,1,0,(2,0)),90),((0,5,1,0,(2,1)),220),((0,5,1,0,(2,2)),200),((0,5,1,0,(2,3)),200),
>                       ((0,5,1,0,(3,0)),200),((0,5,1,0,(3,1)),200),((0,5,1,0,(3,2)),200),((0,5,1,0,(3,3)),200),
>                       
>                       ((0,5,1,1,(0,0)),190),((0,5,1,1,(0,1)),220),((0,5,1,1,(0,2)),200),((0,5,1,1,(0,3)),210),
>                       ((0,5,1,1,(1,0)),190),((0,5,1,1,(1,1)),220),((0,5,1,1,(1,2)),200),((0,5,1,1,(1,3)),210),
>                       ((0,5,1,1,(2,0)),200),((0,5,1,1,(2,1)),200),((0,5,1,1,(2,2)),200),((0,5,1,1,(2,3)),200),
>                       ((0,5,1,1,(3,0)),190),((0,5,1,1,(3,1)),220),((0,5,1,1,(3,2)),200),((0,5,1,1,(3,3)),210),
>                       
>                       ((0,5,1,2,(0,0)),90),((0,5,1,2,(0,1)),220),((0,5,1,2,(0,2)),200),((0,5,1,2,(0,3)),200),
>                       ((0,5,1,2,(1,0)),200),((0,5,1,2,(1,1)),200),((0,5,1,2,(1,2)),200),((0,5,1,2,(1,3)),200),
>                       ((0,5,1,2,(2,0)),130),((0,5,1,2,(2,1)),220),((0,5,1,2,(2,2)),200),((0,5,1,2,(2,3)),200),
>                       ((0,5,1,2,(3,0)),-90),((0,5,1,2,(3,1)),40),((0,5,1,2,(3,2)),200),((0,5,1,2,(3,3)),30),
>                       
>                       ((0,5,1,3,(0,0)),200),((0,5,1,3,(0,1)),200),((0,5,1,3,(0,2)),200),((0,5,1,3,(0,3)),200),
>                       ((0,5,1,3,(1,0)),160),((0,5,1,3,(1,1)),190),((0,5,1,3,(1,2)),200),((0,5,1,3,(1,3)),180),
>                       ((0,5,1,3,(2,0)),40),((0,5,1,3,(2,1)),170),((0,5,1,3,(2,2)),200),((0,5,1,3,(2,3)),150),
>                       ((0,5,1,3,(3,0)),110),((0,5,1,3,(3,1)),140),((0,5,1,3,(3,2)),200),((0,5,1,3,(3,3)),120),
>                       
>                       
>                       ((0,5,2,0,(0,0)),100),((0,5,2,0,(0,1)),200),((0,5,2,0,(0,2)),180),((0,5,2,0,(0,3)),180),
>                       ((0,5,2,0,(1,0)),60),((0,5,2,0,(1,1)),200),((0,5,2,0,(1,2)),130),((0,5,2,0,(1,3)),40),
>                       ((0,5,2,0,(2,0)),0),((0,5,2,0,(2,1)),200),((0,5,2,0,(2,2)),70),((0,5,2,0,(2,3)),160),
>                       ((0,5,2,0,(3,0)),200),((0,5,2,0,(3,1)),200),((0,5,2,0,(3,2)),200),((0,5,2,0,(3,3)),200),
>                       
>                       ((0,5,2,1,(0,0)),100),((0,5,2,1,(0,1)),200),((0,5,2,1,(0,2)),180),((0,5,2,1,(0,3)),80),
>                       ((0,5,2,1,(1,0)),200),((0,5,2,1,(1,1)),200),((0,5,2,1,(1,2)),240),((0,5,2,1,(1,3)),180),
>                       ((0,5,2,1,(2,0)),200),((0,5,2,1,(2,1)),200),((0,5,2,1,(2,2)),200),((0,5,2,1,(2,3)),200),
>                       ((0,5,2,1,(3,0)),200),((0,5,2,1,(3,1)),200),((0,5,2,1,(3,2)),240),((0,5,2,1,(3,3)),180),
>                       
>                       ((0,5,2,2,(0,0)),0),((0,5,2,2,(0,1)),200),((0,5,2,2,(0,2)),70),((0,5,2,2,(0,3)),160),
>                       ((0,5,2,2,(1,0)),200),((0,5,2,2,(1,1)),200),((0,5,2,2,(1,2)),200),((0,5,2,2,(1,3)),200),
>                       ((0,5,2,2,(2,0)),40),((0,5,2,2,(2,1)),200),((0,5,2,2,(2,2)),110),((0,5,2,2,(2,3)),120),
>                       ((0,5,2,2,(3,0)),0),((0,5,2,2,(3,1)),200),((0,5,2,2,(3,2)),0),((0,5,2,2,(3,3)),-200),
>                       
>                       ((0,5,2,3,(0,0)),200),((0,5,2,3,(0,1)),200),((0,5,2,3,(0,2)),200),((0,5,2,3,(0,3)),200),
>                       ((0,5,2,3,(1,0)),170),((0,5,2,3,(1,1)),200),((0,5,2,3,(1,2)),210),((0,5,2,3,(1,3)),150),
>                       ((0,5,2,3,(2,0)),130),((0,5,2,3,(2,1)),200),((0,5,2,3,(2,2)),120),((0,5,2,3,(2,3)),-70),
>                       ((0,5,2,3,(3,0)),200),((0,5,2,3,(3,1)),200),((0,5,2,3,(3,2)),190),((0,5,2,3,(3,3)),180),
>                       
>                       
>                       ((0,5,3,0,(0,0)),200),((0,5,3,0,(0,1)),270),((0,5,3,0,(0,2)),30),((0,5,3,0,(0,3)),220),
>                       ((0,5,3,0,(1,0)),200),((0,5,3,0,(1,1)),160),((0,5,3,0,(1,2)),-110),((0,5,3,0,(1,3)),70),
>                       ((0,5,3,0,(2,0)),200),((0,5,3,0,(2,1)),200),((0,5,3,0,(2,2)),10),((0,5,3,0,(2,3)),190),
>                       ((0,5,3,0,(3,0)),200),((0,5,3,0,(3,1)),200),((0,5,3,0,(3,2)),200),((0,5,3,0,(3,3)),200),
>                       
>                       ((0,5,3,1,(0,0)),200),((0,5,3,1,(0,1)),210),((0,5,3,1,(0,2)),-70),((0,5,3,1,(0,3)),120),
>                       ((0,5,3,1,(1,0)),200),((0,5,3,1,(1,1)),210),((0,5,3,1,(1,2)),30),((0,5,3,1,(1,3)),120),
>                       ((0,5,3,1,(2,0)),200),((0,5,3,1,(2,1)),200),((0,5,3,1,(2,2)),200),((0,5,3,1,(2,3)),200),
>                       ((0,5,3,1,(3,0)),200),((0,5,3,1,(3,1)),210),((0,5,3,1,(3,2)),30),((0,5,3,1,(3,3)),120),
>                       
>                       ((0,5,3,2,(0,0)),200),((0,5,3,2,(0,1)),200),((0,5,3,2,(0,2)),10),((0,5,3,2,(0,3)),190),
>                       ((0,5,3,2,(1,0)),200),((0,5,3,2,(1,1)),200),((0,5,3,2,(1,2)),200),((0,5,3,2,(1,3)),200),
>                       ((0,5,3,2,(2,0)),200),((0,5,3,2,(2,1)),200),((0,5,3,2,(2,2)),-30),((0,5,3,2,(2,3)),150),
>                       ((0,5,3,2,(3,0)),200),((0,5,3,2,(3,1)),30),((0,5,3,2,(3,2)),-350),((0,5,3,2,(3,3)),20),
>                       
>                       ((0,5,3,3,(0,0)),200),((0,5,3,3,(0,1)),200),((0,5,3,3,(0,2)),200),((0,5,3,3,(0,3)),200),
>                       ((0,5,3,3,(1,0)),200),((0,5,3,3,(1,1)),180),((0,5,3,3,(1,2)),0),((0,5,3,3,(1,3)),90),
>                       ((0,5,3,3,(2,0)),200),((0,5,3,3,(2,1)),150),((0,5,3,3,(2,2)),-220),((0,5,3,3,(2,3)),150),
>                       ((0,5,3,3,(3,0)),200),((0,5,3,3,(3,1)),120),((0,5,3,3,(3,2)),30),((0,5,3,3,(3,3)),30),
>                       
>                       
>                       
>                       
>                       ((1,0,0,0,(0,0)),50),((1,0,0,0,(0,1)),110),((1,0,0,0,(0,2)),40),((1,0,0,0,(0,3)),200),
>                       ((1,0,0,0,(1,0)),130),((1,0,0,0,(1,1)),100),((1,0,0,0,(1,2)),70),((1,0,0,0,(1,3)),200),
>                       ((1,0,0,0,(2,0)),-20),((1,0,0,0,(2,1)),70),((1,0,0,0,(2,2)),-50),((1,0,0,0,(2,3)),200),
>                       ((1,0,0,0,(3,0)),200),((1,0,0,0,(3,1)),200),((1,0,0,0,(3,2)),200),((1,0,0,0,(3,3)),200),
>                       
>                       ((1,0,0,1,(0,0)),60),((1,0,0,1,(0,1)),110),((1,0,0,1,(0,2)),50),((1,0,0,1,(0,3)),200),
>                       ((1,0,0,1,(1,0)),220),((1,0,0,1,(1,1)),190),((1,0,0,1,(1,2)),70),((1,0,0,1,(1,3)),200),
>                       ((1,0,0,1,(2,0)),200),((1,0,0,1,(2,1)),200),((1,0,0,1,(2,2)),200),((1,0,0,1,(2,3)),200),
>                       ((1,0,0,1,(3,0)),200),((1,0,0,1,(3,1)),110),((1,0,0,1,(3,2)),50),((1,0,0,1,(3,3)),200),
>                       
>                       ((1,0,0,2,(0,0)),0),((1,0,0,2,(0,1)),-100),((1,0,0,2,(0,2)),-70),((1,0,0,2,(0,3)),200),
>                       ((1,0,0,2,(1,0)),200),((1,0,0,2,(1,1)),200),((1,0,0,2,(1,2)),200),((1,0,0,2,(1,3)),200),
>                       ((1,0,0,2,(2,0)),110),((1,0,0,2,(2,1)),80),((1,0,0,2,(2,2)),-20),((1,0,0,2,(2,3)),200),
>                       ((1,0,0,2,(3,0)),-10),((1,0,0,2,(3,1)),-160),((1,0,0,2,(3,2)),-60),((1,0,0,2,(3,3)),200),
>                       
>                       ((1,0,0,3,(0,0)),200),((1,0,0,3,(0,1)),200),((1,0,0,3,(0,2)),200),((1,0,0,3,(0,3)),200),
>                       ((1,0,0,3,(1,0)),200),((1,0,0,3,(1,1)),110),((1,0,0,3,(1,2)),100),((1,0,0,3,(1,3)),200),
>                       ((1,0,0,3,(2,0)),90),((1,0,0,3,(2,1)),-10),((1,0,0,3,(2,2)),60),((1,0,0,3,(2,3)),200),
>                       ((1,0,0,3,(3,0)),140),((1,0,0,3,(3,1)),30),((1,0,0,3,(3,2)),140),((1,0,0,3,(3,3)),200),
>                       
>                       
>                       ((1,0,1,0,(0,0)),110),((1,0,1,0,(0,1)),170),((1,0,1,0,(0,2)),200),((1,0,1,0,(0,3)),180),
>                       ((1,0,1,0,(1,0)),100),((1,0,1,0,(1,1)),100),((1,0,1,0,(1,2)),200),((1,0,1,0,(1,3)),110),
>                       ((1,0,1,0,(2,0)),-40),((1,0,1,0,(2,1)),110),((1,0,1,0,(2,2)),200),((1,0,1,0,(2,3)),120),
>                       ((1,0,1,0,(3,0)),200),((1,0,1,0,(3,1)),200),((1,0,1,0,(3,2)),200),((1,0,1,0,(3,3)),200),
>                       
>                       ((1,0,1,1,(0,0)),150),((1,0,1,1,(0,1)),150),((1,0,1,1,(0,2)),200),((1,0,1,1,(0,3)),150),
>                       ((1,0,1,1,(1,0)),130),((1,0,1,1,(1,1)),130),((1,0,1,1,(1,2)),200),((1,0,1,1,(1,3)),140),
>                       ((1,0,1,1,(2,0)),200),((1,0,1,1,(2,1)),200),((1,0,1,1,(2,2)),200),((1,0,1,1,(2,3)),200),
>                       ((1,0,1,1,(3,0)),120),((1,0,1,1,(3,1)),120),((1,0,1,1,(3,2)),200),((1,0,1,1,(3,3)),120),
>                       
>                       ((1,0,1,2,(0,0)),-70),((1,0,1,2,(0,1)),-60),((1,0,1,2,(0,2)),200),((1,0,1,2,(0,3)),120),
>                       ((1,0,1,2,(1,0)),200),((1,0,1,2,(1,1)),200),((1,0,1,2,(1,2)),200),((1,0,1,2,(1,3)),200),
>                       ((1,0,1,2,(2,0)),90),((1,0,1,2,(2,1)),150),((1,0,1,2,(2,2)),200),((1,0,1,2,(2,3)),150),
>                       ((1,0,1,2,(3,0)),-160),((1,0,1,2,(3,1)),-60),((1,0,1,2,(3,2)),200),((1,0,1,2,(3,3)),-50),
>                       
>                       ((1,0,1,3,(0,0)),200),((1,0,1,3,(0,1)),200),((1,0,1,3,(0,2)),200),((1,0,1,3,(0,3)),200),
>                       ((1,0,1,3,(1,0)),120),((1,0,1,3,(1,1)),120),((1,0,1,3,(1,2)),200),((1,0,1,3,(1,3)),120),
>                       ((1,0,1,3,(2,0)),0),((1,0,1,3,(2,1)),100),((1,0,1,3,(2,2)),200),((1,0,1,3,(2,3)),100),
>                       ((1,0,1,3,(3,0)),30),((1,0,1,3,(3,1)),30),((1,0,1,3,(3,2)),200),((1,0,1,3,(3,3)),30),
>                       
>                       
>                       ((1,0,2,0,(0,0)),-30),((1,0,2,0,(0,1)),200),((1,0,2,0,(0,2)),100),((1,0,2,0,(0,3)),-50),
>                       ((1,0,2,0,(1,0)),-70),((1,0,2,0,(1,1)),200),((1,0,2,0,(1,2)),90),((1,0,2,0,(1,3)),-150),
>                       ((1,0,2,0,(2,0)),-170),((1,0,2,0,(2,1)),200),((1,0,2,0,(2,2)),0),((1,0,2,0,(2,3)),-130),
>                       ((1,0,2,0,(3,0)),200),((1,0,2,0,(3,1)),200),((1,0,2,0,(3,2)),200),((1,0,2,0,(3,3)),200),
>                       
>                       ((1,0,2,1,(0,0)),10),((1,0,2,1,(0,1)),200),((1,0,2,1,(0,2)),140),((1,0,2,1,(0,3)),-60),
>                       ((1,0,2,1,(1,0)),70),((1,0,2,1,(1,1)),200),((1,0,2,1,(1,2)),180),((1,0,2,1,(1,3)),-20),
>                       ((1,0,2,1,(2,0)),200),((1,0,2,1,(2,1)),200),((1,0,2,1,(2,2)),200),((1,0,2,1,(2,3)),200),
>                       ((1,0,2,1,(3,0)),40),((1,0,2,1,(3,1)),200),((1,0,2,1,(3,2)),170),((1,0,2,1,(3,3)),-10),
>                       
>                       ((1,0,2,2,(0,0)),-160),((1,0,2,2,(0,1)),200),((1,0,2,2,(0,2)),0),((1,0,2,2,(0,3)),-60),
>                       ((1,0,2,2,(1,0)),200),((1,0,2,2,(1,1)),200),((1,0,2,2,(1,2)),200),((1,0,2,2,(1,3)),200),
>                       ((1,0,2,2,(2,0)),-90),((1,0,2,2,(2,1)),200),((1,0,2,2,(2,2)),80),((1,0,2,2,(2,3)),-60),
>                       ((1,0,2,2,(3,0)),-160),((1,0,2,2,(3,1)),200),((1,0,2,2,(3,2)),-70),((1,0,2,2,(3,3)),-410),
>                       
>                       ((1,0,2,3,(0,0)),200),((1,0,2,3,(0,1)),200),((1,0,2,3,(0,2)),200),((1,0,2,3,(0,3)),200),
>                       ((1,0,2,3,(1,0)),40),((1,0,2,3,(1,1)),200),((1,0,2,3,(1,2)),170),((1,0,2,3,(1,3)),-30),
>                       ((1,0,2,3,(2,0)),30),((1,0,2,3,(2,1)),200),((1,0,2,3,(2,2)),90),((1,0,2,3,(2,3)),-240),
>                       ((1,0,2,3,(3,0)),50),((1,0,2,3,(3,1)),200),((1,0,2,3,(3,2)),120),((1,0,2,3,(3,3)),10),
>                       
>                       
>                       ((1,0,3,0,(0,0)),200),((1,0,3,0,(0,1)),70),((1,0,3,0,(0,2)),10),((1,0,3,0,(0,3)),150),
>                       ((1,0,3,0,(1,0)),200),((1,0,3,0,(1,1)),0),((1,0,3,0,(1,2)),-190),((1,0,3,0,(1,3)),-20),
>                       ((1,0,3,0,(2,0)),200),((1,0,3,0,(2,1)),20),((1,0,3,0,(2,2)),-90),((1,0,3,0,(2,3)),90),
>                       ((1,0,3,0,(3,0)),200),((1,0,3,0,(3,1)),200),((1,0,3,0,(3,2)),200),((1,0,3,0,(3,3)),200),
>                       
>                       ((1,0,3,1,(0,0)),200),((1,0,3,1,(0,1)),50),((1,0,3,1,(0,2)),-70),((1,0,3,1,(0,3)),0),
>                       ((1,0,3,1,(1,0)),200),((1,0,3,1,(1,1)),30),((1,0,3,1,(1,2)),-30),((1,0,3,1,(1,3)),-10),
>                       ((1,0,3,1,(2,0)),200),((1,0,3,1,(2,1)),200),((1,0,3,1,(2,2)),200),((1,0,3,1,(2,3)),200),
>                       ((1,0,3,1,(3,0)),200),((1,0,3,1,(3,1)),20),((1,0,3,1,(3,2)),-70),((1,0,3,1,(3,3)),40),
>                       
>                       ((1,0,3,2,(0,0)),200),((1,0,3,2,(0,1)),20),((1,0,3,2,(0,2)),-80),((1,0,3,2,(0,3)),90),
>                       ((1,0,3,2,(1,0)),200),((1,0,3,2,(1,1)),200),((1,0,3,2,(1,2)),200),((1,0,3,2,(1,3)),200),
>                       ((1,0,3,2,(2,0)),200),((1,0,3,2,(2,1)),50),((1,0,3,2,(2,2)),-100),((1,0,3,2,(2,3)),110),
>                       ((1,0,3,2,(3,0)),200),((1,0,3,2,(3,1)),-160),((1,0,3,2,(3,2)),-440),((1,0,3,2,(3,3)),-100),
>                       
>                       ((1,0,3,3,(0,0)),200),((1,0,3,3,(0,1)),200),((1,0,3,3,(0,2)),200),((1,0,3,3,(0,3)),200),
>                       ((1,0,3,3,(1,0)),200),((1,0,3,3,(1,1)),170),((1,0,3,3,(1,2)),-70),((1,0,3,3,(1,3)),20),
>                       ((1,0,3,3,(2,0)),200),((1,0,3,3,(2,1)),0),((1,0,3,3,(2,2)),-300),((1,0,3,3,(2,3)),60),
>                       ((1,0,3,3,(3,0)),200),((1,0,3,3,(3,1)),10),((1,0,3,3,(3,2)),-100),((1,0,3,3,(3,3)),60),
>                       
>                       
>                       
>                       ((1,1,0,0,(0,0)),150),((1,1,0,0,(0,1)),120),((1,1,0,0,(0,2)),10),((1,1,0,0,(0,3)),200),
>                       ((1,1,0,0,(1,0)),120),((1,1,0,0,(1,1)),90),((1,1,0,0,(1,2)),-10),((1,1,0,0,(1,3)),200),
>                       ((1,1,0,0,(2,0)),-50),((1,1,0,0,(2,1)),-80),((1,1,0,0,(2,2)),-190),((1,1,0,0,(2,3)),200),
>                       ((1,1,0,0,(3,0)),200),((1,1,0,0,(3,1)),200),((1,1,0,0,(3,2)),200),((1,1,0,0,(3,3)),200),
>                       
>                       ((1,1,0,1,(0,0)),120),((1,1,0,1,(0,1)),90),((1,1,0,1,(0,2)),-20),((1,1,0,1,(0,3)),200),
>                       ((1,1,0,1,(1,0)),180),((1,1,0,1,(1,1)),90),((1,1,0,1,(1,2)),90),((1,1,0,1,(1,3)),200),
>                       ((1,1,0,1,(2,0)),200),((1,1,0,1,(2,1)),200),((1,1,0,1,(2,2)),200),((1,1,0,1,(2,3)),200),
>                       ((1,1,0,1,(3,0)),80),((1,1,0,1,(3,1)),0),((1,1,0,1,(3,2)),-10),((1,1,0,1,(3,3)),200),
>                       
>                       ((1,1,0,2,(0,0)),10),((1,1,0,2,(0,1)),-20),((1,1,0,2,(0,2)),-130),((1,1,0,2,(0,3)),200),
>                       ((1,1,0,2,(1,0)),200),((1,1,0,2,(1,1)),200),((1,1,0,2,(1,2)),200),((1,1,0,2,(1,3)),200),
>                       ((1,1,0,2,(2,0)),110),((1,1,0,2,(2,1)),80),((1,1,0,2,(2,2)),-20),((1,1,0,2,(2,3)),200),
>                       ((1,1,0,2,(3,0)),-70),((1,1,0,2,(3,1)),-200),((1,1,0,2,(3,2)),-130),((1,1,0,2,(3,3)),200),
>                       
>                       ((1,1,0,3,(0,0)),200),((1,1,0,3,(0,1)),200),((1,1,0,3,(0,2)),200),((1,1,0,3,(0,3)),200),
>                       ((1,1,0,3,(1,0)),190),((1,1,0,3,(1,1)),100),((1,1,0,3,(1,2)),90),((1,1,0,3,(1,3)),200),
>                       ((1,1,0,3,(2,0)),-30),((1,1,0,3,(2,1)),-160),((1,1,0,3,(2,2)),-90),((1,1,0,3,(2,3)),200),
>                       ((1,1,0,3,(3,0)),150),((1,1,0,3,(3,1)),20),((1,1,0,3,(3,2)),90),((1,1,0,3,(3,3)),200),
>                       
>                       
>                       ((1,1,1,0,(0,0)),120),((1,1,1,0,(0,1)),180),((1,1,1,0,(0,2)),200),((1,1,1,0,(0,3)),190),
>                       ((1,1,1,0,(1,0)),100),((1,1,1,0,(1,1)),100),((1,1,1,0,(1,2)),200),((1,1,1,0,(1,3)),100),
>                       ((1,1,1,0,(2,0)),-80),((1,1,1,0,(2,1)),20),((1,1,1,0,(2,2)),200),((1,1,1,0,(2,3)),30),
>                       ((1,1,1,0,(3,0)),200),((1,1,1,0,(3,1)),200),((1,1,1,0,(3,2)),200),((1,1,1,0,(3,3)),200),
>                       
>                       ((1,1,1,1,(0,0)),90),((1,1,1,1,(0,1)),90),((1,1,1,1,(0,2)),200),((1,1,1,1,(0,3)),100),
>                       ((1,1,1,1,(1,0)),100),((1,1,1,1,(1,1)),100),((1,1,1,1,(1,2)),200),((1,1,1,1,(1,3)),100),
>                       ((1,1,1,1,(2,0)),200),((1,1,1,1,(2,1)),200),((1,1,1,1,(2,2)),200),((1,1,1,1,(2,3)),200),
>                       ((1,1,1,1,(3,0)),0),((1,1,1,1,(3,1)),0),((1,1,1,1,(3,2)),200),((1,1,1,1,(3,3)),0),
>                       
>                       ((1,1,1,2,(0,0)),-10),((1,1,1,2,(0,1)),90),((1,1,1,2,(0,2)),200),((1,1,1,2,(0,3)),90),
>                       ((1,1,1,2,(1,0)),200),((1,1,1,2,(1,1)),200),((1,1,1,2,(1,2)),200),((1,1,1,2,(1,3)),200),
>                       ((1,1,1,2,(2,0)),90),((1,1,1,2,(2,1)),150),((1,1,1,2,(2,2)),200),((1,1,1,2,(2,3)),150),
>                       ((1,1,1,2,(3,0)),-190),((1,1,1,2,(3,1)),-90),((1,1,1,2,(3,2)),200),((1,1,1,2,(3,3)),-90),
>                       
>                       ((1,1,1,3,(0,0)),200),((1,1,1,3,(0,1)),200),((1,1,1,3,(0,2)),200),((1,1,1,3,(0,3)),200),
>                       ((1,1,1,3,(1,0)),100),((1,1,1,3,(1,1)),100),((1,1,1,3,(1,2)),200),((1,1,1,3,(1,3)),110),
>                       ((1,1,1,3,(2,0)),-150),((1,1,1,3,(2,1)),-50),((1,1,1,3,(2,2)),200),((1,1,1,3,(2,3)),-50),
>                       ((1,1,1,3,(3,0)),20),((1,1,1,3,(3,1)),20),((1,1,1,3,(3,2)),200),((1,1,1,3,(3,3)),30),
>                       
>                       
>                       ((1,1,2,0,(0,0)),-50),((1,1,2,0,(0,1)),200),((1,1,2,0,(0,2)),110),((1,1,2,0,(0,3)),-30),
>                       ((1,1,2,0,(1,0)),-80),((1,1,2,0,(1,1)),200),((1,1,2,0,(1,2)),90),((1,1,2,0,(1,3)),-150),
>                       ((1,1,2,0,(2,0)),-260),((1,1,2,0,(2,1)),200),((1,1,2,0,(2,2)),-90),((1,1,2,0,(2,3)),-150),
>                       ((1,1,2,0,(3,0)),200),((1,1,2,0,(3,1)),200),((1,1,2,0,(3,2)),200),((1,1,2,0,(3,3)),200),
>                       
>                       ((1,1,2,1,(0,0)),-80),((1,1,2,1,(0,1)),200),((1,1,2,1,(0,2)),80),((1,1,2,1,(0,3)),-160),
>                       ((1,1,2,1,(1,0)),20),((1,1,2,1,(1,1)),200),((1,1,2,1,(1,2)),150),((1,1,2,1,(1,3)),-50),
>                       ((1,1,2,1,(2,0)),200),((1,1,2,1,(2,1)),200),((1,1,2,1,(2,2)),200),((1,1,2,1,(2,3)),200),
>                       ((1,1,2,1,(3,0)),-80),((1,1,2,1,(3,1)),200),((1,1,2,1,(3,2)),50),((1,1,2,1,(3,3)),-150),
>                       
>                       ((1,1,2,2,(0,0)),-190),((1,1,2,2,(0,1)),200),((1,1,2,2,(0,2)),-20),((1,1,2,2,(0,3)),-90),
>                       ((1,1,2,2,(1,0)),200),((1,1,2,2,(1,1)),200),((1,1,2,2,(1,2)),200),((1,1,2,2,(1,3)),200),
>                       ((1,1,2,2,(2,0)),-90),((1,1,2,2,(2,1)),200),((1,1,2,2,(2,2)),80),((1,1,2,2,(2,3)),-60),
>                       ((1,1,2,2,(3,0)),-190),((1,1,2,2,(3,1)),200),((1,1,2,2,(3,2)),-100),((1,1,2,2,(3,3)),-450),
>                       
>                       ((1,1,2,3,(0,0)),200),((1,1,2,3,(0,1)),200),((1,1,2,3,(0,2)),200),((1,1,2,3,(0,3)),200),
>                       ((1,1,2,3,(1,0)),30),((1,1,2,3,(1,1)),200),((1,1,2,3,(1,2)),150),((1,1,2,3,(1,3)),-50),
>                       ((1,1,2,3,(2,0)),-150),((1,1,2,3,(2,1)),200),((1,1,2,3,(2,2)),-60),((1,1,2,3,(2,3)),-410),
>                       ((1,1,2,3,(3,0)),30),((1,1,2,3,(3,1)),200),((1,1,2,3,(3,2)),110),((1,1,2,3,(3,3)),-50),
>                       
>                       
>                       ((1,1,3,0,(0,0)),200),((1,1,3,0,(0,1)),80),((1,1,3,0,(0,2)),-70),((1,1,3,0,(0,3)),150),
>                       ((1,1,3,0,(1,0)),200),((1,1,3,0,(1,1)),0),((1,1,3,0,(1,2)),-190),((1,1,3,0,(1,3)),20),
>                       ((1,1,3,0,(2,0)),200),((1,1,3,0,(2,1)),-80),((1,1,3,0,(2,2)),-190),((1,1,3,0,(2,3)),30),
>                       ((1,1,3,0,(3,0)),200),((1,1,3,0,(3,1)),200),((1,1,3,0,(3,2)),200),((1,1,3,0,(3,3)),200),
>                       
>                       ((1,1,3,1,(0,0)),200),((1,1,3,1,(0,1)),0),((1,1,3,1,(0,2)),-200),((1,1,3,1,(0,3)),20),
>                       ((1,1,3,1,(1,0)),200),((1,1,3,1,(1,1)),0),((1,1,3,1,(1,2)),-90),((1,1,3,1,(1,3)),20),
>                       ((1,1,3,1,(2,0)),200),((1,1,3,1,(2,1)),200),((1,1,3,1,(2,2)),200),((1,1,3,1,(2,3)),200),
>                       ((1,1,3,1,(3,0)),200),((1,1,3,1,(3,1)),-100),((1,1,3,1,(3,2)),-190),((1,1,3,1,(3,3)),-70),
>                       
>                       ((1,1,3,2,(0,0)),200),((1,1,3,2,(0,1)),-10),((1,1,3,2,(0,2)),-130),((1,1,3,2,(0,3)),90),
>                       ((1,1,3,2,(1,0)),200),((1,1,3,2,(1,1)),200),((1,1,3,2,(1,2)),200),((1,1,3,2,(1,3)),200),
>                       ((1,1,3,2,(2,0)),200),((1,1,3,2,(2,1)),50),((1,1,3,2,(2,2)),-100),((1,1,3,2,(2,3)),110),
>                       ((1,1,3,2,(3,0)),200),((1,1,3,2,(3,1)),-190),((1,1,3,2,(3,2)),-490),((1,1,3,2,(3,3)),-90),
>                       
>                       ((1,1,3,3,(0,0)),200),((1,1,3,3,(0,1)),200),((1,1,3,3,(0,2)),200),((1,1,3,3,(0,3)),200),
>                       ((1,1,3,3,(1,0)),200),((1,1,3,3,(1,1)),0),((1,1,3,3,(1,2)),-90),((1,1,3,3,(1,3)),30),
>                       ((1,1,3,3,(2,0)),200),((1,1,3,3,(2,1)),-150),((1,1,3,3,(2,2)),-450),((1,1,3,3,(2,3)),-50),
>                       ((1,1,3,3,(3,0)),200),((1,1,3,3,(3,1)),-70),((1,1,3,3,(3,2)),-90),((1,1,3,3,(3,3)),-50),
>                       
>                       
>                       
>                       ((1,2,0,0,(0,0)),210),((1,2,0,0,(0,1)),180),((1,2,0,0,(0,2)),70),((1,2,0,0,(0,3)),200),
>                       ((1,2,0,0,(1,0)),190),((1,2,0,0,(1,1)),160),((1,2,0,0,(1,2)),50),((1,2,0,0,(1,3)),200),
>                       ((1,2,0,0,(2,0)),90),((1,2,0,0,(2,1)),60),((1,2,0,0,(2,2)),-50),((1,2,0,0,(2,3)),200),
>                       ((1,2,0,0,(3,0)),200),((1,2,0,0,(3,1)),200),((1,2,0,0,(3,2)),200),((1,2,0,0,(3,3)),200),
>                       
>                       ((1,2,0,1,(0,0)),200),((1,2,0,1,(0,1)),170),((1,2,0,1,(0,2)),60),((1,2,0,1,(0,3)),200),
>                       ((1,2,0,1,(1,0)),240),((1,2,0,1,(1,1)),150),((1,2,0,1,(1,2)),140),((1,2,0,1,(1,3)),200),
>                       ((1,2,0,1,(2,0)),200),((1,2,0,1,(2,1)),200),((1,2,0,1,(2,2)),200),((1,2,0,1,(2,3)),200),
>                       ((1,2,0,1,(3,0)),240),((1,2,0,1,(3,1)),150),((1,2,0,1,(3,2)),140),((1,2,0,1,(3,3)),200),
>                       
>                       ((1,2,0,2,(0,0)),90),((1,2,0,2,(0,1)),60),((1,2,0,2,(0,2)),-50),((1,2,0,2,(0,3)),200),
>                       ((1,2,0,2,(1,0)),200),((1,2,0,2,(1,1)),200),((1,2,0,2,(1,2)),200),((1,2,0,2,(1,3)),200),
>                       ((1,2,0,2,(2,0)),140),((1,2,0,2,(2,1)),110),((1,2,0,2,(2,2)),0),((1,2,0,2,(2,3)),200),
>                       ((1,2,0,2,(3,0)),70),((1,2,0,2,(3,1)),-60),((1,2,0,2,(3,2)),10),((1,2,0,2,(3,3)),200),
>                       
>                       ((1,2,0,3,(0,0)),200),((1,2,0,3,(0,1)),200),((1,2,0,3,(0,2)),200),((1,2,0,3,(0,3)),200),
>                       ((1,2,0,3,(1,0)),240),((1,2,0,3,(1,1)),150),((1,2,0,3,(1,2)),140),((1,2,0,3,(1,3)),200),
>                       ((1,2,0,3,(2,0)),170),((1,2,0,3,(2,1)),40),((1,2,0,3,(2,2)),110),((1,2,0,3,(2,3)),200),
>                       ((1,2,0,3,(3,0)),200),((1,2,0,3,(3,1)),70),((1,2,0,3,(3,2)),150),((1,2,0,3,(3,3)),200),
>                       
>                       
>                       ((1,2,1,0,(0,0)),190),((1,2,1,0,(0,1)),250),((1,2,1,0,(0,2)),200),((1,2,1,0,(0,3)),250),
>                       ((1,2,1,0,(1,0)),160),((1,2,1,0,(1,1)),160),((1,2,1,0,(1,2)),200),((1,2,1,0,(1,3)),170),
>                       ((1,2,1,0,(2,0)),60),((1,2,1,0,(2,1)),160),((1,2,1,0,(2,2)),200),((1,2,1,0,(2,3)),170),
>                       ((1,2,1,0,(3,0)),200),((1,2,1,0,(3,1)),200),((1,2,1,0,(3,2)),200),((1,2,1,0,(3,3)),200),
>                       
>                       ((1,2,1,1,(0,0)),170),((1,2,1,1,(0,1)),170),((1,2,1,1,(0,2)),200),((1,2,1,1,(0,3)),180),
>                       ((1,2,1,1,(1,0)),160),((1,2,1,1,(1,1)),160),((1,2,1,1,(1,2)),200),((1,2,1,1,(1,3)),160),
>                       ((1,2,1,1,(2,0)),200),((1,2,1,1,(2,1)),200),((1,2,1,1,(2,2)),200),((1,2,1,1,(2,3)),200),
>                       ((1,2,1,1,(3,0)),160),((1,2,1,1,(3,1)),160),((1,2,1,1,(3,2)),200),((1,2,1,1,(3,3)),160),
>                       
>                       ((1,2,1,2,(0,0)),60),((1,2,1,2,(0,1)),160),((1,2,1,2,(0,2)),200),((1,2,1,2,(0,3)),170),
>                       ((1,2,1,2,(1,0)),200),((1,2,1,2,(1,1)),200),((1,2,1,2,(1,2)),200),((1,2,1,2,(1,3)),200),
>                       ((1,2,1,2,(2,0)),120),((1,2,1,2,(2,1)),180),((1,2,1,2,(2,2)),200),((1,2,1,2,(2,3)),180),
>                       ((1,2,1,2,(3,0)),-50),((1,2,1,2,(3,1)),50),((1,2,1,2,(3,2)),200),((1,2,1,2,(3,3)),50),
>                       
>                       ((1,2,1,3,(0,0)),200),((1,2,1,3,(0,1)),200),((1,2,1,3,(0,2)),200),((1,2,1,3,(0,3)),200),
>                       ((1,2,1,3,(1,0)),160),((1,2,1,3,(1,1)),160),((1,2,1,3,(1,2)),200),((1,2,1,3,(1,3)),160),
>                       ((1,2,1,3,(2,0)),40),((1,2,1,3,(2,1)),140),((1,2,1,3,(2,2)),200),((1,2,1,3,(2,3)),150),
>                       ((1,2,1,3,(3,0)),80),((1,2,1,3,(3,1)),80),((1,2,1,3,(3,2)),200),((1,2,1,3,(3,3)),80),
>                       
>                       
>                       ((1,2,2,0,(0,0)),10),((1,2,2,0,(0,1)),200),((1,2,2,0,(0,2)),180),((1,2,2,0,(0,3)),40),
>                       ((1,2,2,0,(1,0)),-10),((1,2,2,0,(1,1)),200),((1,2,2,0,(1,2)),150),((1,2,2,0,(1,3)),-90),
>                       ((1,2,2,0,(2,0)),-110),((1,2,2,0,(2,1)),200),((1,2,2,0,(2,2)),50),((1,2,2,0,(2,3)),-10),
>                       ((1,2,2,0,(3,0)),200),((1,2,2,0,(3,1)),200),((1,2,2,0,(3,2)),200),((1,2,2,0,(3,3)),200),
>                       
>                       ((1,2,2,1,(0,0)),0),((1,2,2,1,(0,1)),200),((1,2,2,1,(0,2)),160),((1,2,2,1,(0,3)),-80),
>                       ((1,2,2,1,(1,0)),80),((1,2,2,1,(1,1)),200),((1,2,2,1,(1,2)),210),((1,2,2,1,(1,3)),10),
>                       ((1,2,2,1,(2,0)),200),((1,2,2,1,(2,1)),200),((1,2,2,1,(2,2)),200),((1,2,2,1,(2,3)),200),
>                       ((1,2,2,1,(3,0)),80),((1,2,2,1,(3,1)),200),((1,2,2,1,(3,2)),210),((1,2,2,1,(3,3)),10),
>                       
>                       ((1,2,2,2,(0,0)),-110),((1,2,2,2,(0,1)),200),((1,2,2,2,(0,2)),50),((1,2,2,2,(0,3)),-10),
>                       ((1,2,2,2,(1,0)),200),((1,2,2,2,(1,1)),200),((1,2,2,2,(1,2)),200),((1,2,2,2,(1,3)),200),
>                       ((1,2,2,2,(2,0)),-60),((1,2,2,2,(2,1)),200),((1,2,2,2,(2,2)),110),((1,2,2,2,(2,3)),-30),
>                       ((1,2,2,2,(3,0)),-50),((1,2,2,2,(3,1)),200),((1,2,2,2,(3,2)),40),((1,2,2,2,(3,3)),-310),
>                       
>                       ((1,2,2,3,(0,0)),200),((1,2,2,3,(0,1)),200),((1,2,2,3,(0,2)),200),((1,2,2,3,(0,3)),200),
>                       ((1,2,2,3,(1,0)),80),((1,2,2,3,(1,1)),200),((1,2,2,3,(1,2)),210),((1,2,2,3,(1,3)),10),
>                       ((1,2,2,3,(2,0)),50),((1,2,2,3,(2,1)),200),((1,2,2,3,(2,2)),130),((1,2,2,3,(2,3)),-210),
>                       ((1,2,2,3,(3,0)),80),((1,2,2,3,(3,1)),200),((1,2,2,3,(3,2)),170),((1,2,2,3,(3,3)),10),
>                       
>                       
>                       ((1,2,3,0,(0,0)),200),((1,2,3,0,(0,1)),150),((1,2,3,0,(0,2)),0),((1,2,3,0,(0,3)),210),
>                       ((1,2,3,0,(1,0)),200),((1,2,3,0,(1,1)),60),((1,2,3,0,(1,2)),-130),((1,2,3,0,(1,3)),90),
>                       ((1,2,3,0,(2,0)),200),((1,2,3,0,(2,1)),70),((1,2,3,0,(2,2)),-50),((1,2,3,0,(2,3)),170),
>                       ((1,2,3,0,(3,0)),200),((1,2,3,0,(3,1)),200),((1,2,3,0,(3,2)),200),((1,2,3,0,(3,3)),200),
>                       
>                       ((1,2,3,1,(0,0)),200),((1,2,3,1,(0,1)),70),((1,2,3,1,(0,2)),-120),((1,2,3,1,(0,3)),100),
>                       ((1,2,3,1,(1,0)),200),((1,2,3,1,(1,1)),60),((1,2,3,1,(1,2)),-30),((1,2,3,1,(1,3)),80),
>                       ((1,2,3,1,(2,0)),200),((1,2,3,1,(2,1)),200),((1,2,3,1,(2,2)),200),((1,2,3,1,(2,3)),200),
>                       ((1,2,3,1,(3,0)),200),((1,2,3,1,(3,1)),60),((1,2,3,1,(3,2)),-30),((1,2,3,1,(3,3)),80),
>                       
>                       ((1,2,3,2,(0,0)),200),((1,2,3,2,(0,1)),70),((1,2,3,2,(0,2)),-50),((1,2,3,2,(0,3)),170),
>                       ((1,2,3,2,(1,0)),200),((1,2,3,2,(1,1)),200),((1,2,3,2,(1,2)),200),((1,2,3,2,(1,3)),200),
>                       ((1,2,3,2,(2,0)),200),((1,2,3,2,(2,1)),80),((1,2,3,2,(2,2)),-70),((1,2,3,2,(2,3)),140),
>                       ((1,2,3,2,(3,0)),200),((1,2,3,2,(3,1)),-50),((1,2,3,2,(3,2)),-350),((1,2,3,2,(3,3)),50),
>                       
>                       ((1,2,3,3,(0,0)),200),((1,2,3,3,(0,1)),200),((1,2,3,3,(0,2)),200),((1,2,3,3,(0,3)),200),
>                       ((1,2,3,3,(1,0)),200),((1,2,3,3,(1,1)),60),((1,2,3,3,(1,2)),-30),((1,2,3,3,(1,3)),80),
>                       ((1,2,3,3,(2,0)),200),((1,2,3,3,(2,1)),50),((1,2,3,3,(2,2)),-250),((1,2,3,3,(2,3)),150),
>                       ((1,2,3,3,(3,0)),200),((1,2,3,3,(3,1)),-20),((1,2,3,3,(3,2)),-30),((1,2,3,3,(3,3)),0),
>                       
>                       
>                       
>                       ((1,3,0,0,(0,0)),210),((1,3,0,0,(0,1)),180),((1,3,0,0,(0,2)),70),((1,3,0,0,(0,3)),200),
>                       ((1,3,0,0,(1,0)),170),((1,3,0,0,(1,1)),140),((1,3,0,0,(1,2)),30),((1,3,0,0,(1,3)),200),
>                       ((1,3,0,0,(2,0)),110),((1,3,0,0,(2,1)),80),((1,3,0,0,(2,2)),-30),((1,3,0,0,(2,3)),200),
>                       ((1,3,0,0,(3,0)),200),((1,3,0,0,(3,1)),200),((1,3,0,0,(3,2)),200),((1,3,0,0,(3,3)),200),
>                       
>                       ((1,3,0,1,(0,0)),210),((1,3,0,1,(0,1)),180),((1,3,0,1,(0,2)),70),((1,3,0,1,(0,3)),200),
>                       ((1,3,0,1,(1,0)),270),((1,3,0,1,(1,1)),180),((1,3,0,1,(1,2)),170),((1,3,0,1,(1,3)),200),
>                       ((1,3,0,1,(2,0)),200),((1,3,0,1,(2,1)),200),((1,3,0,1,(2,2)),200),((1,3,0,1,(2,3)),200),
>                       ((1,3,0,1,(3,0)),270),((1,3,0,1,(3,1)),180),((1,3,0,1,(3,2)),170),((1,3,0,1,(3,3)),200),
>                       
>                       ((1,3,0,2,(0,0)),110),((1,3,0,2,(0,1)),80),((1,3,0,2,(0,2)),-30),((1,3,0,2,(0,3)),200),
>                       ((1,3,0,2,(1,0)),200),((1,3,0,2,(1,1)),200),((1,3,0,2,(1,2)),200),((1,3,0,2,(1,3)),200),
>                       ((1,3,0,2,(2,0)),150),((1,3,0,2,(2,1)),120),((1,3,0,2,(2,2)),10),((1,3,0,2,(2,3)),200),
>                       ((1,3,0,2,(3,0)),30),((1,3,0,2,(3,1)),-100),((1,3,0,2,(3,2)),-30),((1,3,0,2,(3,3)),200),
>                       
>                       ((1,3,0,3,(0,0)),200),((1,3,0,3,(0,1)),200),((1,3,0,3,(0,2)),200),((1,3,0,3,(0,3)),200),
>                       ((1,3,0,3,(1,0)),240),((1,3,0,3,(1,1)),150),((1,3,0,3,(1,2)),140),((1,3,0,3,(1,3)),200),
>                       ((1,3,0,3,(2,0)),160),((1,3,0,3,(2,1)),30),((1,3,0,3,(2,2)),100),((1,3,0,3,(2,3)),200),
>                       ((1,3,0,3,(3,0)),230),((1,3,0,3,(3,1)),100),((1,3,0,3,(3,2)),170),((1,3,0,3,(3,3)),200),
>                       
>                       
>                       ((1,3,1,0,(0,0)),190),((1,3,1,0,(0,1)),250),((1,3,1,0,(0,2)),200),((1,3,1,0,(0,3)),250),
>                       ((1,3,1,0,(1,0)),140),((1,3,1,0,(1,1)),140),((1,3,1,0,(1,2)),200),((1,3,1,0,(1,3)),150),
>                       ((1,3,1,0,(2,0)),80),((1,3,1,0,(2,1)),180),((1,3,1,0,(2,2)),200),((1,3,1,0,(2,3)),190),
>                       ((1,3,1,0,(3,0)),200),((1,3,1,0,(3,1)),200),((1,3,1,0,(3,2)),200),((1,3,1,0,(3,3)),200),
>                       
>                       ((1,3,1,1,(0,0)),190),((1,3,1,1,(0,1)),190),((1,3,1,1,(0,2)),200),((1,3,1,1,(0,3)),190),
>                       ((1,3,1,1,(1,0)),190),((1,3,1,1,(1,1)),190),((1,3,1,1,(1,2)),200),((1,3,1,1,(1,3)),190),
>                       ((1,3,1,1,(2,0)),200),((1,3,1,1,(2,1)),200),((1,3,1,1,(2,2)),200),((1,3,1,1,(2,3)),200),
>                       ((1,3,1,1,(3,0)),190),((1,3,1,1,(3,1)),190),((1,3,1,1,(3,2)),200),((1,3,1,1,(3,3)),190),
>                       
>                       ((1,3,1,2,(0,0)),80),((1,3,1,2,(0,1)),180),((1,3,1,2,(0,2)),200),((1,3,1,2,(0,3)),190),
>                       ((1,3,1,2,(1,0)),200),((1,3,1,2,(1,1)),200),((1,3,1,2,(1,2)),200),((1,3,1,2,(1,3)),200),
>                       ((1,3,1,2,(2,0)),120),((1,3,1,2,(2,1)),180),((1,3,1,2,(2,2)),200),((1,3,1,2,(2,3)),190),
>                       ((1,3,1,2,(3,0)),-90),((1,3,1,2,(3,1)),10),((1,3,1,2,(3,2)),200),((1,3,1,2,(3,3)),10),
>                       
>                       ((1,3,1,3,(0,0)),200),((1,3,1,3,(0,1)),200),((1,3,1,3,(0,2)),200),((1,3,1,3,(0,3)),200),
>                       ((1,3,1,3,(1,0)),160),((1,3,1,3,(1,1)),160),((1,3,1,3,(1,2)),200),((1,3,1,3,(1,3)),160),
>                       ((1,3,1,3,(2,0)),30),((1,3,1,3,(2,1)),130),((1,3,1,3,(2,2)),200),((1,3,1,3,(2,3)),140),
>                       ((1,3,1,3,(3,0)),100),((1,3,1,3,(3,1)),100),((1,3,1,3,(3,2)),200),((1,3,1,3,(3,3)),110),
>                       
>                       
>                       ((1,3,2,0,(0,0)),10),((1,3,2,0,(0,1)),200),((1,3,2,0,(0,2)),180),((1,3,2,0,(0,3)),40),
>                       ((1,3,2,0,(1,0)),-30),((1,3,2,0,(1,1)),200),((1,3,2,0,(1,2)),130),((1,3,2,0,(1,3)),-110),
>                       ((1,3,2,0,(2,0)),-90),((1,3,2,0,(2,1)),200),((1,3,2,0,(2,2)),70),((1,3,2,0,(2,3)),10),
>                       ((1,3,2,0,(3,0)),200),((1,3,2,0,(3,1)),200),((1,3,2,0,(3,2)),200),((1,3,2,0,(3,3)),200),
>                       
>                       ((1,3,2,1,(0,0)),10),((1,3,2,1,(0,1)),200),((1,3,2,1,(0,2)),180),((1,3,2,1,(0,3)),-60),
>                       ((1,3,2,1,(1,0)),110),((1,3,2,1,(1,1)),200),((1,3,2,1,(1,2)),240),((1,3,2,1,(1,3)),40),
>                       ((1,3,2,1,(2,0)),200),((1,3,2,1,(2,1)),200),((1,3,2,1,(2,2)),200),((1,3,2,1,(2,3)),200),
>                       ((1,3,2,1,(3,0)),110),((1,3,2,1,(3,1)),200),((1,3,2,1,(3,2)),240),((1,3,2,1,(3,3)),40),
>                       
>                       ((1,3,2,2,(0,0)),-90),((1,3,2,2,(0,1)),200),((1,3,2,2,(0,2)),70),((1,3,2,2,(0,3)),10),
>                       ((1,3,2,2,(1,0)),200),((1,3,2,2,(1,1)),200),((1,3,2,2,(1,2)),200),((1,3,2,2,(1,3)),200),
>                       ((1,3,2,2,(2,0)),-50),((1,3,2,2,(2,1)),200),((1,3,2,2,(2,2)),110),((1,3,2,2,(2,3)),-30),
>                       ((1,3,2,2,(3,0)),-90),((1,3,2,2,(3,1)),200),((1,3,2,2,(3,2)),0),((1,3,2,2,(3,3)),-350),
>                       
>                       ((1,3,2,3,(0,0)),200),((1,3,2,3,(0,1)),200),((1,3,2,3,(0,2)),200),((1,3,2,3,(0,3)),200),
>                       ((1,3,2,3,(1,0)),80),((1,3,2,3,(1,1)),200),((1,3,2,3,(1,2)),210),((1,3,2,3,(1,3)),10),
>                       ((1,3,2,3,(2,0)),40),((1,3,2,3,(2,1)),200),((1,3,2,3,(2,2)),120),((1,3,2,3,(2,3)),-220),
>                       ((1,3,2,3,(3,0)),110),((1,3,2,3,(3,1)),200),((1,3,2,3,(3,2)),190),((1,3,2,3,(3,3)),30),
>                       
>                       
>                       ((1,3,3,0,(0,0)),200),((1,3,3,0,(0,1)),150),((1,3,3,0,(0,2)),0),((1,3,3,0,(0,3)),210),
>                       ((1,3,3,0,(1,0)),200),((1,3,3,0,(1,1)),40),((1,3,3,0,(1,2)),-150),((1,3,3,0,(1,3)),70),
>                       ((1,3,3,0,(2,0)),200),((1,3,3,0,(2,1)),90),((1,3,3,0,(2,2)),-30),((1,3,3,0,(2,3)),190),
>                       ((1,3,3,0,(3,0)),200),((1,3,3,0,(3,1)),200),((1,3,3,0,(3,2)),200),((1,3,3,0,(3,3)),200),
>                       
>                       ((1,3,3,1,(0,0)),200),((1,3,3,1,(0,1)),90),((1,3,3,1,(0,2)),-100),((1,3,3,1,(0,3)),110),
>                       ((1,3,3,1,(1,0)),200),((1,3,3,1,(1,1)),90),((1,3,3,1,(1,2)),0),((1,3,3,1,(1,3)),110),
>                       ((1,3,3,1,(2,0)),200),((1,3,3,1,(2,1)),200),((1,3,3,1,(2,2)),200),((1,3,3,1,(2,3)),200),
>                       ((1,3,3,1,(3,0)),200),((1,3,3,1,(3,1)),90),((1,3,3,1,(3,2)),0),((1,3,3,1,(3,3)),110),
>                       
>                       ((1,3,3,2,(0,0)),200),((1,3,3,2,(0,1)),90),((1,3,3,2,(0,2)),-30),((1,3,3,2,(0,3)),190),
>                       ((1,3,3,2,(1,0)),200),((1,3,3,2,(1,1)),200),((1,3,3,2,(1,2)),200),((1,3,3,2,(1,3)),200),
>                       ((1,3,3,2,(2,0)),200),((1,3,3,2,(2,1)),80),((1,3,3,2,(2,2)),-70),((1,3,3,2,(2,3)),150),
>                       ((1,3,3,2,(3,0)),200),((1,3,3,2,(3,1)),-90),((1,3,3,2,(3,2)),-390),((1,3,3,2,(3,3)),10),
>                       
>                       ((1,3,3,3,(0,0)),200),((1,3,3,3,(0,1)),200),((1,3,3,3,(0,2)),200),((1,3,3,3,(0,3)),200),
>                       ((1,3,3,3,(1,0)),200),((1,3,3,3,(1,1)),60),((1,3,3,3,(1,2)),-30),((1,3,3,3,(1,3)),80),
>                       ((1,3,3,3,(2,0)),200),((1,3,3,3,(2,1)),40),((1,3,3,3,(2,2)),-260),((1,3,3,3,(2,3)),140),
>                       ((1,3,3,3,(3,0)),200),((1,3,3,3,(3,1)),0),((1,3,3,3,(3,2)),-10),((1,3,3,3,(3,3)),30),
>                       
>                       
>                       
>                       ((1,4,0,0,(0,0)),210),((1,4,0,0,(0,1)),180),((1,4,0,0,(0,2)),70),((1,4,0,0,(0,3)),200),
>                       ((1,4,0,0,(1,0)),190),((1,4,0,0,(1,1)),160),((1,4,0,0,(1,2)),50),((1,4,0,0,(1,3)),200),
>                       ((1,4,0,0,(2,0)),90),((1,4,0,0,(2,1)),60),((1,4,0,0,(2,2)),-50),((1,4,0,0,(2,3)),200),
>                       ((1,4,0,0,(3,0)),200),((1,4,0,0,(3,1)),200),((1,4,0,0,(3,2)),200),((1,4,0,0,(3,3)),200),
>                       
>                       ((1,4,0,1,(0,0)),200),((1,4,0,1,(0,1)),170),((1,4,0,1,(0,2)),60),((1,4,0,1,(0,3)),200),
>                       ((1,4,0,1,(1,0)),240),((1,4,0,1,(1,1)),150),((1,4,0,1,(1,2)),140),((1,4,0,1,(1,3)),200),
>                       ((1,4,0,1,(2,0)),200),((1,4,0,1,(2,1)),200),((1,4,0,1,(2,2)),200),((1,4,0,1,(2,3)),200),
>                       ((1,4,0,1,(3,0)),240),((1,4,0,1,(3,1)),150),((1,4,0,1,(3,2)),140),((1,4,0,1,(3,3)),200),
>                       
>                       ((1,4,0,2,(0,0)),90),((1,4,0,2,(0,1)),60),((1,4,0,2,(0,2)),-50),((1,4,0,2,(0,3)),200),
>                       ((1,4,0,2,(1,0)),200),((1,4,0,2,(1,1)),200),((1,4,0,2,(1,2)),200),((1,4,0,2,(1,3)),200),
>                       ((1,4,0,2,(2,0)),140),((1,4,0,2,(2,1)),110),((1,4,0,2,(2,2)),0),((1,4,0,2,(2,3)),200),
>                       ((1,4,0,2,(3,0)),70),((1,4,0,2,(3,1)),-60),((1,4,0,2,(3,2)),10),((1,4,0,2,(3,3)),200),
>                       
>                       ((1,4,0,3,(0,0)),200),((1,4,0,3,(0,1)),200),((1,4,0,3,(0,2)),200),((1,4,0,3,(0,3)),200),
>                       ((1,4,0,3,(1,0)),240),((1,4,0,3,(1,1)),150),((1,4,0,3,(1,2)),140),((1,4,0,3,(1,3)),200),
>                       ((1,4,0,3,(2,0)),170),((1,4,0,3,(2,1)),40),((1,4,0,3,(2,2)),110),((1,4,0,3,(2,3)),200),
>                       ((1,4,0,3,(3,0)),200),((1,4,0,3,(3,1)),70),((1,4,0,3,(3,2)),150),((1,4,0,3,(3,3)),200),
>                       
>                       
>                       ((1,4,1,0,(0,0)),190),((1,4,1,0,(0,1)),250),((1,4,1,0,(0,2)),200),((1,4,1,0,(0,3)),250),
>                       ((1,4,1,0,(1,0)),160),((1,4,1,0,(1,1)),160),((1,4,1,0,(1,2)),200),((1,4,1,0,(1,3)),170),
>                       ((1,4,1,0,(2,0)),60),((1,4,1,0,(2,1)),160),((1,4,1,0,(2,2)),200),((1,4,1,0,(2,3)),170),
>                       ((1,4,1,0,(3,0)),200),((1,4,1,0,(3,1)),200),((1,4,1,0,(3,2)),200),((1,4,1,0,(3,3)),200),
>                       
>                       ((1,4,1,1,(0,0)),170),((1,4,1,1,(0,1)),170),((1,4,1,1,(0,2)),200),((1,4,1,1,(0,3)),180),
>                       ((1,4,1,1,(1,0)),160),((1,4,1,1,(1,1)),160),((1,4,1,1,(1,2)),200),((1,4,1,1,(1,3)),160),
>                       ((1,4,1,1,(2,0)),200),((1,4,1,1,(2,1)),200),((1,4,1,1,(2,2)),200),((1,4,1,1,(2,3)),200),
>                       ((1,4,1,1,(3,0)),160),((1,4,1,1,(3,1)),160),((1,4,1,1,(3,2)),200),((1,4,1,1,(3,3)),160),
>                       
>                       ((1,4,1,2,(0,0)),60),((1,4,1,2,(0,1)),160),((1,4,1,2,(0,2)),200),((1,4,1,2,(0,3)),170),
>                       ((1,4,1,2,(1,0)),200),((1,4,1,2,(1,1)),200),((1,4,1,2,(1,2)),200),((1,4,1,2,(1,3)),200),
>                       ((1,4,1,2,(2,0)),120),((1,4,1,2,(2,1)),180),((1,4,1,2,(2,2)),200),((1,4,1,2,(2,3)),180),
>                       ((1,4,1,2,(3,0)),-50),((1,4,1,2,(3,1)),50),((1,4,1,2,(3,2)),200),((1,4,1,2,(3,3)),50),
>                       
>                       ((1,4,1,3,(0,0)),200),((1,4,1,3,(0,1)),200),((1,4,1,3,(0,2)),200),((1,4,1,3,(0,3)),200),
>                       ((1,4,1,3,(1,0)),160),((1,4,1,3,(1,1)),160),((1,4,1,3,(1,2)),200),((1,4,1,3,(1,3)),160),
>                       ((1,4,1,3,(2,0)),40),((1,4,1,3,(2,1)),140),((1,4,1,3,(2,2)),200),((1,4,1,3,(2,3)),150),
>                       ((1,4,1,3,(3,0)),80),((1,4,1,3,(3,1)),80),((1,4,1,3,(3,2)),200),((1,4,1,3,(3,3)),80),
>                       
>                       
>                       ((1,4,2,0,(0,0)),10),((1,4,2,0,(0,1)),200),((1,4,2,0,(0,2)),180),((1,4,2,0,(0,3)),40),
>                       ((1,4,2,0,(1,0)),-10),((1,4,2,0,(1,1)),200),((1,4,2,0,(1,2)),150),((1,4,2,0,(1,3)),-90),
>                       ((1,4,2,0,(2,0)),-110),((1,4,2,0,(2,1)),200),((1,4,2,0,(2,2)),50),((1,4,2,0,(2,3)),-10),
>                       ((1,4,2,0,(3,0)),200),((1,4,2,0,(3,1)),200),((1,4,2,0,(3,2)),200),((1,4,2,0,(3,3)),200),
>                       
>                       ((1,4,2,1,(0,0)),0),((1,4,2,1,(0,1)),200),((1,4,2,1,(0,2)),160),((1,4,2,1,(0,3)),-80),
>                       ((1,4,2,1,(1,0)),80),((1,4,2,1,(1,1)),200),((1,4,2,1,(1,2)),210),((1,4,2,1,(1,3)),10),
>                       ((1,4,2,1,(2,0)),200),((1,4,2,1,(2,1)),200),((1,4,2,1,(2,2)),200),((1,4,2,1,(2,3)),200),
>                       ((1,4,2,1,(3,0)),80),((1,4,2,1,(3,1)),200),((1,4,2,1,(3,2)),210),((1,4,2,1,(3,3)),10),
>                       
>                       ((1,4,2,2,(0,0)),-110),((1,4,2,2,(0,1)),200),((1,4,2,2,(0,2)),50),((1,4,2,2,(0,3)),-10),
>                       ((1,4,2,2,(1,0)),200),((1,4,2,2,(1,1)),200),((1,4,2,2,(1,2)),200),((1,4,2,2,(1,3)),200),
>                       ((1,4,2,2,(2,0)),-60),((1,4,2,2,(2,1)),200),((1,4,2,2,(2,2)),110),((1,4,2,2,(2,3)),-30),
>                       ((1,4,2,2,(3,0)),-50),((1,4,2,2,(3,1)),200),((1,4,2,2,(3,2)),40),((1,4,2,2,(3,3)),-310),
>                       
>                       ((1,4,2,3,(0,0)),200),((1,4,2,3,(0,1)),200),((1,4,2,3,(0,2)),200),((1,4,2,3,(0,3)),200),
>                       ((1,4,2,3,(1,0)),80),((1,4,2,3,(1,1)),200),((1,4,2,3,(1,2)),210),((1,4,2,3,(1,3)),10),
>                       ((1,4,2,3,(2,0)),50),((1,4,2,3,(2,1)),200),((1,4,2,3,(2,2)),130),((1,4,2,3,(2,3)),-210),
>                       ((1,4,2,3,(3,0)),80),((1,4,2,3,(3,1)),200),((1,4,2,3,(3,2)),170),((1,4,2,3,(3,3)),10),
>                       
>                       
>                       ((1,4,3,0,(0,0)),200),((1,4,3,0,(0,1)),150),((1,4,3,0,(0,2)),0),((1,4,3,0,(0,3)),210),
>                       ((1,4,3,0,(1,0)),200),((1,4,3,0,(1,1)),60),((1,4,3,0,(1,2)),-130),((1,4,3,0,(1,3)),90),
>                       ((1,4,3,0,(2,0)),200),((1,4,3,0,(2,1)),70),((1,4,3,0,(2,2)),-50),((1,4,3,0,(2,3)),170),
>                       ((1,4,3,0,(3,0)),200),((1,4,3,0,(3,1)),200),((1,4,3,0,(3,2)),200),((1,4,3,0,(3,3)),200),
>                       
>                       ((1,4,3,1,(0,0)),200),((1,4,3,1,(0,1)),70),((1,4,3,1,(0,2)),-120),((1,4,3,1,(0,3)),100),
>                       ((1,4,3,1,(1,0)),200),((1,4,3,1,(1,1)),60),((1,4,3,1,(1,2)),-30),((1,4,3,1,(1,3)),80),
>                       ((1,4,3,1,(2,0)),200),((1,4,3,1,(2,1)),200),((1,4,3,1,(2,2)),200),((1,4,3,1,(2,3)),200),
>                       ((1,4,3,1,(3,0)),200),((1,4,3,1,(3,1)),60),((1,4,3,1,(3,2)),-30),((1,4,3,1,(3,3)),80),
>                       
>                       ((1,4,3,2,(0,0)),200),((1,4,3,2,(0,1)),70),((1,4,3,2,(0,2)),-50),((1,4,3,2,(0,3)),170),
>                       ((1,4,3,2,(1,0)),200),((1,4,3,2,(1,1)),200),((1,4,3,2,(1,2)),200),((1,4,3,2,(1,3)),200),
>                       ((1,4,3,2,(2,0)),200),((1,4,3,2,(2,1)),80),((1,4,3,2,(2,2)),-70),((1,4,3,2,(2,3)),140),
>                       ((1,4,3,2,(3,0)),200),((1,4,3,2,(3,1)),-50),((1,4,3,2,(3,2)),-350),((1,4,3,2,(3,3)),50),
>                       
>                       ((1,4,3,3,(0,0)),200),((1,4,3,3,(0,1)),200),((1,4,3,3,(0,2)),200),((1,4,3,3,(0,3)),200),
>                       ((1,4,3,3,(1,0)),200),((1,4,3,3,(1,1)),60),((1,4,3,3,(1,2)),-30),((1,4,3,3,(1,3)),80),
>                       ((1,4,3,3,(2,0)),200),((1,4,3,3,(2,1)),50),((1,4,3,3,(2,2)),-250),((1,4,3,3,(2,3)),150),
>                       ((1,4,3,3,(3,0)),200),((1,4,3,3,(3,1)),-20),((1,4,3,3,(3,2)),-30),((1,4,3,3,(3,3)),0),
>                       
>                       
>                       
>                       ((1,5,0,0,(0,0)),210),((1,5,0,0,(0,1)),180),((1,5,0,0,(0,2)),70),((1,5,0,0,(0,3)),200),
>                       ((1,5,0,0,(1,0)),170),((1,5,0,0,(1,1)),140),((1,5,0,0,(1,2)),30),((1,5,0,0,(1,3)),200),
>                       ((1,5,0,0,(2,0)),110),((1,5,0,0,(2,1)),80),((1,5,0,0,(2,2)),-30),((1,5,0,0,(2,3)),200),
>                       ((1,5,0,0,(3,0)),200),((1,5,0,0,(3,1)),200),((1,5,0,0,(3,2)),200),((1,5,0,0,(3,3)),200),
>                       
>                       ((1,5,0,1,(0,0)),210),((1,5,0,1,(0,1)),180),((1,5,0,1,(0,2)),70),((1,5,0,1,(0,3)),200),
>                       ((1,5,0,1,(1,0)),270),((1,5,0,1,(1,1)),180),((1,5,0,1,(1,2)),170),((1,5,0,1,(1,3)),200),
>                       ((1,5,0,1,(2,0)),200),((1,5,0,1,(2,1)),200),((1,5,0,1,(2,2)),200),((1,5,0,1,(2,3)),200),
>                       ((1,5,0,1,(3,0)),270),((1,5,0,1,(3,1)),180),((1,5,0,1,(3,2)),170),((1,5,0,1,(3,3)),200),
>                       
>                       ((1,5,0,2,(0,0)),110),((1,5,0,2,(0,1)),80),((1,5,0,2,(0,2)),-30),((1,5,0,2,(0,3)),200),
>                       ((1,5,0,2,(1,0)),200),((1,5,0,2,(1,1)),200),((1,5,0,2,(1,2)),200),((1,5,0,2,(1,3)),200),
>                       ((1,5,0,2,(2,0)),150),((1,5,0,2,(2,1)),120),((1,5,0,2,(2,2)),10),((1,5,0,2,(2,3)),200),
>                       ((1,5,0,2,(3,0)),30),((1,5,0,2,(3,1)),-100),((1,5,0,2,(3,2)),-30),((1,5,0,2,(3,3)),200),
>                       
>                       ((1,5,0,3,(0,0)),200),((1,5,0,3,(0,1)),200),((1,5,0,3,(0,2)),200),((1,5,0,3,(0,3)),200),
>                       ((1,5,0,3,(1,0)),240),((1,5,0,3,(1,1)),150),((1,5,0,3,(1,2)),140),((1,5,0,3,(1,3)),200),
>                       ((1,5,0,3,(2,0)),160),((1,5,0,3,(2,1)),30),((1,5,0,3,(2,2)),100),((1,5,0,3,(2,3)),200),
>                       ((1,5,0,3,(3,0)),230),((1,5,0,3,(3,1)),100),((1,5,0,3,(3,2)),170),((1,5,0,3,(3,3)),200),
>                       
>                       
>                       ((1,5,1,0,(0,0)),190),((1,5,1,0,(0,1)),250),((1,5,1,0,(0,2)),200),((1,5,1,0,(0,3)),250),
>                       ((1,5,1,0,(1,0)),140),((1,5,1,0,(1,1)),140),((1,5,1,0,(1,2)),200),((1,5,1,0,(1,3)),150),
>                       ((1,5,1,0,(2,0)),80),((1,5,1,0,(2,1)),180),((1,5,1,0,(2,2)),200),((1,5,1,0,(2,3)),190),
>                       ((1,5,1,0,(3,0)),200),((1,5,1,0,(3,1)),200),((1,5,1,0,(3,2)),200),((1,5,1,0,(3,3)),200),
>                       
>                       ((1,5,1,1,(0,0)),190),((1,5,1,1,(0,1)),190),((1,5,1,1,(0,2)),200),((1,5,1,1,(0,3)),190),
>                       ((1,5,1,1,(1,0)),190),((1,5,1,1,(1,1)),190),((1,5,1,1,(1,2)),200),((1,5,1,1,(1,3)),190),
>                       ((1,5,1,1,(2,0)),200),((1,5,1,1,(2,1)),200),((1,5,1,1,(2,2)),200),((1,5,1,1,(2,3)),200),
>                       ((1,5,1,1,(3,0)),190),((1,5,1,1,(3,1)),190),((1,5,1,1,(3,2)),200),((1,5,1,1,(3,3)),190),
>                       
>                       ((1,5,1,2,(0,0)),80),((1,5,1,2,(0,1)),180),((1,5,1,2,(0,2)),200),((1,5,1,2,(0,3)),190),
>                       ((1,5,1,2,(1,0)),200),((1,5,1,2,(1,1)),200),((1,5,1,2,(1,2)),200),((1,5,1,2,(1,3)),200),
>                       ((1,5,1,2,(2,0)),120),((1,5,1,2,(2,1)),180),((1,5,1,2,(2,2)),200),((1,5,1,2,(2,3)),190),
>                       ((1,5,1,2,(3,0)),-90),((1,5,1,2,(3,1)),10),((1,5,1,2,(3,2)),200),((1,5,1,2,(3,3)),10),
>                       
>                       ((1,5,1,3,(0,0)),200),((1,5,1,3,(0,1)),200),((1,5,1,3,(0,2)),200),((1,5,1,3,(0,3)),200),
>                       ((1,5,1,3,(1,0)),160),((1,5,1,3,(1,1)),160),((1,5,1,3,(1,2)),200),((1,5,1,3,(1,3)),160),
>                       ((1,5,1,3,(2,0)),30),((1,5,1,3,(2,1)),130),((1,5,1,3,(2,2)),200),((1,5,1,3,(2,3)),140),
>                       ((1,5,1,3,(3,0)),100),((1,5,1,3,(3,1)),100),((1,5,1,3,(3,2)),200),((1,5,1,3,(3,3)),110),
>                       
>                       
>                       ((1,5,2,0,(0,0)),10),((1,5,2,0,(0,1)),200),((1,5,2,0,(0,2)),180),((1,5,2,0,(0,3)),40),
>                       ((1,5,2,0,(1,0)),-30),((1,5,2,0,(1,1)),200),((1,5,2,0,(1,2)),130),((1,5,2,0,(1,3)),-110),
>                       ((1,5,2,0,(2,0)),-90),((1,5,2,0,(2,1)),200),((1,5,2,0,(2,2)),70),((1,5,2,0,(2,3)),10),
>                       ((1,5,2,0,(3,0)),200),((1,5,2,0,(3,1)),200),((1,5,2,0,(3,2)),200),((1,5,2,0,(3,3)),200),
>                       
>                       ((1,5,2,1,(0,0)),10),((1,5,2,1,(0,1)),200),((1,5,2,1,(0,2)),180),((1,5,2,1,(0,3)),-60),
>                       ((1,5,2,1,(1,0)),110),((1,5,2,1,(1,1)),200),((1,5,2,1,(1,2)),240),((1,5,2,1,(1,3)),40),
>                       ((1,5,2,1,(2,0)),200),((1,5,2,1,(2,1)),200),((1,5,2,1,(2,2)),200),((1,5,2,1,(2,3)),200),
>                       ((1,5,2,1,(3,0)),110),((1,5,2,1,(3,1)),200),((1,5,2,1,(3,2)),240),((1,5,2,1,(3,3)),40),
>                       
>                       ((1,5,2,2,(0,0)),-90),((1,5,2,2,(0,1)),200),((1,5,2,2,(0,2)),70),((1,5,2,2,(0,3)),10),
>                       ((1,5,2,2,(1,0)),200),((1,5,2,2,(1,1)),200),((1,5,2,2,(1,2)),200),((1,5,2,2,(1,3)),200),
>                       ((1,5,2,2,(2,0)),-50),((1,5,2,2,(2,1)),200),((1,5,2,2,(2,2)),110),((1,5,2,2,(2,3)),-30),
>                       ((1,5,2,2,(3,0)),-90),((1,5,2,2,(3,1)),200),((1,5,2,2,(3,2)),0),((1,5,2,2,(3,3)),-350),
>                       
>                       ((1,5,2,3,(0,0)),200),((1,5,2,3,(0,1)),200),((1,5,2,3,(0,2)),200),((1,5,2,3,(0,3)),200),
>                       ((1,5,2,3,(1,0)),80),((1,5,2,3,(1,1)),200),((1,5,2,3,(1,2)),210),((1,5,2,3,(1,3)),10),
>                       ((1,5,2,3,(2,0)),40),((1,5,2,3,(2,1)),200),((1,5,2,3,(2,2)),120),((1,5,2,3,(2,3)),-220),
>                       ((1,5,2,3,(3,0)),110),((1,5,2,3,(3,1)),200),((1,5,2,3,(3,2)),190),((1,5,2,3,(3,3)),30),
>                       
>                       
>                       ((1,5,3,0,(0,0)),200),((1,5,3,0,(0,1)),150),((1,5,3,0,(0,2)),0),((1,5,3,0,(0,3)),210),
>                       ((1,5,3,0,(1,0)),200),((1,5,3,0,(1,1)),40),((1,5,3,0,(1,2)),-150),((1,5,3,0,(1,3)),70),
>                       ((1,5,3,0,(2,0)),200),((1,5,3,0,(2,1)),90),((1,5,3,0,(2,2)),-30),((1,5,3,0,(2,3)),190),
>                       ((1,5,3,0,(3,0)),200),((1,5,3,0,(3,1)),200),((1,5,3,0,(3,2)),200),((1,5,3,0,(3,3)),200),
>                       
>                       ((1,5,3,1,(0,0)),200),((1,5,3,1,(0,1)),90),((1,5,3,1,(0,2)),-100),((1,5,3,1,(0,3)),110),
>                       ((1,5,3,1,(1,0)),200),((1,5,3,1,(1,1)),90),((1,5,3,1,(1,2)),0),((1,5,3,1,(1,3)),110),
>                       ((1,5,3,1,(2,0)),200),((1,5,3,1,(2,1)),200),((1,5,3,1,(2,2)),200),((1,5,3,1,(2,3)),200),
>                       ((1,5,3,1,(3,0)),200),((1,5,3,1,(3,1)),90),((1,5,3,1,(3,2)),0),((1,5,3,1,(3,3)),110),
>                       
>                       ((1,5,3,2,(0,0)),200),((1,5,3,2,(0,1)),90),((1,5,3,2,(0,2)),-30),((1,5,3,2,(0,3)),190),
>                       ((1,5,3,2,(1,0)),200),((1,5,3,2,(1,1)),200),((1,5,3,2,(1,2)),200),((1,5,3,2,(1,3)),200),
>                       ((1,5,3,2,(2,0)),200),((1,5,3,2,(2,1)),80),((1,5,3,2,(2,2)),-70),((1,5,3,2,(2,3)),150),
>                       ((1,5,3,2,(3,0)),200),((1,5,3,2,(3,1)),-90),((1,5,3,2,(3,2)),-390),((1,5,3,2,(3,3)),10),
>                       
>                       ((1,5,3,3,(0,0)),200),((1,5,3,3,(0,1)),200),((1,5,3,3,(0,2)),200),((1,5,3,3,(0,3)),200),
>                       ((1,5,3,3,(1,0)),200),((1,5,3,3,(1,1)),60),((1,5,3,3,(1,2)),-30),((1,5,3,3,(1,3)),80),
>                       ((1,5,3,3,(2,0)),200),((1,5,3,3,(2,1)),40),((1,5,3,3,(2,2)),-260),((1,5,3,3,(2,3)),140),
>                       ((1,5,3,3,(3,0)),200),((1,5,3,3,(3,1)),0),((1,5,3,3,(3,2)),-10),((1,5,3,3,(3,3)),30),
>                       
>                       
>                       
>                       
>                       ((2,0,0,0,(0,0)),200),((2,0,0,0,(0,1)),190),((2,0,0,0,(0,2)),80),((2,0,0,0,(0,3)),200),
>                       ((2,0,0,0,(1,0)),190),((2,0,0,0,(1,1)),180),((2,0,0,0,(1,2)),70),((2,0,0,0,(1,3)),200),
>                       ((2,0,0,0,(2,0)),100),((2,0,0,0,(2,1)),90),((2,0,0,0,(2,2)),-20),((2,0,0,0,(2,3)),200),
>                       ((2,0,0,0,(3,0)),200),((2,0,0,0,(3,1)),200),((2,0,0,0,(3,2)),200),((2,0,0,0,(3,3)),200),
>                       
>                       ((2,0,0,1,(0,0)),240),((2,0,0,1,(0,1)),220),((2,0,0,1,(0,2)),110),((2,0,0,1,(0,3)),200),
>                       ((2,0,0,1,(1,0)),280),((2,0,0,1,(1,1)),210),((2,0,0,1,(1,2)),200),((2,0,0,1,(1,3)),200),
>                       ((2,0,0,1,(2,0)),200),((2,0,0,1,(2,1)),200),((2,0,0,1,(2,2)),200),((2,0,0,1,(2,3)),200),
>                       ((2,0,0,1,(3,0)),270),((2,0,0,1,(3,1)),190),((2,0,0,1,(3,2)),180),((2,0,0,1,(3,3)),200),
>                       
>                       ((2,0,0,2,(0,0)),100),((2,0,0,2,(0,1)),90),((2,0,0,2,(0,2)),-20),((2,0,0,2,(0,3)),200),
>                       ((2,0,0,2,(1,0)),200),((2,0,0,2,(1,1)),200),((2,0,0,2,(1,2)),200),((2,0,0,2,(1,3)),200),
>                       ((2,0,0,2,(2,0)),180),((2,0,0,2,(2,1)),160),((2,0,0,2,(2,2)),50),((2,0,0,2,(2,3)),200),
>                       ((2,0,0,2,(3,0)),30),((2,0,0,2,(3,1)),-80),((2,0,0,2,(3,2)),-10),((2,0,0,2,(3,3)),200),
>                       
>                       ((2,0,0,3,(0,0)),200),((2,0,0,3,(0,1)),200),((2,0,0,3,(0,2)),200),((2,0,0,3,(0,3)),200),
>                       ((2,0,0,3,(1,0)),270),((2,0,0,3,(1,1)),190),((2,0,0,3,(1,2)),180),((2,0,0,3,(1,3)),200),
>                       ((2,0,0,3,(2,0)),180),((2,0,0,3,(2,1)),70),((2,0,0,3,(2,2)),140),((2,0,0,3,(2,3)),200),
>                       ((2,0,0,3,(3,0)),220),((2,0,0,3,(3,1)),100),((2,0,0,3,(3,2)),180),((2,0,0,3,(3,3)),200),
>                       
>                       
>                       ((2,0,1,0,(0,0)),180),((2,0,1,0,(0,1)),230),((2,0,1,0,(0,2)),200),((2,0,1,0,(0,3)),230),
>                       ((2,0,1,0,(1,0)),170),((2,0,1,0,(1,1)),160),((2,0,1,0,(1,2)),200),((2,0,1,0,(1,3)),160),
>                       ((2,0,1,0,(2,0)),80),((2,0,1,0,(2,1)),170),((2,0,1,0,(2,2)),200),((2,0,1,0,(2,3)),170),
>                       ((2,0,1,0,(3,0)),200),((2,0,1,0,(3,1)),200),((2,0,1,0,(3,2)),200),((2,0,1,0,(3,3)),200),
>                       
>                       ((2,0,1,1,(0,0)),210),((2,0,1,1,(0,1)),210),((2,0,1,1,(0,2)),200),((2,0,1,1,(0,3)),210),
>                       ((2,0,1,1,(1,0)),200),((2,0,1,1,(1,1)),190),((2,0,1,1,(1,2)),200),((2,0,1,1,(1,3)),190),
>                       ((2,0,1,1,(2,0)),200),((2,0,1,1,(2,1)),200),((2,0,1,1,(2,2)),200),((2,0,1,1,(2,3)),200),
>                       ((2,0,1,1,(3,0)),180),((2,0,1,1,(3,1)),180),((2,0,1,1,(3,2)),200),((2,0,1,1,(3,3)),180),
>                       
>                       ((2,0,1,2,(0,0)),80),((2,0,1,2,(0,1)),170),((2,0,1,2,(0,2)),200),((2,0,1,2,(0,3)),170),
>                       ((2,0,1,2,(1,0)),200),((2,0,1,2,(1,1)),200),((2,0,1,2,(1,2)),200),((2,0,1,2,(1,3)),200),
>                       ((2,0,1,2,(2,0)),150),((2,0,1,2,(2,1)),210),((2,0,1,2,(2,2)),200),((2,0,1,2,(2,3)),210),
>                       ((2,0,1,2,(3,0)),-90),((2,0,1,2,(3,1)),0),((2,0,1,2,(3,2)),200),((2,0,1,2,(3,3)),0),
>                       
>                       ((2,0,1,3,(0,0)),200),((2,0,1,3,(0,1)),200),((2,0,1,3,(0,2)),200),((2,0,1,3,(0,3)),200),
>                       ((2,0,1,3,(1,0)),180),((2,0,1,3,(1,1)),180),((2,0,1,3,(1,2)),200),((2,0,1,3,(1,3)),180),
>                       ((2,0,1,3,(2,0)),60),((2,0,1,3,(2,1)),150),((2,0,1,3,(2,2)),200),((2,0,1,3,(2,3)),150),
>                       ((2,0,1,3,(3,0)),90),((2,0,1,3,(3,1)),90),((2,0,1,3,(3,2)),200),((2,0,1,3,(3,3)),90),
>                       
>                       
>                       ((2,0,2,0,(0,0)),80),((2,0,2,0,(0,1)),200),((2,0,2,0,(0,2)),130),((2,0,2,0,(0,3)),160),
>                       ((2,0,2,0,(1,0)),70),((2,0,2,0,(1,1)),200),((2,0,2,0,(1,2)),120),((2,0,2,0,(1,3)),50),
>                       ((2,0,2,0,(2,0)),-20),((2,0,2,0,(2,1)),200),((2,0,2,0,(2,2)),30),((2,0,2,0,(2,3)),140),
>                       ((2,0,2,0,(3,0)),200),((2,0,2,0,(3,1)),200),((2,0,2,0,(3,2)),200),((2,0,2,0,(3,3)),200),
>                       
>                       ((2,0,2,1,(0,0)),110),((2,0,2,1,(0,1)),200),((2,0,2,1,(0,2)),170),((2,0,2,1,(0,3)),90),
>                       ((2,0,2,1,(1,0)),200),((2,0,2,1,(1,1)),200),((2,0,2,1,(1,2)),210),((2,0,2,1,(1,3)),180),
>                       ((2,0,2,1,(2,0)),200),((2,0,2,1,(2,1)),200),((2,0,2,1,(2,2)),200),((2,0,2,1,(2,3)),200),
>                       ((2,0,2,1,(3,0)),180),((2,0,2,1,(3,1)),200),((2,0,2,1,(3,2)),200),((2,0,2,1,(3,3)),160),
>                       
>                       ((2,0,2,2,(0,0)),-20),((2,0,2,2,(0,1)),200),((2,0,2,2,(0,2)),30),((2,0,2,2,(0,3)),140),
>                       ((2,0,2,2,(1,0)),200),((2,0,2,2,(1,1)),200),((2,0,2,2,(1,2)),200),((2,0,2,2,(1,3)),200),
>                       ((2,0,2,2,(2,0)),50),((2,0,2,2,(2,1)),200),((2,0,2,2,(2,2)),110),((2,0,2,2,(2,3)),130),
>                       ((2,0,2,2,(3,0)),-10),((2,0,2,2,(3,1)),200),((2,0,2,2,(3,2)),-40),((2,0,2,2,(3,3)),-210),
>                       
>                       ((2,0,2,3,(0,0)),200),((2,0,2,3,(0,1)),200),((2,0,2,3,(0,2)),200),((2,0,2,3,(0,3)),200),
>                       ((2,0,2,3,(1,0)),180),((2,0,2,3,(1,1)),200),((2,0,2,3,(1,2)),200),((2,0,2,3,(1,3)),160),
>                       ((2,0,2,3,(2,0)),140),((2,0,2,3,(2,1)),200),((2,0,2,3,(2,2)),110),((2,0,2,3,(2,3)),-60),
>                       ((2,0,2,3,(3,0)),180),((2,0,2,3,(3,1)),200),((2,0,2,3,(3,2)),150),((2,0,2,3,(3,3)),160),
>                       
>                       
>                       ((2,0,3,0,(0,0)),200),((2,0,3,0,(0,1)),230),((2,0,3,0,(0,2)),60),((2,0,3,0,(0,3)),190),
>                       ((2,0,3,0,(1,0)),200),((2,0,3,0,(1,1)),160),((2,0,3,0,(1,2)),-50),((2,0,3,0,(1,3)),80),
>                       ((2,0,3,0,(2,0)),200),((2,0,3,0,(2,1)),170),((2,0,3,0,(2,2)),40),((2,0,3,0,(2,3)),180),
>                       ((2,0,3,0,(3,0)),200),((2,0,3,0,(3,1)),200),((2,0,3,0,(3,2)),200),((2,0,3,0,(3,3)),200),
>                       
>                       ((2,0,3,1,(0,0)),200),((2,0,3,1,(0,1)),210),((2,0,3,1,(0,2)),0),((2,0,3,1,(0,3)),130),
>                       ((2,0,3,1,(1,0)),200),((2,0,3,1,(1,1)),190),((2,0,3,1,(1,2)),80),((2,0,3,1,(1,3)),110),
>                       ((2,0,3,1,(2,0)),200),((2,0,3,1,(2,1)),200),((2,0,3,1,(2,2)),200),((2,0,3,1,(2,3)),200),
>                       ((2,0,3,1,(3,0)),200),((2,0,3,1,(3,1)),180),((2,0,3,1,(3,2)),70),((2,0,3,1,(3,3)),100),
>                       
>                       ((2,0,3,2,(0,0)),200),((2,0,3,2,(0,1)),170),((2,0,3,2,(0,2)),40),((2,0,3,2,(0,3)),180),
>                       ((2,0,3,2,(1,0)),200),((2,0,3,2,(1,1)),200),((2,0,3,2,(1,2)),200),((2,0,3,2,(1,3)),200),
>                       ((2,0,3,2,(2,0)),200),((2,0,3,2,(2,1)),210),((2,0,3,2,(2,2)),40),((2,0,3,2,(2,3)),170),
>                       ((2,0,3,2,(3,0)),200),((2,0,3,2,(3,1)),0),((2,0,3,2,(3,2)),-310),((2,0,3,2,(3,3)),0),
>                       
>                       ((2,0,3,3,(0,0)),200),((2,0,3,3,(0,1)),200),((2,0,3,3,(0,2)),200),((2,0,3,3,(0,3)),200),
>                       ((2,0,3,3,(1,0)),200),((2,0,3,3,(1,1)),180),((2,0,3,3,(1,2)),70),((2,0,3,3,(1,3)),100),
>                       ((2,0,3,3,(2,0)),200),((2,0,3,3,(2,1)),150),((2,0,3,3,(2,2)),-160),((2,0,3,3,(2,3)),160),
>                       ((2,0,3,3,(3,0)),200),((2,0,3,3,(3,1)),90),((2,0,3,3,(3,2)),60),((2,0,3,3,(3,3)),10),
>                       
>                       
>                       
>                       ((2,1,0,0,(0,0)),210),((2,1,0,0,(0,1)),200),((2,1,0,0,(0,2)),90),((2,1,0,0,(0,3)),200),
>                       ((2,1,0,0,(1,0)),190),((2,1,0,0,(1,1)),170),((2,1,0,0,(1,2)),60),((2,1,0,0,(1,3)),200),
>                       ((2,1,0,0,(2,0)),10),((2,1,0,0,(2,1)),0),((2,1,0,0,(2,2)),-110),((2,1,0,0,(2,3)),200),
>                       ((2,1,0,0,(3,0)),200),((2,1,0,0,(3,1)),200),((2,1,0,0,(3,2)),200),((2,1,0,0,(3,3)),200),
>                       
>                       ((2,1,0,1,(0,0)),180),((2,1,0,1,(0,1)),170),((2,1,0,1,(0,2)),60),((2,1,0,1,(0,3)),200),
>                       ((2,1,0,1,(1,0)),250),((2,1,0,1,(1,1)),170),((2,1,0,1,(1,2)),160),((2,1,0,1,(1,3)),200),
>                       ((2,1,0,1,(2,0)),200),((2,1,0,1,(2,1)),200),((2,1,0,1,(2,2)),200),((2,1,0,1,(2,3)),200),
>                       ((2,1,0,1,(3,0)),150),((2,1,0,1,(3,1)),70),((2,1,0,1,(3,2)),70),((2,1,0,1,(3,3)),200),
>                       
>                       ((2,1,0,2,(0,0)),70),((2,1,0,2,(0,1)),60),((2,1,0,2,(0,2)),-50),((2,1,0,2,(0,3)),200),
>                       ((2,1,0,2,(1,0)),200),((2,1,0,2,(1,1)),200),((2,1,0,2,(1,2)),200),((2,1,0,2,(1,3)),200),
>                       ((2,1,0,2,(2,0)),180),((2,1,0,2,(2,1)),160),((2,1,0,2,(2,2)),50),((2,1,0,2,(2,3)),200),
>                       ((2,1,0,2,(3,0)),0),((2,1,0,2,(3,1)),-120),((2,1,0,2,(3,2)),-50),((2,1,0,2,(3,3)),200),
>                       
>                       ((2,1,0,3,(0,0)),200),((2,1,0,3,(0,1)),200),((2,1,0,3,(0,2)),200),((2,1,0,3,(0,3)),200),
>                       ((2,1,0,3,(1,0)),250),((2,1,0,3,(1,1)),180),((2,1,0,3,(1,2)),170),((2,1,0,3,(1,3)),200),
>                       ((2,1,0,3,(2,0)),40),((2,1,0,3,(2,1)),-80),((2,1,0,3,(2,2)),-10),((2,1,0,3,(2,3)),200),
>                       ((2,1,0,3,(3,0)),210),((2,1,0,3,(3,1)),100),((2,1,0,3,(3,2)),170),((2,1,0,3,(3,3)),200),
>                       
>                       
>                       ((2,1,1,0,(0,0)),190),((2,1,1,0,(0,1)),240),((2,1,1,0,(0,2)),200),((2,1,1,0,(0,3)),240),
>                       ((2,1,1,0,(1,0)),160),((2,1,1,0,(1,1)),160),((2,1,1,0,(1,2)),200),((2,1,1,0,(1,3)),160),
>                       ((2,1,1,0,(2,0)),-10),((2,1,1,0,(2,1)),80),((2,1,1,0,(2,2)),200),((2,1,1,0,(2,3)),80),
>                       ((2,1,1,0,(3,0)),200),((2,1,1,0,(3,1)),200),((2,1,1,0,(3,2)),200),((2,1,1,0,(3,3)),200),
>                       
>                       ((2,1,1,1,(0,0)),160),((2,1,1,1,(0,1)),150),((2,1,1,1,(0,2)),200),((2,1,1,1,(0,3)),150),
>                       ((2,1,1,1,(1,0)),160),((2,1,1,1,(1,1)),160),((2,1,1,1,(1,2)),200),((2,1,1,1,(1,3)),160),
>                       ((2,1,1,1,(2,0)),200),((2,1,1,1,(2,1)),200),((2,1,1,1,(2,2)),200),((2,1,1,1,(2,3)),200),
>                       ((2,1,1,1,(3,0)),60),((2,1,1,1,(3,1)),60),((2,1,1,1,(3,2)),200),((2,1,1,1,(3,3)),60),
>                       
>                       ((2,1,1,2,(0,0)),50),((2,1,1,2,(0,1)),140),((2,1,1,2,(0,2)),200),((2,1,1,2,(0,3)),140),
>                       ((2,1,1,2,(1,0)),200),((2,1,1,2,(1,1)),200),((2,1,1,2,(1,2)),200),((2,1,1,2,(1,3)),200),
>                       ((2,1,1,2,(2,0)),150),((2,1,1,2,(2,1)),210),((2,1,1,2,(2,2)),200),((2,1,1,2,(2,3)),210),
>                       ((2,1,1,2,(3,0)),-130),((2,1,1,2,(3,1)),-30),((2,1,1,2,(3,2)),200),((2,1,1,2,(3,3)),-30),
>                       
>                       ((2,1,1,3,(0,0)),200),((2,1,1,3,(0,1)),200),((2,1,1,3,(0,2)),200),((2,1,1,3,(0,3)),200),
>                       ((2,1,1,3,(1,0)),170),((2,1,1,3,(1,1)),160),((2,1,1,3,(1,2)),200),((2,1,1,3,(1,3)),160),
>                       ((2,1,1,3,(2,0)),-90),((2,1,1,3,(2,1)),10),((2,1,1,3,(2,2)),200),((2,1,1,3,(2,3)),10),
>                       ((2,1,1,3,(3,0)),90),((2,1,1,3,(3,1)),80),((2,1,1,3,(3,2)),200),((2,1,1,3,(3,3)),80),
>                       
>                       
>                       ((2,1,2,0,(0,0)),90),((2,1,2,0,(0,1)),200),((2,1,2,0,(0,2)),140),((2,1,2,0,(0,3)),170),
>                       ((2,1,2,0,(1,0)),60),((2,1,2,0,(1,1)),200),((2,1,2,0,(1,2)),120),((2,1,2,0,(1,3)),40),
>                       ((2,1,2,0,(2,0)),-110),((2,1,2,0,(2,1)),200),((2,1,2,0,(2,2)),-60),((2,1,2,0,(2,3)),50),
>                       ((2,1,2,0,(3,0)),200),((2,1,2,0,(3,1)),200),((2,1,2,0,(3,2)),200),((2,1,2,0,(3,3)),200),
>                       
>                       ((2,1,2,1,(0,0)),60),((2,1,2,1,(0,1)),200),((2,1,2,1,(0,2)),110),((2,1,2,1,(0,3)),40),
>                       ((2,1,2,1,(1,0)),160),((2,1,2,1,(1,1)),200),((2,1,2,1,(1,2)),180),((2,1,2,1,(1,3)),140),
>                       ((2,1,2,1,(2,0)),200),((2,1,2,1,(2,1)),200),((2,1,2,1,(2,2)),200),((2,1,2,1,(2,3)),200),
>                       ((2,1,2,1,(3,0)),70),((2,1,2,1,(3,1)),200),((2,1,2,1,(3,2)),80),((2,1,2,1,(3,3)),50),
>                       
>                       ((2,1,2,2,(0,0)),-50),((2,1,2,2,(0,1)),200),((2,1,2,2,(0,2)),0),((2,1,2,2,(0,3)),110),
>                       ((2,1,2,2,(1,0)),200),((2,1,2,2,(1,1)),200),((2,1,2,2,(1,2)),200),((2,1,2,2,(1,3)),200),
>                       ((2,1,2,2,(2,0)),50),((2,1,2,2,(2,1)),200),((2,1,2,2,(2,2)),110),((2,1,2,2,(2,3)),130),
>                       ((2,1,2,2,(3,0)),-50),((2,1,2,2,(3,1)),200),((2,1,2,2,(3,2)),-70),((2,1,2,2,(3,3)),-250),
>                       
>                       ((2,1,2,3,(0,0)),200),((2,1,2,3,(0,1)),200),((2,1,2,3,(0,2)),200),((2,1,2,3,(0,3)),200),
>                       ((2,1,2,3,(1,0)),170),((2,1,2,3,(1,1)),200),((2,1,2,3,(1,2)),180),((2,1,2,3,(1,3)),150),
>                       ((2,1,2,3,(2,0)),-10),((2,1,2,3,(2,1)),200),((2,1,2,3,(2,2)),-30),((2,1,2,3,(2,3)),-210),
>                       ((2,1,2,3,(3,0)),170),((2,1,2,3,(3,1)),200),((2,1,2,3,(3,2)),140),((2,1,2,3,(3,3)),150),
>                       
>                       
>                       ((2,1,3,0,(0,0)),200),((2,1,3,0,(0,1)),240),((2,1,3,0,(0,2)),70),((2,1,3,0,(0,3)),200),
>                       ((2,1,3,0,(1,0)),200),((2,1,3,0,(1,1)),160),((2,1,3,0,(1,2)),-50),((2,1,3,0,(1,3)),80),
>                       ((2,1,3,0,(2,0)),200),((2,1,3,0,(2,1)),80),((2,1,3,0,(2,2)),-50),((2,1,3,0,(2,3)),80),
>                       ((2,1,3,0,(3,0)),200),((2,1,3,0,(3,1)),200),((2,1,3,0,(3,2)),200),((2,1,3,0,(3,3)),200),
>                       
>                       ((2,1,3,1,(0,0)),200),((2,1,3,1,(0,1)),150),((2,1,3,1,(0,2)),-60),((2,1,3,1,(0,3)),70),
>                       ((2,1,3,1,(1,0)),200),((2,1,3,1,(1,1)),160),((2,1,3,1,(1,2)),50),((2,1,3,1,(1,3)),80),
>                       ((2,1,3,1,(2,0)),200),((2,1,3,1,(2,1)),200),((2,1,3,1,(2,2)),200),((2,1,3,1,(2,3)),200),
>                       ((2,1,3,1,(3,0)),200),((2,1,3,1,(3,1)),60),((2,1,3,1,(3,2)),-50),((2,1,3,1,(3,3)),-20),
>                       
>                       ((2,1,3,2,(0,0)),200),((2,1,3,2,(0,1)),140),((2,1,3,2,(0,2)),10),((2,1,3,2,(0,3)),150),
>                       ((2,1,3,2,(1,0)),200),((2,1,3,2,(1,1)),200),((2,1,3,2,(1,2)),200),((2,1,3,2,(1,3)),200),
>                       ((2,1,3,2,(2,0)),200),((2,1,3,2,(2,1)),210),((2,1,3,2,(2,2)),40),((2,1,3,2,(2,3)),170),
>                       ((2,1,3,2,(3,0)),200),((2,1,3,2,(3,1)),-30),((2,1,3,2,(3,2)),-350),((2,1,3,2,(3,3)),-30),
>                       
>                       ((2,1,3,3,(0,0)),200),((2,1,3,3,(0,1)),200),((2,1,3,3,(0,2)),200),((2,1,3,3,(0,3)),200),
>                       ((2,1,3,3,(1,0)),200),((2,1,3,3,(1,1)),160),((2,1,3,3,(1,2)),50),((2,1,3,3,(1,3)),80),
>                       ((2,1,3,3,(2,0)),200),((2,1,3,3,(2,1)),10),((2,1,3,3,(2,2)),-310),((2,1,3,3,(2,3)),10),
>                       ((2,1,3,3,(3,0)),200),((2,1,3,3,(3,1)),80),((2,1,3,3,(3,2)),50),((2,1,3,3,(3,3)),0),
>                       
>                       
>                       
>                       ((2,2,0,0,(0,0)),280),((2,2,0,0,(0,1)),260),((2,2,0,0,(0,2)),150),((2,2,0,0,(0,3)),200),
>                       ((2,2,0,0,(1,0)),250),((2,2,0,0,(1,1)),240),((2,2,0,0,(1,2)),130),((2,2,0,0,(1,3)),200),
>                       ((2,2,0,0,(2,0)),150),((2,2,0,0,(2,1)),140),((2,2,0,0,(2,2)),30),((2,2,0,0,(2,3)),200),
>                       ((2,2,0,0,(3,0)),200),((2,2,0,0,(3,1)),200),((2,2,0,0,(3,2)),200),((2,2,0,0,(3,3)),200),
>                       
>                       ((2,2,0,1,(0,0)),260),((2,2,0,1,(0,1)),250),((2,2,0,1,(0,2)),140),((2,2,0,1,(0,3)),200),
>                       ((2,2,0,1,(1,0)),310),((2,2,0,1,(1,1)),230),((2,2,0,1,(1,2)),220),((2,2,0,1,(1,3)),200),
>                       ((2,2,0,1,(2,0)),200),((2,2,0,1,(2,1)),200),((2,2,0,1,(2,2)),200),((2,2,0,1,(2,3)),200),
>                       ((2,2,0,1,(3,0)),310),((2,2,0,1,(3,1)),230),((2,2,0,1,(3,2)),220),((2,2,0,1,(3,3)),200),
>                       
>                       ((2,2,0,2,(0,0)),150),((2,2,0,2,(0,1)),140),((2,2,0,2,(0,2)),30),((2,2,0,2,(0,3)),200),
>                       ((2,2,0,2,(1,0)),200),((2,2,0,2,(1,1)),200),((2,2,0,2,(1,2)),200),((2,2,0,2,(1,3)),200),
>                       ((2,2,0,2,(2,0)),210),((2,2,0,2,(2,1)),190),((2,2,0,2,(2,2)),80),((2,2,0,2,(2,3)),200),
>                       ((2,2,0,2,(3,0)),130),((2,2,0,2,(3,1)),20),((2,2,0,2,(3,2)),90),((2,2,0,2,(3,3)),200),
>                       
>                       ((2,2,0,3,(0,0)),200),((2,2,0,3,(0,1)),200),((2,2,0,3,(0,2)),200),((2,2,0,3,(0,3)),200),
>                       ((2,2,0,3,(1,0)),310),((2,2,0,3,(1,1)),230),((2,2,0,3,(1,2)),220),((2,2,0,3,(1,3)),200),
>                       ((2,2,0,3,(2,0)),230),((2,2,0,3,(2,1)),120),((2,2,0,3,(2,2)),190),((2,2,0,3,(2,3)),200),
>                       ((2,2,0,3,(3,0)),270),((2,2,0,3,(3,1)),150),((2,2,0,3,(3,2)),220),((2,2,0,3,(3,3)),200),
>                       
>                       
>                       ((2,2,1,0,(0,0)),250),((2,2,1,0,(0,1)),310),((2,2,1,0,(0,2)),200),((2,2,1,0,(0,3)),310),
>                       ((2,2,1,0,(1,0)),230),((2,2,1,0,(1,1)),220),((2,2,1,0,(1,2)),200),((2,2,1,0,(1,3)),220),
>                       ((2,2,1,0,(2,0)),130),((2,2,1,0,(2,1)),220),((2,2,1,0,(2,2)),200),((2,2,1,0,(2,3)),220),
>                       ((2,2,1,0,(3,0)),200),((2,2,1,0,(3,1)),200),((2,2,1,0,(3,2)),200),((2,2,1,0,(3,3)),200),
>                       
>                       ((2,2,1,1,(0,0)),240),((2,2,1,1,(0,1)),230),((2,2,1,1,(0,2)),200),((2,2,1,1,(0,3)),230),
>                       ((2,2,1,1,(1,0)),220),((2,2,1,1,(1,1)),220),((2,2,1,1,(1,2)),200),((2,2,1,1,(1,3)),220),
>                       ((2,2,1,1,(2,0)),200),((2,2,1,1,(2,1)),200),((2,2,1,1,(2,2)),200),((2,2,1,1,(2,3)),200),
>                       ((2,2,1,1,(3,0)),220),((2,2,1,1,(3,1)),220),((2,2,1,1,(3,2)),200),((2,2,1,1,(3,3)),220),
>                       
>                       ((2,2,1,2,(0,0)),130),((2,2,1,2,(0,1)),220),((2,2,1,2,(0,2)),200),((2,2,1,2,(0,3)),220),
>                       ((2,2,1,2,(1,0)),200),((2,2,1,2,(1,1)),200),((2,2,1,2,(1,2)),200),((2,2,1,2,(1,3)),200),
>                       ((2,2,1,2,(2,0)),180),((2,2,1,2,(2,1)),240),((2,2,1,2,(2,2)),200),((2,2,1,2,(2,3)),240),
>                       ((2,2,1,2,(3,0)),10),((2,2,1,2,(3,1)),100),((2,2,1,2,(3,2)),200),((2,2,1,2,(3,3)),100),
>                       
>                       ((2,2,1,3,(0,0)),200),((2,2,1,3,(0,1)),200),((2,2,1,3,(0,2)),200),((2,2,1,3,(0,3)),200),
>                       ((2,2,1,3,(1,0)),220),((2,2,1,3,(1,1)),220),((2,2,1,3,(1,2)),200),((2,2,1,3,(1,3)),220),
>                       ((2,2,1,3,(2,0)),110),((2,2,1,3,(2,1)),200),((2,2,1,3,(2,2)),200),((2,2,1,3,(2,3)),200),
>                       ((2,2,1,3,(3,0)),140),((2,2,1,3,(3,1)),140),((2,2,1,3,(3,2)),200),((2,2,1,3,(3,3)),140),
>                       
>                       
>                       ((2,2,2,0,(0,0)),150),((2,2,2,0,(0,1)),200),((2,2,2,0,(0,2)),210),((2,2,2,0,(0,3)),230),
>                       ((2,2,2,0,(1,0)),130),((2,2,2,0,(1,1)),200),((2,2,2,0,(1,2)),180),((2,2,2,0,(1,3)),110),
>                       ((2,2,2,0,(2,0)),30),((2,2,2,0,(2,1)),200),((2,2,2,0,(2,2)),80),((2,2,2,0,(2,3)),190),
>                       ((2,2,2,0,(3,0)),200),((2,2,2,0,(3,1)),200),((2,2,2,0,(3,2)),200),((2,2,2,0,(3,3)),200),
>                       
>                       ((2,2,2,1,(0,0)),140),((2,2,2,1,(0,1)),200),((2,2,2,1,(0,2)),190),((2,2,2,1,(0,3)),120),
>                       ((2,2,2,1,(1,0)),220),((2,2,2,1,(1,1)),200),((2,2,2,1,(1,2)),240),((2,2,2,1,(1,3)),200),
>                       ((2,2,2,1,(2,0)),200),((2,2,2,1,(2,1)),200),((2,2,2,1,(2,2)),200),((2,2,2,1,(2,3)),200),
>                       ((2,2,2,1,(3,0)),220),((2,2,2,1,(3,1)),200),((2,2,2,1,(3,2)),240),((2,2,2,1,(3,3)),200),
>                       
>                       ((2,2,2,2,(0,0)),30),((2,2,2,2,(0,1)),200),((2,2,2,2,(0,2)),80),((2,2,2,2,(0,3)),190),
>                       ((2,2,2,2,(1,0)),200),((2,2,2,2,(1,1)),200),((2,2,2,2,(1,2)),200),((2,2,2,2,(1,3)),200),
>                       ((2,2,2,2,(2,0)),80),((2,2,2,2,(2,1)),200),((2,2,2,2,(2,2)),140),((2,2,2,2,(2,3)),160),
>                       ((2,2,2,2,(3,0)),90),((2,2,2,2,(3,1)),200),((2,2,2,2,(3,2)),70),((2,2,2,2,(3,3)),-110),
>                       
>                       ((2,2,2,3,(0,0)),200),((2,2,2,3,(0,1)),200),((2,2,2,3,(0,2)),200),((2,2,2,3,(0,3)),200),
>                       ((2,2,2,3,(1,0)),220),((2,2,2,3,(1,1)),200),((2,2,2,3,(1,2)),240),((2,2,2,3,(1,3)),200),
>                       ((2,2,2,3,(2,0)),190),((2,2,2,3,(2,1)),200),((2,2,2,3,(2,2)),160),((2,2,2,3,(2,3)),-10),
>                       ((2,2,2,3,(3,0)),220),((2,2,2,3,(3,1)),200),((2,2,2,3,(3,2)),200),((2,2,2,3,(3,3)),200),
>                       
>                       
>                       ((2,2,3,0,(0,0)),200),((2,2,3,0,(0,1)),310),((2,2,3,0,(0,2)),130),((2,2,3,0,(0,3)),270),
>                       ((2,2,3,0,(1,0)),200),((2,2,3,0,(1,1)),220),((2,2,3,0,(1,2)),10),((2,2,3,0,(1,3)),140),
>                       ((2,2,3,0,(2,0)),200),((2,2,3,0,(2,1)),220),((2,2,3,0,(2,2)),90),((2,2,3,0,(2,3)),220),
>                       ((2,2,3,0,(3,0)),200),((2,2,3,0,(3,1)),200),((2,2,3,0,(3,2)),200),((2,2,3,0,(3,3)),200),
>                       
>                       ((2,2,3,1,(0,0)),200),((2,2,3,1,(0,1)),230),((2,2,3,1,(0,2)),20),((2,2,3,1,(0,3)),150),
>                       ((2,2,3,1,(1,0)),200),((2,2,3,1,(1,1)),220),((2,2,3,1,(1,2)),100),((2,2,3,1,(1,3)),140),
>                       ((2,2,3,1,(2,0)),200),((2,2,3,1,(2,1)),200),((2,2,3,1,(2,2)),200),((2,2,3,1,(2,3)),200),
>                       ((2,2,3,1,(3,0)),200),((2,2,3,1,(3,1)),220),((2,2,3,1,(3,2)),100),((2,2,3,1,(3,3)),140),
>                       
>                       ((2,2,3,2,(0,0)),200),((2,2,3,2,(0,1)),220),((2,2,3,2,(0,2)),90),((2,2,3,2,(0,3)),220),
>                       ((2,2,3,2,(1,0)),200),((2,2,3,2,(1,1)),200),((2,2,3,2,(1,2)),200),((2,2,3,2,(1,3)),200),
>                       ((2,2,3,2,(2,0)),200),((2,2,3,2,(2,1)),240),((2,2,3,2,(2,2)),70),((2,2,3,2,(2,3)),200),
>                       ((2,2,3,2,(3,0)),200),((2,2,3,2,(3,1)),100),((2,2,3,2,(3,2)),-210),((2,2,3,2,(3,3)),110),
>                       
>                       ((2,2,3,3,(0,0)),200),((2,2,3,3,(0,1)),200),((2,2,3,3,(0,2)),200),((2,2,3,3,(0,3)),200),
>                       ((2,2,3,3,(1,0)),200),((2,2,3,3,(1,1)),220),((2,2,3,3,(1,2)),100),((2,2,3,3,(1,3)),140),
>                       ((2,2,3,3,(2,0)),200),((2,2,3,3,(2,1)),200),((2,2,3,3,(2,2)),-110),((2,2,3,3,(2,3)),200),
>                       ((2,2,3,3,(3,0)),200),((2,2,3,3,(3,1)),140),((2,2,3,3,(3,2)),110),((2,2,3,3,(3,3)),60),
>                       
>                       
>                       
>                       ((2,3,0,0,(0,0)),280),((2,3,0,0,(0,1)),260),((2,3,0,0,(0,2)),150),((2,3,0,0,(0,3)),200),
>                       ((2,3,0,0,(1,0)),230),((2,3,0,0,(1,1)),220),((2,3,0,0,(1,2)),110),((2,3,0,0,(1,3)),200),
>                       ((2,3,0,0,(2,0)),170),((2,3,0,0,(2,1)),160),((2,3,0,0,(2,2)),50),((2,3,0,0,(2,3)),200),
>                       ((2,3,0,0,(3,0)),200),((2,3,0,0,(3,1)),200),((2,3,0,0,(3,2)),200),((2,3,0,0,(3,3)),200),
>                       
>                       ((2,3,0,1,(0,0)),280),((2,3,0,1,(0,1)),260),((2,3,0,1,(0,2)),150),((2,3,0,1,(0,3)),200),
>                       ((2,3,0,1,(1,0)),340),((2,3,0,1,(1,1)),260),((2,3,0,1,(1,2)),250),((2,3,0,1,(1,3)),200),
>                       ((2,3,0,1,(2,0)),200),((2,3,0,1,(2,1)),200),((2,3,0,1,(2,2)),200),((2,3,0,1,(2,3)),200),
>                       ((2,3,0,1,(3,0)),340),((2,3,0,1,(3,1)),260),((2,3,0,1,(3,2)),250),((2,3,0,1,(3,3)),200),
>                       
>                       ((2,3,0,2,(0,0)),170),((2,3,0,2,(0,1)),160),((2,3,0,2,(0,2)),50),((2,3,0,2,(0,3)),200),
>                       ((2,3,0,2,(1,0)),200),((2,3,0,2,(1,1)),200),((2,3,0,2,(1,2)),200),((2,3,0,2,(1,3)),200),
>                       ((2,3,0,2,(2,0)),210),((2,3,0,2,(2,1)),200),((2,3,0,2,(2,2)),90),((2,3,0,2,(2,3)),200),
>                       ((2,3,0,2,(3,0)),100),((2,3,0,2,(3,1)),-20),((2,3,0,2,(3,2)),50),((2,3,0,2,(3,3)),200),
>                       
>                       ((2,3,0,3,(0,0)),200),((2,3,0,3,(0,1)),200),((2,3,0,3,(0,2)),200),((2,3,0,3,(0,3)),200),
>                       ((2,3,0,3,(1,0)),310),((2,3,0,3,(1,1)),230),((2,3,0,3,(1,2)),220),((2,3,0,3,(1,3)),200),
>                       ((2,3,0,3,(2,0)),220),((2,3,0,3,(2,1)),110),((2,3,0,3,(2,2)),180),((2,3,0,3,(2,3)),200),
>                       ((2,3,0,3,(3,0)),290),((2,3,0,3,(3,1)),180),((2,3,0,3,(3,2)),250),((2,3,0,3,(3,3)),200),
>                       
>                       
>                       ((2,3,1,0,(0,0)),250),((2,3,1,0,(0,1)),310),((2,3,1,0,(0,2)),200),((2,3,1,0,(0,3)),310),
>                       ((2,3,1,0,(1,0)),210),((2,3,1,0,(1,1)),200),((2,3,1,0,(1,2)),200),((2,3,1,0,(1,3)),200),
>                       ((2,3,1,0,(2,0)),150),((2,3,1,0,(2,1)),240),((2,3,1,0,(2,2)),200),((2,3,1,0,(2,3)),240),
>                       ((2,3,1,0,(3,0)),200),((2,3,1,0,(3,1)),200),((2,3,1,0,(3,2)),200),((2,3,1,0,(3,3)),200),
>                       
>                       ((2,3,1,1,(0,0)),250),((2,3,1,1,(0,1)),250),((2,3,1,1,(0,2)),200),((2,3,1,1,(0,3)),250),
>                       ((2,3,1,1,(1,0)),250),((2,3,1,1,(1,1)),250),((2,3,1,1,(1,2)),200),((2,3,1,1,(1,3)),250),
>                       ((2,3,1,1,(2,0)),200),((2,3,1,1,(2,1)),200),((2,3,1,1,(2,2)),200),((2,3,1,1,(2,3)),200),
>                       ((2,3,1,1,(3,0)),250),((2,3,1,1,(3,1)),250),((2,3,1,1,(3,2)),200),((2,3,1,1,(3,3)),250),
>                       
>                       ((2,3,1,2,(0,0)),150),((2,3,1,2,(0,1)),240),((2,3,1,2,(0,2)),200),((2,3,1,2,(0,3)),240),
>                       ((2,3,1,2,(1,0)),200),((2,3,1,2,(1,1)),200),((2,3,1,2,(1,2)),200),((2,3,1,2,(1,3)),200),
>                       ((2,3,1,2,(2,0)),190),((2,3,1,2,(2,1)),240),((2,3,1,2,(2,2)),200),((2,3,1,2,(2,3)),240),
>                       ((2,3,1,2,(3,0)),-30),((2,3,1,2,(3,1)),70),((2,3,1,2,(3,2)),200),((2,3,1,2,(3,3)),70),
>                       
>                       ((2,3,1,3,(0,0)),200),((2,3,1,3,(0,1)),200),((2,3,1,3,(0,2)),200),((2,3,1,3,(0,3)),200),
>                       ((2,3,1,3,(1,0)),220),((2,3,1,3,(1,1)),220),((2,3,1,3,(1,2)),200),((2,3,1,3,(1,3)),220),
>                       ((2,3,1,3,(2,0)),100),((2,3,1,3,(2,1)),190),((2,3,1,3,(2,2)),200),((2,3,1,3,(2,3)),190),
>                       ((2,3,1,3,(3,0)),170),((2,3,1,3,(3,1)),160),((2,3,1,3,(3,2)),200),((2,3,1,3,(3,3)),160),
>                       
>                       
>                       ((2,3,2,0,(0,0)),150),((2,3,2,0,(0,1)),200),((2,3,2,0,(0,2)),210),((2,3,2,0,(0,3)),230),
>                       ((2,3,2,0,(1,0)),110),((2,3,2,0,(1,1)),200),((2,3,2,0,(1,2)),160),((2,3,2,0,(1,3)),90),
>                       ((2,3,2,0,(2,0)),50),((2,3,2,0,(2,1)),200),((2,3,2,0,(2,2)),100),((2,3,2,0,(2,3)),210),
>                       ((2,3,2,0,(3,0)),200),((2,3,2,0,(3,1)),200),((2,3,2,0,(3,2)),200),((2,3,2,0,(3,3)),200),
>                       
>                       ((2,3,2,1,(0,0)),150),((2,3,2,1,(0,1)),200),((2,3,2,1,(0,2)),210),((2,3,2,1,(0,3)),130),
>                       ((2,3,2,1,(1,0)),250),((2,3,2,1,(1,1)),200),((2,3,2,1,(1,2)),270),((2,3,2,1,(1,3)),230),
>                       ((2,3,2,1,(2,0)),200),((2,3,2,1,(2,1)),200),((2,3,2,1,(2,2)),200),((2,3,2,1,(2,3)),200),
>                       ((2,3,2,1,(3,0)),250),((2,3,2,1,(3,1)),200),((2,3,2,1,(3,2)),270),((2,3,2,1,(3,3)),230),
>                       
>                       ((2,3,2,2,(0,0)),50),((2,3,2,2,(0,1)),200),((2,3,2,2,(0,2)),100),((2,3,2,2,(0,3)),210),
>                       ((2,3,2,2,(1,0)),200),((2,3,2,2,(1,1)),200),((2,3,2,2,(1,2)),200),((2,3,2,2,(1,3)),200),
>                       ((2,3,2,2,(2,0)),90),((2,3,2,2,(2,1)),200),((2,3,2,2,(2,2)),140),((2,3,2,2,(2,3)),170),
>                       ((2,3,2,2,(3,0)),50),((2,3,2,2,(3,1)),200),((2,3,2,2,(3,2)),30),((2,3,2,2,(3,3)),-150),
>                       
>                       ((2,3,2,3,(0,0)),200),((2,3,2,3,(0,1)),200),((2,3,2,3,(0,2)),200),((2,3,2,3,(0,3)),200),
>                       ((2,3,2,3,(1,0)),220),((2,3,2,3,(1,1)),200),((2,3,2,3,(1,2)),240),((2,3,2,3,(1,3)),200),
>                       ((2,3,2,3,(2,0)),180),((2,3,2,3,(2,1)),200),((2,3,2,3,(2,2)),150),((2,3,2,3,(2,3)),-20),
>                       ((2,3,2,3,(3,0)),250),((2,3,2,3,(3,1)),200),((2,3,2,3,(3,2)),220),((2,3,2,3,(3,3)),230),
>                       
>                       
>                       ((2,3,3,0,(0,0)),200),((2,3,3,0,(0,1)),310),((2,3,3,0,(0,2)),130),((2,3,3,0,(0,3)),270),
>                       ((2,3,3,0,(1,0)),200),((2,3,3,0,(1,1)),200),((2,3,3,0,(1,2)),-10),((2,3,3,0,(1,3)),120),
>                       ((2,3,3,0,(2,0)),200),((2,3,3,0,(2,1)),240),((2,3,3,0,(2,2)),110),((2,3,3,0,(2,3)),240),
>                       ((2,3,3,0,(3,0)),200),((2,3,3,0,(3,1)),200),((2,3,3,0,(3,2)),200),((2,3,3,0,(3,3)),200),
>                       
>                       ((2,3,3,1,(0,0)),200),((2,3,3,1,(0,1)),250),((2,3,3,1,(0,2)),30),((2,3,3,1,(0,3)),170),
>                       ((2,3,3,1,(1,0)),200),((2,3,3,1,(1,1)),250),((2,3,3,1,(1,2)),130),((2,3,3,1,(1,3)),170),
>                       ((2,3,3,1,(2,0)),200),((2,3,3,1,(2,1)),200),((2,3,3,1,(2,2)),200),((2,3,3,1,(2,3)),200),
>                       ((2,3,3,1,(3,0)),200),((2,3,3,1,(3,1)),250),((2,3,3,1,(3,2)),130),((2,3,3,1,(3,3)),170),
>                       
>                       ((2,3,3,2,(0,0)),200),((2,3,3,2,(0,1)),240),((2,3,3,2,(0,2)),110),((2,3,3,2,(0,3)),240),
>                       ((2,3,3,2,(1,0)),200),((2,3,3,2,(1,1)),200),((2,3,3,2,(1,2)),200),((2,3,3,2,(1,3)),200),
>                       ((2,3,3,2,(2,0)),200),((2,3,3,2,(2,1)),240),((2,3,3,2,(2,2)),70),((2,3,3,2,(2,3)),200),
>                       ((2,3,3,2,(3,0)),200),((2,3,3,2,(3,1)),70),((2,3,3,2,(3,2)),-250),((2,3,3,2,(3,3)),70),
>                       
>                       ((2,3,3,3,(0,0)),200),((2,3,3,3,(0,1)),200),((2,3,3,3,(0,2)),200),((2,3,3,3,(0,3)),200),
>                       ((2,3,3,3,(1,0)),200),((2,3,3,3,(1,1)),220),((2,3,3,3,(1,2)),100),((2,3,3,3,(1,3)),140),
>                       ((2,3,3,3,(2,0)),200),((2,3,3,3,(2,1)),190),((2,3,3,3,(2,2)),-120),((2,3,3,3,(2,3)),190),
>                       ((2,3,3,3,(3,0)),200),((2,3,3,3,(3,1)),160),((2,3,3,3,(3,2)),130),((2,3,3,3,(3,3)),80),
>                       
>                       
>                       
>                       ((2,4,0,0,(0,0)),280),((2,4,0,0,(0,1)),260),((2,4,0,0,(0,2)),150),((2,4,0,0,(0,3)),200),
>                       ((2,4,0,0,(1,0)),250),((2,4,0,0,(1,1)),240),((2,4,0,0,(1,2)),130),((2,4,0,0,(1,3)),200),
>                       ((2,4,0,0,(2,0)),150),((2,4,0,0,(2,1)),140),((2,4,0,0,(2,2)),30),((2,4,0,0,(2,3)),200),
>                       ((2,4,0,0,(3,0)),200),((2,4,0,0,(3,1)),200),((2,4,0,0,(3,2)),200),((2,4,0,0,(3,3)),200),
>                       
>                       ((2,4,0,1,(0,0)),260),((2,4,0,1,(0,1)),250),((2,4,0,1,(0,2)),140),((2,4,0,1,(0,3)),200),
>                       ((2,4,0,1,(1,0)),310),((2,4,0,1,(1,1)),230),((2,4,0,1,(1,2)),220),((2,4,0,1,(1,3)),200),
>                       ((2,4,0,1,(2,0)),200),((2,4,0,1,(2,1)),200),((2,4,0,1,(2,2)),200),((2,4,0,1,(2,3)),200),
>                       ((2,4,0,1,(3,0)),310),((2,4,0,1,(3,1)),230),((2,4,0,1,(3,2)),220),((2,4,0,1,(3,3)),200),
>                       
>                       ((2,4,0,2,(0,0)),150),((2,4,0,2,(0,1)),140),((2,4,0,2,(0,2)),30),((2,4,0,2,(0,3)),200),
>                       ((2,4,0,2,(1,0)),200),((2,4,0,2,(1,1)),200),((2,4,0,2,(1,2)),200),((2,4,0,2,(1,3)),200),
>                       ((2,4,0,2,(2,0)),210),((2,4,0,2,(2,1)),190),((2,4,0,2,(2,2)),80),((2,4,0,2,(2,3)),200),
>                       ((2,4,0,2,(3,0)),130),((2,4,0,2,(3,1)),20),((2,4,0,2,(3,2)),90),((2,4,0,2,(3,3)),200),
>                       
>                       ((2,4,0,3,(0,0)),200),((2,4,0,3,(0,1)),200),((2,4,0,3,(0,2)),200),((2,4,0,3,(0,3)),200),
>                       ((2,4,0,3,(1,0)),310),((2,4,0,3,(1,1)),230),((2,4,0,3,(1,2)),220),((2,4,0,3,(1,3)),200),
>                       ((2,4,0,3,(2,0)),230),((2,4,0,3,(2,1)),120),((2,4,0,3,(2,2)),190),((2,4,0,3,(2,3)),200),
>                       ((2,4,0,3,(3,0)),270),((2,4,0,3,(3,1)),150),((2,4,0,3,(3,2)),220),((2,4,0,3,(3,3)),200),
>                       
>                       
>                       ((2,4,1,0,(0,0)),250),((2,4,1,0,(0,1)),310),((2,4,1,0,(0,2)),200),((2,4,1,0,(0,3)),310),
>                       ((2,4,1,0,(1,0)),230),((2,4,1,0,(1,1)),220),((2,4,1,0,(1,2)),200),((2,4,1,0,(1,3)),220),
>                       ((2,4,1,0,(2,0)),130),((2,4,1,0,(2,1)),220),((2,4,1,0,(2,2)),200),((2,4,1,0,(2,3)),220),
>                       ((2,4,1,0,(3,0)),200),((2,4,1,0,(3,1)),200),((2,4,1,0,(3,2)),200),((2,4,1,0,(3,3)),200),
>                       
>                       ((2,4,1,1,(0,0)),240),((2,4,1,1,(0,1)),230),((2,4,1,1,(0,2)),200),((2,4,1,1,(0,3)),230),
>                       ((2,4,1,1,(1,0)),220),((2,4,1,1,(1,1)),220),((2,4,1,1,(1,2)),200),((2,4,1,1,(1,3)),220),
>                       ((2,4,1,1,(2,0)),200),((2,4,1,1,(2,1)),200),((2,4,1,1,(2,2)),200),((2,4,1,1,(2,3)),200),
>                       ((2,4,1,1,(3,0)),220),((2,4,1,1,(3,1)),220),((2,4,1,1,(3,2)),200),((2,4,1,1,(3,3)),220),
>                       
>                       ((2,4,1,2,(0,0)),130),((2,4,1,2,(0,1)),220),((2,4,1,2,(0,2)),200),((2,4,1,2,(0,3)),220),
>                       ((2,4,1,2,(1,0)),200),((2,4,1,2,(1,1)),200),((2,4,1,2,(1,2)),200),((2,4,1,2,(1,3)),200),
>                       ((2,4,1,2,(2,0)),180),((2,4,1,2,(2,1)),240),((2,4,1,2,(2,2)),200),((2,4,1,2,(2,3)),240),
>                       ((2,4,1,2,(3,0)),10),((2,4,1,2,(3,1)),100),((2,4,1,2,(3,2)),200),((2,4,1,2,(3,3)),100),
>                       
>                       ((2,4,1,3,(0,0)),200),((2,4,1,3,(0,1)),200),((2,4,1,3,(0,2)),200),((2,4,1,3,(0,3)),200),
>                       ((2,4,1,3,(1,0)),220),((2,4,1,3,(1,1)),220),((2,4,1,3,(1,2)),200),((2,4,1,3,(1,3)),220),
>                       ((2,4,1,3,(2,0)),110),((2,4,1,3,(2,1)),200),((2,4,1,3,(2,2)),200),((2,4,1,3,(2,3)),200),
>                       ((2,4,1,3,(3,0)),140),((2,4,1,3,(3,1)),140),((2,4,1,3,(3,2)),200),((2,4,1,3,(3,3)),140),
>                       
>                       
>                       ((2,4,2,0,(0,0)),150),((2,4,2,0,(0,1)),200),((2,4,2,0,(0,2)),210),((2,4,2,0,(0,3)),230),
>                       ((2,4,2,0,(1,0)),130),((2,4,2,0,(1,1)),200),((2,4,2,0,(1,2)),180),((2,4,2,0,(1,3)),110),
>                       ((2,4,2,0,(2,0)),30),((2,4,2,0,(2,1)),200),((2,4,2,0,(2,2)),80),((2,4,2,0,(2,3)),190),
>                       ((2,4,2,0,(3,0)),200),((2,4,2,0,(3,1)),200),((2,4,2,0,(3,2)),200),((2,4,2,0,(3,3)),200),
>                       
>                       ((2,4,2,1,(0,0)),140),((2,4,2,1,(0,1)),200),((2,4,2,1,(0,2)),190),((2,4,2,1,(0,3)),120),
>                       ((2,4,2,1,(1,0)),220),((2,4,2,1,(1,1)),200),((2,4,2,1,(1,2)),240),((2,4,2,1,(1,3)),200),
>                       ((2,4,2,1,(2,0)),200),((2,4,2,1,(2,1)),200),((2,4,2,1,(2,2)),200),((2,4,2,1,(2,3)),200),
>                       ((2,4,2,1,(3,0)),220),((2,4,2,1,(3,1)),200),((2,4,2,1,(3,2)),240),((2,4,2,1,(3,3)),200),
>                       
>                       ((2,4,2,2,(0,0)),30),((2,4,2,2,(0,1)),200),((2,4,2,2,(0,2)),80),((2,4,2,2,(0,3)),190),
>                       ((2,4,2,2,(1,0)),200),((2,4,2,2,(1,1)),200),((2,4,2,2,(1,2)),200),((2,4,2,2,(1,3)),200),
>                       ((2,4,2,2,(2,0)),80),((2,4,2,2,(2,1)),200),((2,4,2,2,(2,2)),140),((2,4,2,2,(2,3)),160),
>                       ((2,4,2,2,(3,0)),90),((2,4,2,2,(3,1)),200),((2,4,2,2,(3,2)),70),((2,4,2,2,(3,3)),-110),
>                       
>                       ((2,4,2,3,(0,0)),200),((2,4,2,3,(0,1)),200),((2,4,2,3,(0,2)),200),((2,4,2,3,(0,3)),200),
>                       ((2,4,2,3,(1,0)),220),((2,4,2,3,(1,1)),200),((2,4,2,3,(1,2)),240),((2,4,2,3,(1,3)),200),
>                       ((2,4,2,3,(2,0)),190),((2,4,2,3,(2,1)),200),((2,4,2,3,(2,2)),160),((2,4,2,3,(2,3)),-10),
>                       ((2,4,2,3,(3,0)),220),((2,4,2,3,(3,1)),200),((2,4,2,3,(3,2)),200),((2,4,2,3,(3,3)),200),
>                       
>                       
>                       ((2,4,3,0,(0,0)),200),((2,4,3,0,(0,1)),310),((2,4,3,0,(0,2)),130),((2,4,3,0,(0,3)),270),
>                       ((2,4,3,0,(1,0)),200),((2,4,3,0,(1,1)),220),((2,4,3,0,(1,2)),10),((2,4,3,0,(1,3)),140),
>                       ((2,4,3,0,(2,0)),200),((2,4,3,0,(2,1)),220),((2,4,3,0,(2,2)),90),((2,4,3,0,(2,3)),220),
>                       ((2,4,3,0,(3,0)),200),((2,4,3,0,(3,1)),200),((2,4,3,0,(3,2)),200),((2,4,3,0,(3,3)),200),
>                       
>                       ((2,4,3,1,(0,0)),200),((2,4,3,1,(0,1)),230),((2,4,3,1,(0,2)),20),((2,4,3,1,(0,3)),150),
>                       ((2,4,3,1,(1,0)),200),((2,4,3,1,(1,1)),220),((2,4,3,1,(1,2)),100),((2,4,3,1,(1,3)),140),
>                       ((2,4,3,1,(2,0)),200),((2,4,3,1,(2,1)),200),((2,4,3,1,(2,2)),200),((2,4,3,1,(2,3)),200),
>                       ((2,4,3,1,(3,0)),200),((2,4,3,1,(3,1)),220),((2,4,3,1,(3,2)),100),((2,4,3,1,(3,3)),140),
>                       
>                       ((2,4,3,2,(0,0)),200),((2,4,3,2,(0,1)),220),((2,4,3,2,(0,2)),90),((2,4,3,2,(0,3)),220),
>                       ((2,4,3,2,(1,0)),200),((2,4,3,2,(1,1)),200),((2,4,3,2,(1,2)),200),((2,4,3,2,(1,3)),200),
>                       ((2,4,3,2,(2,0)),200),((2,4,3,2,(2,1)),240),((2,4,3,2,(2,2)),70),((2,4,3,2,(2,3)),200),
>                       ((2,4,3,2,(3,0)),200),((2,4,3,2,(3,1)),100),((2,4,3,2,(3,2)),-210),((2,4,3,2,(3,3)),110),
>                       
>                       ((2,4,3,3,(0,0)),200),((2,4,3,3,(0,1)),200),((2,4,3,3,(0,2)),200),((2,4,3,3,(0,3)),200),
>                       ((2,4,3,3,(1,0)),200),((2,4,3,3,(1,1)),220),((2,4,3,3,(1,2)),100),((2,4,3,3,(1,3)),140),
>                       ((2,4,3,3,(2,0)),200),((2,4,3,3,(2,1)),200),((2,4,3,3,(2,2)),-110),((2,4,3,3,(2,3)),200),
>                       ((2,4,3,3,(3,0)),200),((2,4,3,3,(3,1)),140),((2,4,3,3,(3,2)),110),((2,4,3,3,(3,3)),60),
>                       
>                       
>                       
>                       ((2,5,0,0,(0,0)),280),((2,5,0,0,(0,1)),260),((2,5,0,0,(0,2)),150),((2,5,0,0,(0,3)),200),
>                       ((2,5,0,0,(1,0)),230),((2,5,0,0,(1,1)),220),((2,5,0,0,(1,2)),110),((2,5,0,0,(1,3)),200),
>                       ((2,5,0,0,(2,0)),170),((2,5,0,0,(2,1)),160),((2,5,0,0,(2,2)),50),((2,5,0,0,(2,3)),200),
>                       ((2,5,0,0,(3,0)),200),((2,5,0,0,(3,1)),200),((2,5,0,0,(3,2)),200),((2,5,0,0,(3,3)),200),
>                       
>                       ((2,5,0,1,(0,0)),280),((2,5,0,1,(0,1)),260),((2,5,0,1,(0,2)),150),((2,5,0,1,(0,3)),200),
>                       ((2,5,0,1,(1,0)),340),((2,5,0,1,(1,1)),260),((2,5,0,1,(1,2)),250),((2,5,0,1,(1,3)),200),
>                       ((2,5,0,1,(2,0)),200),((2,5,0,1,(2,1)),200),((2,5,0,1,(2,2)),200),((2,5,0,1,(2,3)),200),
>                       ((2,5,0,1,(3,0)),340),((2,5,0,1,(3,1)),260),((2,5,0,1,(3,2)),250),((2,5,0,1,(3,3)),200),
>                       
>                       ((2,5,0,2,(0,0)),170),((2,5,0,2,(0,1)),160),((2,5,0,2,(0,2)),50),((2,5,0,2,(0,3)),200),
>                       ((2,5,0,2,(1,0)),200),((2,5,0,2,(1,1)),200),((2,5,0,2,(1,2)),200),((2,5,0,2,(1,3)),200),
>                       ((2,5,0,2,(2,0)),210),((2,5,0,2,(2,1)),200),((2,5,0,2,(2,2)),90),((2,5,0,2,(2,3)),200),
>                       ((2,5,0,2,(3,0)),100),((2,5,0,2,(3,1)),-20),((2,5,0,2,(3,2)),50),((2,5,0,2,(3,3)),200),
>                       
>                       ((2,5,0,3,(0,0)),200),((2,5,0,3,(0,1)),200),((2,5,0,3,(0,2)),200),((2,5,0,3,(0,3)),200),
>                       ((2,5,0,3,(1,0)),310),((2,5,0,3,(1,1)),230),((2,5,0,3,(1,2)),220),((2,5,0,3,(1,3)),200),
>                       ((2,5,0,3,(2,0)),220),((2,5,0,3,(2,1)),110),((2,5,0,3,(2,2)),180),((2,5,0,3,(2,3)),200),
>                       ((2,5,0,3,(3,0)),290),((2,5,0,3,(3,1)),180),((2,5,0,3,(3,2)),250),((2,5,0,3,(3,3)),200),
>                       
>                       
>                       ((2,5,1,0,(0,0)),250),((2,5,1,0,(0,1)),310),((2,5,1,0,(0,2)),200),((2,5,1,0,(0,3)),310),
>                       ((2,5,1,0,(1,0)),210),((2,5,1,0,(1,1)),200),((2,5,1,0,(1,2)),200),((2,5,1,0,(1,3)),200),
>                       ((2,5,1,0,(2,0)),150),((2,5,1,0,(2,1)),240),((2,5,1,0,(2,2)),200),((2,5,1,0,(2,3)),240),
>                       ((2,5,1,0,(3,0)),200),((2,5,1,0,(3,1)),200),((2,5,1,0,(3,2)),200),((2,5,1,0,(3,3)),200),
>                       
>                       ((2,5,1,1,(0,0)),250),((2,5,1,1,(0,1)),250),((2,5,1,1,(0,2)),200),((2,5,1,1,(0,3)),250),
>                       ((2,5,1,1,(1,0)),250),((2,5,1,1,(1,1)),250),((2,5,1,1,(1,2)),200),((2,5,1,1,(1,3)),250),
>                       ((2,5,1,1,(2,0)),200),((2,5,1,1,(2,1)),200),((2,5,1,1,(2,2)),200),((2,5,1,1,(2,3)),200),
>                       ((2,5,1,1,(3,0)),250),((2,5,1,1,(3,1)),250),((2,5,1,1,(3,2)),200),((2,5,1,1,(3,3)),250),
>                       
>                       ((2,5,1,2,(0,0)),150),((2,5,1,2,(0,1)),240),((2,5,1,2,(0,2)),200),((2,5,1,2,(0,3)),240),
>                       ((2,5,1,2,(1,0)),200),((2,5,1,2,(1,1)),200),((2,5,1,2,(1,2)),200),((2,5,1,2,(1,3)),200),
>                       ((2,5,1,2,(2,0)),190),((2,5,1,2,(2,1)),240),((2,5,1,2,(2,2)),200),((2,5,1,2,(2,3)),240),
>                       ((2,5,1,2,(3,0)),-30),((2,5,1,2,(3,1)),70),((2,5,1,2,(3,2)),200),((2,5,1,2,(3,3)),70),
>                       
>                       ((2,5,1,3,(0,0)),200),((2,5,1,3,(0,1)),200),((2,5,1,3,(0,2)),200),((2,5,1,3,(0,3)),200),
>                       ((2,5,1,3,(1,0)),220),((2,5,1,3,(1,1)),220),((2,5,1,3,(1,2)),200),((2,5,1,3,(1,3)),220),
>                       ((2,5,1,3,(2,0)),100),((2,5,1,3,(2,1)),190),((2,5,1,3,(2,2)),200),((2,5,1,3,(2,3)),190),
>                       ((2,5,1,3,(3,0)),170),((2,5,1,3,(3,1)),160),((2,5,1,3,(3,2)),200),((2,5,1,3,(3,3)),160),
>                       
>                       
>                       ((2,5,2,0,(0,0)),150),((2,5,2,0,(0,1)),200),((2,5,2,0,(0,2)),210),((2,5,2,0,(0,3)),230),
>                       ((2,5,2,0,(1,0)),110),((2,5,2,0,(1,1)),200),((2,5,2,0,(1,2)),160),((2,5,2,0,(1,3)),90),
>                       ((2,5,2,0,(2,0)),50),((2,5,2,0,(2,1)),200),((2,5,2,0,(2,2)),100),((2,5,2,0,(2,3)),210),
>                       ((2,5,2,0,(3,0)),200),((2,5,2,0,(3,1)),200),((2,5,2,0,(3,2)),200),((2,5,2,0,(3,3)),200),
>                       
>                       ((2,5,2,1,(0,0)),150),((2,5,2,1,(0,1)),200),((2,5,2,1,(0,2)),210),((2,5,2,1,(0,3)),130),
>                       ((2,5,2,1,(1,0)),250),((2,5,2,1,(1,1)),200),((2,5,2,1,(1,2)),270),((2,5,2,1,(1,3)),230),
>                       ((2,5,2,1,(2,0)),200),((2,5,2,1,(2,1)),200),((2,5,2,1,(2,2)),200),((2,5,2,1,(2,3)),200),
>                       ((2,5,2,1,(3,0)),250),((2,5,2,1,(3,1)),200),((2,5,2,1,(3,2)),270),((2,5,2,1,(3,3)),230),
>                       
>                       ((2,5,2,2,(0,0)),50),((2,5,2,2,(0,1)),200),((2,5,2,2,(0,2)),100),((2,5,2,2,(0,3)),210),
>                       ((2,5,2,2,(1,0)),200),((2,5,2,2,(1,1)),200),((2,5,2,2,(1,2)),200),((2,5,2,2,(1,3)),200),
>                       ((2,5,2,2,(2,0)),90),((2,5,2,2,(2,1)),200),((2,5,2,2,(2,2)),140),((2,5,2,2,(2,3)),170),
>                       ((2,5,2,2,(3,0)),50),((2,5,2,2,(3,1)),200),((2,5,2,2,(3,2)),30),((2,5,2,2,(3,3)),-150),
>                       
>                       ((2,5,2,3,(0,0)),200),((2,5,2,3,(0,1)),200),((2,5,2,3,(0,2)),200),((2,5,2,3,(0,3)),200),
>                       ((2,5,2,3,(1,0)),220),((2,5,2,3,(1,1)),200),((2,5,2,3,(1,2)),240),((2,5,2,3,(1,3)),200),
>                       ((2,5,2,3,(2,0)),180),((2,5,2,3,(2,1)),200),((2,5,2,3,(2,2)),150),((2,5,2,3,(2,3)),-20),
>                       ((2,5,2,3,(3,0)),250),((2,5,2,3,(3,1)),200),((2,5,2,3,(3,2)),220),((2,5,2,3,(3,3)),230),
>                       
>                       
>                       ((2,5,3,0,(0,0)),200),((2,5,3,0,(0,1)),310),((2,5,3,0,(0,2)),130),((2,5,3,0,(0,3)),270),
>                       ((2,5,3,0,(1,0)),200),((2,5,3,0,(1,1)),200),((2,5,3,0,(1,2)),-10),((2,5,3,0,(1,3)),120),
>                       ((2,5,3,0,(2,0)),200),((2,5,3,0,(2,1)),240),((2,5,3,0,(2,2)),110),((2,5,3,0,(2,3)),240),
>                       ((2,5,3,0,(3,0)),200),((2,5,3,0,(3,1)),200),((2,5,3,0,(3,2)),200),((2,5,3,0,(3,3)),200),
>                       
>                       ((2,5,3,1,(0,0)),200),((2,5,3,1,(0,1)),250),((2,5,3,1,(0,2)),30),((2,5,3,1,(0,3)),170),
>                       ((2,5,3,1,(1,0)),200),((2,5,3,1,(1,1)),250),((2,5,3,1,(1,2)),130),((2,5,3,1,(1,3)),170),
>                       ((2,5,3,1,(2,0)),200),((2,5,3,1,(2,1)),200),((2,5,3,1,(2,2)),200),((2,5,3,1,(2,3)),200),
>                       ((2,5,3,1,(3,0)),200),((2,5,3,1,(3,1)),250),((2,5,3,1,(3,2)),130),((2,5,3,1,(3,3)),170),
>                       
>                       ((2,5,3,2,(0,0)),200),((2,5,3,2,(0,1)),240),((2,5,3,2,(0,2)),110),((2,5,3,2,(0,3)),240),
>                       ((2,5,3,2,(1,0)),200),((2,5,3,2,(1,1)),200),((2,5,3,2,(1,2)),200),((2,5,3,2,(1,3)),200),
>                       ((2,5,3,2,(2,0)),200),((2,5,3,2,(2,1)),240),((2,5,3,2,(2,2)),70),((2,5,3,2,(2,3)),200),
>                       ((2,5,3,2,(3,0)),200),((2,5,3,2,(3,1)),70),((2,5,3,2,(3,2)),-250),((2,5,3,2,(3,3)),70),
>                       
>                       ((2,5,3,3,(0,0)),200),((2,5,3,3,(0,1)),200),((2,5,3,3,(0,2)),200),((2,5,3,3,(0,3)),200),
>                       ((2,5,3,3,(1,0)),200),((2,5,3,3,(1,1)),220),((2,5,3,3,(1,2)),100),((2,5,3,3,(1,3)),140),
>                       ((2,5,3,3,(2,0)),200),((2,5,3,3,(2,1)),190),((2,5,3,3,(2,2)),-120),((2,5,3,3,(2,3)),190),
>                       ((2,5,3,3,(3,0)),200),((2,5,3,3,(3,1)),160),((2,5,3,3,(3,2)),130),((2,5,3,3,(3,3)),80),
>                       
>                       
>                       
>                       
>                       ((3,0,0,0,(0,0)),200),((3,0,0,0,(0,1)),200),((3,0,0,0,(0,2)),100),((3,0,0,0,(0,3)),200),
>                       ((3,0,0,0,(1,0)),190),((3,0,0,0,(1,1)),190),((3,0,0,0,(1,2)),90),((3,0,0,0,(1,3)),200),
>                       ((3,0,0,0,(2,0)),100),((3,0,0,0,(2,1)),100),((3,0,0,0,(2,2)),0),((3,0,0,0,(2,3)),200),
>                       ((3,0,0,0,(3,0)),200),((3,0,0,0,(3,1)),200),((3,0,0,0,(3,2)),200),((3,0,0,0,(3,3)),200),
>                       
>                       ((3,0,0,1,(0,0)),240),((3,0,0,1,(0,1)),240),((3,0,0,1,(0,2)),130),((3,0,0,1,(0,3)),200),
>                       ((3,0,0,1,(1,0)),280),((3,0,0,1,(1,1)),220),((3,0,0,1,(1,2)),220),((3,0,0,1,(1,3)),200),
>                       ((3,0,0,1,(2,0)),200),((3,0,0,1,(2,1)),200),((3,0,0,1,(2,2)),200),((3,0,0,1,(2,3)),200),
>                       ((3,0,0,1,(3,0)),270),((3,0,0,1,(3,1)),210),((3,0,0,1,(3,2)),200),((3,0,0,1,(3,3)),200),
>                       
>                       ((3,0,0,2,(0,0)),100),((3,0,0,2,(0,1)),100),((3,0,0,2,(0,2)),0),((3,0,0,2,(0,3)),200),
>                       ((3,0,0,2,(1,0)),200),((3,0,0,2,(1,1)),200),((3,0,0,2,(1,2)),200),((3,0,0,2,(1,3)),200),
>                       ((3,0,0,2,(2,0)),180),((3,0,0,2,(2,1)),180),((3,0,0,2,(2,2)),70),((3,0,0,2,(2,3)),200),
>                       ((3,0,0,2,(3,0)),30),((3,0,0,2,(3,1)),-70),((3,0,0,2,(3,2)),10),((3,0,0,2,(3,3)),200),
>                       
>                       ((3,0,0,3,(0,0)),200),((3,0,0,3,(0,1)),200),((3,0,0,3,(0,2)),200),((3,0,0,3,(0,3)),200),
>                       ((3,0,0,3,(1,0)),270),((3,0,0,3,(1,1)),210),((3,0,0,3,(1,2)),200),((3,0,0,3,(1,3)),200),
>                       ((3,0,0,3,(2,0)),180),((3,0,0,3,(2,1)),80),((3,0,0,3,(2,2)),160),((3,0,0,3,(2,3)),200),
>                       ((3,0,0,3,(3,0)),220),((3,0,0,3,(3,1)),120),((3,0,0,3,(3,2)),190),((3,0,0,3,(3,3)),200),
>                       
>                       
>                       ((3,0,1,0,(0,0)),160),((3,0,1,0,(0,1)),260),((3,0,1,0,(0,2)),200),((3,0,1,0,(0,3)),230),
>                       ((3,0,1,0,(1,0)),150),((3,0,1,0,(1,1)),190),((3,0,1,0,(1,2)),200),((3,0,1,0,(1,3)),160),
>                       ((3,0,1,0,(2,0)),60),((3,0,1,0,(2,1)),200),((3,0,1,0,(2,2)),200),((3,0,1,0,(2,3)),170),
>                       ((3,0,1,0,(3,0)),200),((3,0,1,0,(3,1)),200),((3,0,1,0,(3,2)),200),((3,0,1,0,(3,3)),200),
>                       
>                       ((3,0,1,1,(0,0)),190),((3,0,1,1,(0,1)),240),((3,0,1,1,(0,2)),200),((3,0,1,1,(0,3)),210),
>                       ((3,0,1,1,(1,0)),180),((3,0,1,1,(1,1)),220),((3,0,1,1,(1,2)),200),((3,0,1,1,(1,3)),190),
>                       ((3,0,1,1,(2,0)),200),((3,0,1,1,(2,1)),200),((3,0,1,1,(2,2)),200),((3,0,1,1,(2,3)),200),
>                       ((3,0,1,1,(3,0)),160),((3,0,1,1,(3,1)),210),((3,0,1,1,(3,2)),200),((3,0,1,1,(3,3)),180),
>                       
>                       ((3,0,1,2,(0,0)),60),((3,0,1,2,(0,1)),200),((3,0,1,2,(0,2)),200),((3,0,1,2,(0,3)),170),
>                       ((3,0,1,2,(1,0)),200),((3,0,1,2,(1,1)),200),((3,0,1,2,(1,2)),200),((3,0,1,2,(1,3)),200),
>                       ((3,0,1,2,(2,0)),130),((3,0,1,2,(2,1)),240),((3,0,1,2,(2,2)),200),((3,0,1,2,(2,3)),210),
>                       ((3,0,1,2,(3,0)),-110),((3,0,1,2,(3,1)),30),((3,0,1,2,(3,2)),200),((3,0,1,2,(3,3)),0),
>                       
>                       ((3,0,1,3,(0,0)),200),((3,0,1,3,(0,1)),200),((3,0,1,3,(0,2)),200),((3,0,1,3,(0,3)),200),
>                       ((3,0,1,3,(1,0)),160),((3,0,1,3,(1,1)),210),((3,0,1,3,(1,2)),200),((3,0,1,3,(1,3)),180),
>                       ((3,0,1,3,(2,0)),40),((3,0,1,3,(2,1)),180),((3,0,1,3,(2,2)),200),((3,0,1,3,(2,3)),150),
>                       ((3,0,1,3,(3,0)),70),((3,0,1,3,(3,1)),120),((3,0,1,3,(3,2)),200),((3,0,1,3,(3,3)),90),
>                       
>                       
>                       ((3,0,2,0,(0,0)),100),((3,0,2,0,(0,1)),200),((3,0,2,0,(0,2)),140),((3,0,2,0,(0,3)),150),
>                       ((3,0,2,0,(1,0)),90),((3,0,2,0,(1,1)),200),((3,0,2,0,(1,2)),130),((3,0,2,0,(1,3)),40),
>                       ((3,0,2,0,(2,0)),0),((3,0,2,0,(2,1)),200),((3,0,2,0,(2,2)),40),((3,0,2,0,(2,3)),130),
>                       ((3,0,2,0,(3,0)),200),((3,0,2,0,(3,1)),200),((3,0,2,0,(3,2)),200),((3,0,2,0,(3,3)),200),
>                       
>                       ((3,0,2,1,(0,0)),130),((3,0,2,1,(0,1)),200),((3,0,2,1,(0,2)),170),((3,0,2,1,(0,3)),80),
>                       ((3,0,2,1,(1,0)),220),((3,0,2,1,(1,1)),200),((3,0,2,1,(1,2)),220),((3,0,2,1,(1,3)),170),
>                       ((3,0,2,1,(2,0)),200),((3,0,2,1,(2,1)),200),((3,0,2,1,(2,2)),200),((3,0,2,1,(2,3)),200),
>                       ((3,0,2,1,(3,0)),200),((3,0,2,1,(3,1)),200),((3,0,2,1,(3,2)),200),((3,0,2,1,(3,3)),150),
>                       
>                       ((3,0,2,2,(0,0)),0),((3,0,2,2,(0,1)),200),((3,0,2,2,(0,2)),40),((3,0,2,2,(0,3)),130),
>                       ((3,0,2,2,(1,0)),200),((3,0,2,2,(1,1)),200),((3,0,2,2,(1,2)),200),((3,0,2,2,(1,3)),200),
>                       ((3,0,2,2,(2,0)),70),((3,0,2,2,(2,1)),200),((3,0,2,2,(2,2)),110),((3,0,2,2,(2,3)),120),
>                       ((3,0,2,2,(3,0)),10),((3,0,2,2,(3,1)),200),((3,0,2,2,(3,2)),-30),((3,0,2,2,(3,3)),-220),
>                       
>                       ((3,0,2,3,(0,0)),200),((3,0,2,3,(0,1)),200),((3,0,2,3,(0,2)),200),((3,0,2,3,(0,3)),200),
>                       ((3,0,2,3,(1,0)),200),((3,0,2,3,(1,1)),200),((3,0,2,3,(1,2)),200),((3,0,2,3,(1,3)),150),
>                       ((3,0,2,3,(2,0)),160),((3,0,2,3,(2,1)),200),((3,0,2,3,(2,2)),120),((3,0,2,3,(2,3)),-70),
>                       ((3,0,2,3,(3,0)),190),((3,0,2,3,(3,1)),200),((3,0,2,3,(3,2)),150),((3,0,2,3,(3,3)),150),
>                       
>                       
>                       ((3,0,3,0,(0,0)),200),((3,0,3,0,(0,1)),260),((3,0,3,0,(0,2)),20),((3,0,3,0,(0,3)),220),
>                       ((3,0,3,0,(1,0)),200),((3,0,3,0,(1,1)),190),((3,0,3,0,(1,2)),-90),((3,0,3,0,(1,3)),110),
>                       ((3,0,3,0,(2,0)),200),((3,0,3,0,(2,1)),200),((3,0,3,0,(2,2)),0),((3,0,3,0,(2,3)),200),
>                       ((3,0,3,0,(3,0)),200),((3,0,3,0,(3,1)),200),((3,0,3,0,(3,2)),200),((3,0,3,0,(3,3)),200),
>                       
>                       ((3,0,3,1,(0,0)),200),((3,0,3,1,(0,1)),240),((3,0,3,1,(0,2)),-40),((3,0,3,1,(0,3)),150),
>                       ((3,0,3,1,(1,0)),200),((3,0,3,1,(1,1)),220),((3,0,3,1,(1,2)),40),((3,0,3,1,(1,3)),140),
>                       ((3,0,3,1,(2,0)),200),((3,0,3,1,(2,1)),200),((3,0,3,1,(2,2)),200),((3,0,3,1,(2,3)),200),
>                       ((3,0,3,1,(3,0)),200),((3,0,3,1,(3,1)),210),((3,0,3,1,(3,2)),30),((3,0,3,1,(3,3)),120),
>                       
>                       ((3,0,3,2,(0,0)),200),((3,0,3,2,(0,1)),200),((3,0,3,2,(0,2)),0),((3,0,3,2,(0,3)),200),
>                       ((3,0,3,2,(1,0)),200),((3,0,3,2,(1,1)),200),((3,0,3,2,(1,2)),200),((3,0,3,2,(1,3)),200),
>                       ((3,0,3,2,(2,0)),200),((3,0,3,2,(2,1)),240),((3,0,3,2,(2,2)),0),((3,0,3,2,(2,3)),190),
>                       ((3,0,3,2,(3,0)),200),((3,0,3,2,(3,1)),30),((3,0,3,2,(3,2)),-350),((3,0,3,2,(3,3)),30),
>                       
>                       ((3,0,3,3,(0,0)),200),((3,0,3,3,(0,1)),200),((3,0,3,3,(0,2)),200),((3,0,3,3,(0,3)),200),
>                       ((3,0,3,3,(1,0)),200),((3,0,3,3,(1,1)),210),((3,0,3,3,(1,2)),30),((3,0,3,3,(1,3)),120),
>                       ((3,0,3,3,(2,0)),200),((3,0,3,3,(2,1)),180),((3,0,3,3,(2,2)),-200),((3,0,3,3,(2,3)),180),
>                       ((3,0,3,3,(3,0)),200),((3,0,3,3,(3,1)),120),((3,0,3,3,(3,2)),20),((3,0,3,3,(3,3)),30),
>                       
>                       
>                       
>                       ((3,1,0,0,(0,0)),210),((3,1,0,0,(0,1)),210),((3,1,0,0,(0,2)),110),((3,1,0,0,(0,3)),200),
>                       ((3,1,0,0,(1,0)),190),((3,1,0,0,(1,1)),190),((3,1,0,0,(1,2)),80),((3,1,0,0,(1,3)),200),
>                       ((3,1,0,0,(2,0)),10),((3,1,0,0,(2,1)),10),((3,1,0,0,(2,2)),-90),((3,1,0,0,(2,3)),200),
>                       ((3,1,0,0,(3,0)),200),((3,1,0,0,(3,1)),200),((3,1,0,0,(3,2)),200),((3,1,0,0,(3,3)),200),
>                       
>                       ((3,1,0,1,(0,0)),180),((3,1,0,1,(0,1)),180),((3,1,0,1,(0,2)),80),((3,1,0,1,(0,3)),200),
>                       ((3,1,0,1,(1,0)),250),((3,1,0,1,(1,1)),190),((3,1,0,1,(1,2)),180),((3,1,0,1,(1,3)),200),
>                       ((3,1,0,1,(2,0)),200),((3,1,0,1,(2,1)),200),((3,1,0,1,(2,2)),200),((3,1,0,1,(2,3)),200),
>                       ((3,1,0,1,(3,0)),150),((3,1,0,1,(3,1)),90),((3,1,0,1,(3,2)),90),((3,1,0,1,(3,3)),200),
>                       
>                       ((3,1,0,2,(0,0)),70),((3,1,0,2,(0,1)),70),((3,1,0,2,(0,2)),-30),((3,1,0,2,(0,3)),200),
>                       ((3,1,0,2,(1,0)),200),((3,1,0,2,(1,1)),200),((3,1,0,2,(1,2)),200),((3,1,0,2,(1,3)),200),
>                       ((3,1,0,2,(2,0)),180),((3,1,0,2,(2,1)),180),((3,1,0,2,(2,2)),70),((3,1,0,2,(2,3)),200),
>                       ((3,1,0,2,(3,0)),0),((3,1,0,2,(3,1)),-100),((3,1,0,2,(3,2)),-30),((3,1,0,2,(3,3)),200),
>                       
>                       ((3,1,0,3,(0,0)),200),((3,1,0,3,(0,1)),200),((3,1,0,3,(0,2)),200),((3,1,0,3,(0,3)),200),
>                       ((3,1,0,3,(1,0)),250),((3,1,0,3,(1,1)),190),((3,1,0,3,(1,2)),190),((3,1,0,3,(1,3)),200),
>                       ((3,1,0,3,(2,0)),40),((3,1,0,3,(2,1)),-60),((3,1,0,3,(2,2)),10),((3,1,0,3,(2,3)),200),
>                       ((3,1,0,3,(3,0)),210),((3,1,0,3,(3,1)),110),((3,1,0,3,(3,2)),190),((3,1,0,3,(3,3)),200),
>                       
>                       
>                       ((3,1,1,0,(0,0)),170),((3,1,1,0,(0,1)),270),((3,1,1,0,(0,2)),200),((3,1,1,0,(0,3)),240),
>                       ((3,1,1,0,(1,0)),140),((3,1,1,0,(1,1)),190),((3,1,1,0,(1,2)),200),((3,1,1,0,(1,3)),160),
>                       ((3,1,1,0,(2,0)),-30),((3,1,1,0,(2,1)),110),((3,1,1,0,(2,2)),200),((3,1,1,0,(2,3)),80),
>                       ((3,1,1,0,(3,0)),200),((3,1,1,0,(3,1)),200),((3,1,1,0,(3,2)),200),((3,1,1,0,(3,3)),200),
>                       
>                       ((3,1,1,1,(0,0)),140),((3,1,1,1,(0,1)),180),((3,1,1,1,(0,2)),200),((3,1,1,1,(0,3)),150),
>                       ((3,1,1,1,(1,0)),140),((3,1,1,1,(1,1)),190),((3,1,1,1,(1,2)),200),((3,1,1,1,(1,3)),160),
>                       ((3,1,1,1,(2,0)),200),((3,1,1,1,(2,1)),200),((3,1,1,1,(2,2)),200),((3,1,1,1,(2,3)),200),
>                       ((3,1,1,1,(3,0)),40),((3,1,1,1,(3,1)),90),((3,1,1,1,(3,2)),200),((3,1,1,1,(3,3)),60),
>                       
>                       ((3,1,1,2,(0,0)),30),((3,1,1,2,(0,1)),170),((3,1,1,2,(0,2)),200),((3,1,1,2,(0,3)),140),
>                       ((3,1,1,2,(1,0)),200),((3,1,1,2,(1,1)),200),((3,1,1,2,(1,2)),200),((3,1,1,2,(1,3)),200),
>                       ((3,1,1,2,(2,0)),130),((3,1,1,2,(2,1)),240),((3,1,1,2,(2,2)),200),((3,1,1,2,(2,3)),210),
>                       ((3,1,1,2,(3,0)),-150),((3,1,1,2,(3,1)),0),((3,1,1,2,(3,2)),200),((3,1,1,2,(3,3)),-30),
>                       
>                       ((3,1,1,3,(0,0)),200),((3,1,1,3,(0,1)),200),((3,1,1,3,(0,2)),200),((3,1,1,3,(0,3)),200),
>                       ((3,1,1,3,(1,0)),150),((3,1,1,3,(1,1)),190),((3,1,1,3,(1,2)),200),((3,1,1,3,(1,3)),160),
>                       ((3,1,1,3,(2,0)),-110),((3,1,1,3,(2,1)),40),((3,1,1,3,(2,2)),200),((3,1,1,3,(2,3)),10),
>                       ((3,1,1,3,(3,0)),70),((3,1,1,3,(3,1)),110),((3,1,1,3,(3,2)),200),((3,1,1,3,(3,3)),80),
>                       
>                       
>                       ((3,1,2,0,(0,0)),110),((3,1,2,0,(0,1)),200),((3,1,2,0,(0,2)),150),((3,1,2,0,(0,3)),160),
>                       ((3,1,2,0,(1,0)),80),((3,1,2,0,(1,1)),200),((3,1,2,0,(1,2)),120),((3,1,2,0,(1,3)),30),
>                       ((3,1,2,0,(2,0)),-90),((3,1,2,0,(2,1)),200),((3,1,2,0,(2,2)),-50),((3,1,2,0,(2,3)),40),
>                       ((3,1,2,0,(3,0)),200),((3,1,2,0,(3,1)),200),((3,1,2,0,(3,2)),200),((3,1,2,0,(3,3)),200),
>                       
>                       ((3,1,2,1,(0,0)),80),((3,1,2,1,(0,1)),200),((3,1,2,1,(0,2)),120),((3,1,2,1,(0,3)),30),
>                       ((3,1,2,1,(1,0)),180),((3,1,2,1,(1,1)),200),((3,1,2,1,(1,2)),180),((3,1,2,1,(1,3)),130),
>                       ((3,1,2,1,(2,0)),200),((3,1,2,1,(2,1)),200),((3,1,2,1,(2,2)),200),((3,1,2,1,(2,3)),200),
>                       ((3,1,2,1,(3,0)),90),((3,1,2,1,(3,1)),200),((3,1,2,1,(3,2)),80),((3,1,2,1,(3,3)),40),
>                       
>                       ((3,1,2,2,(0,0)),-30),((3,1,2,2,(0,1)),200),((3,1,2,2,(0,2)),10),((3,1,2,2,(0,3)),100),
>                       ((3,1,2,2,(1,0)),200),((3,1,2,2,(1,1)),200),((3,1,2,2,(1,2)),200),((3,1,2,2,(1,3)),200),
>                       ((3,1,2,2,(2,0)),70),((3,1,2,2,(2,1)),200),((3,1,2,2,(2,2)),110),((3,1,2,2,(2,3)),120),
>                       ((3,1,2,2,(3,0)),-30),((3,1,2,2,(3,1)),200),((3,1,2,2,(3,2)),-70),((3,1,2,2,(3,3)),-260),
>                       
>                       ((3,1,2,3,(0,0)),200),((3,1,2,3,(0,1)),200),((3,1,2,3,(0,2)),200),((3,1,2,3,(0,3)),200),
>                       ((3,1,2,3,(1,0)),190),((3,1,2,3,(1,1)),200),((3,1,2,3,(1,2)),190),((3,1,2,3,(1,3)),140),
>                       ((3,1,2,3,(2,0)),10),((3,1,2,3,(2,1)),200),((3,1,2,3,(2,2)),-30),((3,1,2,3,(2,3)),-220),
>                       ((3,1,2,3,(3,0)),190),((3,1,2,3,(3,1)),200),((3,1,2,3,(3,2)),150),((3,1,2,3,(3,3)),140),
>                       
>                       
>                       ((3,1,3,0,(0,0)),200),((3,1,3,0,(0,1)),270),((3,1,3,0,(0,2)),30),((3,1,3,0,(0,3)),230),
>                       ((3,1,3,0,(1,0)),200),((3,1,3,0,(1,1)),190),((3,1,3,0,(1,2)),-90),((3,1,3,0,(1,3)),100),
>                       ((3,1,3,0,(2,0)),200),((3,1,3,0,(2,1)),110),((3,1,3,0,(2,2)),-90),((3,1,3,0,(2,3)),110),
>                       ((3,1,3,0,(3,0)),200),((3,1,3,0,(3,1)),200),((3,1,3,0,(3,2)),200),((3,1,3,0,(3,3)),200),
>                       
>                       ((3,1,3,1,(0,0)),200),((3,1,3,1,(0,1)),180),((3,1,3,1,(0,2)),-100),((3,1,3,1,(0,3)),100),
>                       ((3,1,3,1,(1,0)),200),((3,1,3,1,(1,1)),190),((3,1,3,1,(1,2)),10),((3,1,3,1,(1,3)),100),
>                       ((3,1,3,1,(2,0)),200),((3,1,3,1,(2,1)),200),((3,1,3,1,(2,2)),200),((3,1,3,1,(2,3)),200),
>                       ((3,1,3,1,(3,0)),200),((3,1,3,1,(3,1)),90),((3,1,3,1,(3,2)),-90),((3,1,3,1,(3,3)),0),
>                       
>                       ((3,1,3,2,(0,0)),200),((3,1,3,2,(0,1)),170),((3,1,3,2,(0,2)),-30),((3,1,3,2,(0,3)),170),
>                       ((3,1,3,2,(1,0)),200),((3,1,3,2,(1,1)),200),((3,1,3,2,(1,2)),200),((3,1,3,2,(1,3)),200),
>                       ((3,1,3,2,(2,0)),200),((3,1,3,2,(2,1)),240),((3,1,3,2,(2,2)),0),((3,1,3,2,(2,3)),190),
>                       ((3,1,3,2,(3,0)),200),((3,1,3,2,(3,1)),0),((3,1,3,2,(3,2)),-390),((3,1,3,2,(3,3)),-10),
>                       
>                       ((3,1,3,3,(0,0)),200),((3,1,3,3,(0,1)),200),((3,1,3,3,(0,2)),200),((3,1,3,3,(0,3)),200),
>                       ((3,1,3,3,(1,0)),200),((3,1,3,3,(1,1)),190),((3,1,3,3,(1,2)),10),((3,1,3,3,(1,3)),110),
>                       ((3,1,3,3,(2,0)),200),((3,1,3,3,(2,1)),40),((3,1,3,3,(2,2)),-350),((3,1,3,3,(2,3)),30),
>                       ((3,1,3,3,(3,0)),200),((3,1,3,3,(3,1)),110),((3,1,3,3,(3,2)),10),((3,1,3,3,(3,3)),30),
>                       
>                       
>                       
>                       ((3,2,0,0,(0,0)),280),((3,2,0,0,(0,1)),280),((3,2,0,0,(0,2)),170),((3,2,0,0,(0,3)),200),
>                       ((3,2,0,0,(1,0)),250),((3,2,0,0,(1,1)),250),((3,2,0,0,(1,2)),150),((3,2,0,0,(1,3)),200),
>                       ((3,2,0,0,(2,0)),150),((3,2,0,0,(2,1)),150),((3,2,0,0,(2,2)),50),((3,2,0,0,(2,3)),200),
>                       ((3,2,0,0,(3,0)),200),((3,2,0,0,(3,1)),200),((3,2,0,0,(3,2)),200),((3,2,0,0,(3,3)),200),
>                       
>                       ((3,2,0,1,(0,0)),260),((3,2,0,1,(0,1)),260),((3,2,0,1,(0,2)),160),((3,2,0,1,(0,3)),200),
>                       ((3,2,0,1,(1,0)),310),((3,2,0,1,(1,1)),250),((3,2,0,1,(1,2)),240),((3,2,0,1,(1,3)),200),
>                       ((3,2,0,1,(2,0)),200),((3,2,0,1,(2,1)),200),((3,2,0,1,(2,2)),200),((3,2,0,1,(2,3)),200),
>                       ((3,2,0,1,(3,0)),310),((3,2,0,1,(3,1)),250),((3,2,0,1,(3,2)),240),((3,2,0,1,(3,3)),200),
>                       
>                       ((3,2,0,2,(0,0)),150),((3,2,0,2,(0,1)),150),((3,2,0,2,(0,2)),50),((3,2,0,2,(0,3)),200),
>                       ((3,2,0,2,(1,0)),200),((3,2,0,2,(1,1)),200),((3,2,0,2,(1,2)),200),((3,2,0,2,(1,3)),200),
>                       ((3,2,0,2,(2,0)),210),((3,2,0,2,(2,1)),210),((3,2,0,2,(2,2)),100),((3,2,0,2,(2,3)),200),
>                       ((3,2,0,2,(3,0)),130),((3,2,0,2,(3,1)),30),((3,2,0,2,(3,2)),110),((3,2,0,2,(3,3)),200),
>                       
>                       ((3,2,0,3,(0,0)),200),((3,2,0,3,(0,1)),200),((3,2,0,3,(0,2)),200),((3,2,0,3,(0,3)),200),
>                       ((3,2,0,3,(1,0)),310),((3,2,0,3,(1,1)),250),((3,2,0,3,(1,2)),240),((3,2,0,3,(1,3)),200),
>                       ((3,2,0,3,(2,0)),230),((3,2,0,3,(2,1)),130),((3,2,0,3,(2,2)),210),((3,2,0,3,(2,3)),200),
>                       ((3,2,0,3,(3,0)),270),((3,2,0,3,(3,1)),170),((3,2,0,3,(3,2)),240),((3,2,0,3,(3,3)),200),
>                       
>                       
>                       ((3,2,1,0,(0,0)),230),((3,2,1,0,(0,1)),340),((3,2,1,0,(0,2)),200),((3,2,1,0,(0,3)),310),
>                       ((3,2,1,0,(1,0)),210),((3,2,1,0,(1,1)),250),((3,2,1,0,(1,2)),200),((3,2,1,0,(1,3)),220),
>                       ((3,2,1,0,(2,0)),110),((3,2,1,0,(2,1)),250),((3,2,1,0,(2,2)),200),((3,2,1,0,(2,3)),220),
>                       ((3,2,1,0,(3,0)),200),((3,2,1,0,(3,1)),200),((3,2,1,0,(3,2)),200),((3,2,1,0,(3,3)),200),
>                       
>                       ((3,2,1,1,(0,0)),220),((3,2,1,1,(0,1)),260),((3,2,1,1,(0,2)),200),((3,2,1,1,(0,3)),230),
>                       ((3,2,1,1,(1,0)),200),((3,2,1,1,(1,1)),250),((3,2,1,1,(1,2)),200),((3,2,1,1,(1,3)),220),
>                       ((3,2,1,1,(2,0)),200),((3,2,1,1,(2,1)),200),((3,2,1,1,(2,2)),200),((3,2,1,1,(2,3)),200),
>                       ((3,2,1,1,(3,0)),200),((3,2,1,1,(3,1)),250),((3,2,1,1,(3,2)),200),((3,2,1,1,(3,3)),220),
>                       
>                       ((3,2,1,2,(0,0)),110),((3,2,1,2,(0,1)),250),((3,2,1,2,(0,2)),200),((3,2,1,2,(0,3)),220),
>                       ((3,2,1,2,(1,0)),200),((3,2,1,2,(1,1)),200),((3,2,1,2,(1,2)),200),((3,2,1,2,(1,3)),200),
>                       ((3,2,1,2,(2,0)),160),((3,2,1,2,(2,1)),270),((3,2,1,2,(2,2)),200),((3,2,1,2,(2,3)),240),
>                       ((3,2,1,2,(3,0)),-10),((3,2,1,2,(3,1)),130),((3,2,1,2,(3,2)),200),((3,2,1,2,(3,3)),100),
>                       
>                       ((3,2,1,3,(0,0)),200),((3,2,1,3,(0,1)),200),((3,2,1,3,(0,2)),200),((3,2,1,3,(0,3)),200),
>                       ((3,2,1,3,(1,0)),200),((3,2,1,3,(1,1)),250),((3,2,1,3,(1,2)),200),((3,2,1,3,(1,3)),220),
>                       ((3,2,1,3,(2,0)),90),((3,2,1,3,(2,1)),230),((3,2,1,3,(2,2)),200),((3,2,1,3,(2,3)),200),
>                       ((3,2,1,3,(3,0)),120),((3,2,1,3,(3,1)),170),((3,2,1,3,(3,2)),200),((3,2,1,3,(3,3)),140),
>                       
>                       
>                       ((3,2,2,0,(0,0)),170),((3,2,2,0,(0,1)),200),((3,2,2,0,(0,2)),210),((3,2,2,0,(0,3)),220),
>                       ((3,2,2,0,(1,0)),150),((3,2,2,0,(1,1)),200),((3,2,2,0,(1,2)),190),((3,2,2,0,(1,3)),100),
>                       ((3,2,2,0,(2,0)),50),((3,2,2,0,(2,1)),200),((3,2,2,0,(2,2)),90),((3,2,2,0,(2,3)),180),
>                       ((3,2,2,0,(3,0)),200),((3,2,2,0,(3,1)),200),((3,2,2,0,(3,2)),200),((3,2,2,0,(3,3)),200),
>                       
>                       ((3,2,2,1,(0,0)),160),((3,2,2,1,(0,1)),200),((3,2,2,1,(0,2)),200),((3,2,2,1,(0,3)),110),
>                       ((3,2,2,1,(1,0)),240),((3,2,2,1,(1,1)),200),((3,2,2,1,(1,2)),240),((3,2,2,1,(1,3)),190),
>                       ((3,2,2,1,(2,0)),200),((3,2,2,1,(2,1)),200),((3,2,2,1,(2,2)),200),((3,2,2,1,(2,3)),200),
>                       ((3,2,2,1,(3,0)),240),((3,2,2,1,(3,1)),200),((3,2,2,1,(3,2)),240),((3,2,2,1,(3,3)),190),
>                       
>                       ((3,2,2,2,(0,0)),50),((3,2,2,2,(0,1)),200),((3,2,2,2,(0,2)),90),((3,2,2,2,(0,3)),180),
>                       ((3,2,2,2,(1,0)),200),((3,2,2,2,(1,1)),200),((3,2,2,2,(1,2)),200),((3,2,2,2,(1,3)),200),
>                       ((3,2,2,2,(2,0)),100),((3,2,2,2,(2,1)),200),((3,2,2,2,(2,2)),140),((3,2,2,2,(2,3)),150),
>                       ((3,2,2,2,(3,0)),110),((3,2,2,2,(3,1)),200),((3,2,2,2,(3,2)),70),((3,2,2,2,(3,3)),-120),
>                       
>                       ((3,2,2,3,(0,0)),200),((3,2,2,3,(0,1)),200),((3,2,2,3,(0,2)),200),((3,2,2,3,(0,3)),200),
>                       ((3,2,2,3,(1,0)),240),((3,2,2,3,(1,1)),200),((3,2,2,3,(1,2)),240),((3,2,2,3,(1,3)),190),
>                       ((3,2,2,3,(2,0)),210),((3,2,2,3,(2,1)),200),((3,2,2,3,(2,2)),170),((3,2,2,3,(2,3)),-20),
>                       ((3,2,2,3,(3,0)),240),((3,2,2,3,(3,1)),200),((3,2,2,3,(3,2)),200),((3,2,2,3,(3,3)),190),
>                       
>                       
>                       ((3,2,3,0,(0,0)),200),((3,2,3,0,(0,1)),340),((3,2,3,0,(0,2)),100),((3,2,3,0,(0,3)),290),
>                       ((3,2,3,0,(1,0)),200),((3,2,3,0,(1,1)),250),((3,2,3,0,(1,2)),-30),((3,2,3,0,(1,3)),170),
>                       ((3,2,3,0,(2,0)),200),((3,2,3,0,(2,1)),250),((3,2,3,0,(2,2)),50),((3,2,3,0,(2,3)),250),
>                       ((3,2,3,0,(3,0)),200),((3,2,3,0,(3,1)),200),((3,2,3,0,(3,2)),200),((3,2,3,0,(3,3)),200),
>                       
>                       ((3,2,3,1,(0,0)),200),((3,2,3,1,(0,1)),260),((3,2,3,1,(0,2)),-20),((3,2,3,1,(0,3)),180),
>                       ((3,2,3,1,(1,0)),200),((3,2,3,1,(1,1)),250),((3,2,3,1,(1,2)),70),((3,2,3,1,(1,3)),160),
>                       ((3,2,3,1,(2,0)),200),((3,2,3,1,(2,1)),200),((3,2,3,1,(2,2)),200),((3,2,3,1,(2,3)),200),
>                       ((3,2,3,1,(3,0)),200),((3,2,3,1,(3,1)),250),((3,2,3,1,(3,2)),70),((3,2,3,1,(3,3)),160),
>                       
>                       ((3,2,3,2,(0,0)),200),((3,2,3,2,(0,1)),250),((3,2,3,2,(0,2)),50),((3,2,3,2,(0,3)),250),
>                       ((3,2,3,2,(1,0)),200),((3,2,3,2,(1,1)),200),((3,2,3,2,(1,2)),200),((3,2,3,2,(1,3)),200),
>                       ((3,2,3,2,(2,0)),200),((3,2,3,2,(2,1)),270),((3,2,3,2,(2,2)),30),((3,2,3,2,(2,3)),220),
>                       ((3,2,3,2,(3,0)),200),((3,2,3,2,(3,1)),130),((3,2,3,2,(3,2)),-250),((3,2,3,2,(3,3)),130),
>                       
>                       ((3,2,3,3,(0,0)),200),((3,2,3,3,(0,1)),200),((3,2,3,3,(0,2)),200),((3,2,3,3,(0,3)),200),
>                       ((3,2,3,3,(1,0)),200),((3,2,3,3,(1,1)),250),((3,2,3,3,(1,2)),70),((3,2,3,3,(1,3)),160),
>                       ((3,2,3,3,(2,0)),200),((3,2,3,3,(2,1)),230),((3,2,3,3,(2,2)),-150),((3,2,3,3,(2,3)),230),
>                       ((3,2,3,3,(3,0)),200),((3,2,3,3,(3,1)),170),((3,2,3,3,(3,2)),70),((3,2,3,3,(3,3)),80),
>                       
>                       
>                       
>                       ((3,3,0,0,(0,0)),280),((3,3,0,0,(0,1)),280),((3,3,0,0,(0,2)),170),((3,3,0,0,(0,3)),200),
>                       ((3,3,0,0,(1,0)),230),((3,3,0,0,(1,1)),230),((3,3,0,0,(1,2)),130),((3,3,0,0,(1,3)),200),
>                       ((3,3,0,0,(2,0)),170),((3,3,0,0,(2,1)),170),((3,3,0,0,(2,2)),70),((3,3,0,0,(2,3)),200),
>                       ((3,3,0,0,(3,0)),200),((3,3,0,0,(3,1)),200),((3,3,0,0,(3,2)),200),((3,3,0,0,(3,3)),200),
>                       
>                       ((3,3,0,1,(0,0)),280),((3,3,0,1,(0,1)),280),((3,3,0,1,(0,2)),170),((3,3,0,1,(0,3)),200),
>                       ((3,3,0,1,(1,0)),340),((3,3,0,1,(1,1)),280),((3,3,0,1,(1,2)),270),((3,3,0,1,(1,3)),200),
>                       ((3,3,0,1,(2,0)),200),((3,3,0,1,(2,1)),200),((3,3,0,1,(2,2)),200),((3,3,0,1,(2,3)),200),
>                       ((3,3,0,1,(3,0)),340),((3,3,0,1,(3,1)),280),((3,3,0,1,(3,2)),270),((3,3,0,1,(3,3)),200),
>                       
>                       ((3,3,0,2,(0,0)),170),((3,3,0,2,(0,1)),170),((3,3,0,2,(0,2)),70),((3,3,0,2,(0,3)),200),
>                       ((3,3,0,2,(1,0)),200),((3,3,0,2,(1,1)),200),((3,3,0,2,(1,2)),200),((3,3,0,2,(1,3)),200),
>                       ((3,3,0,2,(2,0)),210),((3,3,0,2,(2,1)),210),((3,3,0,2,(2,2)),110),((3,3,0,2,(2,3)),200),
>                       ((3,3,0,2,(3,0)),100),((3,3,0,2,(3,1)),0),((3,3,0,2,(3,2)),70),((3,3,0,2,(3,3)),200),
>                       
>                       ((3,3,0,3,(0,0)),200),((3,3,0,3,(0,1)),200),((3,3,0,3,(0,2)),200),((3,3,0,3,(0,3)),200),
>                       ((3,3,0,3,(1,0)),310),((3,3,0,3,(1,1)),250),((3,3,0,3,(1,2)),240),((3,3,0,3,(1,3)),200),
>                       ((3,3,0,3,(2,0)),220),((3,3,0,3,(2,1)),120),((3,3,0,3,(2,2)),200),((3,3,0,3,(2,3)),200),
>                       ((3,3,0,3,(3,0)),290),((3,3,0,3,(3,1)),190),((3,3,0,3,(3,2)),270),((3,3,0,3,(3,3)),200),
>                       
>                       
>                       ((3,3,1,0,(0,0)),230),((3,3,1,0,(0,1)),340),((3,3,1,0,(0,2)),200),((3,3,1,0,(0,3)),310),
>                       ((3,3,1,0,(1,0)),190),((3,3,1,0,(1,1)),230),((3,3,1,0,(1,2)),200),((3,3,1,0,(1,3)),200),
>                       ((3,3,1,0,(2,0)),130),((3,3,1,0,(2,1)),270),((3,3,1,0,(2,2)),200),((3,3,1,0,(2,3)),240),
>                       ((3,3,1,0,(3,0)),200),((3,3,1,0,(3,1)),200),((3,3,1,0,(3,2)),200),((3,3,1,0,(3,3)),200),
>                       
>                       ((3,3,1,1,(0,0)),230),((3,3,1,1,(0,1)),280),((3,3,1,1,(0,2)),200),((3,3,1,1,(0,3)),250),
>                       ((3,3,1,1,(1,0)),230),((3,3,1,1,(1,1)),280),((3,3,1,1,(1,2)),200),((3,3,1,1,(1,3)),250),
>                       ((3,3,1,1,(2,0)),200),((3,3,1,1,(2,1)),200),((3,3,1,1,(2,2)),200),((3,3,1,1,(2,3)),200),
>                       ((3,3,1,1,(3,0)),230),((3,3,1,1,(3,1)),280),((3,3,1,1,(3,2)),200),((3,3,1,1,(3,3)),250),
>                       
>                       ((3,3,1,2,(0,0)),130),((3,3,1,2,(0,1)),270),((3,3,1,2,(0,2)),200),((3,3,1,2,(0,3)),240),
>                       ((3,3,1,2,(1,0)),200),((3,3,1,2,(1,1)),200),((3,3,1,2,(1,2)),200),((3,3,1,2,(1,3)),200),
>                       ((3,3,1,2,(2,0)),170),((3,3,1,2,(2,1)),270),((3,3,1,2,(2,2)),200),((3,3,1,2,(2,3)),240),
>                       ((3,3,1,2,(3,0)),-50),((3,3,1,2,(3,1)),100),((3,3,1,2,(3,2)),200),((3,3,1,2,(3,3)),70),
>                       
>                       ((3,3,1,3,(0,0)),200),((3,3,1,3,(0,1)),200),((3,3,1,3,(0,2)),200),((3,3,1,3,(0,3)),200),
>                       ((3,3,1,3,(1,0)),200),((3,3,1,3,(1,1)),250),((3,3,1,3,(1,2)),200),((3,3,1,3,(1,3)),220),
>                       ((3,3,1,3,(2,0)),80),((3,3,1,3,(2,1)),220),((3,3,1,3,(2,2)),200),((3,3,1,3,(2,3)),190),
>                       ((3,3,1,3,(3,0)),150),((3,3,1,3,(3,1)),190),((3,3,1,3,(3,2)),200),((3,3,1,3,(3,3)),160),
>                       
>                       
>                       ((3,3,2,0,(0,0)),170),((3,3,2,0,(0,1)),200),((3,3,2,0,(0,2)),210),((3,3,2,0,(0,3)),220),
>                       ((3,3,2,0,(1,0)),130),((3,3,2,0,(1,1)),200),((3,3,2,0,(1,2)),170),((3,3,2,0,(1,3)),80),
>                       ((3,3,2,0,(2,0)),70),((3,3,2,0,(2,1)),200),((3,3,2,0,(2,2)),110),((3,3,2,0,(2,3)),200),
>                       ((3,3,2,0,(3,0)),200),((3,3,2,0,(3,1)),200),((3,3,2,0,(3,2)),200),((3,3,2,0,(3,3)),200),
>                       
>                       ((3,3,2,1,(0,0)),170),((3,3,2,1,(0,1)),200),((3,3,2,1,(0,2)),210),((3,3,2,1,(0,3)),120),
>                       ((3,3,2,1,(1,0)),270),((3,3,2,1,(1,1)),200),((3,3,2,1,(1,2)),270),((3,3,2,1,(1,3)),220),
>                       ((3,3,2,1,(2,0)),200),((3,3,2,1,(2,1)),200),((3,3,2,1,(2,2)),200),((3,3,2,1,(2,3)),200),
>                       ((3,3,2,1,(3,0)),270),((3,3,2,1,(3,1)),200),((3,3,2,1,(3,2)),270),((3,3,2,1,(3,3)),220),
>                       
>                       ((3,3,2,2,(0,0)),70),((3,3,2,2,(0,1)),200),((3,3,2,2,(0,2)),110),((3,3,2,2,(0,3)),200),
>                       ((3,3,2,2,(1,0)),200),((3,3,2,2,(1,1)),200),((3,3,2,2,(1,2)),200),((3,3,2,2,(1,3)),200),
>                       ((3,3,2,2,(2,0)),110),((3,3,2,2,(2,1)),200),((3,3,2,2,(2,2)),150),((3,3,2,2,(2,3)),160),
>                       ((3,3,2,2,(3,0)),70),((3,3,2,2,(3,1)),200),((3,3,2,2,(3,2)),30),((3,3,2,2,(3,3)),-160),
>                       
>                       ((3,3,2,3,(0,0)),200),((3,3,2,3,(0,1)),200),((3,3,2,3,(0,2)),200),((3,3,2,3,(0,3)),200),
>                       ((3,3,2,3,(1,0)),240),((3,3,2,3,(1,1)),200),((3,3,2,3,(1,2)),240),((3,3,2,3,(1,3)),190),
>                       ((3,3,2,3,(2,0)),200),((3,3,2,3,(2,1)),200),((3,3,2,3,(2,2)),160),((3,3,2,3,(2,3)),-30),
>                       ((3,3,2,3,(3,0)),270),((3,3,2,3,(3,1)),200),((3,3,2,3,(3,2)),230),((3,3,2,3,(3,3)),220),
>                       
>                       
>                       ((3,3,3,0,(0,0)),200),((3,3,3,0,(0,1)),340),((3,3,3,0,(0,2)),100),((3,3,3,0,(0,3)),290),
>                       ((3,3,3,0,(1,0)),200),((3,3,3,0,(1,1)),230),((3,3,3,0,(1,2)),-50),((3,3,3,0,(1,3)),150),
>                       ((3,3,3,0,(2,0)),200),((3,3,3,0,(2,1)),270),((3,3,3,0,(2,2)),70),((3,3,3,0,(2,3)),270),
>                       ((3,3,3,0,(3,0)),200),((3,3,3,0,(3,1)),200),((3,3,3,0,(3,2)),200),((3,3,3,0,(3,3)),200),
>                       
>                       ((3,3,3,1,(0,0)),200),((3,3,3,1,(0,1)),280),((3,3,3,1,(0,2)),0),((3,3,3,1,(0,3)),190),
>                       ((3,3,3,1,(1,0)),200),((3,3,3,1,(1,1)),280),((3,3,3,1,(1,2)),100),((3,3,3,1,(1,3)),190),
>                       ((3,3,3,1,(2,0)),200),((3,3,3,1,(2,1)),200),((3,3,3,1,(2,2)),200),((3,3,3,1,(2,3)),200),
>                       ((3,3,3,1,(3,0)),200),((3,3,3,1,(3,1)),280),((3,3,3,1,(3,2)),100),((3,3,3,1,(3,3)),190),
>                       
>                       ((3,3,3,2,(0,0)),200),((3,3,3,2,(0,1)),270),((3,3,3,2,(0,2)),70),((3,3,3,2,(0,3)),270),
>                       ((3,3,3,2,(1,0)),200),((3,3,3,2,(1,1)),200),((3,3,3,2,(1,2)),200),((3,3,3,2,(1,3)),200),
>                       ((3,3,3,2,(2,0)),200),((3,3,3,2,(2,1)),270),((3,3,3,2,(2,2)),30),((3,3,3,2,(2,3)),230),
>                       ((3,3,3,2,(3,0)),200),((3,3,3,2,(3,1)),100),((3,3,3,2,(3,2)),-290),((3,3,3,2,(3,3)),90),
>                       
>                       ((3,3,3,3,(0,0)),200),((3,3,3,3,(0,1)),200),((3,3,3,3,(0,2)),200),((3,3,3,3,(0,3)),200),
>                       ((3,3,3,3,(1,0)),200),((3,3,3,3,(1,1)),250),((3,3,3,3,(1,2)),70),((3,3,3,3,(1,3)),160),
>                       ((3,3,3,3,(2,0)),200),((3,3,3,3,(2,1)),220),((3,3,3,3,(2,2)),-160),((3,3,3,3,(2,3)),220),
>                       ((3,3,3,3,(3,0)),200),((3,3,3,3,(3,1)),190),((3,3,3,3,(3,2)),90),((3,3,3,3,(3,3)),110),
>                       
>                       
>                       
>                       ((3,4,0,0,(0,0)),280),((3,4,0,0,(0,1)),280),((3,4,0,0,(0,2)),170),((3,4,0,0,(0,3)),200),
>                       ((3,4,0,0,(1,0)),250),((3,4,0,0,(1,1)),250),((3,4,0,0,(1,2)),150),((3,4,0,0,(1,3)),200),
>                       ((3,4,0,0,(2,0)),150),((3,4,0,0,(2,1)),150),((3,4,0,0,(2,2)),50),((3,4,0,0,(2,3)),200),
>                       ((3,4,0,0,(3,0)),200),((3,4,0,0,(3,1)),200),((3,4,0,0,(3,2)),200),((3,4,0,0,(3,3)),200),
>                       
>                       ((3,4,0,1,(0,0)),260),((3,4,0,1,(0,1)),260),((3,4,0,1,(0,2)),160),((3,4,0,1,(0,3)),200),
>                       ((3,4,0,1,(1,0)),310),((3,4,0,1,(1,1)),250),((3,4,0,1,(1,2)),240),((3,4,0,1,(1,3)),200),
>                       ((3,4,0,1,(2,0)),200),((3,4,0,1,(2,1)),200),((3,4,0,1,(2,2)),200),((3,4,0,1,(2,3)),200),
>                       ((3,4,0,1,(3,0)),310),((3,4,0,1,(3,1)),250),((3,4,0,1,(3,2)),240),((3,4,0,1,(3,3)),200),
>                       
>                       ((3,4,0,2,(0,0)),150),((3,4,0,2,(0,1)),150),((3,4,0,2,(0,2)),50),((3,4,0,2,(0,3)),200),
>                       ((3,4,0,2,(1,0)),200),((3,4,0,2,(1,1)),200),((3,4,0,2,(1,2)),200),((3,4,0,2,(1,3)),200),
>                       ((3,4,0,2,(2,0)),210),((3,4,0,2,(2,1)),210),((3,4,0,2,(2,2)),100),((3,4,0,2,(2,3)),200),
>                       ((3,4,0,2,(3,0)),130),((3,4,0,2,(3,1)),30),((3,4,0,2,(3,2)),110),((3,4,0,2,(3,3)),200),
>                       
>                       ((3,4,0,3,(0,0)),200),((3,4,0,3,(0,1)),200),((3,4,0,3,(0,2)),200),((3,4,0,3,(0,3)),200),
>                       ((3,4,0,3,(1,0)),310),((3,4,0,3,(1,1)),250),((3,4,0,3,(1,2)),240),((3,4,0,3,(1,3)),200),
>                       ((3,4,0,3,(2,0)),230),((3,4,0,3,(2,1)),130),((3,4,0,3,(2,2)),210),((3,4,0,3,(2,3)),200),
>                       ((3,4,0,3,(3,0)),270),((3,4,0,3,(3,1)),170),((3,4,0,3,(3,2)),240),((3,4,0,3,(3,3)),200),
>                       
>                       
>                       ((3,4,1,0,(0,0)),230),((3,4,1,0,(0,1)),340),((3,4,1,0,(0,2)),200),((3,4,1,0,(0,3)),310),
>                       ((3,4,1,0,(1,0)),210),((3,4,1,0,(1,1)),250),((3,4,1,0,(1,2)),200),((3,4,1,0,(1,3)),220),
>                       ((3,4,1,0,(2,0)),110),((3,4,1,0,(2,1)),250),((3,4,1,0,(2,2)),200),((3,4,1,0,(2,3)),220),
>                       ((3,4,1,0,(3,0)),200),((3,4,1,0,(3,1)),200),((3,4,1,0,(3,2)),200),((3,4,1,0,(3,3)),200),
>                       
>                       ((3,4,1,1,(0,0)),220),((3,4,1,1,(0,1)),260),((3,4,1,1,(0,2)),200),((3,4,1,1,(0,3)),230),
>                       ((3,4,1,1,(1,0)),200),((3,4,1,1,(1,1)),250),((3,4,1,1,(1,2)),200),((3,4,1,1,(1,3)),220),
>                       ((3,4,1,1,(2,0)),200),((3,4,1,1,(2,1)),200),((3,4,1,1,(2,2)),200),((3,4,1,1,(2,3)),200),
>                       ((3,4,1,1,(3,0)),200),((3,4,1,1,(3,1)),250),((3,4,1,1,(3,2)),200),((3,4,1,1,(3,3)),220),
>                       
>                       ((3,4,1,2,(0,0)),110),((3,4,1,2,(0,1)),250),((3,4,1,2,(0,2)),200),((3,4,1,2,(0,3)),220),
>                       ((3,4,1,2,(1,0)),200),((3,4,1,2,(1,1)),200),((3,4,1,2,(1,2)),200),((3,4,1,2,(1,3)),200),
>                       ((3,4,1,2,(2,0)),160),((3,4,1,2,(2,1)),270),((3,4,1,2,(2,2)),200),((3,4,1,2,(2,3)),240),
>                       ((3,4,1,2,(3,0)),-10),((3,4,1,2,(3,1)),130),((3,4,1,2,(3,2)),200),((3,4,1,2,(3,3)),100),
>                       
>                       ((3,4,1,3,(0,0)),200),((3,4,1,3,(0,1)),200),((3,4,1,3,(0,2)),200),((3,4,1,3,(0,3)),200),
>                       ((3,4,1,3,(1,0)),200),((3,4,1,3,(1,1)),250),((3,4,1,3,(1,2)),200),((3,4,1,3,(1,3)),220),
>                       ((3,4,1,3,(2,0)),90),((3,4,1,3,(2,1)),230),((3,4,1,3,(2,2)),200),((3,4,1,3,(2,3)),200),
>                       ((3,4,1,3,(3,0)),120),((3,4,1,3,(3,1)),170),((3,4,1,3,(3,2)),200),((3,4,1,3,(3,3)),140),
>                       
>                       
>                       ((3,4,2,0,(0,0)),170),((3,4,2,0,(0,1)),200),((3,4,2,0,(0,2)),210),((3,4,2,0,(0,3)),220),
>                       ((3,4,2,0,(1,0)),150),((3,4,2,0,(1,1)),200),((3,4,2,0,(1,2)),190),((3,4,2,0,(1,3)),100),
>                       ((3,4,2,0,(2,0)),50),((3,4,2,0,(2,1)),200),((3,4,2,0,(2,2)),90),((3,4,2,0,(2,3)),180),
>                       ((3,4,2,0,(3,0)),200),((3,4,2,0,(3,1)),200),((3,4,2,0,(3,2)),200),((3,4,2,0,(3,3)),200),
>                       
>                       ((3,4,2,1,(0,0)),160),((3,4,2,1,(0,1)),200),((3,4,2,1,(0,2)),200),((3,4,2,1,(0,3)),110),
>                       ((3,4,2,1,(1,0)),240),((3,4,2,1,(1,1)),200),((3,4,2,1,(1,2)),240),((3,4,2,1,(1,3)),190),
>                       ((3,4,2,1,(2,0)),200),((3,4,2,1,(2,1)),200),((3,4,2,1,(2,2)),200),((3,4,2,1,(2,3)),200),
>                       ((3,4,2,1,(3,0)),240),((3,4,2,1,(3,1)),200),((3,4,2,1,(3,2)),240),((3,4,2,1,(3,3)),190),
>                       
>                       ((3,4,2,2,(0,0)),50),((3,4,2,2,(0,1)),200),((3,4,2,2,(0,2)),90),((3,4,2,2,(0,3)),180),
>                       ((3,4,2,2,(1,0)),200),((3,4,2,2,(1,1)),200),((3,4,2,2,(1,2)),200),((3,4,2,2,(1,3)),200),
>                       ((3,4,2,2,(2,0)),100),((3,4,2,2,(2,1)),200),((3,4,2,2,(2,2)),140),((3,4,2,2,(2,3)),150),
>                       ((3,4,2,2,(3,0)),110),((3,4,2,2,(3,1)),200),((3,4,2,2,(3,2)),70),((3,4,2,2,(3,3)),-120),
>                       
>                       ((3,4,2,3,(0,0)),200),((3,4,2,3,(0,1)),200),((3,4,2,3,(0,2)),200),((3,4,2,3,(0,3)),200),
>                       ((3,4,2,3,(1,0)),240),((3,4,2,3,(1,1)),200),((3,4,2,3,(1,2)),240),((3,4,2,3,(1,3)),190),
>                       ((3,4,2,3,(2,0)),210),((3,4,2,3,(2,1)),200),((3,4,2,3,(2,2)),170),((3,4,2,3,(2,3)),-20),
>                       ((3,4,2,3,(3,0)),240),((3,4,2,3,(3,1)),200),((3,4,2,3,(3,2)),200),((3,4,2,3,(3,3)),190),
>                       
>                       
>                       ((3,4,3,0,(0,0)),200),((3,4,3,0,(0,1)),340),((3,4,3,0,(0,2)),100),((3,4,3,0,(0,3)),290),
>                       ((3,4,3,0,(1,0)),200),((3,4,3,0,(1,1)),250),((3,4,3,0,(1,2)),-30),((3,4,3,0,(1,3)),170),
>                       ((3,4,3,0,(2,0)),200),((3,4,3,0,(2,1)),250),((3,4,3,0,(2,2)),50),((3,4,3,0,(2,3)),250),
>                       ((3,4,3,0,(3,0)),200),((3,4,3,0,(3,1)),200),((3,4,3,0,(3,2)),200),((3,4,3,0,(3,3)),200),
>                       
>                       ((3,4,3,1,(0,0)),200),((3,4,3,1,(0,1)),260),((3,4,3,1,(0,2)),-20),((3,4,3,1,(0,3)),180),
>                       ((3,4,3,1,(1,0)),200),((3,4,3,1,(1,1)),250),((3,4,3,1,(1,2)),70),((3,4,3,1,(1,3)),160),
>                       ((3,4,3,1,(2,0)),200),((3,4,3,1,(2,1)),200),((3,4,3,1,(2,2)),200),((3,4,3,1,(2,3)),200),
>                       ((3,4,3,1,(3,0)),200),((3,4,3,1,(3,1)),250),((3,4,3,1,(3,2)),70),((3,4,3,1,(3,3)),160),
>                       
>                       ((3,4,3,2,(0,0)),200),((3,4,3,2,(0,1)),250),((3,4,3,2,(0,2)),50),((3,4,3,2,(0,3)),250),
>                       ((3,4,3,2,(1,0)),200),((3,4,3,2,(1,1)),200),((3,4,3,2,(1,2)),200),((3,4,3,2,(1,3)),200),
>                       ((3,4,3,2,(2,0)),200),((3,4,3,2,(2,1)),270),((3,4,3,2,(2,2)),30),((3,4,3,2,(2,3)),220),
>                       ((3,4,3,2,(3,0)),200),((3,4,3,2,(3,1)),130),((3,4,3,2,(3,2)),-250),((3,4,3,2,(3,3)),130),
>                       
>                       ((3,4,3,3,(0,0)),200),((3,4,3,3,(0,1)),200),((3,4,3,3,(0,2)),200),((3,4,3,3,(0,3)),200),
>                       ((3,4,3,3,(1,0)),200),((3,4,3,3,(1,1)),250),((3,4,3,3,(1,2)),70),((3,4,3,3,(1,3)),160),
>                       ((3,4,3,3,(2,0)),200),((3,4,3,3,(2,1)),230),((3,4,3,3,(2,2)),-150),((3,4,3,3,(2,3)),230),
>                       ((3,4,3,3,(3,0)),200),((3,4,3,3,(3,1)),170),((3,4,3,3,(3,2)),70),((3,4,3,3,(3,3)),80),
>                       
>                       
>                       
>                       ((3,5,0,0,(0,0)),280),((3,5,0,0,(0,1)),280),((3,5,0,0,(0,2)),170),((3,5,0,0,(0,3)),200),
>                       ((3,5,0,0,(1,0)),230),((3,5,0,0,(1,1)),230),((3,5,0,0,(1,2)),130),((3,5,0,0,(1,3)),200),
>                       ((3,5,0,0,(2,0)),170),((3,5,0,0,(2,1)),170),((3,5,0,0,(2,2)),70),((3,5,0,0,(2,3)),200),
>                       ((3,5,0,0,(3,0)),200),((3,5,0,0,(3,1)),200),((3,5,0,0,(3,2)),200),((3,5,0,0,(3,3)),200),
>                       
>                       ((3,5,0,1,(0,0)),280),((3,5,0,1,(0,1)),280),((3,5,0,1,(0,2)),170),((3,5,0,1,(0,3)),200),
>                       ((3,5,0,1,(1,0)),340),((3,5,0,1,(1,1)),280),((3,5,0,1,(1,2)),270),((3,5,0,1,(1,3)),200),
>                       ((3,5,0,1,(2,0)),200),((3,5,0,1,(2,1)),200),((3,5,0,1,(2,2)),200),((3,5,0,1,(2,3)),200),
>                       ((3,5,0,1,(3,0)),340),((3,5,0,1,(3,1)),280),((3,5,0,1,(3,2)),270),((3,5,0,1,(3,3)),200),
>                       
>                       ((3,5,0,2,(0,0)),170),((3,5,0,2,(0,1)),170),((3,5,0,2,(0,2)),70),((3,5,0,2,(0,3)),200),
>                       ((3,5,0,2,(1,0)),200),((3,5,0,2,(1,1)),200),((3,5,0,2,(1,2)),200),((3,5,0,2,(1,3)),200),
>                       ((3,5,0,2,(2,0)),210),((3,5,0,2,(2,1)),210),((3,5,0,2,(2,2)),110),((3,5,0,2,(2,3)),200),
>                       ((3,5,0,2,(3,0)),100),((3,5,0,2,(3,1)),0),((3,5,0,2,(3,2)),70),((3,5,0,2,(3,3)),200),
>                       
>                       ((3,5,0,3,(0,0)),200),((3,5,0,3,(0,1)),200),((3,5,0,3,(0,2)),200),((3,5,0,3,(0,3)),200),
>                       ((3,5,0,3,(1,0)),310),((3,5,0,3,(1,1)),250),((3,5,0,3,(1,2)),240),((3,5,0,3,(1,3)),200),
>                       ((3,5,0,3,(2,0)),220),((3,5,0,3,(2,1)),120),((3,5,0,3,(2,2)),200),((3,5,0,3,(2,3)),200),
>                       ((3,5,0,3,(3,0)),290),((3,5,0,3,(3,1)),190),((3,5,0,3,(3,2)),270),((3,5,0,3,(3,3)),200),
>                       
>                       
>                       ((3,5,1,0,(0,0)),230),((3,5,1,0,(0,1)),340),((3,5,1,0,(0,2)),200),((3,5,1,0,(0,3)),310),
>                       ((3,5,1,0,(1,0)),190),((3,5,1,0,(1,1)),230),((3,5,1,0,(1,2)),200),((3,5,1,0,(1,3)),200),
>                       ((3,5,1,0,(2,0)),130),((3,5,1,0,(2,1)),270),((3,5,1,0,(2,2)),200),((3,5,1,0,(2,3)),240),
>                       ((3,5,1,0,(3,0)),200),((3,5,1,0,(3,1)),200),((3,5,1,0,(3,2)),200),((3,5,1,0,(3,3)),200),
>                       
>                       ((3,5,1,1,(0,0)),230),((3,5,1,1,(0,1)),280),((3,5,1,1,(0,2)),200),((3,5,1,1,(0,3)),250),
>                       ((3,5,1,1,(1,0)),230),((3,5,1,1,(1,1)),280),((3,5,1,1,(1,2)),200),((3,5,1,1,(1,3)),250),
>                       ((3,5,1,1,(2,0)),200),((3,5,1,1,(2,1)),200),((3,5,1,1,(2,2)),200),((3,5,1,1,(2,3)),200),
>                       ((3,5,1,1,(3,0)),230),((3,5,1,1,(3,1)),280),((3,5,1,1,(3,2)),200),((3,5,1,1,(3,3)),250),
>                       
>                       ((3,5,1,2,(0,0)),130),((3,5,1,2,(0,1)),270),((3,5,1,2,(0,2)),200),((3,5,1,2,(0,3)),240),
>                       ((3,5,1,2,(1,0)),200),((3,5,1,2,(1,1)),200),((3,5,1,2,(1,2)),200),((3,5,1,2,(1,3)),200),
>                       ((3,5,1,2,(2,0)),170),((3,5,1,2,(2,1)),270),((3,5,1,2,(2,2)),200),((3,5,1,2,(2,3)),240),
>                       ((3,5,1,2,(3,0)),-50),((3,5,1,2,(3,1)),100),((3,5,1,2,(3,2)),200),((3,5,1,2,(3,3)),70),
>                       
>                       ((3,5,1,3,(0,0)),200),((3,5,1,3,(0,1)),200),((3,5,1,3,(0,2)),200),((3,5,1,3,(0,3)),200),
>                       ((3,5,1,3,(1,0)),200),((3,5,1,3,(1,1)),250),((3,5,1,3,(1,2)),200),((3,5,1,3,(1,3)),220),
>                       ((3,5,1,3,(2,0)),80),((3,5,1,3,(2,1)),220),((3,5,1,3,(2,2)),200),((3,5,1,3,(2,3)),190),
>                       ((3,5,1,3,(3,0)),150),((3,5,1,3,(3,1)),190),((3,5,1,3,(3,2)),200),((3,5,1,3,(3,3)),160),
>                       
>                       
>                       ((3,5,2,0,(0,0)),170),((3,5,2,0,(0,1)),200),((3,5,2,0,(0,2)),210),((3,5,2,0,(0,3)),220),
>                       ((3,5,2,0,(1,0)),130),((3,5,2,0,(1,1)),200),((3,5,2,0,(1,2)),170),((3,5,2,0,(1,3)),80),
>                       ((3,5,2,0,(2,0)),70),((3,5,2,0,(2,1)),200),((3,5,2,0,(2,2)),110),((3,5,2,0,(2,3)),200),
>                       ((3,5,2,0,(3,0)),200),((3,5,2,0,(3,1)),200),((3,5,2,0,(3,2)),200),((3,5,2,0,(3,3)),200),
>                       
>                       ((3,5,2,1,(0,0)),170),((3,5,2,1,(0,1)),200),((3,5,2,1,(0,2)),210),((3,5,2,1,(0,3)),120),
>                       ((3,5,2,1,(1,0)),270),((3,5,2,1,(1,1)),200),((3,5,2,1,(1,2)),270),((3,5,2,1,(1,3)),220),
>                       ((3,5,2,1,(2,0)),200),((3,5,2,1,(2,1)),200),((3,5,2,1,(2,2)),200),((3,5,2,1,(2,3)),200),
>                       ((3,5,2,1,(3,0)),270),((3,5,2,1,(3,1)),200),((3,5,2,1,(3,2)),270),((3,5,2,1,(3,3)),220),
>                       
>                       ((3,5,2,2,(0,0)),70),((3,5,2,2,(0,1)),200),((3,5,2,2,(0,2)),110),((3,5,2,2,(0,3)),200),
>                       ((3,5,2,2,(1,0)),200),((3,5,2,2,(1,1)),200),((3,5,2,2,(1,2)),200),((3,5,2,2,(1,3)),200),
>                       ((3,5,2,2,(2,0)),110),((3,5,2,2,(2,1)),200),((3,5,2,2,(2,2)),150),((3,5,2,2,(2,3)),160),
>                       ((3,5,2,2,(3,0)),70),((3,5,2,2,(3,1)),200),((3,5,2,2,(3,2)),30),((3,5,2,2,(3,3)),-160),
>                       
>                       ((3,5,2,3,(0,0)),200),((3,5,2,3,(0,1)),200),((3,5,2,3,(0,2)),200),((3,5,2,3,(0,3)),200),
>                       ((3,5,2,3,(1,0)),240),((3,5,2,3,(1,1)),200),((3,5,2,3,(1,2)),240),((3,5,2,3,(1,3)),190),
>                       ((3,5,2,3,(2,0)),200),((3,5,2,3,(2,1)),200),((3,5,2,3,(2,2)),160),((3,5,2,3,(2,3)),-30),
>                       ((3,5,2,3,(3,0)),270),((3,5,2,3,(3,1)),200),((3,5,2,3,(3,2)),230),((3,5,2,3,(3,3)),220),
>                       
>                       
>                       ((3,5,3,0,(0,0)),200),((3,5,3,0,(0,1)),340),((3,5,3,0,(0,2)),100),((3,5,3,0,(0,3)),290),
>                       ((3,5,3,0,(1,0)),200),((3,5,3,0,(1,1)),230),((3,5,3,0,(1,2)),-50),((3,5,3,0,(1,3)),150),
>                       ((3,5,3,0,(2,0)),200),((3,5,3,0,(2,1)),270),((3,5,3,0,(2,2)),70),((3,5,3,0,(2,3)),270),
>                       ((3,5,3,0,(3,0)),200),((3,5,3,0,(3,1)),200),((3,5,3,0,(3,2)),200),((3,5,3,0,(3,3)),200),
>                       
>                       ((3,5,3,1,(0,0)),200),((3,5,3,1,(0,1)),280),((3,5,3,1,(0,2)),0),((3,5,3,1,(0,3)),190),
>                       ((3,5,3,1,(1,0)),200),((3,5,3,1,(1,1)),280),((3,5,3,1,(1,2)),100),((3,5,3,1,(1,3)),190),
>                       ((3,5,3,1,(2,0)),200),((3,5,3,1,(2,1)),200),((3,5,3,1,(2,2)),200),((3,5,3,1,(2,3)),200),
>                       ((3,5,3,1,(3,0)),200),((3,5,3,1,(3,1)),280),((3,5,3,1,(3,2)),100),((3,5,3,1,(3,3)),190),
>                       
>                       ((3,5,3,2,(0,0)),200),((3,5,3,2,(0,1)),270),((3,5,3,2,(0,2)),70),((3,5,3,2,(0,3)),270),
>                       ((3,5,3,2,(1,0)),200),((3,5,3,2,(1,1)),200),((3,5,3,2,(1,2)),200),((3,5,3,2,(1,3)),200),
>                       ((3,5,3,2,(2,0)),200),((3,5,3,2,(2,1)),270),((3,5,3,2,(2,2)),30),((3,5,3,2,(2,3)),230),
>                       ((3,5,3,2,(3,0)),200),((3,5,3,2,(3,1)),100),((3,5,3,2,(3,2)),-290),((3,5,3,2,(3,3)),90),
>                       
>                       ((3,5,3,3,(0,0)),200),((3,5,3,3,(0,1)),200),((3,5,3,3,(0,2)),200),((3,5,3,3,(0,3)),200),
>                       ((3,5,3,3,(1,0)),200),((3,5,3,3,(1,1)),250),((3,5,3,3,(1,2)),70),((3,5,3,3,(1,3)),160),
>                       ((3,5,3,3,(2,0)),200),((3,5,3,3,(2,1)),220),((3,5,3,3,(2,2)),-160),((3,5,3,3,(2,3)),220),
>                       ((3,5,3,3,(3,0)),200),((3,5,3,3,(3,1)),190),((3,5,3,3,(3,2)),90),((3,5,3,3,(3,3)),110),
>                       
>                       
>                       
>                       
>                       ((4,0,0,0,(0,0)),200),((4,0,0,0,(0,1)),190),((4,0,0,0,(0,2)),80),((4,0,0,0,(0,3)),200),
>                       ((4,0,0,0,(1,0)),190),((4,0,0,0,(1,1)),180),((4,0,0,0,(1,2)),70),((4,0,0,0,(1,3)),200),
>                       ((4,0,0,0,(2,0)),100),((4,0,0,0,(2,1)),90),((4,0,0,0,(2,2)),-20),((4,0,0,0,(2,3)),200),
>                       ((4,0,0,0,(3,0)),200),((4,0,0,0,(3,1)),200),((4,0,0,0,(3,2)),200),((4,0,0,0,(3,3)),200),
>                       
>                       ((4,0,0,1,(0,0)),240),((4,0,0,1,(0,1)),220),((4,0,0,1,(0,2)),110),((4,0,0,1,(0,3)),200),
>                       ((4,0,0,1,(1,0)),280),((4,0,0,1,(1,1)),210),((4,0,0,1,(1,2)),200),((4,0,0,1,(1,3)),200),
>                       ((4,0,0,1,(2,0)),200),((4,0,0,1,(2,1)),200),((4,0,0,1,(2,2)),200),((4,0,0,1,(2,3)),200),
>                       ((4,0,0,1,(3,0)),270),((4,0,0,1,(3,1)),190),((4,0,0,1,(3,2)),180),((4,0,0,1,(3,3)),200),
>                       
>                       ((4,0,0,2,(0,0)),100),((4,0,0,2,(0,1)),90),((4,0,0,2,(0,2)),-20),((4,0,0,2,(0,3)),200),
>                       ((4,0,0,2,(1,0)),200),((4,0,0,2,(1,1)),200),((4,0,0,2,(1,2)),200),((4,0,0,2,(1,3)),200),
>                       ((4,0,0,2,(2,0)),180),((4,0,0,2,(2,1)),160),((4,0,0,2,(2,2)),50),((4,0,0,2,(2,3)),200),
>                       ((4,0,0,2,(3,0)),30),((4,0,0,2,(3,1)),-80),((4,0,0,2,(3,2)),-10),((4,0,0,2,(3,3)),200),
>                       
>                       ((4,0,0,3,(0,0)),200),((4,0,0,3,(0,1)),200),((4,0,0,3,(0,2)),200),((4,0,0,3,(0,3)),200),
>                       ((4,0,0,3,(1,0)),270),((4,0,0,3,(1,1)),190),((4,0,0,3,(1,2)),180),((4,0,0,3,(1,3)),200),
>                       ((4,0,0,3,(2,0)),180),((4,0,0,3,(2,1)),70),((4,0,0,3,(2,2)),140),((4,0,0,3,(2,3)),200),
>                       ((4,0,0,3,(3,0)),220),((4,0,0,3,(3,1)),100),((4,0,0,3,(3,2)),180),((4,0,0,3,(3,3)),200),
>                       
>                       
>                       ((4,0,1,0,(0,0)),180),((4,0,1,0,(0,1)),230),((4,0,1,0,(0,2)),200),((4,0,1,0,(0,3)),230),
>                       ((4,0,1,0,(1,0)),170),((4,0,1,0,(1,1)),160),((4,0,1,0,(1,2)),200),((4,0,1,0,(1,3)),160),
>                       ((4,0,1,0,(2,0)),80),((4,0,1,0,(2,1)),170),((4,0,1,0,(2,2)),200),((4,0,1,0,(2,3)),170),
>                       ((4,0,1,0,(3,0)),200),((4,0,1,0,(3,1)),200),((4,0,1,0,(3,2)),200),((4,0,1,0,(3,3)),200),
>                       
>                       ((4,0,1,1,(0,0)),210),((4,0,1,1,(0,1)),210),((4,0,1,1,(0,2)),200),((4,0,1,1,(0,3)),210),
>                       ((4,0,1,1,(1,0)),200),((4,0,1,1,(1,1)),190),((4,0,1,1,(1,2)),200),((4,0,1,1,(1,3)),190),
>                       ((4,0,1,1,(2,0)),200),((4,0,1,1,(2,1)),200),((4,0,1,1,(2,2)),200),((4,0,1,1,(2,3)),200),
>                       ((4,0,1,1,(3,0)),180),((4,0,1,1,(3,1)),180),((4,0,1,1,(3,2)),200),((4,0,1,1,(3,3)),180),
>                       
>                       ((4,0,1,2,(0,0)),80),((4,0,1,2,(0,1)),170),((4,0,1,2,(0,2)),200),((4,0,1,2,(0,3)),170),
>                       ((4,0,1,2,(1,0)),200),((4,0,1,2,(1,1)),200),((4,0,1,2,(1,2)),200),((4,0,1,2,(1,3)),200),
>                       ((4,0,1,2,(2,0)),150),((4,0,1,2,(2,1)),210),((4,0,1,2,(2,2)),200),((4,0,1,2,(2,3)),210),
>                       ((4,0,1,2,(3,0)),-90),((4,0,1,2,(3,1)),0),((4,0,1,2,(3,2)),200),((4,0,1,2,(3,3)),0),
>                       
>                       ((4,0,1,3,(0,0)),200),((4,0,1,3,(0,1)),200),((4,0,1,3,(0,2)),200),((4,0,1,3,(0,3)),200),
>                       ((4,0,1,3,(1,0)),180),((4,0,1,3,(1,1)),180),((4,0,1,3,(1,2)),200),((4,0,1,3,(1,3)),180),
>                       ((4,0,1,3,(2,0)),60),((4,0,1,3,(2,1)),150),((4,0,1,3,(2,2)),200),((4,0,1,3,(2,3)),150),
>                       ((4,0,1,3,(3,0)),90),((4,0,1,3,(3,1)),90),((4,0,1,3,(3,2)),200),((4,0,1,3,(3,3)),90),
>                       
>                       
>                       ((4,0,2,0,(0,0)),80),((4,0,2,0,(0,1)),200),((4,0,2,0,(0,2)),130),((4,0,2,0,(0,3)),160),
>                       ((4,0,2,0,(1,0)),70),((4,0,2,0,(1,1)),200),((4,0,2,0,(1,2)),120),((4,0,2,0,(1,3)),50),
>                       ((4,0,2,0,(2,0)),-20),((4,0,2,0,(2,1)),200),((4,0,2,0,(2,2)),30),((4,0,2,0,(2,3)),140),
>                       ((4,0,2,0,(3,0)),200),((4,0,2,0,(3,1)),200),((4,0,2,0,(3,2)),200),((4,0,2,0,(3,3)),200),
>                       
>                       ((4,0,2,1,(0,0)),110),((4,0,2,1,(0,1)),200),((4,0,2,1,(0,2)),170),((4,0,2,1,(0,3)),90),
>                       ((4,0,2,1,(1,0)),200),((4,0,2,1,(1,1)),200),((4,0,2,1,(1,2)),210),((4,0,2,1,(1,3)),180),
>                       ((4,0,2,1,(2,0)),200),((4,0,2,1,(2,1)),200),((4,0,2,1,(2,2)),200),((4,0,2,1,(2,3)),200),
>                       ((4,0,2,1,(3,0)),180),((4,0,2,1,(3,1)),200),((4,0,2,1,(3,2)),200),((4,0,2,1,(3,3)),160),
>                       
>                       ((4,0,2,2,(0,0)),-20),((4,0,2,2,(0,1)),200),((4,0,2,2,(0,2)),30),((4,0,2,2,(0,3)),140),
>                       ((4,0,2,2,(1,0)),200),((4,0,2,2,(1,1)),200),((4,0,2,2,(1,2)),200),((4,0,2,2,(1,3)),200),
>                       ((4,0,2,2,(2,0)),50),((4,0,2,2,(2,1)),200),((4,0,2,2,(2,2)),110),((4,0,2,2,(2,3)),130),
>                       ((4,0,2,2,(3,0)),-10),((4,0,2,2,(3,1)),200),((4,0,2,2,(3,2)),-40),((4,0,2,2,(3,3)),-210),
>                       
>                       ((4,0,2,3,(0,0)),200),((4,0,2,3,(0,1)),200),((4,0,2,3,(0,2)),200),((4,0,2,3,(0,3)),200),
>                       ((4,0,2,3,(1,0)),180),((4,0,2,3,(1,1)),200),((4,0,2,3,(1,2)),200),((4,0,2,3,(1,3)),160),
>                       ((4,0,2,3,(2,0)),140),((4,0,2,3,(2,1)),200),((4,0,2,3,(2,2)),110),((4,0,2,3,(2,3)),-60),
>                       ((4,0,2,3,(3,0)),180),((4,0,2,3,(3,1)),200),((4,0,2,3,(3,2)),150),((4,0,2,3,(3,3)),160),
>                       
>                       
>                       ((4,0,3,0,(0,0)),200),((4,0,3,0,(0,1)),230),((4,0,3,0,(0,2)),60),((4,0,3,0,(0,3)),190),
>                       ((4,0,3,0,(1,0)),200),((4,0,3,0,(1,1)),160),((4,0,3,0,(1,2)),-50),((4,0,3,0,(1,3)),80),
>                       ((4,0,3,0,(2,0)),200),((4,0,3,0,(2,1)),170),((4,0,3,0,(2,2)),40),((4,0,3,0,(2,3)),180),
>                       ((4,0,3,0,(3,0)),200),((4,0,3,0,(3,1)),200),((4,0,3,0,(3,2)),200),((4,0,3,0,(3,3)),200),
>                       
>                       ((4,0,3,1,(0,0)),200),((4,0,3,1,(0,1)),210),((4,0,3,1,(0,2)),0),((4,0,3,1,(0,3)),130),
>                       ((4,0,3,1,(1,0)),200),((4,0,3,1,(1,1)),190),((4,0,3,1,(1,2)),80),((4,0,3,1,(1,3)),110),
>                       ((4,0,3,1,(2,0)),200),((4,0,3,1,(2,1)),200),((4,0,3,1,(2,2)),200),((4,0,3,1,(2,3)),200),
>                       ((4,0,3,1,(3,0)),200),((4,0,3,1,(3,1)),180),((4,0,3,1,(3,2)),70),((4,0,3,1,(3,3)),100),
>                       
>                       ((4,0,3,2,(0,0)),200),((4,0,3,2,(0,1)),170),((4,0,3,2,(0,2)),40),((4,0,3,2,(0,3)),180),
>                       ((4,0,3,2,(1,0)),200),((4,0,3,2,(1,1)),200),((4,0,3,2,(1,2)),200),((4,0,3,2,(1,3)),200),
>                       ((4,0,3,2,(2,0)),200),((4,0,3,2,(2,1)),210),((4,0,3,2,(2,2)),40),((4,0,3,2,(2,3)),170),
>                       ((4,0,3,2,(3,0)),200),((4,0,3,2,(3,1)),0),((4,0,3,2,(3,2)),-310),((4,0,3,2,(3,3)),0),
>                       
>                       ((4,0,3,3,(0,0)),200),((4,0,3,3,(0,1)),200),((4,0,3,3,(0,2)),200),((4,0,3,3,(0,3)),200),
>                       ((4,0,3,3,(1,0)),200),((4,0,3,3,(1,1)),180),((4,0,3,3,(1,2)),70),((4,0,3,3,(1,3)),100),
>                       ((4,0,3,3,(2,0)),200),((4,0,3,3,(2,1)),150),((4,0,3,3,(2,2)),-160),((4,0,3,3,(2,3)),160),
>                       ((4,0,3,3,(3,0)),200),((4,0,3,3,(3,1)),90),((4,0,3,3,(3,2)),60),((4,0,3,3,(3,3)),10),
>                       
>                       
>                       
>                       ((4,1,0,0,(0,0)),210),((4,1,0,0,(0,1)),200),((4,1,0,0,(0,2)),90),((4,1,0,0,(0,3)),200),
>                       ((4,1,0,0,(1,0)),190),((4,1,0,0,(1,1)),170),((4,1,0,0,(1,2)),60),((4,1,0,0,(1,3)),200),
>                       ((4,1,0,0,(2,0)),10),((4,1,0,0,(2,1)),0),((4,1,0,0,(2,2)),-110),((4,1,0,0,(2,3)),200),
>                       ((4,1,0,0,(3,0)),200),((4,1,0,0,(3,1)),200),((4,1,0,0,(3,2)),200),((4,1,0,0,(3,3)),200),
>                       
>                       ((4,1,0,1,(0,0)),180),((4,1,0,1,(0,1)),170),((4,1,0,1,(0,2)),60),((4,1,0,1,(0,3)),200),
>                       ((4,1,0,1,(1,0)),250),((4,1,0,1,(1,1)),170),((4,1,0,1,(1,2)),160),((4,1,0,1,(1,3)),200),
>                       ((4,1,0,1,(2,0)),200),((4,1,0,1,(2,1)),200),((4,1,0,1,(2,2)),200),((4,1,0,1,(2,3)),200),
>                       ((4,1,0,1,(3,0)),150),((4,1,0,1,(3,1)),70),((4,1,0,1,(3,2)),70),((4,1,0,1,(3,3)),200),
>                       
>                       ((4,1,0,2,(0,0)),70),((4,1,0,2,(0,1)),60),((4,1,0,2,(0,2)),-50),((4,1,0,2,(0,3)),200),
>                       ((4,1,0,2,(1,0)),200),((4,1,0,2,(1,1)),200),((4,1,0,2,(1,2)),200),((4,1,0,2,(1,3)),200),
>                       ((4,1,0,2,(2,0)),180),((4,1,0,2,(2,1)),160),((4,1,0,2,(2,2)),50),((4,1,0,2,(2,3)),200),
>                       ((4,1,0,2,(3,0)),0),((4,1,0,2,(3,1)),-120),((4,1,0,2,(3,2)),-50),((4,1,0,2,(3,3)),200),
>                       
>                       ((4,1,0,3,(0,0)),200),((4,1,0,3,(0,1)),200),((4,1,0,3,(0,2)),200),((4,1,0,3,(0,3)),200),
>                       ((4,1,0,3,(1,0)),250),((4,1,0,3,(1,1)),180),((4,1,0,3,(1,2)),170),((4,1,0,3,(1,3)),200),
>                       ((4,1,0,3,(2,0)),40),((4,1,0,3,(2,1)),-80),((4,1,0,3,(2,2)),-10),((4,1,0,3,(2,3)),200),
>                       ((4,1,0,3,(3,0)),210),((4,1,0,3,(3,1)),100),((4,1,0,3,(3,2)),170),((4,1,0,3,(3,3)),200),
>                       
>                       
>                       ((4,1,1,0,(0,0)),190),((4,1,1,0,(0,1)),240),((4,1,1,0,(0,2)),200),((4,1,1,0,(0,3)),240),
>                       ((4,1,1,0,(1,0)),160),((4,1,1,0,(1,1)),160),((4,1,1,0,(1,2)),200),((4,1,1,0,(1,3)),160),
>                       ((4,1,1,0,(2,0)),-10),((4,1,1,0,(2,1)),80),((4,1,1,0,(2,2)),200),((4,1,1,0,(2,3)),80),
>                       ((4,1,1,0,(3,0)),200),((4,1,1,0,(3,1)),200),((4,1,1,0,(3,2)),200),((4,1,1,0,(3,3)),200),
>                       
>                       ((4,1,1,1,(0,0)),160),((4,1,1,1,(0,1)),150),((4,1,1,1,(0,2)),200),((4,1,1,1,(0,3)),150),
>                       ((4,1,1,1,(1,0)),160),((4,1,1,1,(1,1)),160),((4,1,1,1,(1,2)),200),((4,1,1,1,(1,3)),160),
>                       ((4,1,1,1,(2,0)),200),((4,1,1,1,(2,1)),200),((4,1,1,1,(2,2)),200),((4,1,1,1,(2,3)),200),
>                       ((4,1,1,1,(3,0)),60),((4,1,1,1,(3,1)),60),((4,1,1,1,(3,2)),200),((4,1,1,1,(3,3)),60),
>                       
>                       ((4,1,1,2,(0,0)),50),((4,1,1,2,(0,1)),140),((4,1,1,2,(0,2)),200),((4,1,1,2,(0,3)),140),
>                       ((4,1,1,2,(1,0)),200),((4,1,1,2,(1,1)),200),((4,1,1,2,(1,2)),200),((4,1,1,2,(1,3)),200),
>                       ((4,1,1,2,(2,0)),150),((4,1,1,2,(2,1)),210),((4,1,1,2,(2,2)),200),((4,1,1,2,(2,3)),210),
>                       ((4,1,1,2,(3,0)),-130),((4,1,1,2,(3,1)),-30),((4,1,1,2,(3,2)),200),((4,1,1,2,(3,3)),-30),
>                       
>                       ((4,1,1,3,(0,0)),200),((4,1,1,3,(0,1)),200),((4,1,1,3,(0,2)),200),((4,1,1,3,(0,3)),200),
>                       ((4,1,1,3,(1,0)),170),((4,1,1,3,(1,1)),160),((4,1,1,3,(1,2)),200),((4,1,1,3,(1,3)),160),
>                       ((4,1,1,3,(2,0)),-90),((4,1,1,3,(2,1)),10),((4,1,1,3,(2,2)),200),((4,1,1,3,(2,3)),10),
>                       ((4,1,1,3,(3,0)),90),((4,1,1,3,(3,1)),80),((4,1,1,3,(3,2)),200),((4,1,1,3,(3,3)),80),
>                       
>                       
>                       ((4,1,2,0,(0,0)),90),((4,1,2,0,(0,1)),200),((4,1,2,0,(0,2)),140),((4,1,2,0,(0,3)),170),
>                       ((4,1,2,0,(1,0)),60),((4,1,2,0,(1,1)),200),((4,1,2,0,(1,2)),120),((4,1,2,0,(1,3)),40),
>                       ((4,1,2,0,(2,0)),-110),((4,1,2,0,(2,1)),200),((4,1,2,0,(2,2)),-60),((4,1,2,0,(2,3)),50),
>                       ((4,1,2,0,(3,0)),200),((4,1,2,0,(3,1)),200),((4,1,2,0,(3,2)),200),((4,1,2,0,(3,3)),200),
>                       
>                       ((4,1,2,1,(0,0)),60),((4,1,2,1,(0,1)),200),((4,1,2,1,(0,2)),110),((4,1,2,1,(0,3)),40),
>                       ((4,1,2,1,(1,0)),160),((4,1,2,1,(1,1)),200),((4,1,2,1,(1,2)),180),((4,1,2,1,(1,3)),140),
>                       ((4,1,2,1,(2,0)),200),((4,1,2,1,(2,1)),200),((4,1,2,1,(2,2)),200),((4,1,2,1,(2,3)),200),
>                       ((4,1,2,1,(3,0)),70),((4,1,2,1,(3,1)),200),((4,1,2,1,(3,2)),80),((4,1,2,1,(3,3)),50),
>                       
>                       ((4,1,2,2,(0,0)),-50),((4,1,2,2,(0,1)),200),((4,1,2,2,(0,2)),0),((4,1,2,2,(0,3)),110),
>                       ((4,1,2,2,(1,0)),200),((4,1,2,2,(1,1)),200),((4,1,2,2,(1,2)),200),((4,1,2,2,(1,3)),200),
>                       ((4,1,2,2,(2,0)),50),((4,1,2,2,(2,1)),200),((4,1,2,2,(2,2)),110),((4,1,2,2,(2,3)),130),
>                       ((4,1,2,2,(3,0)),-50),((4,1,2,2,(3,1)),200),((4,1,2,2,(3,2)),-70),((4,1,2,2,(3,3)),-250),
>                       
>                       ((4,1,2,3,(0,0)),200),((4,1,2,3,(0,1)),200),((4,1,2,3,(0,2)),200),((4,1,2,3,(0,3)),200),
>                       ((4,1,2,3,(1,0)),170),((4,1,2,3,(1,1)),200),((4,1,2,3,(1,2)),180),((4,1,2,3,(1,3)),150),
>                       ((4,1,2,3,(2,0)),-10),((4,1,2,3,(2,1)),200),((4,1,2,3,(2,2)),-30),((4,1,2,3,(2,3)),-210),
>                       ((4,1,2,3,(3,0)),170),((4,1,2,3,(3,1)),200),((4,1,2,3,(3,2)),140),((4,1,2,3,(3,3)),150),
>                       
>                       
>                       ((4,1,3,0,(0,0)),200),((4,1,3,0,(0,1)),240),((4,1,3,0,(0,2)),70),((4,1,3,0,(0,3)),200),
>                       ((4,1,3,0,(1,0)),200),((4,1,3,0,(1,1)),160),((4,1,3,0,(1,2)),-50),((4,1,3,0,(1,3)),80),
>                       ((4,1,3,0,(2,0)),200),((4,1,3,0,(2,1)),80),((4,1,3,0,(2,2)),-50),((4,1,3,0,(2,3)),80),
>                       ((4,1,3,0,(3,0)),200),((4,1,3,0,(3,1)),200),((4,1,3,0,(3,2)),200),((4,1,3,0,(3,3)),200),
>                       
>                       ((4,1,3,1,(0,0)),200),((4,1,3,1,(0,1)),150),((4,1,3,1,(0,2)),-60),((4,1,3,1,(0,3)),70),
>                       ((4,1,3,1,(1,0)),200),((4,1,3,1,(1,1)),160),((4,1,3,1,(1,2)),50),((4,1,3,1,(1,3)),80),
>                       ((4,1,3,1,(2,0)),200),((4,1,3,1,(2,1)),200),((4,1,3,1,(2,2)),200),((4,1,3,1,(2,3)),200),
>                       ((4,1,3,1,(3,0)),200),((4,1,3,1,(3,1)),60),((4,1,3,1,(3,2)),-50),((4,1,3,1,(3,3)),-20),
>                       
>                       ((4,1,3,2,(0,0)),200),((4,1,3,2,(0,1)),140),((4,1,3,2,(0,2)),10),((4,1,3,2,(0,3)),150),
>                       ((4,1,3,2,(1,0)),200),((4,1,3,2,(1,1)),200),((4,1,3,2,(1,2)),200),((4,1,3,2,(1,3)),200),
>                       ((4,1,3,2,(2,0)),200),((4,1,3,2,(2,1)),210),((4,1,3,2,(2,2)),40),((4,1,3,2,(2,3)),170),
>                       ((4,1,3,2,(3,0)),200),((4,1,3,2,(3,1)),-30),((4,1,3,2,(3,2)),-350),((4,1,3,2,(3,3)),-30),
>                       
>                       ((4,1,3,3,(0,0)),200),((4,1,3,3,(0,1)),200),((4,1,3,3,(0,2)),200),((4,1,3,3,(0,3)),200),
>                       ((4,1,3,3,(1,0)),200),((4,1,3,3,(1,1)),160),((4,1,3,3,(1,2)),50),((4,1,3,3,(1,3)),80),
>                       ((4,1,3,3,(2,0)),200),((4,1,3,3,(2,1)),10),((4,1,3,3,(2,2)),-310),((4,1,3,3,(2,3)),10),
>                       ((4,1,3,3,(3,0)),200),((4,1,3,3,(3,1)),80),((4,1,3,3,(3,2)),50),((4,1,3,3,(3,3)),0),
>                       
>                       
>                       
>                       ((4,2,0,0,(0,0)),280),((4,2,0,0,(0,1)),260),((4,2,0,0,(0,2)),150),((4,2,0,0,(0,3)),200),
>                       ((4,2,0,0,(1,0)),250),((4,2,0,0,(1,1)),240),((4,2,0,0,(1,2)),130),((4,2,0,0,(1,3)),200),
>                       ((4,2,0,0,(2,0)),150),((4,2,0,0,(2,1)),140),((4,2,0,0,(2,2)),30),((4,2,0,0,(2,3)),200),
>                       ((4,2,0,0,(3,0)),200),((4,2,0,0,(3,1)),200),((4,2,0,0,(3,2)),200),((4,2,0,0,(3,3)),200),
>                       
>                       ((4,2,0,1,(0,0)),260),((4,2,0,1,(0,1)),250),((4,2,0,1,(0,2)),140),((4,2,0,1,(0,3)),200),
>                       ((4,2,0,1,(1,0)),310),((4,2,0,1,(1,1)),230),((4,2,0,1,(1,2)),220),((4,2,0,1,(1,3)),200),
>                       ((4,2,0,1,(2,0)),200),((4,2,0,1,(2,1)),200),((4,2,0,1,(2,2)),200),((4,2,0,1,(2,3)),200),
>                       ((4,2,0,1,(3,0)),310),((4,2,0,1,(3,1)),230),((4,2,0,1,(3,2)),220),((4,2,0,1,(3,3)),200),
>                       
>                       ((4,2,0,2,(0,0)),150),((4,2,0,2,(0,1)),140),((4,2,0,2,(0,2)),30),((4,2,0,2,(0,3)),200),
>                       ((4,2,0,2,(1,0)),200),((4,2,0,2,(1,1)),200),((4,2,0,2,(1,2)),200),((4,2,0,2,(1,3)),200),
>                       ((4,2,0,2,(2,0)),210),((4,2,0,2,(2,1)),190),((4,2,0,2,(2,2)),80),((4,2,0,2,(2,3)),200),
>                       ((4,2,0,2,(3,0)),130),((4,2,0,2,(3,1)),20),((4,2,0,2,(3,2)),90),((4,2,0,2,(3,3)),200),
>                       
>                       ((4,2,0,3,(0,0)),200),((4,2,0,3,(0,1)),200),((4,2,0,3,(0,2)),200),((4,2,0,3,(0,3)),200),
>                       ((4,2,0,3,(1,0)),310),((4,2,0,3,(1,1)),230),((4,2,0,3,(1,2)),220),((4,2,0,3,(1,3)),200),
>                       ((4,2,0,3,(2,0)),230),((4,2,0,3,(2,1)),120),((4,2,0,3,(2,2)),190),((4,2,0,3,(2,3)),200),
>                       ((4,2,0,3,(3,0)),270),((4,2,0,3,(3,1)),150),((4,2,0,3,(3,2)),220),((4,2,0,3,(3,3)),200),
>                       
>                       
>                       ((4,2,1,0,(0,0)),250),((4,2,1,0,(0,1)),310),((4,2,1,0,(0,2)),200),((4,2,1,0,(0,3)),310),
>                       ((4,2,1,0,(1,0)),230),((4,2,1,0,(1,1)),220),((4,2,1,0,(1,2)),200),((4,2,1,0,(1,3)),220),
>                       ((4,2,1,0,(2,0)),130),((4,2,1,0,(2,1)),220),((4,2,1,0,(2,2)),200),((4,2,1,0,(2,3)),220),
>                       ((4,2,1,0,(3,0)),200),((4,2,1,0,(3,1)),200),((4,2,1,0,(3,2)),200),((4,2,1,0,(3,3)),200),
>                       
>                       ((4,2,1,1,(0,0)),240),((4,2,1,1,(0,1)),230),((4,2,1,1,(0,2)),200),((4,2,1,1,(0,3)),230),
>                       ((4,2,1,1,(1,0)),220),((4,2,1,1,(1,1)),220),((4,2,1,1,(1,2)),200),((4,2,1,1,(1,3)),220),
>                       ((4,2,1,1,(2,0)),200),((4,2,1,1,(2,1)),200),((4,2,1,1,(2,2)),200),((4,2,1,1,(2,3)),200),
>                       ((4,2,1,1,(3,0)),220),((4,2,1,1,(3,1)),220),((4,2,1,1,(3,2)),200),((4,2,1,1,(3,3)),220),
>                       
>                       ((4,2,1,2,(0,0)),130),((4,2,1,2,(0,1)),220),((4,2,1,2,(0,2)),200),((4,2,1,2,(0,3)),220),
>                       ((4,2,1,2,(1,0)),200),((4,2,1,2,(1,1)),200),((4,2,1,2,(1,2)),200),((4,2,1,2,(1,3)),200),
>                       ((4,2,1,2,(2,0)),180),((4,2,1,2,(2,1)),240),((4,2,1,2,(2,2)),200),((4,2,1,2,(2,3)),240),
>                       ((4,2,1,2,(3,0)),10),((4,2,1,2,(3,1)),100),((4,2,1,2,(3,2)),200),((4,2,1,2,(3,3)),100),
>                       
>                       ((4,2,1,3,(0,0)),200),((4,2,1,3,(0,1)),200),((4,2,1,3,(0,2)),200),((4,2,1,3,(0,3)),200),
>                       ((4,2,1,3,(1,0)),220),((4,2,1,3,(1,1)),220),((4,2,1,3,(1,2)),200),((4,2,1,3,(1,3)),220),
>                       ((4,2,1,3,(2,0)),110),((4,2,1,3,(2,1)),200),((4,2,1,3,(2,2)),200),((4,2,1,3,(2,3)),200),
>                       ((4,2,1,3,(3,0)),140),((4,2,1,3,(3,1)),140),((4,2,1,3,(3,2)),200),((4,2,1,3,(3,3)),140),
>                       
>                       
>                       ((4,2,2,0,(0,0)),150),((4,2,2,0,(0,1)),200),((4,2,2,0,(0,2)),210),((4,2,2,0,(0,3)),230),
>                       ((4,2,2,0,(1,0)),130),((4,2,2,0,(1,1)),200),((4,2,2,0,(1,2)),180),((4,2,2,0,(1,3)),110),
>                       ((4,2,2,0,(2,0)),30),((4,2,2,0,(2,1)),200),((4,2,2,0,(2,2)),80),((4,2,2,0,(2,3)),190),
>                       ((4,2,2,0,(3,0)),200),((4,2,2,0,(3,1)),200),((4,2,2,0,(3,2)),200),((4,2,2,0,(3,3)),200),
>                       
>                       ((4,2,2,1,(0,0)),140),((4,2,2,1,(0,1)),200),((4,2,2,1,(0,2)),190),((4,2,2,1,(0,3)),120),
>                       ((4,2,2,1,(1,0)),220),((4,2,2,1,(1,1)),200),((4,2,2,1,(1,2)),240),((4,2,2,1,(1,3)),200),
>                       ((4,2,2,1,(2,0)),200),((4,2,2,1,(2,1)),200),((4,2,2,1,(2,2)),200),((4,2,2,1,(2,3)),200),
>                       ((4,2,2,1,(3,0)),220),((4,2,2,1,(3,1)),200),((4,2,2,1,(3,2)),240),((4,2,2,1,(3,3)),200),
>                       
>                       ((4,2,2,2,(0,0)),30),((4,2,2,2,(0,1)),200),((4,2,2,2,(0,2)),80),((4,2,2,2,(0,3)),190),
>                       ((4,2,2,2,(1,0)),200),((4,2,2,2,(1,1)),200),((4,2,2,2,(1,2)),200),((4,2,2,2,(1,3)),200),
>                       ((4,2,2,2,(2,0)),80),((4,2,2,2,(2,1)),200),((4,2,2,2,(2,2)),140),((4,2,2,2,(2,3)),160),
>                       ((4,2,2,2,(3,0)),90),((4,2,2,2,(3,1)),200),((4,2,2,2,(3,2)),70),((4,2,2,2,(3,3)),-110),
>                       
>                       ((4,2,2,3,(0,0)),200),((4,2,2,3,(0,1)),200),((4,2,2,3,(0,2)),200),((4,2,2,3,(0,3)),200),
>                       ((4,2,2,3,(1,0)),220),((4,2,2,3,(1,1)),200),((4,2,2,3,(1,2)),240),((4,2,2,3,(1,3)),200),
>                       ((4,2,2,3,(2,0)),190),((4,2,2,3,(2,1)),200),((4,2,2,3,(2,2)),160),((4,2,2,3,(2,3)),-10),
>                       ((4,2,2,3,(3,0)),220),((4,2,2,3,(3,1)),200),((4,2,2,3,(3,2)),200),((4,2,2,3,(3,3)),200),
>                       
>                       
>                       ((4,2,3,0,(0,0)),200),((4,2,3,0,(0,1)),310),((4,2,3,0,(0,2)),130),((4,2,3,0,(0,3)),270),
>                       ((4,2,3,0,(1,0)),200),((4,2,3,0,(1,1)),220),((4,2,3,0,(1,2)),10),((4,2,3,0,(1,3)),140),
>                       ((4,2,3,0,(2,0)),200),((4,2,3,0,(2,1)),220),((4,2,3,0,(2,2)),90),((4,2,3,0,(2,3)),220),
>                       ((4,2,3,0,(3,0)),200),((4,2,3,0,(3,1)),200),((4,2,3,0,(3,2)),200),((4,2,3,0,(3,3)),200),
>                       
>                       ((4,2,3,1,(0,0)),200),((4,2,3,1,(0,1)),230),((4,2,3,1,(0,2)),20),((4,2,3,1,(0,3)),150),
>                       ((4,2,3,1,(1,0)),200),((4,2,3,1,(1,1)),220),((4,2,3,1,(1,2)),100),((4,2,3,1,(1,3)),140),
>                       ((4,2,3,1,(2,0)),200),((4,2,3,1,(2,1)),200),((4,2,3,1,(2,2)),200),((4,2,3,1,(2,3)),200),
>                       ((4,2,3,1,(3,0)),200),((4,2,3,1,(3,1)),220),((4,2,3,1,(3,2)),100),((4,2,3,1,(3,3)),140),
>                       
>                       ((4,2,3,2,(0,0)),200),((4,2,3,2,(0,1)),220),((4,2,3,2,(0,2)),90),((4,2,3,2,(0,3)),220),
>                       ((4,2,3,2,(1,0)),200),((4,2,3,2,(1,1)),200),((4,2,3,2,(1,2)),200),((4,2,3,2,(1,3)),200),
>                       ((4,2,3,2,(2,0)),200),((4,2,3,2,(2,1)),240),((4,2,3,2,(2,2)),70),((4,2,3,2,(2,3)),200),
>                       ((4,2,3,2,(3,0)),200),((4,2,3,2,(3,1)),100),((4,2,3,2,(3,2)),-210),((4,2,3,2,(3,3)),110),
>                       
>                       ((4,2,3,3,(0,0)),200),((4,2,3,3,(0,1)),200),((4,2,3,3,(0,2)),200),((4,2,3,3,(0,3)),200),
>                       ((4,2,3,3,(1,0)),200),((4,2,3,3,(1,1)),220),((4,2,3,3,(1,2)),100),((4,2,3,3,(1,3)),140),
>                       ((4,2,3,3,(2,0)),200),((4,2,3,3,(2,1)),200),((4,2,3,3,(2,2)),-110),((4,2,3,3,(2,3)),200),
>                       ((4,2,3,3,(3,0)),200),((4,2,3,3,(3,1)),140),((4,2,3,3,(3,2)),110),((4,2,3,3,(3,3)),60),
>                       
>                       
>                       
>                       ((4,3,0,0,(0,0)),280),((4,3,0,0,(0,1)),260),((4,3,0,0,(0,2)),150),((4,3,0,0,(0,3)),200),
>                       ((4,3,0,0,(1,0)),230),((4,3,0,0,(1,1)),220),((4,3,0,0,(1,2)),110),((4,3,0,0,(1,3)),200),
>                       ((4,3,0,0,(2,0)),170),((4,3,0,0,(2,1)),160),((4,3,0,0,(2,2)),50),((4,3,0,0,(2,3)),200),
>                       ((4,3,0,0,(3,0)),200),((4,3,0,0,(3,1)),200),((4,3,0,0,(3,2)),200),((4,3,0,0,(3,3)),200),
>                       
>                       ((4,3,0,1,(0,0)),280),((4,3,0,1,(0,1)),260),((4,3,0,1,(0,2)),150),((4,3,0,1,(0,3)),200),
>                       ((4,3,0,1,(1,0)),340),((4,3,0,1,(1,1)),260),((4,3,0,1,(1,2)),250),((4,3,0,1,(1,3)),200),
>                       ((4,3,0,1,(2,0)),200),((4,3,0,1,(2,1)),200),((4,3,0,1,(2,2)),200),((4,3,0,1,(2,3)),200),
>                       ((4,3,0,1,(3,0)),340),((4,3,0,1,(3,1)),260),((4,3,0,1,(3,2)),250),((4,3,0,1,(3,3)),200),
>                       
>                       ((4,3,0,2,(0,0)),170),((4,3,0,2,(0,1)),160),((4,3,0,2,(0,2)),50),((4,3,0,2,(0,3)),200),
>                       ((4,3,0,2,(1,0)),200),((4,3,0,2,(1,1)),200),((4,3,0,2,(1,2)),200),((4,3,0,2,(1,3)),200),
>                       ((4,3,0,2,(2,0)),210),((4,3,0,2,(2,1)),200),((4,3,0,2,(2,2)),90),((4,3,0,2,(2,3)),200),
>                       ((4,3,0,2,(3,0)),100),((4,3,0,2,(3,1)),-20),((4,3,0,2,(3,2)),50),((4,3,0,2,(3,3)),200),
>                       
>                       ((4,3,0,3,(0,0)),200),((4,3,0,3,(0,1)),200),((4,3,0,3,(0,2)),200),((4,3,0,3,(0,3)),200),
>                       ((4,3,0,3,(1,0)),310),((4,3,0,3,(1,1)),230),((4,3,0,3,(1,2)),220),((4,3,0,3,(1,3)),200),
>                       ((4,3,0,3,(2,0)),220),((4,3,0,3,(2,1)),110),((4,3,0,3,(2,2)),180),((4,3,0,3,(2,3)),200),
>                       ((4,3,0,3,(3,0)),290),((4,3,0,3,(3,1)),180),((4,3,0,3,(3,2)),250),((4,3,0,3,(3,3)),200),
>                       
>                       
>                       ((4,3,1,0,(0,0)),250),((4,3,1,0,(0,1)),310),((4,3,1,0,(0,2)),200),((4,3,1,0,(0,3)),310),
>                       ((4,3,1,0,(1,0)),210),((4,3,1,0,(1,1)),200),((4,3,1,0,(1,2)),200),((4,3,1,0,(1,3)),200),
>                       ((4,3,1,0,(2,0)),150),((4,3,1,0,(2,1)),240),((4,3,1,0,(2,2)),200),((4,3,1,0,(2,3)),240),
>                       ((4,3,1,0,(3,0)),200),((4,3,1,0,(3,1)),200),((4,3,1,0,(3,2)),200),((4,3,1,0,(3,3)),200),
>                       
>                       ((4,3,1,1,(0,0)),250),((4,3,1,1,(0,1)),250),((4,3,1,1,(0,2)),200),((4,3,1,1,(0,3)),250),
>                       ((4,3,1,1,(1,0)),250),((4,3,1,1,(1,1)),250),((4,3,1,1,(1,2)),200),((4,3,1,1,(1,3)),250),
>                       ((4,3,1,1,(2,0)),200),((4,3,1,1,(2,1)),200),((4,3,1,1,(2,2)),200),((4,3,1,1,(2,3)),200),
>                       ((4,3,1,1,(3,0)),250),((4,3,1,1,(3,1)),250),((4,3,1,1,(3,2)),200),((4,3,1,1,(3,3)),250),
>                       
>                       ((4,3,1,2,(0,0)),150),((4,3,1,2,(0,1)),240),((4,3,1,2,(0,2)),200),((4,3,1,2,(0,3)),240),
>                       ((4,3,1,2,(1,0)),200),((4,3,1,2,(1,1)),200),((4,3,1,2,(1,2)),200),((4,3,1,2,(1,3)),200),
>                       ((4,3,1,2,(2,0)),190),((4,3,1,2,(2,1)),240),((4,3,1,2,(2,2)),200),((4,3,1,2,(2,3)),240),
>                       ((4,3,1,2,(3,0)),-30),((4,3,1,2,(3,1)),70),((4,3,1,2,(3,2)),200),((4,3,1,2,(3,3)),70),
>                       
>                       ((4,3,1,3,(0,0)),200),((4,3,1,3,(0,1)),200),((4,3,1,3,(0,2)),200),((4,3,1,3,(0,3)),200),
>                       ((4,3,1,3,(1,0)),220),((4,3,1,3,(1,1)),220),((4,3,1,3,(1,2)),200),((4,3,1,3,(1,3)),220),
>                       ((4,3,1,3,(2,0)),100),((4,3,1,3,(2,1)),190),((4,3,1,3,(2,2)),200),((4,3,1,3,(2,3)),190),
>                       ((4,3,1,3,(3,0)),170),((4,3,1,3,(3,1)),160),((4,3,1,3,(3,2)),200),((4,3,1,3,(3,3)),160),
>                       
>                       
>                       ((4,3,2,0,(0,0)),150),((4,3,2,0,(0,1)),200),((4,3,2,0,(0,2)),210),((4,3,2,0,(0,3)),230),
>                       ((4,3,2,0,(1,0)),110),((4,3,2,0,(1,1)),200),((4,3,2,0,(1,2)),160),((4,3,2,0,(1,3)),90),
>                       ((4,3,2,0,(2,0)),50),((4,3,2,0,(2,1)),200),((4,3,2,0,(2,2)),100),((4,3,2,0,(2,3)),210),
>                       ((4,3,2,0,(3,0)),200),((4,3,2,0,(3,1)),200),((4,3,2,0,(3,2)),200),((4,3,2,0,(3,3)),200),
>                       
>                       ((4,3,2,1,(0,0)),150),((4,3,2,1,(0,1)),200),((4,3,2,1,(0,2)),210),((4,3,2,1,(0,3)),130),
>                       ((4,3,2,1,(1,0)),250),((4,3,2,1,(1,1)),200),((4,3,2,1,(1,2)),270),((4,3,2,1,(1,3)),230),
>                       ((4,3,2,1,(2,0)),200),((4,3,2,1,(2,1)),200),((4,3,2,1,(2,2)),200),((4,3,2,1,(2,3)),200),
>                       ((4,3,2,1,(3,0)),250),((4,3,2,1,(3,1)),200),((4,3,2,1,(3,2)),270),((4,3,2,1,(3,3)),230),
>                       
>                       ((4,3,2,2,(0,0)),50),((4,3,2,2,(0,1)),200),((4,3,2,2,(0,2)),100),((4,3,2,2,(0,3)),210),
>                       ((4,3,2,2,(1,0)),200),((4,3,2,2,(1,1)),200),((4,3,2,2,(1,2)),200),((4,3,2,2,(1,3)),200),
>                       ((4,3,2,2,(2,0)),90),((4,3,2,2,(2,1)),200),((4,3,2,2,(2,2)),140),((4,3,2,2,(2,3)),170),
>                       ((4,3,2,2,(3,0)),50),((4,3,2,2,(3,1)),200),((4,3,2,2,(3,2)),30),((4,3,2,2,(3,3)),-150),
>                       
>                       ((4,3,2,3,(0,0)),200),((4,3,2,3,(0,1)),200),((4,3,2,3,(0,2)),200),((4,3,2,3,(0,3)),200),
>                       ((4,3,2,3,(1,0)),220),((4,3,2,3,(1,1)),200),((4,3,2,3,(1,2)),240),((4,3,2,3,(1,3)),200),
>                       ((4,3,2,3,(2,0)),180),((4,3,2,3,(2,1)),200),((4,3,2,3,(2,2)),150),((4,3,2,3,(2,3)),-20),
>                       ((4,3,2,3,(3,0)),250),((4,3,2,3,(3,1)),200),((4,3,2,3,(3,2)),220),((4,3,2,3,(3,3)),230),
>                       
>                       
>                       ((4,3,3,0,(0,0)),200),((4,3,3,0,(0,1)),310),((4,3,3,0,(0,2)),130),((4,3,3,0,(0,3)),270),
>                       ((4,3,3,0,(1,0)),200),((4,3,3,0,(1,1)),200),((4,3,3,0,(1,2)),-10),((4,3,3,0,(1,3)),120),
>                       ((4,3,3,0,(2,0)),200),((4,3,3,0,(2,1)),240),((4,3,3,0,(2,2)),110),((4,3,3,0,(2,3)),240),
>                       ((4,3,3,0,(3,0)),200),((4,3,3,0,(3,1)),200),((4,3,3,0,(3,2)),200),((4,3,3,0,(3,3)),200),
>                       
>                       ((4,3,3,1,(0,0)),200),((4,3,3,1,(0,1)),250),((4,3,3,1,(0,2)),30),((4,3,3,1,(0,3)),170),
>                       ((4,3,3,1,(1,0)),200),((4,3,3,1,(1,1)),250),((4,3,3,1,(1,2)),130),((4,3,3,1,(1,3)),170),
>                       ((4,3,3,1,(2,0)),200),((4,3,3,1,(2,1)),200),((4,3,3,1,(2,2)),200),((4,3,3,1,(2,3)),200),
>                       ((4,3,3,1,(3,0)),200),((4,3,3,1,(3,1)),250),((4,3,3,1,(3,2)),130),((4,3,3,1,(3,3)),170),
>                       
>                       ((4,3,3,2,(0,0)),200),((4,3,3,2,(0,1)),240),((4,3,3,2,(0,2)),110),((4,3,3,2,(0,3)),240),
>                       ((4,3,3,2,(1,0)),200),((4,3,3,2,(1,1)),200),((4,3,3,2,(1,2)),200),((4,3,3,2,(1,3)),200),
>                       ((4,3,3,2,(2,0)),200),((4,3,3,2,(2,1)),240),((4,3,3,2,(2,2)),70),((4,3,3,2,(2,3)),200),
>                       ((4,3,3,2,(3,0)),200),((4,3,3,2,(3,1)),70),((4,3,3,2,(3,2)),-250),((4,3,3,2,(3,3)),70),
>                       
>                       ((4,3,3,3,(0,0)),200),((4,3,3,3,(0,1)),200),((4,3,3,3,(0,2)),200),((4,3,3,3,(0,3)),200),
>                       ((4,3,3,3,(1,0)),200),((4,3,3,3,(1,1)),220),((4,3,3,3,(1,2)),100),((4,3,3,3,(1,3)),140),
>                       ((4,3,3,3,(2,0)),200),((4,3,3,3,(2,1)),190),((4,3,3,3,(2,2)),-120),((4,3,3,3,(2,3)),190),
>                       ((4,3,3,3,(3,0)),200),((4,3,3,3,(3,1)),160),((4,3,3,3,(3,2)),130),((4,3,3,3,(3,3)),80),
>                       
>                       
>                       
>                       ((4,4,0,0,(0,0)),280),((4,4,0,0,(0,1)),260),((4,4,0,0,(0,2)),150),((4,4,0,0,(0,3)),200),
>                       ((4,4,0,0,(1,0)),250),((4,4,0,0,(1,1)),240),((4,4,0,0,(1,2)),130),((4,4,0,0,(1,3)),200),
>                       ((4,4,0,0,(2,0)),150),((4,4,0,0,(2,1)),140),((4,4,0,0,(2,2)),30),((4,4,0,0,(2,3)),200),
>                       ((4,4,0,0,(3,0)),200),((4,4,0,0,(3,1)),200),((4,4,0,0,(3,2)),200),((4,4,0,0,(3,3)),200),
>                       
>                       ((4,4,0,1,(0,0)),260),((4,4,0,1,(0,1)),250),((4,4,0,1,(0,2)),140),((4,4,0,1,(0,3)),200),
>                       ((4,4,0,1,(1,0)),310),((4,4,0,1,(1,1)),230),((4,4,0,1,(1,2)),220),((4,4,0,1,(1,3)),200),
>                       ((4,4,0,1,(2,0)),200),((4,4,0,1,(2,1)),200),((4,4,0,1,(2,2)),200),((4,4,0,1,(2,3)),200),
>                       ((4,4,0,1,(3,0)),310),((4,4,0,1,(3,1)),230),((4,4,0,1,(3,2)),220),((4,4,0,1,(3,3)),200),
>                       
>                       ((4,4,0,2,(0,0)),150),((4,4,0,2,(0,1)),140),((4,4,0,2,(0,2)),30),((4,4,0,2,(0,3)),200),
>                       ((4,4,0,2,(1,0)),200),((4,4,0,2,(1,1)),200),((4,4,0,2,(1,2)),200),((4,4,0,2,(1,3)),200),
>                       ((4,4,0,2,(2,0)),210),((4,4,0,2,(2,1)),190),((4,4,0,2,(2,2)),80),((4,4,0,2,(2,3)),200),
>                       ((4,4,0,2,(3,0)),130),((4,4,0,2,(3,1)),20),((4,4,0,2,(3,2)),90),((4,4,0,2,(3,3)),200),
>                       
>                       ((4,4,0,3,(0,0)),200),((4,4,0,3,(0,1)),200),((4,4,0,3,(0,2)),200),((4,4,0,3,(0,3)),200),
>                       ((4,4,0,3,(1,0)),310),((4,4,0,3,(1,1)),230),((4,4,0,3,(1,2)),220),((4,4,0,3,(1,3)),200),
>                       ((4,4,0,3,(2,0)),230),((4,4,0,3,(2,1)),120),((4,4,0,3,(2,2)),190),((4,4,0,3,(2,3)),200),
>                       ((4,4,0,3,(3,0)),270),((4,4,0,3,(3,1)),150),((4,4,0,3,(3,2)),220),((4,4,0,3,(3,3)),200),
>                       
>                       
>                       ((4,4,1,0,(0,0)),250),((4,4,1,0,(0,1)),310),((4,4,1,0,(0,2)),200),((4,4,1,0,(0,3)),310),
>                       ((4,4,1,0,(1,0)),230),((4,4,1,0,(1,1)),220),((4,4,1,0,(1,2)),200),((4,4,1,0,(1,3)),220),
>                       ((4,4,1,0,(2,0)),130),((4,4,1,0,(2,1)),220),((4,4,1,0,(2,2)),200),((4,4,1,0,(2,3)),220),
>                       ((4,4,1,0,(3,0)),200),((4,4,1,0,(3,1)),200),((4,4,1,0,(3,2)),200),((4,4,1,0,(3,3)),200),
>                       
>                       ((4,4,1,1,(0,0)),240),((4,4,1,1,(0,1)),230),((4,4,1,1,(0,2)),200),((4,4,1,1,(0,3)),230),
>                       ((4,4,1,1,(1,0)),220),((4,4,1,1,(1,1)),220),((4,4,1,1,(1,2)),200),((4,4,1,1,(1,3)),220),
>                       ((4,4,1,1,(2,0)),200),((4,4,1,1,(2,1)),200),((4,4,1,1,(2,2)),200),((4,4,1,1,(2,3)),200),
>                       ((4,4,1,1,(3,0)),220),((4,4,1,1,(3,1)),220),((4,4,1,1,(3,2)),200),((4,4,1,1,(3,3)),220),
>                       
>                       ((4,4,1,2,(0,0)),130),((4,4,1,2,(0,1)),220),((4,4,1,2,(0,2)),200),((4,4,1,2,(0,3)),220),
>                       ((4,4,1,2,(1,0)),200),((4,4,1,2,(1,1)),200),((4,4,1,2,(1,2)),200),((4,4,1,2,(1,3)),200),
>                       ((4,4,1,2,(2,0)),180),((4,4,1,2,(2,1)),240),((4,4,1,2,(2,2)),200),((4,4,1,2,(2,3)),240),
>                       ((4,4,1,2,(3,0)),10),((4,4,1,2,(3,1)),100),((4,4,1,2,(3,2)),200),((4,4,1,2,(3,3)),100),
>                       
>                       ((4,4,1,3,(0,0)),200),((4,4,1,3,(0,1)),200),((4,4,1,3,(0,2)),200),((4,4,1,3,(0,3)),200),
>                       ((4,4,1,3,(1,0)),220),((4,4,1,3,(1,1)),220),((4,4,1,3,(1,2)),200),((4,4,1,3,(1,3)),220),
>                       ((4,4,1,3,(2,0)),110),((4,4,1,3,(2,1)),200),((4,4,1,3,(2,2)),200),((4,4,1,3,(2,3)),200),
>                       ((4,4,1,3,(3,0)),140),((4,4,1,3,(3,1)),140),((4,4,1,3,(3,2)),200),((4,4,1,3,(3,3)),140),
>                       
>                       
>                       ((4,4,2,0,(0,0)),150),((4,4,2,0,(0,1)),200),((4,4,2,0,(0,2)),210),((4,4,2,0,(0,3)),230),
>                       ((4,4,2,0,(1,0)),130),((4,4,2,0,(1,1)),200),((4,4,2,0,(1,2)),180),((4,4,2,0,(1,3)),110),
>                       ((4,4,2,0,(2,0)),30),((4,4,2,0,(2,1)),200),((4,4,2,0,(2,2)),80),((4,4,2,0,(2,3)),190),
>                       ((4,4,2,0,(3,0)),200),((4,4,2,0,(3,1)),200),((4,4,2,0,(3,2)),200),((4,4,2,0,(3,3)),200),
>                       
>                       ((4,4,2,1,(0,0)),140),((4,4,2,1,(0,1)),200),((4,4,2,1,(0,2)),190),((4,4,2,1,(0,3)),120),
>                       ((4,4,2,1,(1,0)),220),((4,4,2,1,(1,1)),200),((4,4,2,1,(1,2)),240),((4,4,2,1,(1,3)),200),
>                       ((4,4,2,1,(2,0)),200),((4,4,2,1,(2,1)),200),((4,4,2,1,(2,2)),200),((4,4,2,1,(2,3)),200),
>                       ((4,4,2,1,(3,0)),220),((4,4,2,1,(3,1)),200),((4,4,2,1,(3,2)),240),((4,4,2,1,(3,3)),200),
>                       
>                       ((4,4,2,2,(0,0)),30),((4,4,2,2,(0,1)),200),((4,4,2,2,(0,2)),80),((4,4,2,2,(0,3)),190),
>                       ((4,4,2,2,(1,0)),200),((4,4,2,2,(1,1)),200),((4,4,2,2,(1,2)),200),((4,4,2,2,(1,3)),200),
>                       ((4,4,2,2,(2,0)),80),((4,4,2,2,(2,1)),200),((4,4,2,2,(2,2)),140),((4,4,2,2,(2,3)),160),
>                       ((4,4,2,2,(3,0)),90),((4,4,2,2,(3,1)),200),((4,4,2,2,(3,2)),70),((4,4,2,2,(3,3)),-110),
>                       
>                       ((4,4,2,3,(0,0)),200),((4,4,2,3,(0,1)),200),((4,4,2,3,(0,2)),200),((4,4,2,3,(0,3)),200),
>                       ((4,4,2,3,(1,0)),220),((4,4,2,3,(1,1)),200),((4,4,2,3,(1,2)),240),((4,4,2,3,(1,3)),200),
>                       ((4,4,2,3,(2,0)),190),((4,4,2,3,(2,1)),200),((4,4,2,3,(2,2)),160),((4,4,2,3,(2,3)),-10),
>                       ((4,4,2,3,(3,0)),220),((4,4,2,3,(3,1)),200),((4,4,2,3,(3,2)),200),((4,4,2,3,(3,3)),200),
>                       
>                       
>                       ((4,4,3,0,(0,0)),200),((4,4,3,0,(0,1)),310),((4,4,3,0,(0,2)),130),((4,4,3,0,(0,3)),270),
>                       ((4,4,3,0,(1,0)),200),((4,4,3,0,(1,1)),220),((4,4,3,0,(1,2)),10),((4,4,3,0,(1,3)),140),
>                       ((4,4,3,0,(2,0)),200),((4,4,3,0,(2,1)),220),((4,4,3,0,(2,2)),90),((4,4,3,0,(2,3)),220),
>                       ((4,4,3,0,(3,0)),200),((4,4,3,0,(3,1)),200),((4,4,3,0,(3,2)),200),((4,4,3,0,(3,3)),200),
>                       
>                       ((4,4,3,1,(0,0)),200),((4,4,3,1,(0,1)),230),((4,4,3,1,(0,2)),20),((4,4,3,1,(0,3)),150),
>                       ((4,4,3,1,(1,0)),200),((4,4,3,1,(1,1)),220),((4,4,3,1,(1,2)),100),((4,4,3,1,(1,3)),140),
>                       ((4,4,3,1,(2,0)),200),((4,4,3,1,(2,1)),200),((4,4,3,1,(2,2)),200),((4,4,3,1,(2,3)),200),
>                       ((4,4,3,1,(3,0)),200),((4,4,3,1,(3,1)),220),((4,4,3,1,(3,2)),100),((4,4,3,1,(3,3)),140),
>                       
>                       ((4,4,3,2,(0,0)),200),((4,4,3,2,(0,1)),220),((4,4,3,2,(0,2)),90),((4,4,3,2,(0,3)),220),
>                       ((4,4,3,2,(1,0)),200),((4,4,3,2,(1,1)),200),((4,4,3,2,(1,2)),200),((4,4,3,2,(1,3)),200),
>                       ((4,4,3,2,(2,0)),200),((4,4,3,2,(2,1)),240),((4,4,3,2,(2,2)),70),((4,4,3,2,(2,3)),200),
>                       ((4,4,3,2,(3,0)),200),((4,4,3,2,(3,1)),100),((4,4,3,2,(3,2)),-210),((4,4,3,2,(3,3)),110),
>                       
>                       ((4,4,3,3,(0,0)),200),((4,4,3,3,(0,1)),200),((4,4,3,3,(0,2)),200),((4,4,3,3,(0,3)),200),
>                       ((4,4,3,3,(1,0)),200),((4,4,3,3,(1,1)),220),((4,4,3,3,(1,2)),100),((4,4,3,3,(1,3)),140),
>                       ((4,4,3,3,(2,0)),200),((4,4,3,3,(2,1)),200),((4,4,3,3,(2,2)),-110),((4,4,3,3,(2,3)),200),
>                       ((4,4,3,3,(3,0)),200),((4,4,3,3,(3,1)),140),((4,4,3,3,(3,2)),110),((4,4,3,3,(3,3)),60),
>                       
>                       
>                       
>                       ((4,5,0,0,(0,0)),280),((4,5,0,0,(0,1)),260),((4,5,0,0,(0,2)),150),((4,5,0,0,(0,3)),200),
>                       ((4,5,0,0,(1,0)),230),((4,5,0,0,(1,1)),220),((4,5,0,0,(1,2)),110),((4,5,0,0,(1,3)),200),
>                       ((4,5,0,0,(2,0)),170),((4,5,0,0,(2,1)),160),((4,5,0,0,(2,2)),50),((4,5,0,0,(2,3)),200),
>                       ((4,5,0,0,(3,0)),200),((4,5,0,0,(3,1)),200),((4,5,0,0,(3,2)),200),((4,5,0,0,(3,3)),200),
>                       
>                       ((4,5,0,1,(0,0)),280),((4,5,0,1,(0,1)),260),((4,5,0,1,(0,2)),150),((4,5,0,1,(0,3)),200),
>                       ((4,5,0,1,(1,0)),340),((4,5,0,1,(1,1)),260),((4,5,0,1,(1,2)),250),((4,5,0,1,(1,3)),200),
>                       ((4,5,0,1,(2,0)),200),((4,5,0,1,(2,1)),200),((4,5,0,1,(2,2)),200),((4,5,0,1,(2,3)),200),
>                       ((4,5,0,1,(3,0)),340),((4,5,0,1,(3,1)),260),((4,5,0,1,(3,2)),250),((4,5,0,1,(3,3)),200),
>                       
>                       ((4,5,0,2,(0,0)),170),((4,5,0,2,(0,1)),160),((4,5,0,2,(0,2)),50),((4,5,0,2,(0,3)),200),
>                       ((4,5,0,2,(1,0)),200),((4,5,0,2,(1,1)),200),((4,5,0,2,(1,2)),200),((4,5,0,2,(1,3)),200),
>                       ((4,5,0,2,(2,0)),210),((4,5,0,2,(2,1)),200),((4,5,0,2,(2,2)),90),((4,5,0,2,(2,3)),200),
>                       ((4,5,0,2,(3,0)),100),((4,5,0,2,(3,1)),-20),((4,5,0,2,(3,2)),50),((4,5,0,2,(3,3)),200),
>                       
>                       ((4,5,0,3,(0,0)),200),((4,5,0,3,(0,1)),200),((4,5,0,3,(0,2)),200),((4,5,0,3,(0,3)),200),
>                       ((4,5,0,3,(1,0)),310),((4,5,0,3,(1,1)),230),((4,5,0,3,(1,2)),220),((4,5,0,3,(1,3)),200),
>                       ((4,5,0,3,(2,0)),220),((4,5,0,3,(2,1)),110),((4,5,0,3,(2,2)),180),((4,5,0,3,(2,3)),200),
>                       ((4,5,0,3,(3,0)),290),((4,5,0,3,(3,1)),180),((4,5,0,3,(3,2)),250),((4,5,0,3,(3,3)),200),
>                       
>                       
>                       ((4,5,1,0,(0,0)),250),((4,5,1,0,(0,1)),310),((4,5,1,0,(0,2)),200),((4,5,1,0,(0,3)),310),
>                       ((4,5,1,0,(1,0)),210),((4,5,1,0,(1,1)),200),((4,5,1,0,(1,2)),200),((4,5,1,0,(1,3)),200),
>                       ((4,5,1,0,(2,0)),150),((4,5,1,0,(2,1)),240),((4,5,1,0,(2,2)),200),((4,5,1,0,(2,3)),240),
>                       ((4,5,1,0,(3,0)),200),((4,5,1,0,(3,1)),200),((4,5,1,0,(3,2)),200),((4,5,1,0,(3,3)),200),
>                       
>                       ((4,5,1,1,(0,0)),250),((4,5,1,1,(0,1)),250),((4,5,1,1,(0,2)),200),((4,5,1,1,(0,3)),250),
>                       ((4,5,1,1,(1,0)),250),((4,5,1,1,(1,1)),250),((4,5,1,1,(1,2)),200),((4,5,1,1,(1,3)),250),
>                       ((4,5,1,1,(2,0)),200),((4,5,1,1,(2,1)),200),((4,5,1,1,(2,2)),200),((4,5,1,1,(2,3)),200),
>                       ((4,5,1,1,(3,0)),250),((4,5,1,1,(3,1)),250),((4,5,1,1,(3,2)),200),((4,5,1,1,(3,3)),250),
>                       
>                       ((4,5,1,2,(0,0)),150),((4,5,1,2,(0,1)),240),((4,5,1,2,(0,2)),200),((4,5,1,2,(0,3)),240),
>                       ((4,5,1,2,(1,0)),200),((4,5,1,2,(1,1)),200),((4,5,1,2,(1,2)),200),((4,5,1,2,(1,3)),200),
>                       ((4,5,1,2,(2,0)),190),((4,5,1,2,(2,1)),240),((4,5,1,2,(2,2)),200),((4,5,1,2,(2,3)),240),
>                       ((4,5,1,2,(3,0)),-30),((4,5,1,2,(3,1)),70),((4,5,1,2,(3,2)),200),((4,5,1,2,(3,3)),70),
>                       
>                       ((4,5,1,3,(0,0)),200),((4,5,1,3,(0,1)),200),((4,5,1,3,(0,2)),200),((4,5,1,3,(0,3)),200),
>                       ((4,5,1,3,(1,0)),220),((4,5,1,3,(1,1)),220),((4,5,1,3,(1,2)),200),((4,5,1,3,(1,3)),220),
>                       ((4,5,1,3,(2,0)),100),((4,5,1,3,(2,1)),190),((4,5,1,3,(2,2)),200),((4,5,1,3,(2,3)),190),
>                       ((4,5,1,3,(3,0)),170),((4,5,1,3,(3,1)),160),((4,5,1,3,(3,2)),200),((4,5,1,3,(3,3)),160),
>                       
>                       
>                       ((4,5,2,0,(0,0)),150),((4,5,2,0,(0,1)),200),((4,5,2,0,(0,2)),210),((4,5,2,0,(0,3)),230),
>                       ((4,5,2,0,(1,0)),110),((4,5,2,0,(1,1)),200),((4,5,2,0,(1,2)),160),((4,5,2,0,(1,3)),90),
>                       ((4,5,2,0,(2,0)),50),((4,5,2,0,(2,1)),200),((4,5,2,0,(2,2)),100),((4,5,2,0,(2,3)),210),
>                       ((4,5,2,0,(3,0)),200),((4,5,2,0,(3,1)),200),((4,5,2,0,(3,2)),200),((4,5,2,0,(3,3)),200),
>                       
>                       ((4,5,2,1,(0,0)),150),((4,5,2,1,(0,1)),200),((4,5,2,1,(0,2)),210),((4,5,2,1,(0,3)),130),
>                       ((4,5,2,1,(1,0)),250),((4,5,2,1,(1,1)),200),((4,5,2,1,(1,2)),270),((4,5,2,1,(1,3)),230),
>                       ((4,5,2,1,(2,0)),200),((4,5,2,1,(2,1)),200),((4,5,2,1,(2,2)),200),((4,5,2,1,(2,3)),200),
>                       ((4,5,2,1,(3,0)),250),((4,5,2,1,(3,1)),200),((4,5,2,1,(3,2)),270),((4,5,2,1,(3,3)),230),
>                       
>                       ((4,5,2,2,(0,0)),50),((4,5,2,2,(0,1)),200),((4,5,2,2,(0,2)),100),((4,5,2,2,(0,3)),210),
>                       ((4,5,2,2,(1,0)),200),((4,5,2,2,(1,1)),200),((4,5,2,2,(1,2)),200),((4,5,2,2,(1,3)),200),
>                       ((4,5,2,2,(2,0)),90),((4,5,2,2,(2,1)),200),((4,5,2,2,(2,2)),140),((4,5,2,2,(2,3)),170),
>                       ((4,5,2,2,(3,0)),50),((4,5,2,2,(3,1)),200),((4,5,2,2,(3,2)),30),((4,5,2,2,(3,3)),-150),
>                       
>                       ((4,5,2,3,(0,0)),200),((4,5,2,3,(0,1)),200),((4,5,2,3,(0,2)),200),((4,5,2,3,(0,3)),200),
>                       ((4,5,2,3,(1,0)),220),((4,5,2,3,(1,1)),200),((4,5,2,3,(1,2)),240),((4,5,2,3,(1,3)),200),
>                       ((4,5,2,3,(2,0)),180),((4,5,2,3,(2,1)),200),((4,5,2,3,(2,2)),150),((4,5,2,3,(2,3)),-20),
>                       ((4,5,2,3,(3,0)),250),((4,5,2,3,(3,1)),200),((4,5,2,3,(3,2)),220),((4,5,2,3,(3,3)),230),
>                       
>                       
>                       ((4,5,3,0,(0,0)),200),((4,5,3,0,(0,1)),310),((4,5,3,0,(0,2)),130),((4,5,3,0,(0,3)),270),
>                       ((4,5,3,0,(1,0)),200),((4,5,3,0,(1,1)),200),((4,5,3,0,(1,2)),-10),((4,5,3,0,(1,3)),120),
>                       ((4,5,3,0,(2,0)),200),((4,5,3,0,(2,1)),240),((4,5,3,0,(2,2)),110),((4,5,3,0,(2,3)),240),
>                       ((4,5,3,0,(3,0)),200),((4,5,3,0,(3,1)),200),((4,5,3,0,(3,2)),200),((4,5,3,0,(3,3)),200),
>                       
>                       ((4,5,3,1,(0,0)),200),((4,5,3,1,(0,1)),250),((4,5,3,1,(0,2)),30),((4,5,3,1,(0,3)),170),
>                       ((4,5,3,1,(1,0)),200),((4,5,3,1,(1,1)),250),((4,5,3,1,(1,2)),130),((4,5,3,1,(1,3)),170),
>                       ((4,5,3,1,(2,0)),200),((4,5,3,1,(2,1)),200),((4,5,3,1,(2,2)),200),((4,5,3,1,(2,3)),200),
>                       ((4,5,3,1,(3,0)),200),((4,5,3,1,(3,1)),250),((4,5,3,1,(3,2)),130),((4,5,3,1,(3,3)),170),
>                       
>                       ((4,5,3,2,(0,0)),200),((4,5,3,2,(0,1)),240),((4,5,3,2,(0,2)),110),((4,5,3,2,(0,3)),240),
>                       ((4,5,3,2,(1,0)),200),((4,5,3,2,(1,1)),200),((4,5,3,2,(1,2)),200),((4,5,3,2,(1,3)),200),
>                       ((4,5,3,2,(2,0)),200),((4,5,3,2,(2,1)),240),((4,5,3,2,(2,2)),70),((4,5,3,2,(2,3)),200),
>                       ((4,5,3,2,(3,0)),200),((4,5,3,2,(3,1)),70),((4,5,3,2,(3,2)),-250),((4,5,3,2,(3,3)),70),
>                       
>                       ((4,5,3,3,(0,0)),200),((4,5,3,3,(0,1)),200),((4,5,3,3,(0,2)),200),((4,5,3,3,(0,3)),200),
>                       ((4,5,3,3,(1,0)),200),((4,5,3,3,(1,1)),220),((4,5,3,3,(1,2)),100),((4,5,3,3,(1,3)),140),
>                       ((4,5,3,3,(2,0)),200),((4,5,3,3,(2,1)),190),((4,5,3,3,(2,2)),-120),((4,5,3,3,(2,3)),190),
>                       ((4,5,3,3,(3,0)),200),((4,5,3,3,(3,1)),160),((4,5,3,3,(3,2)),130),((4,5,3,3,(3,3)),80),
>                       
>                       
>                       
>                       
>                       ((5,0,0,0,(0,0)),200),((5,0,0,0,(0,1)),200),((5,0,0,0,(0,2)),100),((5,0,0,0,(0,3)),200),
>                       ((5,0,0,0,(1,0)),190),((5,0,0,0,(1,1)),190),((5,0,0,0,(1,2)),90),((5,0,0,0,(1,3)),200),
>                       ((5,0,0,0,(2,0)),100),((5,0,0,0,(2,1)),100),((5,0,0,0,(2,2)),0),((5,0,0,0,(2,3)),200),
>                       ((5,0,0,0,(3,0)),200),((5,0,0,0,(3,1)),200),((5,0,0,0,(3,2)),200),((5,0,0,0,(3,3)),200),
>                       
>                       ((5,0,0,1,(0,0)),240),((5,0,0,1,(0,1)),240),((5,0,0,1,(0,2)),130),((5,0,0,1,(0,3)),200),
>                       ((5,0,0,1,(1,0)),280),((5,0,0,1,(1,1)),220),((5,0,0,1,(1,2)),220),((5,0,0,1,(1,3)),200),
>                       ((5,0,0,1,(2,0)),200),((5,0,0,1,(2,1)),200),((5,0,0,1,(2,2)),200),((5,0,0,1,(2,3)),200),
>                       ((5,0,0,1,(3,0)),270),((5,0,0,1,(3,1)),210),((5,0,0,1,(3,2)),200),((5,0,0,1,(3,3)),200),
>                       
>                       ((5,0,0,2,(0,0)),100),((5,0,0,2,(0,1)),100),((5,0,0,2,(0,2)),0),((5,0,0,2,(0,3)),200),
>                       ((5,0,0,2,(1,0)),200),((5,0,0,2,(1,1)),200),((5,0,0,2,(1,2)),200),((5,0,0,2,(1,3)),200),
>                       ((5,0,0,2,(2,0)),180),((5,0,0,2,(2,1)),180),((5,0,0,2,(2,2)),70),((5,0,0,2,(2,3)),200),
>                       ((5,0,0,2,(3,0)),30),((5,0,0,2,(3,1)),-70),((5,0,0,2,(3,2)),10),((5,0,0,2,(3,3)),200),
>                       
>                       ((5,0,0,3,(0,0)),200),((5,0,0,3,(0,1)),200),((5,0,0,3,(0,2)),200),((5,0,0,3,(0,3)),200),
>                       ((5,0,0,3,(1,0)),270),((5,0,0,3,(1,1)),210),((5,0,0,3,(1,2)),200),((5,0,0,3,(1,3)),200),
>                       ((5,0,0,3,(2,0)),180),((5,0,0,3,(2,1)),80),((5,0,0,3,(2,2)),160),((5,0,0,3,(2,3)),200),
>                       ((5,0,0,3,(3,0)),220),((5,0,0,3,(3,1)),120),((5,0,0,3,(3,2)),190),((5,0,0,3,(3,3)),200),
>                       
>                       
>                       ((5,0,1,0,(0,0)),160),((5,0,1,0,(0,1)),260),((5,0,1,0,(0,2)),200),((5,0,1,0,(0,3)),230),
>                       ((5,0,1,0,(1,0)),150),((5,0,1,0,(1,1)),190),((5,0,1,0,(1,2)),200),((5,0,1,0,(1,3)),160),
>                       ((5,0,1,0,(2,0)),60),((5,0,1,0,(2,1)),200),((5,0,1,0,(2,2)),200),((5,0,1,0,(2,3)),170),
>                       ((5,0,1,0,(3,0)),200),((5,0,1,0,(3,1)),200),((5,0,1,0,(3,2)),200),((5,0,1,0,(3,3)),200),
>                       
>                       ((5,0,1,1,(0,0)),190),((5,0,1,1,(0,1)),240),((5,0,1,1,(0,2)),200),((5,0,1,1,(0,3)),210),
>                       ((5,0,1,1,(1,0)),180),((5,0,1,1,(1,1)),220),((5,0,1,1,(1,2)),200),((5,0,1,1,(1,3)),190),
>                       ((5,0,1,1,(2,0)),200),((5,0,1,1,(2,1)),200),((5,0,1,1,(2,2)),200),((5,0,1,1,(2,3)),200),
>                       ((5,0,1,1,(3,0)),160),((5,0,1,1,(3,1)),210),((5,0,1,1,(3,2)),200),((5,0,1,1,(3,3)),180),
>                       
>                       ((5,0,1,2,(0,0)),60),((5,0,1,2,(0,1)),200),((5,0,1,2,(0,2)),200),((5,0,1,2,(0,3)),170),
>                       ((5,0,1,2,(1,0)),200),((5,0,1,2,(1,1)),200),((5,0,1,2,(1,2)),200),((5,0,1,2,(1,3)),200),
>                       ((5,0,1,2,(2,0)),130),((5,0,1,2,(2,1)),240),((5,0,1,2,(2,2)),200),((5,0,1,2,(2,3)),210),
>                       ((5,0,1,2,(3,0)),-110),((5,0,1,2,(3,1)),30),((5,0,1,2,(3,2)),200),((5,0,1,2,(3,3)),0),
>                       
>                       ((5,0,1,3,(0,0)),200),((5,0,1,3,(0,1)),200),((5,0,1,3,(0,2)),200),((5,0,1,3,(0,3)),200),
>                       ((5,0,1,3,(1,0)),160),((5,0,1,3,(1,1)),210),((5,0,1,3,(1,2)),200),((5,0,1,3,(1,3)),180),
>                       ((5,0,1,3,(2,0)),40),((5,0,1,3,(2,1)),180),((5,0,1,3,(2,2)),200),((5,0,1,3,(2,3)),150),
>                       ((5,0,1,3,(3,0)),70),((5,0,1,3,(3,1)),120),((5,0,1,3,(3,2)),200),((5,0,1,3,(3,3)),90),
>                       
>                       
>                       ((5,0,2,0,(0,0)),100),((5,0,2,0,(0,1)),200),((5,0,2,0,(0,2)),140),((5,0,2,0,(0,3)),150),
>                       ((5,0,2,0,(1,0)),90),((5,0,2,0,(1,1)),200),((5,0,2,0,(1,2)),130),((5,0,2,0,(1,3)),40),
>                       ((5,0,2,0,(2,0)),0),((5,0,2,0,(2,1)),200),((5,0,2,0,(2,2)),40),((5,0,2,0,(2,3)),130),
>                       ((5,0,2,0,(3,0)),200),((5,0,2,0,(3,1)),200),((5,0,2,0,(3,2)),200),((5,0,2,0,(3,3)),200),
>                       
>                       ((5,0,2,1,(0,0)),130),((5,0,2,1,(0,1)),200),((5,0,2,1,(0,2)),170),((5,0,2,1,(0,3)),80),
>                       ((5,0,2,1,(1,0)),220),((5,0,2,1,(1,1)),200),((5,0,2,1,(1,2)),220),((5,0,2,1,(1,3)),170),
>                       ((5,0,2,1,(2,0)),200),((5,0,2,1,(2,1)),200),((5,0,2,1,(2,2)),200),((5,0,2,1,(2,3)),200),
>                       ((5,0,2,1,(3,0)),200),((5,0,2,1,(3,1)),200),((5,0,2,1,(3,2)),200),((5,0,2,1,(3,3)),150),
>                       
>                       ((5,0,2,2,(0,0)),0),((5,0,2,2,(0,1)),200),((5,0,2,2,(0,2)),40),((5,0,2,2,(0,3)),130),
>                       ((5,0,2,2,(1,0)),200),((5,0,2,2,(1,1)),200),((5,0,2,2,(1,2)),200),((5,0,2,2,(1,3)),200),
>                       ((5,0,2,2,(2,0)),70),((5,0,2,2,(2,1)),200),((5,0,2,2,(2,2)),110),((5,0,2,2,(2,3)),120),
>                       ((5,0,2,2,(3,0)),10),((5,0,2,2,(3,1)),200),((5,0,2,2,(3,2)),-30),((5,0,2,2,(3,3)),-220),
>                       
>                       ((5,0,2,3,(0,0)),200),((5,0,2,3,(0,1)),200),((5,0,2,3,(0,2)),200),((5,0,2,3,(0,3)),200),
>                       ((5,0,2,3,(1,0)),200),((5,0,2,3,(1,1)),200),((5,0,2,3,(1,2)),200),((5,0,2,3,(1,3)),150),
>                       ((5,0,2,3,(2,0)),160),((5,0,2,3,(2,1)),200),((5,0,2,3,(2,2)),120),((5,0,2,3,(2,3)),-70),
>                       ((5,0,2,3,(3,0)),190),((5,0,2,3,(3,1)),200),((5,0,2,3,(3,2)),150),((5,0,2,3,(3,3)),150),
>                       
>                       
>                       ((5,0,3,0,(0,0)),200),((5,0,3,0,(0,1)),260),((5,0,3,0,(0,2)),20),((5,0,3,0,(0,3)),220),
>                       ((5,0,3,0,(1,0)),200),((5,0,3,0,(1,1)),190),((5,0,3,0,(1,2)),-90),((5,0,3,0,(1,3)),110),
>                       ((5,0,3,0,(2,0)),200),((5,0,3,0,(2,1)),200),((5,0,3,0,(2,2)),0),((5,0,3,0,(2,3)),200),
>                       ((5,0,3,0,(3,0)),200),((5,0,3,0,(3,1)),200),((5,0,3,0,(3,2)),200),((5,0,3,0,(3,3)),200),
>                       
>                       ((5,0,3,1,(0,0)),200),((5,0,3,1,(0,1)),240),((5,0,3,1,(0,2)),-40),((5,0,3,1,(0,3)),150),
>                       ((5,0,3,1,(1,0)),200),((5,0,3,1,(1,1)),220),((5,0,3,1,(1,2)),40),((5,0,3,1,(1,3)),140),
>                       ((5,0,3,1,(2,0)),200),((5,0,3,1,(2,1)),200),((5,0,3,1,(2,2)),200),((5,0,3,1,(2,3)),200),
>                       ((5,0,3,1,(3,0)),200),((5,0,3,1,(3,1)),210),((5,0,3,1,(3,2)),30),((5,0,3,1,(3,3)),120),
>                       
>                       ((5,0,3,2,(0,0)),200),((5,0,3,2,(0,1)),200),((5,0,3,2,(0,2)),0),((5,0,3,2,(0,3)),200),
>                       ((5,0,3,2,(1,0)),200),((5,0,3,2,(1,1)),200),((5,0,3,2,(1,2)),200),((5,0,3,2,(1,3)),200),
>                       ((5,0,3,2,(2,0)),200),((5,0,3,2,(2,1)),240),((5,0,3,2,(2,2)),0),((5,0,3,2,(2,3)),190),
>                       ((5,0,3,2,(3,0)),200),((5,0,3,2,(3,1)),30),((5,0,3,2,(3,2)),-350),((5,0,3,2,(3,3)),30),
>                       
>                       ((5,0,3,3,(0,0)),200),((5,0,3,3,(0,1)),200),((5,0,3,3,(0,2)),200),((5,0,3,3,(0,3)),200),
>                       ((5,0,3,3,(1,0)),200),((5,0,3,3,(1,1)),210),((5,0,3,3,(1,2)),30),((5,0,3,3,(1,3)),120),
>                       ((5,0,3,3,(2,0)),200),((5,0,3,3,(2,1)),180),((5,0,3,3,(2,2)),-200),((5,0,3,3,(2,3)),180),
>                       ((5,0,3,3,(3,0)),200),((5,0,3,3,(3,1)),120),((5,0,3,3,(3,2)),20),((5,0,3,3,(3,3)),30),
>                       
>                       
>                       
>                       ((5,1,0,0,(0,0)),210),((5,1,0,0,(0,1)),210),((5,1,0,0,(0,2)),110),((5,1,0,0,(0,3)),200),
>                       ((5,1,0,0,(1,0)),190),((5,1,0,0,(1,1)),190),((5,1,0,0,(1,2)),80),((5,1,0,0,(1,3)),200),
>                       ((5,1,0,0,(2,0)),10),((5,1,0,0,(2,1)),10),((5,1,0,0,(2,2)),-90),((5,1,0,0,(2,3)),200),
>                       ((5,1,0,0,(3,0)),200),((5,1,0,0,(3,1)),200),((5,1,0,0,(3,2)),200),((5,1,0,0,(3,3)),200),
>                       
>                       ((5,1,0,1,(0,0)),180),((5,1,0,1,(0,1)),180),((5,1,0,1,(0,2)),80),((5,1,0,1,(0,3)),200),
>                       ((5,1,0,1,(1,0)),250),((5,1,0,1,(1,1)),190),((5,1,0,1,(1,2)),180),((5,1,0,1,(1,3)),200),
>                       ((5,1,0,1,(2,0)),200),((5,1,0,1,(2,1)),200),((5,1,0,1,(2,2)),200),((5,1,0,1,(2,3)),200),
>                       ((5,1,0,1,(3,0)),150),((5,1,0,1,(3,1)),90),((5,1,0,1,(3,2)),90),((5,1,0,1,(3,3)),200),
>                       
>                       ((5,1,0,2,(0,0)),70),((5,1,0,2,(0,1)),70),((5,1,0,2,(0,2)),-30),((5,1,0,2,(0,3)),200),
>                       ((5,1,0,2,(1,0)),200),((5,1,0,2,(1,1)),200),((5,1,0,2,(1,2)),200),((5,1,0,2,(1,3)),200),
>                       ((5,1,0,2,(2,0)),180),((5,1,0,2,(2,1)),180),((5,1,0,2,(2,2)),70),((5,1,0,2,(2,3)),200),
>                       ((5,1,0,2,(3,0)),0),((5,1,0,2,(3,1)),-100),((5,1,0,2,(3,2)),-30),((5,1,0,2,(3,3)),200),
>                       
>                       ((5,1,0,3,(0,0)),200),((5,1,0,3,(0,1)),200),((5,1,0,3,(0,2)),200),((5,1,0,3,(0,3)),200),
>                       ((5,1,0,3,(1,0)),250),((5,1,0,3,(1,1)),190),((5,1,0,3,(1,2)),190),((5,1,0,3,(1,3)),200),
>                       ((5,1,0,3,(2,0)),40),((5,1,0,3,(2,1)),-60),((5,1,0,3,(2,2)),10),((5,1,0,3,(2,3)),200),
>                       ((5,1,0,3,(3,0)),210),((5,1,0,3,(3,1)),110),((5,1,0,3,(3,2)),190),((5,1,0,3,(3,3)),200),
>                       
>                       
>                       ((5,1,1,0,(0,0)),170),((5,1,1,0,(0,1)),270),((5,1,1,0,(0,2)),200),((5,1,1,0,(0,3)),240),
>                       ((5,1,1,0,(1,0)),140),((5,1,1,0,(1,1)),190),((5,1,1,0,(1,2)),200),((5,1,1,0,(1,3)),160),
>                       ((5,1,1,0,(2,0)),-30),((5,1,1,0,(2,1)),110),((5,1,1,0,(2,2)),200),((5,1,1,0,(2,3)),80),
>                       ((5,1,1,0,(3,0)),200),((5,1,1,0,(3,1)),200),((5,1,1,0,(3,2)),200),((5,1,1,0,(3,3)),200),
>                       
>                       ((5,1,1,1,(0,0)),140),((5,1,1,1,(0,1)),180),((5,1,1,1,(0,2)),200),((5,1,1,1,(0,3)),150),
>                       ((5,1,1,1,(1,0)),140),((5,1,1,1,(1,1)),190),((5,1,1,1,(1,2)),200),((5,1,1,1,(1,3)),160),
>                       ((5,1,1,1,(2,0)),200),((5,1,1,1,(2,1)),200),((5,1,1,1,(2,2)),200),((5,1,1,1,(2,3)),200),
>                       ((5,1,1,1,(3,0)),40),((5,1,1,1,(3,1)),90),((5,1,1,1,(3,2)),200),((5,1,1,1,(3,3)),60),
>                       
>                       ((5,1,1,2,(0,0)),30),((5,1,1,2,(0,1)),170),((5,1,1,2,(0,2)),200),((5,1,1,2,(0,3)),140),
>                       ((5,1,1,2,(1,0)),200),((5,1,1,2,(1,1)),200),((5,1,1,2,(1,2)),200),((5,1,1,2,(1,3)),200),
>                       ((5,1,1,2,(2,0)),130),((5,1,1,2,(2,1)),240),((5,1,1,2,(2,2)),200),((5,1,1,2,(2,3)),210),
>                       ((5,1,1,2,(3,0)),-150),((5,1,1,2,(3,1)),0),((5,1,1,2,(3,2)),200),((5,1,1,2,(3,3)),-30),
>                       
>                       ((5,1,1,3,(0,0)),200),((5,1,1,3,(0,1)),200),((5,1,1,3,(0,2)),200),((5,1,1,3,(0,3)),200),
>                       ((5,1,1,3,(1,0)),150),((5,1,1,3,(1,1)),190),((5,1,1,3,(1,2)),200),((5,1,1,3,(1,3)),160),
>                       ((5,1,1,3,(2,0)),-110),((5,1,1,3,(2,1)),40),((5,1,1,3,(2,2)),200),((5,1,1,3,(2,3)),10),
>                       ((5,1,1,3,(3,0)),70),((5,1,1,3,(3,1)),110),((5,1,1,3,(3,2)),200),((5,1,1,3,(3,3)),80),
>                       
>                       
>                       ((5,1,2,0,(0,0)),110),((5,1,2,0,(0,1)),200),((5,1,2,0,(0,2)),150),((5,1,2,0,(0,3)),160),
>                       ((5,1,2,0,(1,0)),80),((5,1,2,0,(1,1)),200),((5,1,2,0,(1,2)),120),((5,1,2,0,(1,3)),30),
>                       ((5,1,2,0,(2,0)),-90),((5,1,2,0,(2,1)),200),((5,1,2,0,(2,2)),-50),((5,1,2,0,(2,3)),40),
>                       ((5,1,2,0,(3,0)),200),((5,1,2,0,(3,1)),200),((5,1,2,0,(3,2)),200),((5,1,2,0,(3,3)),200),
>                       
>                       ((5,1,2,1,(0,0)),80),((5,1,2,1,(0,1)),200),((5,1,2,1,(0,2)),120),((5,1,2,1,(0,3)),30),
>                       ((5,1,2,1,(1,0)),180),((5,1,2,1,(1,1)),200),((5,1,2,1,(1,2)),180),((5,1,2,1,(1,3)),130),
>                       ((5,1,2,1,(2,0)),200),((5,1,2,1,(2,1)),200),((5,1,2,1,(2,2)),200),((5,1,2,1,(2,3)),200),
>                       ((5,1,2,1,(3,0)),90),((5,1,2,1,(3,1)),200),((5,1,2,1,(3,2)),80),((5,1,2,1,(3,3)),40),
>                       
>                       ((5,1,2,2,(0,0)),-30),((5,1,2,2,(0,1)),200),((5,1,2,2,(0,2)),10),((5,1,2,2,(0,3)),100),
>                       ((5,1,2,2,(1,0)),200),((5,1,2,2,(1,1)),200),((5,1,2,2,(1,2)),200),((5,1,2,2,(1,3)),200),
>                       ((5,1,2,2,(2,0)),70),((5,1,2,2,(2,1)),200),((5,1,2,2,(2,2)),110),((5,1,2,2,(2,3)),120),
>                       ((5,1,2,2,(3,0)),-30),((5,1,2,2,(3,1)),200),((5,1,2,2,(3,2)),-70),((5,1,2,2,(3,3)),-260),
>                       
>                       ((5,1,2,3,(0,0)),200),((5,1,2,3,(0,1)),200),((5,1,2,3,(0,2)),200),((5,1,2,3,(0,3)),200),
>                       ((5,1,2,3,(1,0)),190),((5,1,2,3,(1,1)),200),((5,1,2,3,(1,2)),190),((5,1,2,3,(1,3)),140),
>                       ((5,1,2,3,(2,0)),10),((5,1,2,3,(2,1)),200),((5,1,2,3,(2,2)),-30),((5,1,2,3,(2,3)),-220),
>                       ((5,1,2,3,(3,0)),190),((5,1,2,3,(3,1)),200),((5,1,2,3,(3,2)),150),((5,1,2,3,(3,3)),140),
>                       
>                       
>                       ((5,1,3,0,(0,0)),200),((5,1,3,0,(0,1)),270),((5,1,3,0,(0,2)),30),((5,1,3,0,(0,3)),230),
>                       ((5,1,3,0,(1,0)),200),((5,1,3,0,(1,1)),190),((5,1,3,0,(1,2)),-90),((5,1,3,0,(1,3)),100),
>                       ((5,1,3,0,(2,0)),200),((5,1,3,0,(2,1)),110),((5,1,3,0,(2,2)),-90),((5,1,3,0,(2,3)),110),
>                       ((5,1,3,0,(3,0)),200),((5,1,3,0,(3,1)),200),((5,1,3,0,(3,2)),200),((5,1,3,0,(3,3)),200),
>                       
>                       ((5,1,3,1,(0,0)),200),((5,1,3,1,(0,1)),180),((5,1,3,1,(0,2)),-100),((5,1,3,1,(0,3)),100),
>                       ((5,1,3,1,(1,0)),200),((5,1,3,1,(1,1)),190),((5,1,3,1,(1,2)),10),((5,1,3,1,(1,3)),100),
>                       ((5,1,3,1,(2,0)),200),((5,1,3,1,(2,1)),200),((5,1,3,1,(2,2)),200),((5,1,3,1,(2,3)),200),
>                       ((5,1,3,1,(3,0)),200),((5,1,3,1,(3,1)),90),((5,1,3,1,(3,2)),-90),((5,1,3,1,(3,3)),0),
>                       
>                       ((5,1,3,2,(0,0)),200),((5,1,3,2,(0,1)),170),((5,1,3,2,(0,2)),-30),((5,1,3,2,(0,3)),170),
>                       ((5,1,3,2,(1,0)),200),((5,1,3,2,(1,1)),200),((5,1,3,2,(1,2)),200),((5,1,3,2,(1,3)),200),
>                       ((5,1,3,2,(2,0)),200),((5,1,3,2,(2,1)),240),((5,1,3,2,(2,2)),0),((5,1,3,2,(2,3)),190),
>                       ((5,1,3,2,(3,0)),200),((5,1,3,2,(3,1)),0),((5,1,3,2,(3,2)),-390),((5,1,3,2,(3,3)),-10),
>                       
>                       ((5,1,3,3,(0,0)),200),((5,1,3,3,(0,1)),200),((5,1,3,3,(0,2)),200),((5,1,3,3,(0,3)),200),
>                       ((5,1,3,3,(1,0)),200),((5,1,3,3,(1,1)),190),((5,1,3,3,(1,2)),10),((5,1,3,3,(1,3)),110),
>                       ((5,1,3,3,(2,0)),200),((5,1,3,3,(2,1)),40),((5,1,3,3,(2,2)),-350),((5,1,3,3,(2,3)),30),
>                       ((5,1,3,3,(3,0)),200),((5,1,3,3,(3,1)),110),((5,1,3,3,(3,2)),10),((5,1,3,3,(3,3)),30),
>                       
>                       
>                       
>                       ((5,2,0,0,(0,0)),280),((5,2,0,0,(0,1)),280),((5,2,0,0,(0,2)),170),((5,2,0,0,(0,3)),200),
>                       ((5,2,0,0,(1,0)),250),((5,2,0,0,(1,1)),250),((5,2,0,0,(1,2)),150),((5,2,0,0,(1,3)),200),
>                       ((5,2,0,0,(2,0)),150),((5,2,0,0,(2,1)),150),((5,2,0,0,(2,2)),50),((5,2,0,0,(2,3)),200),
>                       ((5,2,0,0,(3,0)),200),((5,2,0,0,(3,1)),200),((5,2,0,0,(3,2)),200),((5,2,0,0,(3,3)),200),
>                       
>                       ((5,2,0,1,(0,0)),260),((5,2,0,1,(0,1)),260),((5,2,0,1,(0,2)),160),((5,2,0,1,(0,3)),200),
>                       ((5,2,0,1,(1,0)),310),((5,2,0,1,(1,1)),250),((5,2,0,1,(1,2)),240),((5,2,0,1,(1,3)),200),
>                       ((5,2,0,1,(2,0)),200),((5,2,0,1,(2,1)),200),((5,2,0,1,(2,2)),200),((5,2,0,1,(2,3)),200),
>                       ((5,2,0,1,(3,0)),310),((5,2,0,1,(3,1)),250),((5,2,0,1,(3,2)),240),((5,2,0,1,(3,3)),200),
>                       
>                       ((5,2,0,2,(0,0)),150),((5,2,0,2,(0,1)),150),((5,2,0,2,(0,2)),50),((5,2,0,2,(0,3)),200),
>                       ((5,2,0,2,(1,0)),200),((5,2,0,2,(1,1)),200),((5,2,0,2,(1,2)),200),((5,2,0,2,(1,3)),200),
>                       ((5,2,0,2,(2,0)),210),((5,2,0,2,(2,1)),210),((5,2,0,2,(2,2)),100),((5,2,0,2,(2,3)),200),
>                       ((5,2,0,2,(3,0)),130),((5,2,0,2,(3,1)),30),((5,2,0,2,(3,2)),110),((5,2,0,2,(3,3)),200),
>                       
>                       ((5,2,0,3,(0,0)),200),((5,2,0,3,(0,1)),200),((5,2,0,3,(0,2)),200),((5,2,0,3,(0,3)),200),
>                       ((5,2,0,3,(1,0)),310),((5,2,0,3,(1,1)),250),((5,2,0,3,(1,2)),240),((5,2,0,3,(1,3)),200),
>                       ((5,2,0,3,(2,0)),230),((5,2,0,3,(2,1)),130),((5,2,0,3,(2,2)),210),((5,2,0,3,(2,3)),200),
>                       ((5,2,0,3,(3,0)),270),((5,2,0,3,(3,1)),170),((5,2,0,3,(3,2)),240),((5,2,0,3,(3,3)),200),
>                       
>                       
>                       ((5,2,1,0,(0,0)),230),((5,2,1,0,(0,1)),340),((5,2,1,0,(0,2)),200),((5,2,1,0,(0,3)),310),
>                       ((5,2,1,0,(1,0)),210),((5,2,1,0,(1,1)),250),((5,2,1,0,(1,2)),200),((5,2,1,0,(1,3)),220),
>                       ((5,2,1,0,(2,0)),110),((5,2,1,0,(2,1)),250),((5,2,1,0,(2,2)),200),((5,2,1,0,(2,3)),220),
>                       ((5,2,1,0,(3,0)),200),((5,2,1,0,(3,1)),200),((5,2,1,0,(3,2)),200),((5,2,1,0,(3,3)),200),
>                       
>                       ((5,2,1,1,(0,0)),220),((5,2,1,1,(0,1)),260),((5,2,1,1,(0,2)),200),((5,2,1,1,(0,3)),230),
>                       ((5,2,1,1,(1,0)),200),((5,2,1,1,(1,1)),250),((5,2,1,1,(1,2)),200),((5,2,1,1,(1,3)),220),
>                       ((5,2,1,1,(2,0)),200),((5,2,1,1,(2,1)),200),((5,2,1,1,(2,2)),200),((5,2,1,1,(2,3)),200),
>                       ((5,2,1,1,(3,0)),200),((5,2,1,1,(3,1)),250),((5,2,1,1,(3,2)),200),((5,2,1,1,(3,3)),220),
>                       
>                       ((5,2,1,2,(0,0)),110),((5,2,1,2,(0,1)),250),((5,2,1,2,(0,2)),200),((5,2,1,2,(0,3)),220),
>                       ((5,2,1,2,(1,0)),200),((5,2,1,2,(1,1)),200),((5,2,1,2,(1,2)),200),((5,2,1,2,(1,3)),200),
>                       ((5,2,1,2,(2,0)),160),((5,2,1,2,(2,1)),270),((5,2,1,2,(2,2)),200),((5,2,1,2,(2,3)),240),
>                       ((5,2,1,2,(3,0)),-10),((5,2,1,2,(3,1)),130),((5,2,1,2,(3,2)),200),((5,2,1,2,(3,3)),100),
>                       
>                       ((5,2,1,3,(0,0)),200),((5,2,1,3,(0,1)),200),((5,2,1,3,(0,2)),200),((5,2,1,3,(0,3)),200),
>                       ((5,2,1,3,(1,0)),200),((5,2,1,3,(1,1)),250),((5,2,1,3,(1,2)),200),((5,2,1,3,(1,3)),220),
>                       ((5,2,1,3,(2,0)),90),((5,2,1,3,(2,1)),230),((5,2,1,3,(2,2)),200),((5,2,1,3,(2,3)),200),
>                       ((5,2,1,3,(3,0)),120),((5,2,1,3,(3,1)),170),((5,2,1,3,(3,2)),200),((5,2,1,3,(3,3)),140),
>                       
>                       
>                       ((5,2,2,0,(0,0)),170),((5,2,2,0,(0,1)),200),((5,2,2,0,(0,2)),210),((5,2,2,0,(0,3)),220),
>                       ((5,2,2,0,(1,0)),150),((5,2,2,0,(1,1)),200),((5,2,2,0,(1,2)),190),((5,2,2,0,(1,3)),100),
>                       ((5,2,2,0,(2,0)),50),((5,2,2,0,(2,1)),200),((5,2,2,0,(2,2)),90),((5,2,2,0,(2,3)),180),
>                       ((5,2,2,0,(3,0)),200),((5,2,2,0,(3,1)),200),((5,2,2,0,(3,2)),200),((5,2,2,0,(3,3)),200),
>                       
>                       ((5,2,2,1,(0,0)),160),((5,2,2,1,(0,1)),200),((5,2,2,1,(0,2)),200),((5,2,2,1,(0,3)),110),
>                       ((5,2,2,1,(1,0)),240),((5,2,2,1,(1,1)),200),((5,2,2,1,(1,2)),240),((5,2,2,1,(1,3)),190),
>                       ((5,2,2,1,(2,0)),200),((5,2,2,1,(2,1)),200),((5,2,2,1,(2,2)),200),((5,2,2,1,(2,3)),200),
>                       ((5,2,2,1,(3,0)),240),((5,2,2,1,(3,1)),200),((5,2,2,1,(3,2)),240),((5,2,2,1,(3,3)),190),
>                       
>                       ((5,2,2,2,(0,0)),50),((5,2,2,2,(0,1)),200),((5,2,2,2,(0,2)),90),((5,2,2,2,(0,3)),180),
>                       ((5,2,2,2,(1,0)),200),((5,2,2,2,(1,1)),200),((5,2,2,2,(1,2)),200),((5,2,2,2,(1,3)),200),
>                       ((5,2,2,2,(2,0)),100),((5,2,2,2,(2,1)),200),((5,2,2,2,(2,2)),140),((5,2,2,2,(2,3)),150),
>                       ((5,2,2,2,(3,0)),110),((5,2,2,2,(3,1)),200),((5,2,2,2,(3,2)),70),((5,2,2,2,(3,3)),-120),
>                       
>                       ((5,2,2,3,(0,0)),200),((5,2,2,3,(0,1)),200),((5,2,2,3,(0,2)),200),((5,2,2,3,(0,3)),200),
>                       ((5,2,2,3,(1,0)),240),((5,2,2,3,(1,1)),200),((5,2,2,3,(1,2)),240),((5,2,2,3,(1,3)),190),
>                       ((5,2,2,3,(2,0)),210),((5,2,2,3,(2,1)),200),((5,2,2,3,(2,2)),170),((5,2,2,3,(2,3)),-20),
>                       ((5,2,2,3,(3,0)),240),((5,2,2,3,(3,1)),200),((5,2,2,3,(3,2)),200),((5,2,2,3,(3,3)),190),
>                       
>                       
>                       ((5,2,3,0,(0,0)),200),((5,2,3,0,(0,1)),340),((5,2,3,0,(0,2)),100),((5,2,3,0,(0,3)),290),
>                       ((5,2,3,0,(1,0)),200),((5,2,3,0,(1,1)),250),((5,2,3,0,(1,2)),-30),((5,2,3,0,(1,3)),170),
>                       ((5,2,3,0,(2,0)),200),((5,2,3,0,(2,1)),250),((5,2,3,0,(2,2)),50),((5,2,3,0,(2,3)),250),
>                       ((5,2,3,0,(3,0)),200),((5,2,3,0,(3,1)),200),((5,2,3,0,(3,2)),200),((5,2,3,0,(3,3)),200),
>                       
>                       ((5,2,3,1,(0,0)),200),((5,2,3,1,(0,1)),260),((5,2,3,1,(0,2)),-20),((5,2,3,1,(0,3)),180),
>                       ((5,2,3,1,(1,0)),200),((5,2,3,1,(1,1)),250),((5,2,3,1,(1,2)),70),((5,2,3,1,(1,3)),160),
>                       ((5,2,3,1,(2,0)),200),((5,2,3,1,(2,1)),200),((5,2,3,1,(2,2)),200),((5,2,3,1,(2,3)),200),
>                       ((5,2,3,1,(3,0)),200),((5,2,3,1,(3,1)),250),((5,2,3,1,(3,2)),70),((5,2,3,1,(3,3)),160),
>                       
>                       ((5,2,3,2,(0,0)),200),((5,2,3,2,(0,1)),250),((5,2,3,2,(0,2)),50),((5,2,3,2,(0,3)),250),
>                       ((5,2,3,2,(1,0)),200),((5,2,3,2,(1,1)),200),((5,2,3,2,(1,2)),200),((5,2,3,2,(1,3)),200),
>                       ((5,2,3,2,(2,0)),200),((5,2,3,2,(2,1)),270),((5,2,3,2,(2,2)),30),((5,2,3,2,(2,3)),220),
>                       ((5,2,3,2,(3,0)),200),((5,2,3,2,(3,1)),130),((5,2,3,2,(3,2)),-250),((5,2,3,2,(3,3)),130),
>                       
>                       ((5,2,3,3,(0,0)),200),((5,2,3,3,(0,1)),200),((5,2,3,3,(0,2)),200),((5,2,3,3,(0,3)),200),
>                       ((5,2,3,3,(1,0)),200),((5,2,3,3,(1,1)),250),((5,2,3,3,(1,2)),70),((5,2,3,3,(1,3)),160),
>                       ((5,2,3,3,(2,0)),200),((5,2,3,3,(2,1)),230),((5,2,3,3,(2,2)),-150),((5,2,3,3,(2,3)),230),
>                       ((5,2,3,3,(3,0)),200),((5,2,3,3,(3,1)),170),((5,2,3,3,(3,2)),70),((5,2,3,3,(3,3)),80),
>                       
>                       
>                       
>                       ((5,3,0,0,(0,0)),280),((5,3,0,0,(0,1)),280),((5,3,0,0,(0,2)),170),((5,3,0,0,(0,3)),200),
>                       ((5,3,0,0,(1,0)),230),((5,3,0,0,(1,1)),230),((5,3,0,0,(1,2)),130),((5,3,0,0,(1,3)),200),
>                       ((5,3,0,0,(2,0)),170),((5,3,0,0,(2,1)),170),((5,3,0,0,(2,2)),70),((5,3,0,0,(2,3)),200),
>                       ((5,3,0,0,(3,0)),200),((5,3,0,0,(3,1)),200),((5,3,0,0,(3,2)),200),((5,3,0,0,(3,3)),200),
>                       
>                       ((5,3,0,1,(0,0)),280),((5,3,0,1,(0,1)),280),((5,3,0,1,(0,2)),170),((5,3,0,1,(0,3)),200),
>                       ((5,3,0,1,(1,0)),340),((5,3,0,1,(1,1)),280),((5,3,0,1,(1,2)),270),((5,3,0,1,(1,3)),200),
>                       ((5,3,0,1,(2,0)),200),((5,3,0,1,(2,1)),200),((5,3,0,1,(2,2)),200),((5,3,0,1,(2,3)),200),
>                       ((5,3,0,1,(3,0)),340),((5,3,0,1,(3,1)),280),((5,3,0,1,(3,2)),270),((5,3,0,1,(3,3)),200),
>                       
>                       ((5,3,0,2,(0,0)),170),((5,3,0,2,(0,1)),170),((5,3,0,2,(0,2)),70),((5,3,0,2,(0,3)),200),
>                       ((5,3,0,2,(1,0)),200),((5,3,0,2,(1,1)),200),((5,3,0,2,(1,2)),200),((5,3,0,2,(1,3)),200),
>                       ((5,3,0,2,(2,0)),210),((5,3,0,2,(2,1)),210),((5,3,0,2,(2,2)),110),((5,3,0,2,(2,3)),200),
>                       ((5,3,0,2,(3,0)),100),((5,3,0,2,(3,1)),0),((5,3,0,2,(3,2)),70),((5,3,0,2,(3,3)),200),
>                       
>                       ((5,3,0,3,(0,0)),200),((5,3,0,3,(0,1)),200),((5,3,0,3,(0,2)),200),((5,3,0,3,(0,3)),200),
>                       ((5,3,0,3,(1,0)),310),((5,3,0,3,(1,1)),250),((5,3,0,3,(1,2)),240),((5,3,0,3,(1,3)),200),
>                       ((5,3,0,3,(2,0)),220),((5,3,0,3,(2,1)),120),((5,3,0,3,(2,2)),200),((5,3,0,3,(2,3)),200),
>                       ((5,3,0,3,(3,0)),290),((5,3,0,3,(3,1)),190),((5,3,0,3,(3,2)),270),((5,3,0,3,(3,3)),200),
>                       
>                       
>                       ((5,3,1,0,(0,0)),230),((5,3,1,0,(0,1)),340),((5,3,1,0,(0,2)),200),((5,3,1,0,(0,3)),310),
>                       ((5,3,1,0,(1,0)),190),((5,3,1,0,(1,1)),230),((5,3,1,0,(1,2)),200),((5,3,1,0,(1,3)),200),
>                       ((5,3,1,0,(2,0)),130),((5,3,1,0,(2,1)),270),((5,3,1,0,(2,2)),200),((5,3,1,0,(2,3)),240),
>                       ((5,3,1,0,(3,0)),200),((5,3,1,0,(3,1)),200),((5,3,1,0,(3,2)),200),((5,3,1,0,(3,3)),200),
>                       
>                       ((5,3,1,1,(0,0)),230),((5,3,1,1,(0,1)),280),((5,3,1,1,(0,2)),200),((5,3,1,1,(0,3)),250),
>                       ((5,3,1,1,(1,0)),230),((5,3,1,1,(1,1)),280),((5,3,1,1,(1,2)),200),((5,3,1,1,(1,3)),250),
>                       ((5,3,1,1,(2,0)),200),((5,3,1,1,(2,1)),200),((5,3,1,1,(2,2)),200),((5,3,1,1,(2,3)),200),
>                       ((5,3,1,1,(3,0)),230),((5,3,1,1,(3,1)),280),((5,3,1,1,(3,2)),200),((5,3,1,1,(3,3)),250),
>                       
>                       ((5,3,1,2,(0,0)),130),((5,3,1,2,(0,1)),270),((5,3,1,2,(0,2)),200),((5,3,1,2,(0,3)),240),
>                       ((5,3,1,2,(1,0)),200),((5,3,1,2,(1,1)),200),((5,3,1,2,(1,2)),200),((5,3,1,2,(1,3)),200),
>                       ((5,3,1,2,(2,0)),170),((5,3,1,2,(2,1)),270),((5,3,1,2,(2,2)),200),((5,3,1,2,(2,3)),240),
>                       ((5,3,1,2,(3,0)),-50),((5,3,1,2,(3,1)),100),((5,3,1,2,(3,2)),200),((5,3,1,2,(3,3)),70),
>                       
>                       ((5,3,1,3,(0,0)),200),((5,3,1,3,(0,1)),200),((5,3,1,3,(0,2)),200),((5,3,1,3,(0,3)),200),
>                       ((5,3,1,3,(1,0)),200),((5,3,1,3,(1,1)),250),((5,3,1,3,(1,2)),200),((5,3,1,3,(1,3)),220),
>                       ((5,3,1,3,(2,0)),80),((5,3,1,3,(2,1)),220),((5,3,1,3,(2,2)),200),((5,3,1,3,(2,3)),190),
>                       ((5,3,1,3,(3,0)),150),((5,3,1,3,(3,1)),190),((5,3,1,3,(3,2)),200),((5,3,1,3,(3,3)),160),
>                       
>                       
>                       ((5,3,2,0,(0,0)),170),((5,3,2,0,(0,1)),200),((5,3,2,0,(0,2)),210),((5,3,2,0,(0,3)),220),
>                       ((5,3,2,0,(1,0)),130),((5,3,2,0,(1,1)),200),((5,3,2,0,(1,2)),170),((5,3,2,0,(1,3)),80),
>                       ((5,3,2,0,(2,0)),70),((5,3,2,0,(2,1)),200),((5,3,2,0,(2,2)),110),((5,3,2,0,(2,3)),200),
>                       ((5,3,2,0,(3,0)),200),((5,3,2,0,(3,1)),200),((5,3,2,0,(3,2)),200),((5,3,2,0,(3,3)),200),
>                       
>                       ((5,3,2,1,(0,0)),170),((5,3,2,1,(0,1)),200),((5,3,2,1,(0,2)),210),((5,3,2,1,(0,3)),120),
>                       ((5,3,2,1,(1,0)),270),((5,3,2,1,(1,1)),200),((5,3,2,1,(1,2)),270),((5,3,2,1,(1,3)),220),
>                       ((5,3,2,1,(2,0)),200),((5,3,2,1,(2,1)),200),((5,3,2,1,(2,2)),200),((5,3,2,1,(2,3)),200),
>                       ((5,3,2,1,(3,0)),270),((5,3,2,1,(3,1)),200),((5,3,2,1,(3,2)),270),((5,3,2,1,(3,3)),220),
>                       
>                       ((5,3,2,2,(0,0)),70),((5,3,2,2,(0,1)),200),((5,3,2,2,(0,2)),110),((5,3,2,2,(0,3)),200),
>                       ((5,3,2,2,(1,0)),200),((5,3,2,2,(1,1)),200),((5,3,2,2,(1,2)),200),((5,3,2,2,(1,3)),200),
>                       ((5,3,2,2,(2,0)),110),((5,3,2,2,(2,1)),200),((5,3,2,2,(2,2)),150),((5,3,2,2,(2,3)),160),
>                       ((5,3,2,2,(3,0)),70),((5,3,2,2,(3,1)),200),((5,3,2,2,(3,2)),30),((5,3,2,2,(3,3)),-160),
>                       
>                       ((5,3,2,3,(0,0)),200),((5,3,2,3,(0,1)),200),((5,3,2,3,(0,2)),200),((5,3,2,3,(0,3)),200),
>                       ((5,3,2,3,(1,0)),240),((5,3,2,3,(1,1)),200),((5,3,2,3,(1,2)),240),((5,3,2,3,(1,3)),190),
>                       ((5,3,2,3,(2,0)),200),((5,3,2,3,(2,1)),200),((5,3,2,3,(2,2)),160),((5,3,2,3,(2,3)),-30),
>                       ((5,3,2,3,(3,0)),270),((5,3,2,3,(3,1)),200),((5,3,2,3,(3,2)),230),((5,3,2,3,(3,3)),220),
>                       
>                       
>                       ((5,3,3,0,(0,0)),200),((5,3,3,0,(0,1)),340),((5,3,3,0,(0,2)),100),((5,3,3,0,(0,3)),290),
>                       ((5,3,3,0,(1,0)),200),((5,3,3,0,(1,1)),230),((5,3,3,0,(1,2)),-50),((5,3,3,0,(1,3)),150),
>                       ((5,3,3,0,(2,0)),200),((5,3,3,0,(2,1)),270),((5,3,3,0,(2,2)),70),((5,3,3,0,(2,3)),270),
>                       ((5,3,3,0,(3,0)),200),((5,3,3,0,(3,1)),200),((5,3,3,0,(3,2)),200),((5,3,3,0,(3,3)),200),
>                       
>                       ((5,3,3,1,(0,0)),200),((5,3,3,1,(0,1)),280),((5,3,3,1,(0,2)),0),((5,3,3,1,(0,3)),190),
>                       ((5,3,3,1,(1,0)),200),((5,3,3,1,(1,1)),280),((5,3,3,1,(1,2)),100),((5,3,3,1,(1,3)),190),
>                       ((5,3,3,1,(2,0)),200),((5,3,3,1,(2,1)),200),((5,3,3,1,(2,2)),200),((5,3,3,1,(2,3)),200),
>                       ((5,3,3,1,(3,0)),200),((5,3,3,1,(3,1)),280),((5,3,3,1,(3,2)),100),((5,3,3,1,(3,3)),190),
>                       
>                       ((5,3,3,2,(0,0)),200),((5,3,3,2,(0,1)),270),((5,3,3,2,(0,2)),70),((5,3,3,2,(0,3)),270),
>                       ((5,3,3,2,(1,0)),200),((5,3,3,2,(1,1)),200),((5,3,3,2,(1,2)),200),((5,3,3,2,(1,3)),200),
>                       ((5,3,3,2,(2,0)),200),((5,3,3,2,(2,1)),270),((5,3,3,2,(2,2)),30),((5,3,3,2,(2,3)),230),
>                       ((5,3,3,2,(3,0)),200),((5,3,3,2,(3,1)),100),((5,3,3,2,(3,2)),-290),((5,3,3,2,(3,3)),90),
>                       
>                       ((5,3,3,3,(0,0)),200),((5,3,3,3,(0,1)),200),((5,3,3,3,(0,2)),200),((5,3,3,3,(0,3)),200),
>                       ((5,3,3,3,(1,0)),200),((5,3,3,3,(1,1)),250),((5,3,3,3,(1,2)),70),((5,3,3,3,(1,3)),160),
>                       ((5,3,3,3,(2,0)),200),((5,3,3,3,(2,1)),220),((5,3,3,3,(2,2)),-160),((5,3,3,3,(2,3)),220),
>                       ((5,3,3,3,(3,0)),200),((5,3,3,3,(3,1)),190),((5,3,3,3,(3,2)),90),((5,3,3,3,(3,3)),110),
>                       
>                       
>                       
>                       ((5,4,0,0,(0,0)),280),((5,4,0,0,(0,1)),280),((5,4,0,0,(0,2)),170),((5,4,0,0,(0,3)),200),
>                       ((5,4,0,0,(1,0)),250),((5,4,0,0,(1,1)),250),((5,4,0,0,(1,2)),150),((5,4,0,0,(1,3)),200),
>                       ((5,4,0,0,(2,0)),150),((5,4,0,0,(2,1)),150),((5,4,0,0,(2,2)),50),((5,4,0,0,(2,3)),200),
>                       ((5,4,0,0,(3,0)),200),((5,4,0,0,(3,1)),200),((5,4,0,0,(3,2)),200),((5,4,0,0,(3,3)),200),
>                       
>                       ((5,4,0,1,(0,0)),260),((5,4,0,1,(0,1)),260),((5,4,0,1,(0,2)),160),((5,4,0,1,(0,3)),200),
>                       ((5,4,0,1,(1,0)),310),((5,4,0,1,(1,1)),250),((5,4,0,1,(1,2)),240),((5,4,0,1,(1,3)),200),
>                       ((5,4,0,1,(2,0)),200),((5,4,0,1,(2,1)),200),((5,4,0,1,(2,2)),200),((5,4,0,1,(2,3)),200),
>                       ((5,4,0,1,(3,0)),310),((5,4,0,1,(3,1)),250),((5,4,0,1,(3,2)),240),((5,4,0,1,(3,3)),200),
>                       
>                       ((5,4,0,2,(0,0)),150),((5,4,0,2,(0,1)),150),((5,4,0,2,(0,2)),50),((5,4,0,2,(0,3)),200),
>                       ((5,4,0,2,(1,0)),200),((5,4,0,2,(1,1)),200),((5,4,0,2,(1,2)),200),((5,4,0,2,(1,3)),200),
>                       ((5,4,0,2,(2,0)),210),((5,4,0,2,(2,1)),210),((5,4,0,2,(2,2)),100),((5,4,0,2,(2,3)),200),
>                       ((5,4,0,2,(3,0)),130),((5,4,0,2,(3,1)),30),((5,4,0,2,(3,2)),110),((5,4,0,2,(3,3)),200),
>                       
>                       ((5,4,0,3,(0,0)),200),((5,4,0,3,(0,1)),200),((5,4,0,3,(0,2)),200),((5,4,0,3,(0,3)),200),
>                       ((5,4,0,3,(1,0)),310),((5,4,0,3,(1,1)),250),((5,4,0,3,(1,2)),240),((5,4,0,3,(1,3)),200),
>                       ((5,4,0,3,(2,0)),230),((5,4,0,3,(2,1)),130),((5,4,0,3,(2,2)),210),((5,4,0,3,(2,3)),200),
>                       ((5,4,0,3,(3,0)),270),((5,4,0,3,(3,1)),170),((5,4,0,3,(3,2)),240),((5,4,0,3,(3,3)),200),
>                       
>                       
>                       ((5,4,1,0,(0,0)),230),((5,4,1,0,(0,1)),340),((5,4,1,0,(0,2)),200),((5,4,1,0,(0,3)),310),
>                       ((5,4,1,0,(1,0)),210),((5,4,1,0,(1,1)),250),((5,4,1,0,(1,2)),200),((5,4,1,0,(1,3)),220),
>                       ((5,4,1,0,(2,0)),110),((5,4,1,0,(2,1)),250),((5,4,1,0,(2,2)),200),((5,4,1,0,(2,3)),220),
>                       ((5,4,1,0,(3,0)),200),((5,4,1,0,(3,1)),200),((5,4,1,0,(3,2)),200),((5,4,1,0,(3,3)),200),
>                       
>                       ((5,4,1,1,(0,0)),220),((5,4,1,1,(0,1)),260),((5,4,1,1,(0,2)),200),((5,4,1,1,(0,3)),230),
>                       ((5,4,1,1,(1,0)),200),((5,4,1,1,(1,1)),250),((5,4,1,1,(1,2)),200),((5,4,1,1,(1,3)),220),
>                       ((5,4,1,1,(2,0)),200),((5,4,1,1,(2,1)),200),((5,4,1,1,(2,2)),200),((5,4,1,1,(2,3)),200),
>                       ((5,4,1,1,(3,0)),200),((5,4,1,1,(3,1)),250),((5,4,1,1,(3,2)),200),((5,4,1,1,(3,3)),220),
>                       
>                       ((5,4,1,2,(0,0)),110),((5,4,1,2,(0,1)),250),((5,4,1,2,(0,2)),200),((5,4,1,2,(0,3)),220),
>                       ((5,4,1,2,(1,0)),200),((5,4,1,2,(1,1)),200),((5,4,1,2,(1,2)),200),((5,4,1,2,(1,3)),200),
>                       ((5,4,1,2,(2,0)),160),((5,4,1,2,(2,1)),270),((5,4,1,2,(2,2)),200),((5,4,1,2,(2,3)),240),
>                       ((5,4,1,2,(3,0)),-10),((5,4,1,2,(3,1)),130),((5,4,1,2,(3,2)),200),((5,4,1,2,(3,3)),100),
>                       
>                       ((5,4,1,3,(0,0)),200),((5,4,1,3,(0,1)),200),((5,4,1,3,(0,2)),200),((5,4,1,3,(0,3)),200),
>                       ((5,4,1,3,(1,0)),200),((5,4,1,3,(1,1)),250),((5,4,1,3,(1,2)),200),((5,4,1,3,(1,3)),220),
>                       ((5,4,1,3,(2,0)),90),((5,4,1,3,(2,1)),230),((5,4,1,3,(2,2)),200),((5,4,1,3,(2,3)),200),
>                       ((5,4,1,3,(3,0)),120),((5,4,1,3,(3,1)),170),((5,4,1,3,(3,2)),200),((5,4,1,3,(3,3)),140),
>                       
>                       
>                       ((5,4,2,0,(0,0)),170),((5,4,2,0,(0,1)),200),((5,4,2,0,(0,2)),210),((5,4,2,0,(0,3)),220),
>                       ((5,4,2,0,(1,0)),150),((5,4,2,0,(1,1)),200),((5,4,2,0,(1,2)),190),((5,4,2,0,(1,3)),100),
>                       ((5,4,2,0,(2,0)),50),((5,4,2,0,(2,1)),200),((5,4,2,0,(2,2)),90),((5,4,2,0,(2,3)),180),
>                       ((5,4,2,0,(3,0)),200),((5,4,2,0,(3,1)),200),((5,4,2,0,(3,2)),200),((5,4,2,0,(3,3)),200),
>                       
>                       ((5,4,2,1,(0,0)),160),((5,4,2,1,(0,1)),200),((5,4,2,1,(0,2)),200),((5,4,2,1,(0,3)),110),
>                       ((5,4,2,1,(1,0)),240),((5,4,2,1,(1,1)),200),((5,4,2,1,(1,2)),240),((5,4,2,1,(1,3)),190),
>                       ((5,4,2,1,(2,0)),200),((5,4,2,1,(2,1)),200),((5,4,2,1,(2,2)),200),((5,4,2,1,(2,3)),200),
>                       ((5,4,2,1,(3,0)),240),((5,4,2,1,(3,1)),200),((5,4,2,1,(3,2)),240),((5,4,2,1,(3,3)),190),
>                       
>                       ((5,4,2,2,(0,0)),50),((5,4,2,2,(0,1)),200),((5,4,2,2,(0,2)),90),((5,4,2,2,(0,3)),180),
>                       ((5,4,2,2,(1,0)),200),((5,4,2,2,(1,1)),200),((5,4,2,2,(1,2)),200),((5,4,2,2,(1,3)),200),
>                       ((5,4,2,2,(2,0)),100),((5,4,2,2,(2,1)),200),((5,4,2,2,(2,2)),140),((5,4,2,2,(2,3)),150),
>                       ((5,4,2,2,(3,0)),110),((5,4,2,2,(3,1)),200),((5,4,2,2,(3,2)),70),((5,4,2,2,(3,3)),-120),
>                       
>                       ((5,4,2,3,(0,0)),200),((5,4,2,3,(0,1)),200),((5,4,2,3,(0,2)),200),((5,4,2,3,(0,3)),200),
>                       ((5,4,2,3,(1,0)),240),((5,4,2,3,(1,1)),200),((5,4,2,3,(1,2)),240),((5,4,2,3,(1,3)),190),
>                       ((5,4,2,3,(2,0)),210),((5,4,2,3,(2,1)),200),((5,4,2,3,(2,2)),170),((5,4,2,3,(2,3)),-20),
>                       ((5,4,2,3,(3,0)),240),((5,4,2,3,(3,1)),200),((5,4,2,3,(3,2)),200),((5,4,2,3,(3,3)),190),
>                       
>                       
>                       ((5,4,3,0,(0,0)),200),((5,4,3,0,(0,1)),340),((5,4,3,0,(0,2)),100),((5,4,3,0,(0,3)),290),
>                       ((5,4,3,0,(1,0)),200),((5,4,3,0,(1,1)),250),((5,4,3,0,(1,2)),-30),((5,4,3,0,(1,3)),170),
>                       ((5,4,3,0,(2,0)),200),((5,4,3,0,(2,1)),250),((5,4,3,0,(2,2)),50),((5,4,3,0,(2,3)),250),
>                       ((5,4,3,0,(3,0)),200),((5,4,3,0,(3,1)),200),((5,4,3,0,(3,2)),200),((5,4,3,0,(3,3)),200),
>                       
>                       ((5,4,3,1,(0,0)),200),((5,4,3,1,(0,1)),260),((5,4,3,1,(0,2)),-20),((5,4,3,1,(0,3)),180),
>                       ((5,4,3,1,(1,0)),200),((5,4,3,1,(1,1)),250),((5,4,3,1,(1,2)),70),((5,4,3,1,(1,3)),160),
>                       ((5,4,3,1,(2,0)),200),((5,4,3,1,(2,1)),200),((5,4,3,1,(2,2)),200),((5,4,3,1,(2,3)),200),
>                       ((5,4,3,1,(3,0)),200),((5,4,3,1,(3,1)),250),((5,4,3,1,(3,2)),70),((5,4,3,1,(3,3)),160),
>                       
>                       ((5,4,3,2,(0,0)),200),((5,4,3,2,(0,1)),250),((5,4,3,2,(0,2)),50),((5,4,3,2,(0,3)),250),
>                       ((5,4,3,2,(1,0)),200),((5,4,3,2,(1,1)),200),((5,4,3,2,(1,2)),200),((5,4,3,2,(1,3)),200),
>                       ((5,4,3,2,(2,0)),200),((5,4,3,2,(2,1)),270),((5,4,3,2,(2,2)),30),((5,4,3,2,(2,3)),220),
>                       ((5,4,3,2,(3,0)),200),((5,4,3,2,(3,1)),130),((5,4,3,2,(3,2)),-250),((5,4,3,2,(3,3)),130),
>                       
>                       ((5,4,3,3,(0,0)),200),((5,4,3,3,(0,1)),200),((5,4,3,3,(0,2)),200),((5,4,3,3,(0,3)),200),
>                       ((5,4,3,3,(1,0)),200),((5,4,3,3,(1,1)),250),((5,4,3,3,(1,2)),70),((5,4,3,3,(1,3)),160),
>                       ((5,4,3,3,(2,0)),200),((5,4,3,3,(2,1)),230),((5,4,3,3,(2,2)),-150),((5,4,3,3,(2,3)),230),
>                       ((5,4,3,3,(3,0)),200),((5,4,3,3,(3,1)),170),((5,4,3,3,(3,2)),70),((5,4,3,3,(3,3)),80),
>                       
>                       
>                       
>                       ((5,5,0,0,(0,0)),280),((5,5,0,0,(0,1)),280),((5,5,0,0,(0,2)),170),((5,5,0,0,(0,3)),200),
>                       ((5,5,0,0,(1,0)),230),((5,5,0,0,(1,1)),230),((5,5,0,0,(1,2)),130),((5,5,0,0,(1,3)),200),
>                       ((5,5,0,0,(2,0)),170),((5,5,0,0,(2,1)),170),((5,5,0,0,(2,2)),70),((5,5,0,0,(2,3)),200),
>                       ((5,5,0,0,(3,0)),200),((5,5,0,0,(3,1)),200),((5,5,0,0,(3,2)),200),((5,5,0,0,(3,3)),200),
>                       
>                       ((5,5,0,1,(0,0)),280),((5,5,0,1,(0,1)),280),((5,5,0,1,(0,2)),170),((5,5,0,1,(0,3)),200),
>                       ((5,5,0,1,(1,0)),340),((5,5,0,1,(1,1)),280),((5,5,0,1,(1,2)),270),((5,5,0,1,(1,3)),200),
>                       ((5,5,0,1,(2,0)),200),((5,5,0,1,(2,1)),200),((5,5,0,1,(2,2)),200),((5,5,0,1,(2,3)),200),
>                       ((5,5,0,1,(3,0)),340),((5,5,0,1,(3,1)),280),((5,5,0,1,(3,2)),270),((5,5,0,1,(3,3)),200),
>                       
>                       ((5,5,0,2,(0,0)),170),((5,5,0,2,(0,1)),170),((5,5,0,2,(0,2)),70),((5,5,0,2,(0,3)),200),
>                       ((5,5,0,2,(1,0)),200),((5,5,0,2,(1,1)),200),((5,5,0,2,(1,2)),200),((5,5,0,2,(1,3)),200),
>                       ((5,5,0,2,(2,0)),210),((5,5,0,2,(2,1)),210),((5,5,0,2,(2,2)),110),((5,5,0,2,(2,3)),200),
>                       ((5,5,0,2,(3,0)),100),((5,5,0,2,(3,1)),0),((5,5,0,2,(3,2)),70),((5,5,0,2,(3,3)),200),
>                       
>                       ((5,5,0,3,(0,0)),200),((5,5,0,3,(0,1)),200),((5,5,0,3,(0,2)),200),((5,5,0,3,(0,3)),200),
>                       ((5,5,0,3,(1,0)),310),((5,5,0,3,(1,1)),250),((5,5,0,3,(1,2)),240),((5,5,0,3,(1,3)),200),
>                       ((5,5,0,3,(2,0)),220),((5,5,0,3,(2,1)),120),((5,5,0,3,(2,2)),200),((5,5,0,3,(2,3)),200),
>                       ((5,5,0,3,(3,0)),290),((5,5,0,3,(3,1)),190),((5,5,0,3,(3,2)),270),((5,5,0,3,(3,3)),200),
>                       
>                       
>                       ((5,5,1,0,(0,0)),230),((5,5,1,0,(0,1)),340),((5,5,1,0,(0,2)),200),((5,5,1,0,(0,3)),310),
>                       ((5,5,1,0,(1,0)),190),((5,5,1,0,(1,1)),230),((5,5,1,0,(1,2)),200),((5,5,1,0,(1,3)),200),
>                       ((5,5,1,0,(2,0)),130),((5,5,1,0,(2,1)),270),((5,5,1,0,(2,2)),200),((5,5,1,0,(2,3)),240),
>                       ((5,5,1,0,(3,0)),200),((5,5,1,0,(3,1)),200),((5,5,1,0,(3,2)),200),((5,5,1,0,(3,3)),200),
>                       
>                       ((5,5,1,1,(0,0)),230),((5,5,1,1,(0,1)),280),((5,5,1,1,(0,2)),200),((5,5,1,1,(0,3)),250),
>                       ((5,5,1,1,(1,0)),230),((5,5,1,1,(1,1)),280),((5,5,1,1,(1,2)),200),((5,5,1,1,(1,3)),250),
>                       ((5,5,1,1,(2,0)),200),((5,5,1,1,(2,1)),200),((5,5,1,1,(2,2)),200),((5,5,1,1,(2,3)),200),
>                       ((5,5,1,1,(3,0)),230),((5,5,1,1,(3,1)),280),((5,5,1,1,(3,2)),200),((5,5,1,1,(3,3)),250),
>                       
>                       ((5,5,1,2,(0,0)),130),((5,5,1,2,(0,1)),270),((5,5,1,2,(0,2)),200),((5,5,1,2,(0,3)),240),
>                       ((5,5,1,2,(1,0)),200),((5,5,1,2,(1,1)),200),((5,5,1,2,(1,2)),200),((5,5,1,2,(1,3)),200),
>                       ((5,5,1,2,(2,0)),170),((5,5,1,2,(2,1)),270),((5,5,1,2,(2,2)),200),((5,5,1,2,(2,3)),240),
>                       ((5,5,1,2,(3,0)),-50),((5,5,1,2,(3,1)),100),((5,5,1,2,(3,2)),200),((5,5,1,2,(3,3)),70),
>                       
>                       ((5,5,1,3,(0,0)),200),((5,5,1,3,(0,1)),200),((5,5,1,3,(0,2)),200),((5,5,1,3,(0,3)),200),
>                       ((5,5,1,3,(1,0)),200),((5,5,1,3,(1,1)),250),((5,5,1,3,(1,2)),200),((5,5,1,3,(1,3)),220),
>                       ((5,5,1,3,(2,0)),80),((5,5,1,3,(2,1)),220),((5,5,1,3,(2,2)),200),((5,5,1,3,(2,3)),190),
>                       ((5,5,1,3,(3,0)),150),((5,5,1,3,(3,1)),190),((5,5,1,3,(3,2)),200),((5,5,1,3,(3,3)),160),
>                       
>                       
>                       ((5,5,2,0,(0,0)),170),((5,5,2,0,(0,1)),200),((5,5,2,0,(0,2)),210),((5,5,2,0,(0,3)),220),
>                       ((5,5,2,0,(1,0)),130),((5,5,2,0,(1,1)),200),((5,5,2,0,(1,2)),170),((5,5,2,0,(1,3)),80),
>                       ((5,5,2,0,(2,0)),70),((5,5,2,0,(2,1)),200),((5,5,2,0,(2,2)),110),((5,5,2,0,(2,3)),200),
>                       ((5,5,2,0,(3,0)),200),((5,5,2,0,(3,1)),200),((5,5,2,0,(3,2)),200),((5,5,2,0,(3,3)),200),
>                       
>                       ((5,5,2,1,(0,0)),170),((5,5,2,1,(0,1)),200),((5,5,2,1,(0,2)),210),((5,5,2,1,(0,3)),120),
>                       ((5,5,2,1,(1,0)),270),((5,5,2,1,(1,1)),200),((5,5,2,1,(1,2)),270),((5,5,2,1,(1,3)),220),
>                       ((5,5,2,1,(2,0)),200),((5,5,2,1,(2,1)),200),((5,5,2,1,(2,2)),200),((5,5,2,1,(2,3)),200),
>                       ((5,5,2,1,(3,0)),270),((5,5,2,1,(3,1)),200),((5,5,2,1,(3,2)),270),((5,5,2,1,(3,3)),220),
>                       
>                       ((5,5,2,2,(0,0)),70),((5,5,2,2,(0,1)),200),((5,5,2,2,(0,2)),110),((5,5,2,2,(0,3)),200),
>                       ((5,5,2,2,(1,0)),200),((5,5,2,2,(1,1)),200),((5,5,2,2,(1,2)),200),((5,5,2,2,(1,3)),200),
>                       ((5,5,2,2,(2,0)),110),((5,5,2,2,(2,1)),200),((5,5,2,2,(2,2)),150),((5,5,2,2,(2,3)),160),
>                       ((5,5,2,2,(3,0)),70),((5,5,2,2,(3,1)),200),((5,5,2,2,(3,2)),30),((5,5,2,2,(3,3)),-160),
>                       
>                       ((5,5,2,3,(0,0)),200),((5,5,2,3,(0,1)),200),((5,5,2,3,(0,2)),200),((5,5,2,3,(0,3)),200),
>                       ((5,5,2,3,(1,0)),240),((5,5,2,3,(1,1)),200),((5,5,2,3,(1,2)),240),((5,5,2,3,(1,3)),190),
>                       ((5,5,2,3,(2,0)),200),((5,5,2,3,(2,1)),200),((5,5,2,3,(2,2)),160),((5,5,2,3,(2,3)),-30),
>                       ((5,5,2,3,(3,0)),270),((5,5,2,3,(3,1)),200),((5,5,2,3,(3,2)),230),((5,5,2,3,(3,3)),220),
>                       
>                       
>                       ((5,5,3,0,(0,0)),200),((5,5,3,0,(0,1)),340),((5,5,3,0,(0,2)),100),((5,5,3,0,(0,3)),290),
>                       ((5,5,3,0,(1,0)),200),((5,5,3,0,(1,1)),230),((5,5,3,0,(1,2)),-50),((5,5,3,0,(1,3)),150),
>                       ((5,5,3,0,(2,0)),200),((5,5,3,0,(2,1)),270),((5,5,3,0,(2,2)),70),((5,5,3,0,(2,3)),270),
>                       ((5,5,3,0,(3,0)),200),((5,5,3,0,(3,1)),200),((5,5,3,0,(3,2)),200),((5,5,3,0,(3,3)),200),
>                       
>                       ((5,5,3,1,(0,0)),200),((5,5,3,1,(0,1)),280),((5,5,3,1,(0,2)),0),((5,5,3,1,(0,3)),190),
>                       ((5,5,3,1,(1,0)),200),((5,5,3,1,(1,1)),280),((5,5,3,1,(1,2)),100),((5,5,3,1,(1,3)),190),
>                       ((5,5,3,1,(2,0)),200),((5,5,3,1,(2,1)),200),((5,5,3,1,(2,2)),200),((5,5,3,1,(2,3)),200),
>                       ((5,5,3,1,(3,0)),200),((5,5,3,1,(3,1)),280),((5,5,3,1,(3,2)),100),((5,5,3,1,(3,3)),190),
>                       
>                       ((5,5,3,2,(0,0)),200),((5,5,3,2,(0,1)),270),((5,5,3,2,(0,2)),70),((5,5,3,2,(0,3)),270),
>                       ((5,5,3,2,(1,0)),200),((5,5,3,2,(1,1)),200),((5,5,3,2,(1,2)),200),((5,5,3,2,(1,3)),200),
>                       ((5,5,3,2,(2,0)),200),((5,5,3,2,(2,1)),270),((5,5,3,2,(2,2)),30),((5,5,3,2,(2,3)),230),
>                       ((5,5,3,2,(3,0)),200),((5,5,3,2,(3,1)),100),((5,5,3,2,(3,2)),-290),((5,5,3,2,(3,3)),90),
>                       
>                       ((5,5,3,3,(0,0)),200),((5,5,3,3,(0,1)),200),((5,5,3,3,(0,2)),200),((5,5,3,3,(0,3)),200),
>                       ((5,5,3,3,(1,0)),200),((5,5,3,3,(1,1)),250),((5,5,3,3,(1,2)),70),((5,5,3,3,(1,3)),160),
>                       ((5,5,3,3,(2,0)),200),((5,5,3,3,(2,1)),220),((5,5,3,3,(2,2)),-160),((5,5,3,3,(2,3)),220),
>                       ((5,5,3,3,(3,0)),200),((5,5,3,3,(3,1)),190),((5,5,3,3,(3,2)),90),((5,5,3,3,(3,3)),110)]
